# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator (autorest: 3.7.3, generator: @autorest/python@5.12.0)
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from copy import deepcopy
from typing import TYPE_CHECKING

from azure.core import PipelineClient
from msrest import Deserializer, Serializer

from . import models
from ._configuration import DesignerServiceClientConfiguration
from .operations import ComponentOperations, ComponentsWorkspaceIndependentOperations, ComputesOperations, ComputesV2Operations, DataSetsOperations, DataSetsV2Operations, ExperimentsOperations, ExperimentsV2Operations, FeedsOperations, FeedsV2Operations, ModelsOperations, ModelsV2Operations, ModuleOperations, ModuleWithAuthOperations, ModulesOperations, ModulesV2Operations, PipelineComponentOperations, PipelineDraftsOperations, PipelineDraftsV2Operations, PipelineEndpointsOperations, PipelineEndpointsV2Operations, PipelineRunsOperations, PipelineRunsV2Operations, PublishedPipelinesOperations, PublishedPipelinesV2Operations, RealTimeEndpointsOperations, RealTimeEndpointsV2Operations, RunsOperations, RunsV2Operations, SamplesOperations, SamplesV2Operations

if TYPE_CHECKING:
    # pylint: disable=unused-import,ungrouped-imports
    from typing import Any, Optional

    from azure.core.rest import HttpRequest, HttpResponse

class DesignerServiceClient(object):
    """DesignerServiceClient.

    :ivar component: ComponentOperations operations
    :vartype component: designer.operations.ComponentOperations
    :ivar components_workspace_independent: ComponentsWorkspaceIndependentOperations operations
    :vartype components_workspace_independent:
     designer.operations.ComponentsWorkspaceIndependentOperations
    :ivar computes: ComputesOperations operations
    :vartype computes: designer.operations.ComputesOperations
    :ivar computes_v2: ComputesV2Operations operations
    :vartype computes_v2: designer.operations.ComputesV2Operations
    :ivar data_sets: DataSetsOperations operations
    :vartype data_sets: designer.operations.DataSetsOperations
    :ivar data_sets_v2: DataSetsV2Operations operations
    :vartype data_sets_v2: designer.operations.DataSetsV2Operations
    :ivar experiments: ExperimentsOperations operations
    :vartype experiments: designer.operations.ExperimentsOperations
    :ivar experiments_v2: ExperimentsV2Operations operations
    :vartype experiments_v2: designer.operations.ExperimentsV2Operations
    :ivar feeds: FeedsOperations operations
    :vartype feeds: designer.operations.FeedsOperations
    :ivar feeds_v2: FeedsV2Operations operations
    :vartype feeds_v2: designer.operations.FeedsV2Operations
    :ivar models: ModelsOperations operations
    :vartype models: designer.operations.ModelsOperations
    :ivar models_v2: ModelsV2Operations operations
    :vartype models_v2: designer.operations.ModelsV2Operations
    :ivar module: ModuleOperations operations
    :vartype module: designer.operations.ModuleOperations
    :ivar modules: ModulesOperations operations
    :vartype modules: designer.operations.ModulesOperations
    :ivar modules_v2: ModulesV2Operations operations
    :vartype modules_v2: designer.operations.ModulesV2Operations
    :ivar module_with_auth: ModuleWithAuthOperations operations
    :vartype module_with_auth: designer.operations.ModuleWithAuthOperations
    :ivar pipeline_component: PipelineComponentOperations operations
    :vartype pipeline_component: designer.operations.PipelineComponentOperations
    :ivar pipeline_drafts: PipelineDraftsOperations operations
    :vartype pipeline_drafts: designer.operations.PipelineDraftsOperations
    :ivar pipeline_drafts_v2: PipelineDraftsV2Operations operations
    :vartype pipeline_drafts_v2: designer.operations.PipelineDraftsV2Operations
    :ivar pipeline_endpoints: PipelineEndpointsOperations operations
    :vartype pipeline_endpoints: designer.operations.PipelineEndpointsOperations
    :ivar pipeline_endpoints_v2: PipelineEndpointsV2Operations operations
    :vartype pipeline_endpoints_v2: designer.operations.PipelineEndpointsV2Operations
    :ivar pipeline_runs: PipelineRunsOperations operations
    :vartype pipeline_runs: designer.operations.PipelineRunsOperations
    :ivar pipeline_runs_v2: PipelineRunsV2Operations operations
    :vartype pipeline_runs_v2: designer.operations.PipelineRunsV2Operations
    :ivar published_pipelines: PublishedPipelinesOperations operations
    :vartype published_pipelines: designer.operations.PublishedPipelinesOperations
    :ivar published_pipelines_v2: PublishedPipelinesV2Operations operations
    :vartype published_pipelines_v2: designer.operations.PublishedPipelinesV2Operations
    :ivar real_time_endpoints: RealTimeEndpointsOperations operations
    :vartype real_time_endpoints: designer.operations.RealTimeEndpointsOperations
    :ivar real_time_endpoints_v2: RealTimeEndpointsV2Operations operations
    :vartype real_time_endpoints_v2: designer.operations.RealTimeEndpointsV2Operations
    :ivar runs: RunsOperations operations
    :vartype runs: designer.operations.RunsOperations
    :ivar runs_v2: RunsV2Operations operations
    :vartype runs_v2: designer.operations.RunsV2Operations
    :ivar samples: SamplesOperations operations
    :vartype samples: designer.operations.SamplesOperations
    :ivar samples_v2: SamplesV2Operations operations
    :vartype samples_v2: designer.operations.SamplesV2Operations
    :param base_url: Service URL. Default value is ''.
    :type base_url: str
    """

    def __init__(
        self,
        base_url="",  # type: str
        **kwargs  # type: Any
    ):
        # type: (...) -> None
        self._config = DesignerServiceClientConfiguration(**kwargs)
        self._client = PipelineClient(base_url=base_url, config=self._config, **kwargs)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)
        self._serialize.client_side_validation = False
        self.component = ComponentOperations(self._client, self._config, self._serialize, self._deserialize)
        self.components_workspace_independent = ComponentsWorkspaceIndependentOperations(self._client, self._config, self._serialize, self._deserialize)
        self.computes = ComputesOperations(self._client, self._config, self._serialize, self._deserialize)
        self.computes_v2 = ComputesV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.data_sets = DataSetsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.data_sets_v2 = DataSetsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.experiments = ExperimentsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.experiments_v2 = ExperimentsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.feeds = FeedsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.feeds_v2 = FeedsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.models = ModelsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.models_v2 = ModelsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.module = ModuleOperations(self._client, self._config, self._serialize, self._deserialize)
        self.modules = ModulesOperations(self._client, self._config, self._serialize, self._deserialize)
        self.modules_v2 = ModulesV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.module_with_auth = ModuleWithAuthOperations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_component = PipelineComponentOperations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_drafts = PipelineDraftsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_drafts_v2 = PipelineDraftsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_endpoints = PipelineEndpointsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_endpoints_v2 = PipelineEndpointsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_runs = PipelineRunsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.pipeline_runs_v2 = PipelineRunsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.published_pipelines = PublishedPipelinesOperations(self._client, self._config, self._serialize, self._deserialize)
        self.published_pipelines_v2 = PublishedPipelinesV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.real_time_endpoints = RealTimeEndpointsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.real_time_endpoints_v2 = RealTimeEndpointsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.runs = RunsOperations(self._client, self._config, self._serialize, self._deserialize)
        self.runs_v2 = RunsV2Operations(self._client, self._config, self._serialize, self._deserialize)
        self.samples = SamplesOperations(self._client, self._config, self._serialize, self._deserialize)
        self.samples_v2 = SamplesV2Operations(self._client, self._config, self._serialize, self._deserialize)


    def _send_request(
        self,
        request,  # type: HttpRequest
        **kwargs  # type: Any
    ):
        # type: (...) -> HttpResponse
        """Runs the network request through the client's chained policies.

        >>> from azure.core.rest import HttpRequest
        >>> request = HttpRequest("GET", "https://www.example.org/")
        <HttpRequest [GET], url: 'https://www.example.org/'>
        >>> response = client._send_request(request)
        <HttpResponse: 200 OK>

        For more information on this code flow, see https://aka.ms/azsdk/python/protocol/quickstart

        :param request: The network request you want to make. Required.
        :type request: ~azure.core.rest.HttpRequest
        :keyword bool stream: Whether the response payload will be streamed. Defaults to False.
        :return: The response of your network call. Does not do error handling on your response.
        :rtype: ~azure.core.rest.HttpResponse
        """

        request_copy = deepcopy(request)
        request_copy.url = self._client.format_url(request_copy.url)
        return self._client.send_request(request_copy, **kwargs)

    def close(self):
        # type: () -> None
        self._client.close()

    def __enter__(self):
        # type: () -> DesignerServiceClient
        self._client.__enter__()
        return self

    def __exit__(self, *exc_details):
        # type: (Any) -> None
        self._client.__exit__(*exc_details)
