# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator (autorest: 3.7.3, generator: @autorest/python@5.12.0)
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

import datetime
from typing import Any, Dict, IO, List, Optional, Union

from azure.core.exceptions import HttpResponseError
import msrest.serialization

from ._designer_service_client_enums import *


class ACIAdvanceSettings(msrest.serialization.Model):
    """ACIAdvanceSettings.

    :ivar container_resource_requirements:
    :vartype container_resource_requirements: ~designer.models.ContainerResourceRequirements
    :ivar app_insights_enabled:
    :vartype app_insights_enabled: bool
    :ivar ssl_enabled:
    :vartype ssl_enabled: bool
    :ivar ssl_certificate:
    :vartype ssl_certificate: str
    :ivar ssl_key:
    :vartype ssl_key: str
    :ivar c_name:
    :vartype c_name: str
    :ivar dns_name_label:
    :vartype dns_name_label: str
    """

    _attribute_map = {
        'container_resource_requirements': {'key': 'containerResourceRequirements', 'type': 'ContainerResourceRequirements'},
        'app_insights_enabled': {'key': 'appInsightsEnabled', 'type': 'bool'},
        'ssl_enabled': {'key': 'sslEnabled', 'type': 'bool'},
        'ssl_certificate': {'key': 'sslCertificate', 'type': 'str'},
        'ssl_key': {'key': 'sslKey', 'type': 'str'},
        'c_name': {'key': 'cName', 'type': 'str'},
        'dns_name_label': {'key': 'dnsNameLabel', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        container_resource_requirements: Optional["ContainerResourceRequirements"] = None,
        app_insights_enabled: Optional[bool] = None,
        ssl_enabled: Optional[bool] = None,
        ssl_certificate: Optional[str] = None,
        ssl_key: Optional[str] = None,
        c_name: Optional[str] = None,
        dns_name_label: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword container_resource_requirements:
        :paramtype container_resource_requirements: ~designer.models.ContainerResourceRequirements
        :keyword app_insights_enabled:
        :paramtype app_insights_enabled: bool
        :keyword ssl_enabled:
        :paramtype ssl_enabled: bool
        :keyword ssl_certificate:
        :paramtype ssl_certificate: str
        :keyword ssl_key:
        :paramtype ssl_key: str
        :keyword c_name:
        :paramtype c_name: str
        :keyword dns_name_label:
        :paramtype dns_name_label: str
        """
        super(ACIAdvanceSettings, self).__init__(**kwargs)
        self.container_resource_requirements = container_resource_requirements
        self.app_insights_enabled = app_insights_enabled
        self.ssl_enabled = ssl_enabled
        self.ssl_certificate = ssl_certificate
        self.ssl_key = ssl_key
        self.c_name = c_name
        self.dns_name_label = dns_name_label


class AISuperComputerConfiguration(msrest.serialization.Model):
    """AISuperComputerConfiguration.

    :ivar instance_type:
    :vartype instance_type: str
    :ivar image_version:
    :vartype image_version: str
    :ivar location:
    :vartype location: str
    :ivar ai_super_computer_storage_data: Dictionary of
     :code:`<AISuperComputerStorageReferenceConfiguration>`.
    :vartype ai_super_computer_storage_data: dict[str,
     ~designer.models.AISuperComputerStorageReferenceConfiguration]
    :ivar interactive:
    :vartype interactive: bool
    :ivar scale_policy:
    :vartype scale_policy: ~designer.models.AISuperComputerScalePolicy
    :ivar virtual_cluster_arm_id:
    :vartype virtual_cluster_arm_id: str
    :ivar tensorboard_log_directory:
    :vartype tensorboard_log_directory: str
    :ivar ssh_public_key:
    :vartype ssh_public_key: str
    :ivar ssh_public_keys:
    :vartype ssh_public_keys: list[str]
    :ivar enable_azml_int:
    :vartype enable_azml_int: bool
    :ivar priority:
    :vartype priority: str
    :ivar sla_tier:
    :vartype sla_tier: str
    :ivar suspend_on_idle_time_hours:
    :vartype suspend_on_idle_time_hours: long
    :ivar user_alias:
    :vartype user_alias: str
    """

    _attribute_map = {
        'instance_type': {'key': 'instanceType', 'type': 'str'},
        'image_version': {'key': 'imageVersion', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'ai_super_computer_storage_data': {'key': 'aiSuperComputerStorageData', 'type': '{AISuperComputerStorageReferenceConfiguration}'},
        'interactive': {'key': 'interactive', 'type': 'bool'},
        'scale_policy': {'key': 'scalePolicy', 'type': 'AISuperComputerScalePolicy'},
        'virtual_cluster_arm_id': {'key': 'virtualClusterArmId', 'type': 'str'},
        'tensorboard_log_directory': {'key': 'tensorboardLogDirectory', 'type': 'str'},
        'ssh_public_key': {'key': 'sshPublicKey', 'type': 'str'},
        'ssh_public_keys': {'key': 'sshPublicKeys', 'type': '[str]'},
        'enable_azml_int': {'key': 'enableAzmlInt', 'type': 'bool'},
        'priority': {'key': 'priority', 'type': 'str'},
        'sla_tier': {'key': 'slaTier', 'type': 'str'},
        'suspend_on_idle_time_hours': {'key': 'suspendOnIdleTimeHours', 'type': 'long'},
        'user_alias': {'key': 'userAlias', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        instance_type: Optional[str] = None,
        image_version: Optional[str] = None,
        location: Optional[str] = None,
        ai_super_computer_storage_data: Optional[Dict[str, "AISuperComputerStorageReferenceConfiguration"]] = None,
        interactive: Optional[bool] = None,
        scale_policy: Optional["AISuperComputerScalePolicy"] = None,
        virtual_cluster_arm_id: Optional[str] = None,
        tensorboard_log_directory: Optional[str] = None,
        ssh_public_key: Optional[str] = None,
        ssh_public_keys: Optional[List[str]] = None,
        enable_azml_int: Optional[bool] = None,
        priority: Optional[str] = None,
        sla_tier: Optional[str] = None,
        suspend_on_idle_time_hours: Optional[int] = None,
        user_alias: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword instance_type:
        :paramtype instance_type: str
        :keyword image_version:
        :paramtype image_version: str
        :keyword location:
        :paramtype location: str
        :keyword ai_super_computer_storage_data: Dictionary of
         :code:`<AISuperComputerStorageReferenceConfiguration>`.
        :paramtype ai_super_computer_storage_data: dict[str,
         ~designer.models.AISuperComputerStorageReferenceConfiguration]
        :keyword interactive:
        :paramtype interactive: bool
        :keyword scale_policy:
        :paramtype scale_policy: ~designer.models.AISuperComputerScalePolicy
        :keyword virtual_cluster_arm_id:
        :paramtype virtual_cluster_arm_id: str
        :keyword tensorboard_log_directory:
        :paramtype tensorboard_log_directory: str
        :keyword ssh_public_key:
        :paramtype ssh_public_key: str
        :keyword ssh_public_keys:
        :paramtype ssh_public_keys: list[str]
        :keyword enable_azml_int:
        :paramtype enable_azml_int: bool
        :keyword priority:
        :paramtype priority: str
        :keyword sla_tier:
        :paramtype sla_tier: str
        :keyword suspend_on_idle_time_hours:
        :paramtype suspend_on_idle_time_hours: long
        :keyword user_alias:
        :paramtype user_alias: str
        """
        super(AISuperComputerConfiguration, self).__init__(**kwargs)
        self.instance_type = instance_type
        self.image_version = image_version
        self.location = location
        self.ai_super_computer_storage_data = ai_super_computer_storage_data
        self.interactive = interactive
        self.scale_policy = scale_policy
        self.virtual_cluster_arm_id = virtual_cluster_arm_id
        self.tensorboard_log_directory = tensorboard_log_directory
        self.ssh_public_key = ssh_public_key
        self.ssh_public_keys = ssh_public_keys
        self.enable_azml_int = enable_azml_int
        self.priority = priority
        self.sla_tier = sla_tier
        self.suspend_on_idle_time_hours = suspend_on_idle_time_hours
        self.user_alias = user_alias


class AISuperComputerScalePolicy(msrest.serialization.Model):
    """AISuperComputerScalePolicy.

    :ivar auto_scale_instance_type_count_set:
    :vartype auto_scale_instance_type_count_set: list[int]
    :ivar auto_scale_interval_in_sec:
    :vartype auto_scale_interval_in_sec: int
    :ivar max_instance_type_count:
    :vartype max_instance_type_count: int
    :ivar min_instance_type_count:
    :vartype min_instance_type_count: int
    """

    _attribute_map = {
        'auto_scale_instance_type_count_set': {'key': 'autoScaleInstanceTypeCountSet', 'type': '[int]'},
        'auto_scale_interval_in_sec': {'key': 'autoScaleIntervalInSec', 'type': 'int'},
        'max_instance_type_count': {'key': 'maxInstanceTypeCount', 'type': 'int'},
        'min_instance_type_count': {'key': 'minInstanceTypeCount', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        auto_scale_instance_type_count_set: Optional[List[int]] = None,
        auto_scale_interval_in_sec: Optional[int] = None,
        max_instance_type_count: Optional[int] = None,
        min_instance_type_count: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword auto_scale_instance_type_count_set:
        :paramtype auto_scale_instance_type_count_set: list[int]
        :keyword auto_scale_interval_in_sec:
        :paramtype auto_scale_interval_in_sec: int
        :keyword max_instance_type_count:
        :paramtype max_instance_type_count: int
        :keyword min_instance_type_count:
        :paramtype min_instance_type_count: int
        """
        super(AISuperComputerScalePolicy, self).__init__(**kwargs)
        self.auto_scale_instance_type_count_set = auto_scale_instance_type_count_set
        self.auto_scale_interval_in_sec = auto_scale_interval_in_sec
        self.max_instance_type_count = max_instance_type_count
        self.min_instance_type_count = min_instance_type_count


class AISuperComputerStorageReferenceConfiguration(msrest.serialization.Model):
    """AISuperComputerStorageReferenceConfiguration.

    :ivar container_name:
    :vartype container_name: str
    :ivar relative_path:
    :vartype relative_path: str
    """

    _attribute_map = {
        'container_name': {'key': 'containerName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        container_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword container_name:
        :paramtype container_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        """
        super(AISuperComputerStorageReferenceConfiguration, self).__init__(**kwargs)
        self.container_name = container_name
        self.relative_path = relative_path


class AKSAdvanceSettings(msrest.serialization.Model):
    """AKSAdvanceSettings.

    :ivar auto_scaler:
    :vartype auto_scaler: ~designer.models.AutoScaler
    :ivar container_resource_requirements:
    :vartype container_resource_requirements: ~designer.models.ContainerResourceRequirements
    :ivar app_insights_enabled:
    :vartype app_insights_enabled: bool
    :ivar scoring_timeout_ms:
    :vartype scoring_timeout_ms: int
    :ivar num_replicas:
    :vartype num_replicas: int
    """

    _attribute_map = {
        'auto_scaler': {'key': 'autoScaler', 'type': 'AutoScaler'},
        'container_resource_requirements': {'key': 'containerResourceRequirements', 'type': 'ContainerResourceRequirements'},
        'app_insights_enabled': {'key': 'appInsightsEnabled', 'type': 'bool'},
        'scoring_timeout_ms': {'key': 'scoringTimeoutMs', 'type': 'int'},
        'num_replicas': {'key': 'numReplicas', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        auto_scaler: Optional["AutoScaler"] = None,
        container_resource_requirements: Optional["ContainerResourceRequirements"] = None,
        app_insights_enabled: Optional[bool] = None,
        scoring_timeout_ms: Optional[int] = None,
        num_replicas: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword auto_scaler:
        :paramtype auto_scaler: ~designer.models.AutoScaler
        :keyword container_resource_requirements:
        :paramtype container_resource_requirements: ~designer.models.ContainerResourceRequirements
        :keyword app_insights_enabled:
        :paramtype app_insights_enabled: bool
        :keyword scoring_timeout_ms:
        :paramtype scoring_timeout_ms: int
        :keyword num_replicas:
        :paramtype num_replicas: int
        """
        super(AKSAdvanceSettings, self).__init__(**kwargs)
        self.auto_scaler = auto_scaler
        self.container_resource_requirements = container_resource_requirements
        self.app_insights_enabled = app_insights_enabled
        self.scoring_timeout_ms = scoring_timeout_ms
        self.num_replicas = num_replicas


class AKSReplicaStatus(msrest.serialization.Model):
    """AKSReplicaStatus.

    :ivar desired_replicas:
    :vartype desired_replicas: int
    :ivar updated_replicas:
    :vartype updated_replicas: int
    :ivar available_replicas:
    :vartype available_replicas: int
    :ivar error:
    :vartype error: ~designer.models.ModelManagementErrorResponse
    """

    _attribute_map = {
        'desired_replicas': {'key': 'desiredReplicas', 'type': 'int'},
        'updated_replicas': {'key': 'updatedReplicas', 'type': 'int'},
        'available_replicas': {'key': 'availableReplicas', 'type': 'int'},
        'error': {'key': 'error', 'type': 'ModelManagementErrorResponse'},
    }

    def __init__(
        self,
        *,
        desired_replicas: Optional[int] = None,
        updated_replicas: Optional[int] = None,
        available_replicas: Optional[int] = None,
        error: Optional["ModelManagementErrorResponse"] = None,
        **kwargs
    ):
        """
        :keyword desired_replicas:
        :paramtype desired_replicas: int
        :keyword updated_replicas:
        :paramtype updated_replicas: int
        :keyword available_replicas:
        :paramtype available_replicas: int
        :keyword error:
        :paramtype error: ~designer.models.ModelManagementErrorResponse
        """
        super(AKSReplicaStatus, self).__init__(**kwargs)
        self.desired_replicas = desired_replicas
        self.updated_replicas = updated_replicas
        self.available_replicas = available_replicas
        self.error = error


class AMLComputeConfiguration(msrest.serialization.Model):
    """AMLComputeConfiguration.

    :ivar name:
    :vartype name: str
    :ivar vm_size:
    :vartype vm_size: str
    :ivar vm_priority: Possible values include: "Dedicated", "Lowpriority".
    :vartype vm_priority: str or ~designer.models.VmPriority
    :ivar retain_cluster:
    :vartype retain_cluster: bool
    :ivar cluster_max_node_count:
    :vartype cluster_max_node_count: int
    :ivar os_type:
    :vartype os_type: str
    :ivar virtual_machine_image:
    :vartype virtual_machine_image: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'vm_size': {'key': 'vmSize', 'type': 'str'},
        'vm_priority': {'key': 'vmPriority', 'type': 'str'},
        'retain_cluster': {'key': 'retainCluster', 'type': 'bool'},
        'cluster_max_node_count': {'key': 'clusterMaxNodeCount', 'type': 'int'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'virtual_machine_image': {'key': 'virtualMachineImage', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        vm_size: Optional[str] = None,
        vm_priority: Optional[Union[str, "VmPriority"]] = None,
        retain_cluster: Optional[bool] = None,
        cluster_max_node_count: Optional[int] = None,
        os_type: Optional[str] = None,
        virtual_machine_image: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword vm_size:
        :paramtype vm_size: str
        :keyword vm_priority: Possible values include: "Dedicated", "Lowpriority".
        :paramtype vm_priority: str or ~designer.models.VmPriority
        :keyword retain_cluster:
        :paramtype retain_cluster: bool
        :keyword cluster_max_node_count:
        :paramtype cluster_max_node_count: int
        :keyword os_type:
        :paramtype os_type: str
        :keyword virtual_machine_image:
        :paramtype virtual_machine_image: str
        """
        super(AMLComputeConfiguration, self).__init__(**kwargs)
        self.name = name
        self.vm_size = vm_size
        self.vm_priority = vm_priority
        self.retain_cluster = retain_cluster
        self.cluster_max_node_count = cluster_max_node_count
        self.os_type = os_type
        self.virtual_machine_image = virtual_machine_image


class AmlDataset(msrest.serialization.Model):
    """AmlDataset.

    :ivar registered_data_set_reference:
    :vartype registered_data_set_reference: ~designer.models.RegisteredDataSetReference
    :ivar saved_data_set_reference:
    :vartype saved_data_set_reference: ~designer.models.SavedDataSetReference
    :ivar additional_transformations:
    :vartype additional_transformations: str
    """

    _attribute_map = {
        'registered_data_set_reference': {'key': 'registeredDataSetReference', 'type': 'RegisteredDataSetReference'},
        'saved_data_set_reference': {'key': 'savedDataSetReference', 'type': 'SavedDataSetReference'},
        'additional_transformations': {'key': 'additionalTransformations', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        registered_data_set_reference: Optional["RegisteredDataSetReference"] = None,
        saved_data_set_reference: Optional["SavedDataSetReference"] = None,
        additional_transformations: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword registered_data_set_reference:
        :paramtype registered_data_set_reference: ~designer.models.RegisteredDataSetReference
        :keyword saved_data_set_reference:
        :paramtype saved_data_set_reference: ~designer.models.SavedDataSetReference
        :keyword additional_transformations:
        :paramtype additional_transformations: str
        """
        super(AmlDataset, self).__init__(**kwargs)
        self.registered_data_set_reference = registered_data_set_reference
        self.saved_data_set_reference = saved_data_set_reference
        self.additional_transformations = additional_transformations


class AmlK8SConfiguration(msrest.serialization.Model):
    """AmlK8SConfiguration.

    :ivar resource_configuration:
    :vartype resource_configuration: ~designer.models.ResourceConfiguration
    :ivar priority_configuration:
    :vartype priority_configuration: ~designer.models.AmlK8SPriorityConfiguration
    :ivar interactive_configuration:
    :vartype interactive_configuration: ~designer.models.InteractiveConfiguration
    """

    _attribute_map = {
        'resource_configuration': {'key': 'resourceConfiguration', 'type': 'ResourceConfiguration'},
        'priority_configuration': {'key': 'priorityConfiguration', 'type': 'AmlK8SPriorityConfiguration'},
        'interactive_configuration': {'key': 'interactiveConfiguration', 'type': 'InteractiveConfiguration'},
    }

    def __init__(
        self,
        *,
        resource_configuration: Optional["ResourceConfiguration"] = None,
        priority_configuration: Optional["AmlK8SPriorityConfiguration"] = None,
        interactive_configuration: Optional["InteractiveConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword resource_configuration:
        :paramtype resource_configuration: ~designer.models.ResourceConfiguration
        :keyword priority_configuration:
        :paramtype priority_configuration: ~designer.models.AmlK8SPriorityConfiguration
        :keyword interactive_configuration:
        :paramtype interactive_configuration: ~designer.models.InteractiveConfiguration
        """
        super(AmlK8SConfiguration, self).__init__(**kwargs)
        self.resource_configuration = resource_configuration
        self.priority_configuration = priority_configuration
        self.interactive_configuration = interactive_configuration


class AmlK8SPriorityConfiguration(msrest.serialization.Model):
    """AmlK8SPriorityConfiguration.

    :ivar job_priority:
    :vartype job_priority: int
    :ivar is_preemptible:
    :vartype is_preemptible: bool
    :ivar node_count_set:
    :vartype node_count_set: list[int]
    :ivar scale_interval:
    :vartype scale_interval: int
    """

    _attribute_map = {
        'job_priority': {'key': 'jobPriority', 'type': 'int'},
        'is_preemptible': {'key': 'isPreemptible', 'type': 'bool'},
        'node_count_set': {'key': 'nodeCountSet', 'type': '[int]'},
        'scale_interval': {'key': 'scaleInterval', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        job_priority: Optional[int] = None,
        is_preemptible: Optional[bool] = None,
        node_count_set: Optional[List[int]] = None,
        scale_interval: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword job_priority:
        :paramtype job_priority: int
        :keyword is_preemptible:
        :paramtype is_preemptible: bool
        :keyword node_count_set:
        :paramtype node_count_set: list[int]
        :keyword scale_interval:
        :paramtype scale_interval: int
        """
        super(AmlK8SPriorityConfiguration, self).__init__(**kwargs)
        self.job_priority = job_priority
        self.is_preemptible = is_preemptible
        self.node_count_set = node_count_set
        self.scale_interval = scale_interval


class AmlModuleDetails(msrest.serialization.Model):
    """AmlModuleDetails.

    :ivar module_entity:
    :vartype module_entity: ~designer.models.ModuleEntity
    :ivar versions:
    :vartype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
    :ivar default_version:
    :vartype default_version: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar category:
    :vartype category: str
    :ivar name:
    :vartype name: str
    :ivar hash:
    :vartype hash: str
    :ivar description:
    :vartype description: str
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'module_entity': {'key': 'moduleEntity', 'type': 'ModuleEntity'},
        'versions': {'key': 'versions', 'type': '[AzureMLModuleVersionDescriptor]'},
        'default_version': {'key': 'defaultVersion', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'category': {'key': 'category', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'hash': {'key': 'hash', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        module_entity: Optional["ModuleEntity"] = None,
        versions: Optional[List["AzureMLModuleVersionDescriptor"]] = None,
        default_version: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        category: Optional[str] = None,
        name: Optional[str] = None,
        hash: Optional[str] = None,
        description: Optional[str] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword module_entity:
        :paramtype module_entity: ~designer.models.ModuleEntity
        :keyword versions:
        :paramtype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
        :keyword default_version:
        :paramtype default_version: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword category:
        :paramtype category: str
        :keyword name:
        :paramtype name: str
        :keyword hash:
        :paramtype hash: str
        :keyword description:
        :paramtype description: str
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(AmlModuleDetails, self).__init__(**kwargs)
        self.module_entity = module_entity
        self.versions = versions
        self.default_version = default_version
        self.tags = tags
        self.properties = properties
        self.category = category
        self.name = name
        self.hash = hash
        self.description = description
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class AmlModuleNameAndDefaultVersion(msrest.serialization.Model):
    """AmlModuleNameAndDefaultVersion.

    :ivar module_namespace:
    :vartype module_namespace: str
    :ivar module_name:
    :vartype module_name: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'module_namespace': {'key': 'moduleNamespace', 'type': 'str'},
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_namespace: Optional[str] = None,
        module_name: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword module_namespace:
        :paramtype module_namespace: str
        :keyword module_name:
        :paramtype module_name: str
        :keyword version:
        :paramtype version: str
        """
        super(AmlModuleNameAndDefaultVersion, self).__init__(**kwargs)
        self.module_namespace = module_namespace
        self.module_name = module_name
        self.version = version


class AmlModuleNameMetaInfo(msrest.serialization.Model):
    """AmlModuleNameMetaInfo.

    :ivar module_namespace:
    :vartype module_namespace: str
    :ivar module_name:
    :vartype module_name: str
    :ivar module_version:
    :vartype module_version: str
    """

    _attribute_map = {
        'module_namespace': {'key': 'moduleNamespace', 'type': 'str'},
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_namespace: Optional[str] = None,
        module_name: Optional[str] = None,
        module_version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword module_namespace:
        :paramtype module_namespace: str
        :keyword module_name:
        :paramtype module_name: str
        :keyword module_version:
        :paramtype module_version: str
        """
        super(AmlModuleNameMetaInfo, self).__init__(**kwargs)
        self.module_namespace = module_namespace
        self.module_name = module_name
        self.module_version = module_version


class APCloudConfiguration(msrest.serialization.Model):
    """APCloudConfiguration.

    :ivar referenced_ap_module_guid:
    :vartype referenced_ap_module_guid: str
    :ivar user_alias:
    :vartype user_alias: str
    """

    _attribute_map = {
        'referenced_ap_module_guid': {'key': 'referencedAPModuleGuid', 'type': 'str'},
        'user_alias': {'key': 'userAlias', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        referenced_ap_module_guid: Optional[str] = None,
        user_alias: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword referenced_ap_module_guid:
        :paramtype referenced_ap_module_guid: str
        :keyword user_alias:
        :paramtype user_alias: str
        """
        super(APCloudConfiguration, self).__init__(**kwargs)
        self.referenced_ap_module_guid = referenced_ap_module_guid
        self.user_alias = user_alias


class ApplicationEndpointConfiguration(msrest.serialization.Model):
    """ApplicationEndpointConfiguration.

    :ivar type: Possible values include: "Jupyter", "JupyterLab", "SSH", "TensorBoard", "VSCode",
     "Theia", "Grafana", "Custom".
    :vartype type: str or ~designer.models.ApplicationEndpointType
    :ivar port:
    :vartype port: int
    :ivar properties: Dictionary of :code:`<string>`.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'port': {'key': 'port', 'type': 'int'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        type: Optional[Union[str, "ApplicationEndpointType"]] = None,
        port: Optional[int] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword type: Possible values include: "Jupyter", "JupyterLab", "SSH", "TensorBoard",
         "VSCode", "Theia", "Grafana", "Custom".
        :paramtype type: str or ~designer.models.ApplicationEndpointType
        :keyword port:
        :paramtype port: int
        :keyword properties: Dictionary of :code:`<string>`.
        :paramtype properties: dict[str, str]
        """
        super(ApplicationEndpointConfiguration, self).__init__(**kwargs)
        self.type = type
        self.port = port
        self.properties = properties


class ArgumentAssignment(msrest.serialization.Model):
    """ArgumentAssignment.

    :ivar value_type: Possible values include: "Literal", "Parameter", "Input", "Output",
     "NestedList", "StringInterpolationList".
    :vartype value_type: str or ~designer.models.ArgumentValueType
    :ivar value:
    :vartype value: str
    :ivar nested_argument_list:
    :vartype nested_argument_list: list[~designer.models.ArgumentAssignment]
    :ivar string_interpolation_argument_list:
    :vartype string_interpolation_argument_list: list[~designer.models.ArgumentAssignment]
    """

    _attribute_map = {
        'value_type': {'key': 'valueType', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
        'nested_argument_list': {'key': 'nestedArgumentList', 'type': '[ArgumentAssignment]'},
        'string_interpolation_argument_list': {'key': 'stringInterpolationArgumentList', 'type': '[ArgumentAssignment]'},
    }

    def __init__(
        self,
        *,
        value_type: Optional[Union[str, "ArgumentValueType"]] = None,
        value: Optional[str] = None,
        nested_argument_list: Optional[List["ArgumentAssignment"]] = None,
        string_interpolation_argument_list: Optional[List["ArgumentAssignment"]] = None,
        **kwargs
    ):
        """
        :keyword value_type: Possible values include: "Literal", "Parameter", "Input", "Output",
         "NestedList", "StringInterpolationList".
        :paramtype value_type: str or ~designer.models.ArgumentValueType
        :keyword value:
        :paramtype value: str
        :keyword nested_argument_list:
        :paramtype nested_argument_list: list[~designer.models.ArgumentAssignment]
        :keyword string_interpolation_argument_list:
        :paramtype string_interpolation_argument_list: list[~designer.models.ArgumentAssignment]
        """
        super(ArgumentAssignment, self).__init__(**kwargs)
        self.value_type = value_type
        self.value = value
        self.nested_argument_list = nested_argument_list
        self.string_interpolation_argument_list = string_interpolation_argument_list


class Asset(msrest.serialization.Model):
    """Asset.

    :ivar asset_id:
    :vartype asset_id: str
    :ivar type:
    :vartype type: str
    """

    _attribute_map = {
        'asset_id': {'key': 'assetId', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        asset_id: Optional[str] = None,
        type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword asset_id:
        :paramtype asset_id: str
        :keyword type:
        :paramtype type: str
        """
        super(Asset, self).__init__(**kwargs)
        self.asset_id = asset_id
        self.type = type


class AssetNameAndVersionIdentifier(msrest.serialization.Model):
    """AssetNameAndVersionIdentifier.

    :ivar asset_name:
    :vartype asset_name: str
    :ivar version:
    :vartype version: str
    :ivar feed_name:
    :vartype feed_name: str
    """

    _attribute_map = {
        'asset_name': {'key': 'assetName', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        asset_name: Optional[str] = None,
        version: Optional[str] = None,
        feed_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword version:
        :paramtype version: str
        :keyword feed_name:
        :paramtype feed_name: str
        """
        super(AssetNameAndVersionIdentifier, self).__init__(**kwargs)
        self.asset_name = asset_name
        self.version = version
        self.feed_name = feed_name


class AssetOutputSettings(msrest.serialization.Model):
    """AssetOutputSettings.

    :ivar path:
    :vartype path: str
    :ivar type: Possible values include: "UriFile", "UriFolder", "MLTable", "CustomModel",
     "MLFlowModel", "TritonModel", "OpenAIModel".
    :vartype type: str or ~designer.models.AEVAAssetType
    :ivar options: This is a dictionary.
    :vartype options: dict[str, str]
    """

    _attribute_map = {
        'path': {'key': 'path', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
        'options': {'key': 'options', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        path: Optional[str] = None,
        type: Optional[Union[str, "AEVAAssetType"]] = None,
        options: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword path:
        :paramtype path: str
        :keyword type: Possible values include: "UriFile", "UriFolder", "MLTable", "CustomModel",
         "MLFlowModel", "TritonModel", "OpenAIModel".
        :paramtype type: str or ~designer.models.AEVAAssetType
        :keyword options: This is a dictionary.
        :paramtype options: dict[str, str]
        """
        super(AssetOutputSettings, self).__init__(**kwargs)
        self.path = path
        self.type = type
        self.options = options


class AssetPublishResult(msrest.serialization.Model):
    """AssetPublishResult.

    :ivar feed_name:
    :vartype feed_name: str
    :ivar asset_name:
    :vartype asset_name: str
    :ivar asset_version:
    :vartype asset_version: str
    :ivar step_name:
    :vartype step_name: str
    :ivar status:
    :vartype status: str
    :ivar error_message:
    :vartype error_message: str
    :ivar created_time:
    :vartype created_time: ~datetime.datetime
    :ivar last_updated_time:
    :vartype last_updated_time: ~datetime.datetime
    :ivar regional_publish_results: Dictionary of :code:`<AssetPublishSingleRegionResult>`.
    :vartype regional_publish_results: dict[str, ~designer.models.AssetPublishSingleRegionResult]
    """

    _attribute_map = {
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'asset_name': {'key': 'assetName', 'type': 'str'},
        'asset_version': {'key': 'assetVersion', 'type': 'str'},
        'step_name': {'key': 'stepName', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'last_updated_time': {'key': 'lastUpdatedTime', 'type': 'iso-8601'},
        'regional_publish_results': {'key': 'regionalPublishResults', 'type': '{AssetPublishSingleRegionResult}'},
    }

    def __init__(
        self,
        *,
        feed_name: Optional[str] = None,
        asset_name: Optional[str] = None,
        asset_version: Optional[str] = None,
        step_name: Optional[str] = None,
        status: Optional[str] = None,
        error_message: Optional[str] = None,
        created_time: Optional[datetime.datetime] = None,
        last_updated_time: Optional[datetime.datetime] = None,
        regional_publish_results: Optional[Dict[str, "AssetPublishSingleRegionResult"]] = None,
        **kwargs
    ):
        """
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword asset_version:
        :paramtype asset_version: str
        :keyword step_name:
        :paramtype step_name: str
        :keyword status:
        :paramtype status: str
        :keyword error_message:
        :paramtype error_message: str
        :keyword created_time:
        :paramtype created_time: ~datetime.datetime
        :keyword last_updated_time:
        :paramtype last_updated_time: ~datetime.datetime
        :keyword regional_publish_results: Dictionary of :code:`<AssetPublishSingleRegionResult>`.
        :paramtype regional_publish_results: dict[str, ~designer.models.AssetPublishSingleRegionResult]
        """
        super(AssetPublishResult, self).__init__(**kwargs)
        self.feed_name = feed_name
        self.asset_name = asset_name
        self.asset_version = asset_version
        self.step_name = step_name
        self.status = status
        self.error_message = error_message
        self.created_time = created_time
        self.last_updated_time = last_updated_time
        self.regional_publish_results = regional_publish_results


class AssetPublishSingleRegionResult(msrest.serialization.Model):
    """AssetPublishSingleRegionResult.

    :ivar step_name:
    :vartype step_name: str
    :ivar status:
    :vartype status: str
    :ivar error_message:
    :vartype error_message: str
    :ivar last_updated_time:
    :vartype last_updated_time: ~datetime.datetime
    :ivar total_steps:
    :vartype total_steps: int
    :ivar finished_steps:
    :vartype finished_steps: int
    :ivar remaining_steps:
    :vartype remaining_steps: int
    """

    _attribute_map = {
        'step_name': {'key': 'stepName', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
        'last_updated_time': {'key': 'lastUpdatedTime', 'type': 'iso-8601'},
        'total_steps': {'key': 'totalSteps', 'type': 'int'},
        'finished_steps': {'key': 'finishedSteps', 'type': 'int'},
        'remaining_steps': {'key': 'remainingSteps', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        step_name: Optional[str] = None,
        status: Optional[str] = None,
        error_message: Optional[str] = None,
        last_updated_time: Optional[datetime.datetime] = None,
        total_steps: Optional[int] = None,
        finished_steps: Optional[int] = None,
        remaining_steps: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword step_name:
        :paramtype step_name: str
        :keyword status:
        :paramtype status: str
        :keyword error_message:
        :paramtype error_message: str
        :keyword last_updated_time:
        :paramtype last_updated_time: ~datetime.datetime
        :keyword total_steps:
        :paramtype total_steps: int
        :keyword finished_steps:
        :paramtype finished_steps: int
        :keyword remaining_steps:
        :paramtype remaining_steps: int
        """
        super(AssetPublishSingleRegionResult, self).__init__(**kwargs)
        self.step_name = step_name
        self.status = status
        self.error_message = error_message
        self.last_updated_time = last_updated_time
        self.total_steps = total_steps
        self.finished_steps = finished_steps
        self.remaining_steps = remaining_steps


class AssetReference(msrest.serialization.Model):
    """AssetReference.

    :ivar path:
    :vartype path: str
    :ivar type: Possible values include: "UriFile", "UriFolder", "MLTable", "CustomModel",
     "MLFlowModel", "TritonModel", "OpenAIModel".
    :vartype type: str or ~designer.models.AEVAAssetType
    :ivar asset_id:
    :vartype asset_id: str
    """

    _attribute_map = {
        'path': {'key': 'path', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
        'asset_id': {'key': 'assetId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        path: Optional[str] = None,
        type: Optional[Union[str, "AEVAAssetType"]] = None,
        asset_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword path:
        :paramtype path: str
        :keyword type: Possible values include: "UriFile", "UriFolder", "MLTable", "CustomModel",
         "MLFlowModel", "TritonModel", "OpenAIModel".
        :paramtype type: str or ~designer.models.AEVAAssetType
        :keyword asset_id:
        :paramtype asset_id: str
        """
        super(AssetReference, self).__init__(**kwargs)
        self.path = path
        self.type = type
        self.asset_id = asset_id


class AssetTypeMetaInfo(msrest.serialization.Model):
    """AssetTypeMetaInfo.

    :ivar consumption_mode: Possible values include: "Reference", "Copy", "CopyAndAutoUpgrade".
    :vartype consumption_mode: str or ~designer.models.ConsumeMode
    """

    _attribute_map = {
        'consumption_mode': {'key': 'consumptionMode', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        consumption_mode: Optional[Union[str, "ConsumeMode"]] = None,
        **kwargs
    ):
        """
        :keyword consumption_mode: Possible values include: "Reference", "Copy", "CopyAndAutoUpgrade".
        :paramtype consumption_mode: str or ~designer.models.ConsumeMode
        """
        super(AssetTypeMetaInfo, self).__init__(**kwargs)
        self.consumption_mode = consumption_mode


class AssetVersionPublishRequest(msrest.serialization.Model):
    """AssetVersionPublishRequest.

    :ivar asset_type: Possible values include: "Component", "Model", "Environment", "Dataset",
     "DataStore", "SampleGraph".
    :vartype asset_type: str or ~designer.models.AssetType
    :ivar asset_source_type: Possible values include: "Unknown", "Local", "GithubFile",
     "GithubFolder", "DevopsArtifactsZip".
    :vartype asset_source_type: str or ~designer.models.AssetSourceType
    :ivar yaml_file:
    :vartype yaml_file: str
    :ivar source_zip_url:
    :vartype source_zip_url: str
    :ivar source_zip_file:
    :vartype source_zip_file: IO
    :ivar feed_name:
    :vartype feed_name: str
    :ivar set_as_default_version:
    :vartype set_as_default_version: bool
    :ivar referenced_assets:
    :vartype referenced_assets: list[~designer.models.AssetNameAndVersionIdentifier]
    """

    _attribute_map = {
        'asset_type': {'key': 'assetType', 'type': 'str'},
        'asset_source_type': {'key': 'assetSourceType', 'type': 'str'},
        'yaml_file': {'key': 'yamlFile', 'type': 'str'},
        'source_zip_url': {'key': 'sourceZipUrl', 'type': 'str'},
        'source_zip_file': {'key': 'sourceZipFile', 'type': 'IO'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'set_as_default_version': {'key': 'setAsDefaultVersion', 'type': 'bool'},
        'referenced_assets': {'key': 'referencedAssets', 'type': '[AssetNameAndVersionIdentifier]'},
    }

    def __init__(
        self,
        *,
        asset_type: Optional[Union[str, "AssetType"]] = None,
        asset_source_type: Optional[Union[str, "AssetSourceType"]] = None,
        yaml_file: Optional[str] = None,
        source_zip_url: Optional[str] = None,
        source_zip_file: Optional[IO] = None,
        feed_name: Optional[str] = None,
        set_as_default_version: Optional[bool] = None,
        referenced_assets: Optional[List["AssetNameAndVersionIdentifier"]] = None,
        **kwargs
    ):
        """
        :keyword asset_type: Possible values include: "Component", "Model", "Environment", "Dataset",
         "DataStore", "SampleGraph".
        :paramtype asset_type: str or ~designer.models.AssetType
        :keyword asset_source_type: Possible values include: "Unknown", "Local", "GithubFile",
         "GithubFolder", "DevopsArtifactsZip".
        :paramtype asset_source_type: str or ~designer.models.AssetSourceType
        :keyword yaml_file:
        :paramtype yaml_file: str
        :keyword source_zip_url:
        :paramtype source_zip_url: str
        :keyword source_zip_file:
        :paramtype source_zip_file: IO
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword set_as_default_version:
        :paramtype set_as_default_version: bool
        :keyword referenced_assets:
        :paramtype referenced_assets: list[~designer.models.AssetNameAndVersionIdentifier]
        """
        super(AssetVersionPublishRequest, self).__init__(**kwargs)
        self.asset_type = asset_type
        self.asset_source_type = asset_source_type
        self.yaml_file = yaml_file
        self.source_zip_url = source_zip_url
        self.source_zip_file = source_zip_file
        self.feed_name = feed_name
        self.set_as_default_version = set_as_default_version
        self.referenced_assets = referenced_assets


class AuthKeys(msrest.serialization.Model):
    """AuthKeys.

    :ivar primary_key:
    :vartype primary_key: str
    :ivar secondary_key:
    :vartype secondary_key: str
    """

    _attribute_map = {
        'primary_key': {'key': 'primaryKey', 'type': 'str'},
        'secondary_key': {'key': 'secondaryKey', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        primary_key: Optional[str] = None,
        secondary_key: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword primary_key:
        :paramtype primary_key: str
        :keyword secondary_key:
        :paramtype secondary_key: str
        """
        super(AuthKeys, self).__init__(**kwargs)
        self.primary_key = primary_key
        self.secondary_key = secondary_key


class AutoClusterComputeSpecification(msrest.serialization.Model):
    """AutoClusterComputeSpecification.

    :ivar instance_size:
    :vartype instance_size: str
    :ivar instance_priority:
    :vartype instance_priority: str
    :ivar os_type:
    :vartype os_type: str
    :ivar location:
    :vartype location: str
    """

    _attribute_map = {
        'instance_size': {'key': 'instanceSize', 'type': 'str'},
        'instance_priority': {'key': 'instancePriority', 'type': 'str'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        instance_size: Optional[str] = None,
        instance_priority: Optional[str] = None,
        os_type: Optional[str] = None,
        location: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword instance_size:
        :paramtype instance_size: str
        :keyword instance_priority:
        :paramtype instance_priority: str
        :keyword os_type:
        :paramtype os_type: str
        :keyword location:
        :paramtype location: str
        """
        super(AutoClusterComputeSpecification, self).__init__(**kwargs)
        self.instance_size = instance_size
        self.instance_priority = instance_priority
        self.os_type = os_type
        self.location = location


class AutoFeaturizeConfiguration(msrest.serialization.Model):
    """AutoFeaturizeConfiguration.

    :ivar featurization_config:
    :vartype featurization_config: ~designer.models.FeaturizationConfig
    :ivar enable_dnn_featurization:
    :vartype enable_dnn_featurization: bool
    """

    _attribute_map = {
        'featurization_config': {'key': 'featurizationConfig', 'type': 'FeaturizationConfig'},
        'enable_dnn_featurization': {'key': 'enableDnnFeaturization', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        featurization_config: Optional["FeaturizationConfig"] = None,
        enable_dnn_featurization: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword featurization_config:
        :paramtype featurization_config: ~designer.models.FeaturizationConfig
        :keyword enable_dnn_featurization:
        :paramtype enable_dnn_featurization: bool
        """
        super(AutoFeaturizeConfiguration, self).__init__(**kwargs)
        self.featurization_config = featurization_config
        self.enable_dnn_featurization = enable_dnn_featurization


class AutoMLComponentConfiguration(msrest.serialization.Model):
    """AutoMLComponentConfiguration.

    :ivar auto_train_config:
    :vartype auto_train_config: ~designer.models.AutoTrainConfiguration
    :ivar auto_featurize_config:
    :vartype auto_featurize_config: ~designer.models.AutoFeaturizeConfiguration
    """

    _attribute_map = {
        'auto_train_config': {'key': 'autoTrainConfig', 'type': 'AutoTrainConfiguration'},
        'auto_featurize_config': {'key': 'autoFeaturizeConfig', 'type': 'AutoFeaturizeConfiguration'},
    }

    def __init__(
        self,
        *,
        auto_train_config: Optional["AutoTrainConfiguration"] = None,
        auto_featurize_config: Optional["AutoFeaturizeConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword auto_train_config:
        :paramtype auto_train_config: ~designer.models.AutoTrainConfiguration
        :keyword auto_featurize_config:
        :paramtype auto_featurize_config: ~designer.models.AutoFeaturizeConfiguration
        """
        super(AutoMLComponentConfiguration, self).__init__(**kwargs)
        self.auto_train_config = auto_train_config
        self.auto_featurize_config = auto_featurize_config


class AutoScaler(msrest.serialization.Model):
    """AutoScaler.

    :ivar autoscale_enabled:
    :vartype autoscale_enabled: bool
    :ivar min_replicas:
    :vartype min_replicas: int
    :ivar max_replicas:
    :vartype max_replicas: int
    :ivar target_utilization:
    :vartype target_utilization: int
    :ivar refresh_period_in_seconds:
    :vartype refresh_period_in_seconds: int
    """

    _attribute_map = {
        'autoscale_enabled': {'key': 'autoscaleEnabled', 'type': 'bool'},
        'min_replicas': {'key': 'minReplicas', 'type': 'int'},
        'max_replicas': {'key': 'maxReplicas', 'type': 'int'},
        'target_utilization': {'key': 'targetUtilization', 'type': 'int'},
        'refresh_period_in_seconds': {'key': 'refreshPeriodInSeconds', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        autoscale_enabled: Optional[bool] = None,
        min_replicas: Optional[int] = None,
        max_replicas: Optional[int] = None,
        target_utilization: Optional[int] = None,
        refresh_period_in_seconds: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword autoscale_enabled:
        :paramtype autoscale_enabled: bool
        :keyword min_replicas:
        :paramtype min_replicas: int
        :keyword max_replicas:
        :paramtype max_replicas: int
        :keyword target_utilization:
        :paramtype target_utilization: int
        :keyword refresh_period_in_seconds:
        :paramtype refresh_period_in_seconds: int
        """
        super(AutoScaler, self).__init__(**kwargs)
        self.autoscale_enabled = autoscale_enabled
        self.min_replicas = min_replicas
        self.max_replicas = max_replicas
        self.target_utilization = target_utilization
        self.refresh_period_in_seconds = refresh_period_in_seconds


class AutoTrainConfiguration(msrest.serialization.Model):
    """AutoTrainConfiguration.

    :ivar general_settings:
    :vartype general_settings: ~designer.models.GeneralSettings
    :ivar limit_settings:
    :vartype limit_settings: ~designer.models.LimitSettings
    :ivar data_settings:
    :vartype data_settings: ~designer.models.DataSettings
    :ivar forecasting_settings:
    :vartype forecasting_settings: ~designer.models.ForecastingSettings
    :ivar training_settings:
    :vartype training_settings: ~designer.models.TrainingSettings
    """

    _attribute_map = {
        'general_settings': {'key': 'generalSettings', 'type': 'GeneralSettings'},
        'limit_settings': {'key': 'limitSettings', 'type': 'LimitSettings'},
        'data_settings': {'key': 'dataSettings', 'type': 'DataSettings'},
        'forecasting_settings': {'key': 'forecastingSettings', 'type': 'ForecastingSettings'},
        'training_settings': {'key': 'trainingSettings', 'type': 'TrainingSettings'},
    }

    def __init__(
        self,
        *,
        general_settings: Optional["GeneralSettings"] = None,
        limit_settings: Optional["LimitSettings"] = None,
        data_settings: Optional["DataSettings"] = None,
        forecasting_settings: Optional["ForecastingSettings"] = None,
        training_settings: Optional["TrainingSettings"] = None,
        **kwargs
    ):
        """
        :keyword general_settings:
        :paramtype general_settings: ~designer.models.GeneralSettings
        :keyword limit_settings:
        :paramtype limit_settings: ~designer.models.LimitSettings
        :keyword data_settings:
        :paramtype data_settings: ~designer.models.DataSettings
        :keyword forecasting_settings:
        :paramtype forecasting_settings: ~designer.models.ForecastingSettings
        :keyword training_settings:
        :paramtype training_settings: ~designer.models.TrainingSettings
        """
        super(AutoTrainConfiguration, self).__init__(**kwargs)
        self.general_settings = general_settings
        self.limit_settings = limit_settings
        self.data_settings = data_settings
        self.forecasting_settings = forecasting_settings
        self.training_settings = training_settings


class AzureBlobReference(msrest.serialization.Model):
    """AzureBlobReference.

    :ivar container:
    :vartype container: str
    :ivar sas_token:
    :vartype sas_token: str
    :ivar uri:
    :vartype uri: str
    :ivar account:
    :vartype account: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'container': {'key': 'container', 'type': 'str'},
        'sas_token': {'key': 'sasToken', 'type': 'str'},
        'uri': {'key': 'uri', 'type': 'str'},
        'account': {'key': 'account', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        container: Optional[str] = None,
        sas_token: Optional[str] = None,
        uri: Optional[str] = None,
        account: Optional[str] = None,
        relative_path: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword container:
        :paramtype container: str
        :keyword sas_token:
        :paramtype sas_token: str
        :keyword uri:
        :paramtype uri: str
        :keyword account:
        :paramtype account: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(AzureBlobReference, self).__init__(**kwargs)
        self.container = container
        self.sas_token = sas_token
        self.uri = uri
        self.account = account
        self.relative_path = relative_path
        self.aml_data_store_name = aml_data_store_name


class AzureDatabaseReference(msrest.serialization.Model):
    """AzureDatabaseReference.

    :ivar table_name:
    :vartype table_name: str
    :ivar sql_query:
    :vartype sql_query: str
    :ivar stored_procedure_name:
    :vartype stored_procedure_name: str
    :ivar stored_procedure_parameters:
    :vartype stored_procedure_parameters: list[~designer.models.StoredProcedureParameter]
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'table_name': {'key': 'tableName', 'type': 'str'},
        'sql_query': {'key': 'sqlQuery', 'type': 'str'},
        'stored_procedure_name': {'key': 'storedProcedureName', 'type': 'str'},
        'stored_procedure_parameters': {'key': 'storedProcedureParameters', 'type': '[StoredProcedureParameter]'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        table_name: Optional[str] = None,
        sql_query: Optional[str] = None,
        stored_procedure_name: Optional[str] = None,
        stored_procedure_parameters: Optional[List["StoredProcedureParameter"]] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword table_name:
        :paramtype table_name: str
        :keyword sql_query:
        :paramtype sql_query: str
        :keyword stored_procedure_name:
        :paramtype stored_procedure_name: str
        :keyword stored_procedure_parameters:
        :paramtype stored_procedure_parameters: list[~designer.models.StoredProcedureParameter]
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(AzureDatabaseReference, self).__init__(**kwargs)
        self.table_name = table_name
        self.sql_query = sql_query
        self.stored_procedure_name = stored_procedure_name
        self.stored_procedure_parameters = stored_procedure_parameters
        self.aml_data_store_name = aml_data_store_name


class AzureDataLakeGen2Reference(msrest.serialization.Model):
    """AzureDataLakeGen2Reference.

    :ivar file_system_name:
    :vartype file_system_name: str
    :ivar uri:
    :vartype uri: str
    :ivar account:
    :vartype account: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'file_system_name': {'key': 'fileSystemName', 'type': 'str'},
        'uri': {'key': 'uri', 'type': 'str'},
        'account': {'key': 'account', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        file_system_name: Optional[str] = None,
        uri: Optional[str] = None,
        account: Optional[str] = None,
        relative_path: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword file_system_name:
        :paramtype file_system_name: str
        :keyword uri:
        :paramtype uri: str
        :keyword account:
        :paramtype account: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(AzureDataLakeGen2Reference, self).__init__(**kwargs)
        self.file_system_name = file_system_name
        self.uri = uri
        self.account = account
        self.relative_path = relative_path
        self.aml_data_store_name = aml_data_store_name


class AzureDataLakeReference(msrest.serialization.Model):
    """AzureDataLakeReference.

    :ivar tenant:
    :vartype tenant: str
    :ivar subscription:
    :vartype subscription: str
    :ivar resource_group:
    :vartype resource_group: str
    :ivar uri:
    :vartype uri: str
    :ivar account:
    :vartype account: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'tenant': {'key': 'tenant', 'type': 'str'},
        'subscription': {'key': 'subscription', 'type': 'str'},
        'resource_group': {'key': 'resourceGroup', 'type': 'str'},
        'uri': {'key': 'uri', 'type': 'str'},
        'account': {'key': 'account', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        tenant: Optional[str] = None,
        subscription: Optional[str] = None,
        resource_group: Optional[str] = None,
        uri: Optional[str] = None,
        account: Optional[str] = None,
        relative_path: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword tenant:
        :paramtype tenant: str
        :keyword subscription:
        :paramtype subscription: str
        :keyword resource_group:
        :paramtype resource_group: str
        :keyword uri:
        :paramtype uri: str
        :keyword account:
        :paramtype account: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(AzureDataLakeReference, self).__init__(**kwargs)
        self.tenant = tenant
        self.subscription = subscription
        self.resource_group = resource_group
        self.uri = uri
        self.account = account
        self.relative_path = relative_path
        self.aml_data_store_name = aml_data_store_name


class AzureFilesReference(msrest.serialization.Model):
    """AzureFilesReference.

    :ivar share:
    :vartype share: str
    :ivar uri:
    :vartype uri: str
    :ivar account:
    :vartype account: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'share': {'key': 'share', 'type': 'str'},
        'uri': {'key': 'uri', 'type': 'str'},
        'account': {'key': 'account', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        share: Optional[str] = None,
        uri: Optional[str] = None,
        account: Optional[str] = None,
        relative_path: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword share:
        :paramtype share: str
        :keyword uri:
        :paramtype uri: str
        :keyword account:
        :paramtype account: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(AzureFilesReference, self).__init__(**kwargs)
        self.share = share
        self.uri = uri
        self.account = account
        self.relative_path = relative_path
        self.aml_data_store_name = aml_data_store_name


class AzureMLModuleVersionDescriptor(msrest.serialization.Model):
    """AzureMLModuleVersionDescriptor.

    :ivar module_version_id:
    :vartype module_version_id: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'module_version_id': {'key': 'moduleVersionId', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_version_id: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword module_version_id:
        :paramtype module_version_id: str
        :keyword version:
        :paramtype version: str
        """
        super(AzureMLModuleVersionDescriptor, self).__init__(**kwargs)
        self.module_version_id = module_version_id
        self.version = version


class BatchAiComputeInfo(msrest.serialization.Model):
    """BatchAiComputeInfo.

    :ivar batch_ai_subscription_id:
    :vartype batch_ai_subscription_id: str
    :ivar batch_ai_resource_group:
    :vartype batch_ai_resource_group: str
    :ivar batch_ai_workspace_name:
    :vartype batch_ai_workspace_name: str
    :ivar cluster_name:
    :vartype cluster_name: str
    :ivar native_shared_directory:
    :vartype native_shared_directory: str
    """

    _attribute_map = {
        'batch_ai_subscription_id': {'key': 'batchAiSubscriptionId', 'type': 'str'},
        'batch_ai_resource_group': {'key': 'batchAiResourceGroup', 'type': 'str'},
        'batch_ai_workspace_name': {'key': 'batchAiWorkspaceName', 'type': 'str'},
        'cluster_name': {'key': 'clusterName', 'type': 'str'},
        'native_shared_directory': {'key': 'nativeSharedDirectory', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        batch_ai_subscription_id: Optional[str] = None,
        batch_ai_resource_group: Optional[str] = None,
        batch_ai_workspace_name: Optional[str] = None,
        cluster_name: Optional[str] = None,
        native_shared_directory: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword batch_ai_subscription_id:
        :paramtype batch_ai_subscription_id: str
        :keyword batch_ai_resource_group:
        :paramtype batch_ai_resource_group: str
        :keyword batch_ai_workspace_name:
        :paramtype batch_ai_workspace_name: str
        :keyword cluster_name:
        :paramtype cluster_name: str
        :keyword native_shared_directory:
        :paramtype native_shared_directory: str
        """
        super(BatchAiComputeInfo, self).__init__(**kwargs)
        self.batch_ai_subscription_id = batch_ai_subscription_id
        self.batch_ai_resource_group = batch_ai_resource_group
        self.batch_ai_workspace_name = batch_ai_workspace_name
        self.cluster_name = cluster_name
        self.native_shared_directory = native_shared_directory


class BatchGetComponentRequest(msrest.serialization.Model):
    """BatchGetComponentRequest.

    :ivar version_ids:
    :vartype version_ids: list[str]
    :ivar name_and_versions:
    :vartype name_and_versions: list[~designer.models.ComponentNameMetaInfo]
    """

    _attribute_map = {
        'version_ids': {'key': 'versionIds', 'type': '[str]'},
        'name_and_versions': {'key': 'nameAndVersions', 'type': '[ComponentNameMetaInfo]'},
    }

    def __init__(
        self,
        *,
        version_ids: Optional[List[str]] = None,
        name_and_versions: Optional[List["ComponentNameMetaInfo"]] = None,
        **kwargs
    ):
        """
        :keyword version_ids:
        :paramtype version_ids: list[str]
        :keyword name_and_versions:
        :paramtype name_and_versions: list[~designer.models.ComponentNameMetaInfo]
        """
        super(BatchGetComponentRequest, self).__init__(**kwargs)
        self.version_ids = version_ids
        self.name_and_versions = name_and_versions


class BatchGetModuleRequest(msrest.serialization.Model):
    """BatchGetModuleRequest.

    :ivar module_version_ids:
    :vartype module_version_ids: list[str]
    :ivar aml_modules:
    :vartype aml_modules: list[~designer.models.AmlModuleNameMetaInfo]
    """

    _attribute_map = {
        'module_version_ids': {'key': 'moduleVersionIds', 'type': '[str]'},
        'aml_modules': {'key': 'amlModules', 'type': '[AmlModuleNameMetaInfo]'},
    }

    def __init__(
        self,
        *,
        module_version_ids: Optional[List[str]] = None,
        aml_modules: Optional[List["AmlModuleNameMetaInfo"]] = None,
        **kwargs
    ):
        """
        :keyword module_version_ids:
        :paramtype module_version_ids: list[str]
        :keyword aml_modules:
        :paramtype aml_modules: list[~designer.models.AmlModuleNameMetaInfo]
        """
        super(BatchGetModuleRequest, self).__init__(**kwargs)
        self.module_version_ids = module_version_ids
        self.aml_modules = aml_modules


class CloudPrioritySetting(msrest.serialization.Model):
    """CloudPrioritySetting.

    :ivar scope_priority:
    :vartype scope_priority: ~designer.models.PriorityConfiguration
    :ivar aml_compute_priority:
    :vartype aml_compute_priority: ~designer.models.PriorityConfiguration
    :ivar itp_priority:
    :vartype itp_priority: ~designer.models.PriorityConfiguration
    """

    _attribute_map = {
        'scope_priority': {'key': 'scopePriority', 'type': 'PriorityConfiguration'},
        'aml_compute_priority': {'key': 'AmlComputePriority', 'type': 'PriorityConfiguration'},
        'itp_priority': {'key': 'ItpPriority', 'type': 'PriorityConfiguration'},
    }

    def __init__(
        self,
        *,
        scope_priority: Optional["PriorityConfiguration"] = None,
        aml_compute_priority: Optional["PriorityConfiguration"] = None,
        itp_priority: Optional["PriorityConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword scope_priority:
        :paramtype scope_priority: ~designer.models.PriorityConfiguration
        :keyword aml_compute_priority:
        :paramtype aml_compute_priority: ~designer.models.PriorityConfiguration
        :keyword itp_priority:
        :paramtype itp_priority: ~designer.models.PriorityConfiguration
        """
        super(CloudPrioritySetting, self).__init__(**kwargs)
        self.scope_priority = scope_priority
        self.aml_compute_priority = aml_compute_priority
        self.itp_priority = itp_priority


class CloudSettings(msrest.serialization.Model):
    """CloudSettings.

    :ivar linked_settings:
    :vartype linked_settings: list[~designer.models.ParameterAssignment]
    :ivar priority_config:
    :vartype priority_config: ~designer.models.PriorityConfiguration
    :ivar hdi_run_config:
    :vartype hdi_run_config: ~designer.models.HdiRunConfiguration
    :ivar sub_graph_config:
    :vartype sub_graph_config: ~designer.models.SubGraphConfiguration
    :ivar auto_ml_component_config:
    :vartype auto_ml_component_config: ~designer.models.AutoMLComponentConfiguration
    :ivar ap_cloud_config:
    :vartype ap_cloud_config: ~designer.models.APCloudConfiguration
    :ivar scope_cloud_config:
    :vartype scope_cloud_config: ~designer.models.ScopeCloudConfiguration
    :ivar es_cloud_config:
    :vartype es_cloud_config: ~designer.models.EsCloudConfiguration
    :ivar data_transfer_cloud_config:
    :vartype data_transfer_cloud_config: ~designer.models.DataTransferCloudConfiguration
    """

    _attribute_map = {
        'linked_settings': {'key': 'linkedSettings', 'type': '[ParameterAssignment]'},
        'priority_config': {'key': 'priorityConfig', 'type': 'PriorityConfiguration'},
        'hdi_run_config': {'key': 'hdiRunConfig', 'type': 'HdiRunConfiguration'},
        'sub_graph_config': {'key': 'subGraphConfig', 'type': 'SubGraphConfiguration'},
        'auto_ml_component_config': {'key': 'autoMLComponentConfig', 'type': 'AutoMLComponentConfiguration'},
        'ap_cloud_config': {'key': 'apCloudConfig', 'type': 'APCloudConfiguration'},
        'scope_cloud_config': {'key': 'scopeCloudConfig', 'type': 'ScopeCloudConfiguration'},
        'es_cloud_config': {'key': 'esCloudConfig', 'type': 'EsCloudConfiguration'},
        'data_transfer_cloud_config': {'key': 'dataTransferCloudConfig', 'type': 'DataTransferCloudConfiguration'},
    }

    def __init__(
        self,
        *,
        linked_settings: Optional[List["ParameterAssignment"]] = None,
        priority_config: Optional["PriorityConfiguration"] = None,
        hdi_run_config: Optional["HdiRunConfiguration"] = None,
        sub_graph_config: Optional["SubGraphConfiguration"] = None,
        auto_ml_component_config: Optional["AutoMLComponentConfiguration"] = None,
        ap_cloud_config: Optional["APCloudConfiguration"] = None,
        scope_cloud_config: Optional["ScopeCloudConfiguration"] = None,
        es_cloud_config: Optional["EsCloudConfiguration"] = None,
        data_transfer_cloud_config: Optional["DataTransferCloudConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword linked_settings:
        :paramtype linked_settings: list[~designer.models.ParameterAssignment]
        :keyword priority_config:
        :paramtype priority_config: ~designer.models.PriorityConfiguration
        :keyword hdi_run_config:
        :paramtype hdi_run_config: ~designer.models.HdiRunConfiguration
        :keyword sub_graph_config:
        :paramtype sub_graph_config: ~designer.models.SubGraphConfiguration
        :keyword auto_ml_component_config:
        :paramtype auto_ml_component_config: ~designer.models.AutoMLComponentConfiguration
        :keyword ap_cloud_config:
        :paramtype ap_cloud_config: ~designer.models.APCloudConfiguration
        :keyword scope_cloud_config:
        :paramtype scope_cloud_config: ~designer.models.ScopeCloudConfiguration
        :keyword es_cloud_config:
        :paramtype es_cloud_config: ~designer.models.EsCloudConfiguration
        :keyword data_transfer_cloud_config:
        :paramtype data_transfer_cloud_config: ~designer.models.DataTransferCloudConfiguration
        """
        super(CloudSettings, self).__init__(**kwargs)
        self.linked_settings = linked_settings
        self.priority_config = priority_config
        self.hdi_run_config = hdi_run_config
        self.sub_graph_config = sub_graph_config
        self.auto_ml_component_config = auto_ml_component_config
        self.ap_cloud_config = ap_cloud_config
        self.scope_cloud_config = scope_cloud_config
        self.es_cloud_config = es_cloud_config
        self.data_transfer_cloud_config = data_transfer_cloud_config


class ColumnTransformer(msrest.serialization.Model):
    """ColumnTransformer.

    :ivar fields:
    :vartype fields: list[str]
    :ivar parameters: Dictionary of :code:`<any>`.
    :vartype parameters: dict[str, any]
    """

    _attribute_map = {
        'fields': {'key': 'fields', 'type': '[str]'},
        'parameters': {'key': 'parameters', 'type': '{object}'},
    }

    def __init__(
        self,
        *,
        fields: Optional[List[str]] = None,
        parameters: Optional[Dict[str, Any]] = None,
        **kwargs
    ):
        """
        :keyword fields:
        :paramtype fields: list[str]
        :keyword parameters: Dictionary of :code:`<any>`.
        :paramtype parameters: dict[str, any]
        """
        super(ColumnTransformer, self).__init__(**kwargs)
        self.fields = fields
        self.parameters = parameters


class CommandReturnCodeConfig(msrest.serialization.Model):
    """CommandReturnCodeConfig.

    :ivar return_code: Possible values include: "Zero", "ZeroOrGreater".
    :vartype return_code: str or ~designer.models.SuccessfulCommandReturnCode
    :ivar successful_return_codes:
    :vartype successful_return_codes: list[int]
    """

    _attribute_map = {
        'return_code': {'key': 'returnCode', 'type': 'str'},
        'successful_return_codes': {'key': 'successfulReturnCodes', 'type': '[int]'},
    }

    def __init__(
        self,
        *,
        return_code: Optional[Union[str, "SuccessfulCommandReturnCode"]] = None,
        successful_return_codes: Optional[List[int]] = None,
        **kwargs
    ):
        """
        :keyword return_code: Possible values include: "Zero", "ZeroOrGreater".
        :paramtype return_code: str or ~designer.models.SuccessfulCommandReturnCode
        :keyword successful_return_codes:
        :paramtype successful_return_codes: list[int]
        """
        super(CommandReturnCodeConfig, self).__init__(**kwargs)
        self.return_code = return_code
        self.successful_return_codes = successful_return_codes


class ComponentConfiguration(msrest.serialization.Model):
    """ComponentConfiguration.

    :ivar component_identifier:
    :vartype component_identifier: str
    """

    _attribute_map = {
        'component_identifier': {'key': 'componentIdentifier', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        component_identifier: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword component_identifier:
        :paramtype component_identifier: str
        """
        super(ComponentConfiguration, self).__init__(**kwargs)
        self.component_identifier = component_identifier


class ComponentNameAndDefaultVersion(msrest.serialization.Model):
    """ComponentNameAndDefaultVersion.

    :ivar component_name:
    :vartype component_name: str
    :ivar version:
    :vartype version: str
    :ivar feed_name:
    :vartype feed_name: str
    :ivar registry_name:
    :vartype registry_name: str
    """

    _attribute_map = {
        'component_name': {'key': 'componentName', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'registry_name': {'key': 'registryName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        component_name: Optional[str] = None,
        version: Optional[str] = None,
        feed_name: Optional[str] = None,
        registry_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword component_name:
        :paramtype component_name: str
        :keyword version:
        :paramtype version: str
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword registry_name:
        :paramtype registry_name: str
        """
        super(ComponentNameAndDefaultVersion, self).__init__(**kwargs)
        self.component_name = component_name
        self.version = version
        self.feed_name = feed_name
        self.registry_name = registry_name


class ComponentNameMetaInfo(msrest.serialization.Model):
    """ComponentNameMetaInfo.

    :ivar feed_name:
    :vartype feed_name: str
    :ivar component_name:
    :vartype component_name: str
    :ivar component_version:
    :vartype component_version: str
    :ivar registry_name:
    :vartype registry_name: str
    """

    _attribute_map = {
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'component_name': {'key': 'componentName', 'type': 'str'},
        'component_version': {'key': 'componentVersion', 'type': 'str'},
        'registry_name': {'key': 'registryName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        feed_name: Optional[str] = None,
        component_name: Optional[str] = None,
        component_version: Optional[str] = None,
        registry_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword component_name:
        :paramtype component_name: str
        :keyword component_version:
        :paramtype component_version: str
        :keyword registry_name:
        :paramtype registry_name: str
        """
        super(ComponentNameMetaInfo, self).__init__(**kwargs)
        self.feed_name = feed_name
        self.component_name = component_name
        self.component_version = component_version
        self.registry_name = registry_name


class Compute(msrest.serialization.Model):
    """Compute.

    :ivar target:
    :vartype target: str
    :ivar target_type:
    :vartype target_type: str
    :ivar vm_size:
    :vartype vm_size: str
    :ivar instance_count:
    :vartype instance_count: int
    :ivar gpu_count:
    :vartype gpu_count: int
    :ivar priority:
    :vartype priority: str
    :ivar region:
    :vartype region: str
    """

    _attribute_map = {
        'target': {'key': 'target', 'type': 'str'},
        'target_type': {'key': 'targetType', 'type': 'str'},
        'vm_size': {'key': 'vmSize', 'type': 'str'},
        'instance_count': {'key': 'instanceCount', 'type': 'int'},
        'gpu_count': {'key': 'gpuCount', 'type': 'int'},
        'priority': {'key': 'priority', 'type': 'str'},
        'region': {'key': 'region', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        target: Optional[str] = None,
        target_type: Optional[str] = None,
        vm_size: Optional[str] = None,
        instance_count: Optional[int] = None,
        gpu_count: Optional[int] = None,
        priority: Optional[str] = None,
        region: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword target:
        :paramtype target: str
        :keyword target_type:
        :paramtype target_type: str
        :keyword vm_size:
        :paramtype vm_size: str
        :keyword instance_count:
        :paramtype instance_count: int
        :keyword gpu_count:
        :paramtype gpu_count: int
        :keyword priority:
        :paramtype priority: str
        :keyword region:
        :paramtype region: str
        """
        super(Compute, self).__init__(**kwargs)
        self.target = target
        self.target_type = target_type
        self.vm_size = vm_size
        self.instance_count = instance_count
        self.gpu_count = gpu_count
        self.priority = priority
        self.region = region


class ComputeInfo(msrest.serialization.Model):
    """ComputeInfo.

    :ivar name:
    :vartype name: str
    :ivar compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT", "AKSENDPOINT",
     "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE", "UNKNOWN".
    :vartype compute_type: str or ~designer.models.ComputeEnvironmentType
    :ivar is_ssl_enabled:
    :vartype is_ssl_enabled: bool
    :ivar is_gpu_type:
    :vartype is_gpu_type: bool
    :ivar cluster_purpose:
    :vartype cluster_purpose: str
    :ivar public_ip_address:
    :vartype public_ip_address: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'is_ssl_enabled': {'key': 'isSslEnabled', 'type': 'bool'},
        'is_gpu_type': {'key': 'isGpuType', 'type': 'bool'},
        'cluster_purpose': {'key': 'clusterPurpose', 'type': 'str'},
        'public_ip_address': {'key': 'publicIpAddress', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        compute_type: Optional[Union[str, "ComputeEnvironmentType"]] = None,
        is_ssl_enabled: Optional[bool] = None,
        is_gpu_type: Optional[bool] = None,
        cluster_purpose: Optional[str] = None,
        public_ip_address: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT",
         "AKSENDPOINT", "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE",
         "UNKNOWN".
        :paramtype compute_type: str or ~designer.models.ComputeEnvironmentType
        :keyword is_ssl_enabled:
        :paramtype is_ssl_enabled: bool
        :keyword is_gpu_type:
        :paramtype is_gpu_type: bool
        :keyword cluster_purpose:
        :paramtype cluster_purpose: str
        :keyword public_ip_address:
        :paramtype public_ip_address: str
        """
        super(ComputeInfo, self).__init__(**kwargs)
        self.name = name
        self.compute_type = compute_type
        self.is_ssl_enabled = is_ssl_enabled
        self.is_gpu_type = is_gpu_type
        self.cluster_purpose = cluster_purpose
        self.public_ip_address = public_ip_address


class ComputeRequest(msrest.serialization.Model):
    """ComputeRequest.

    :ivar node_count:
    :vartype node_count: int
    :ivar gpu_count:
    :vartype gpu_count: int
    """

    _attribute_map = {
        'node_count': {'key': 'nodeCount', 'type': 'int'},
        'gpu_count': {'key': 'gpuCount', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        node_count: Optional[int] = None,
        gpu_count: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword node_count:
        :paramtype node_count: int
        :keyword gpu_count:
        :paramtype gpu_count: int
        """
        super(ComputeRequest, self).__init__(**kwargs)
        self.node_count = node_count
        self.gpu_count = gpu_count


class ComputeSetting(msrest.serialization.Model):
    """ComputeSetting.

    :ivar name:
    :vartype name: str
    :ivar compute_type: Possible values include: "BatchAi", "MLC", "HdiCluster", "RemoteDocker",
     "Databricks", "Aisc".
    :vartype compute_type: str or ~designer.models.ComputeType
    :ivar batch_ai_compute_info:
    :vartype batch_ai_compute_info: ~designer.models.BatchAiComputeInfo
    :ivar remote_docker_compute_info:
    :vartype remote_docker_compute_info: ~designer.models.RemoteDockerComputeInfo
    :ivar hdi_cluster_compute_info:
    :vartype hdi_cluster_compute_info: ~designer.models.HdiClusterComputeInfo
    :ivar mlc_compute_info:
    :vartype mlc_compute_info: ~designer.models.MlcComputeInfo
    :ivar databricks_compute_info:
    :vartype databricks_compute_info: ~designer.models.DatabricksComputeInfo
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'batch_ai_compute_info': {'key': 'batchAiComputeInfo', 'type': 'BatchAiComputeInfo'},
        'remote_docker_compute_info': {'key': 'remoteDockerComputeInfo', 'type': 'RemoteDockerComputeInfo'},
        'hdi_cluster_compute_info': {'key': 'hdiClusterComputeInfo', 'type': 'HdiClusterComputeInfo'},
        'mlc_compute_info': {'key': 'mlcComputeInfo', 'type': 'MlcComputeInfo'},
        'databricks_compute_info': {'key': 'databricksComputeInfo', 'type': 'DatabricksComputeInfo'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        compute_type: Optional[Union[str, "ComputeType"]] = None,
        batch_ai_compute_info: Optional["BatchAiComputeInfo"] = None,
        remote_docker_compute_info: Optional["RemoteDockerComputeInfo"] = None,
        hdi_cluster_compute_info: Optional["HdiClusterComputeInfo"] = None,
        mlc_compute_info: Optional["MlcComputeInfo"] = None,
        databricks_compute_info: Optional["DatabricksComputeInfo"] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword compute_type: Possible values include: "BatchAi", "MLC", "HdiCluster", "RemoteDocker",
         "Databricks", "Aisc".
        :paramtype compute_type: str or ~designer.models.ComputeType
        :keyword batch_ai_compute_info:
        :paramtype batch_ai_compute_info: ~designer.models.BatchAiComputeInfo
        :keyword remote_docker_compute_info:
        :paramtype remote_docker_compute_info: ~designer.models.RemoteDockerComputeInfo
        :keyword hdi_cluster_compute_info:
        :paramtype hdi_cluster_compute_info: ~designer.models.HdiClusterComputeInfo
        :keyword mlc_compute_info:
        :paramtype mlc_compute_info: ~designer.models.MlcComputeInfo
        :keyword databricks_compute_info:
        :paramtype databricks_compute_info: ~designer.models.DatabricksComputeInfo
        """
        super(ComputeSetting, self).__init__(**kwargs)
        self.name = name
        self.compute_type = compute_type
        self.batch_ai_compute_info = batch_ai_compute_info
        self.remote_docker_compute_info = remote_docker_compute_info
        self.hdi_cluster_compute_info = hdi_cluster_compute_info
        self.mlc_compute_info = mlc_compute_info
        self.databricks_compute_info = databricks_compute_info


class ComputeStatusDetail(msrest.serialization.Model):
    """ComputeStatusDetail.

    :ivar provisioning_state:
    :vartype provisioning_state: str
    :ivar provisioning_error_message:
    :vartype provisioning_error_message: str
    """

    _attribute_map = {
        'provisioning_state': {'key': 'provisioningState', 'type': 'str'},
        'provisioning_error_message': {'key': 'provisioningErrorMessage', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        provisioning_state: Optional[str] = None,
        provisioning_error_message: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword provisioning_state:
        :paramtype provisioning_state: str
        :keyword provisioning_error_message:
        :paramtype provisioning_error_message: str
        """
        super(ComputeStatusDetail, self).__init__(**kwargs)
        self.provisioning_state = provisioning_state
        self.provisioning_error_message = provisioning_error_message


class ContainerInstanceConfiguration(msrest.serialization.Model):
    """ContainerInstanceConfiguration.

    :ivar region:
    :vartype region: str
    :ivar cpu_cores:
    :vartype cpu_cores: float
    :ivar memory_gb:
    :vartype memory_gb: float
    """

    _attribute_map = {
        'region': {'key': 'region', 'type': 'str'},
        'cpu_cores': {'key': 'cpuCores', 'type': 'float'},
        'memory_gb': {'key': 'memoryGb', 'type': 'float'},
    }

    def __init__(
        self,
        *,
        region: Optional[str] = None,
        cpu_cores: Optional[float] = None,
        memory_gb: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword region:
        :paramtype region: str
        :keyword cpu_cores:
        :paramtype cpu_cores: float
        :keyword memory_gb:
        :paramtype memory_gb: float
        """
        super(ContainerInstanceConfiguration, self).__init__(**kwargs)
        self.region = region
        self.cpu_cores = cpu_cores
        self.memory_gb = memory_gb


class ContainerRegistry(msrest.serialization.Model):
    """ContainerRegistry.

    :ivar address:
    :vartype address: str
    :ivar username:
    :vartype username: str
    :ivar password:
    :vartype password: str
    :ivar registry_identity:
    :vartype registry_identity: ~designer.models.RegistryIdentity
    """

    _attribute_map = {
        'address': {'key': 'address', 'type': 'str'},
        'username': {'key': 'username', 'type': 'str'},
        'password': {'key': 'password', 'type': 'str'},
        'registry_identity': {'key': 'registryIdentity', 'type': 'RegistryIdentity'},
    }

    def __init__(
        self,
        *,
        address: Optional[str] = None,
        username: Optional[str] = None,
        password: Optional[str] = None,
        registry_identity: Optional["RegistryIdentity"] = None,
        **kwargs
    ):
        """
        :keyword address:
        :paramtype address: str
        :keyword username:
        :paramtype username: str
        :keyword password:
        :paramtype password: str
        :keyword registry_identity:
        :paramtype registry_identity: ~designer.models.RegistryIdentity
        """
        super(ContainerRegistry, self).__init__(**kwargs)
        self.address = address
        self.username = username
        self.password = password
        self.registry_identity = registry_identity


class ContainerResourceRequirements(msrest.serialization.Model):
    """ContainerResourceRequirements.

    :ivar cpu:
    :vartype cpu: float
    :ivar cpu_limit:
    :vartype cpu_limit: float
    :ivar memory_in_gb:
    :vartype memory_in_gb: float
    :ivar memory_in_gb_limit:
    :vartype memory_in_gb_limit: float
    :ivar gpu_enabled:
    :vartype gpu_enabled: bool
    :ivar gpu:
    :vartype gpu: int
    :ivar fpga:
    :vartype fpga: int
    """

    _attribute_map = {
        'cpu': {'key': 'cpu', 'type': 'float'},
        'cpu_limit': {'key': 'cpuLimit', 'type': 'float'},
        'memory_in_gb': {'key': 'memoryInGB', 'type': 'float'},
        'memory_in_gb_limit': {'key': 'memoryInGBLimit', 'type': 'float'},
        'gpu_enabled': {'key': 'gpuEnabled', 'type': 'bool'},
        'gpu': {'key': 'gpu', 'type': 'int'},
        'fpga': {'key': 'fpga', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        cpu: Optional[float] = None,
        cpu_limit: Optional[float] = None,
        memory_in_gb: Optional[float] = None,
        memory_in_gb_limit: Optional[float] = None,
        gpu_enabled: Optional[bool] = None,
        gpu: Optional[int] = None,
        fpga: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword cpu:
        :paramtype cpu: float
        :keyword cpu_limit:
        :paramtype cpu_limit: float
        :keyword memory_in_gb:
        :paramtype memory_in_gb: float
        :keyword memory_in_gb_limit:
        :paramtype memory_in_gb_limit: float
        :keyword gpu_enabled:
        :paramtype gpu_enabled: bool
        :keyword gpu:
        :paramtype gpu: int
        :keyword fpga:
        :paramtype fpga: int
        """
        super(ContainerResourceRequirements, self).__init__(**kwargs)
        self.cpu = cpu
        self.cpu_limit = cpu_limit
        self.memory_in_gb = memory_in_gb
        self.memory_in_gb_limit = memory_in_gb_limit
        self.gpu_enabled = gpu_enabled
        self.gpu = gpu
        self.fpga = fpga


class ControlInput(msrest.serialization.Model):
    """ControlInput.

    :ivar name:
    :vartype name: str
    :ivar default_value: Possible values include: "False", "True".
    :vartype default_value: str or ~designer.models.ControlInputValue
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'default_value': {'key': 'defaultValue', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        default_value: Optional[Union[str, "ControlInputValue"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword default_value: Possible values include: "False", "True".
        :paramtype default_value: str or ~designer.models.ControlInputValue
        """
        super(ControlInput, self).__init__(**kwargs)
        self.name = name
        self.default_value = default_value


class ControlOutput(msrest.serialization.Model):
    """ControlOutput.

    :ivar name:
    :vartype name: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        """
        super(ControlOutput, self).__init__(**kwargs)
        self.name = name


class CreatedBy(msrest.serialization.Model):
    """CreatedBy.

    :ivar user_object_id:
    :vartype user_object_id: str
    :ivar user_tenant_id:
    :vartype user_tenant_id: str
    :ivar user_name:
    :vartype user_name: str
    """

    _attribute_map = {
        'user_object_id': {'key': 'userObjectId', 'type': 'str'},
        'user_tenant_id': {'key': 'userTenantId', 'type': 'str'},
        'user_name': {'key': 'userName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        user_object_id: Optional[str] = None,
        user_tenant_id: Optional[str] = None,
        user_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword user_object_id:
        :paramtype user_object_id: str
        :keyword user_tenant_id:
        :paramtype user_tenant_id: str
        :keyword user_name:
        :paramtype user_name: str
        """
        super(CreatedBy, self).__init__(**kwargs)
        self.user_object_id = user_object_id
        self.user_tenant_id = user_tenant_id
        self.user_name = user_name


class CreateInferencePipelineRequest(msrest.serialization.Model):
    """CreateInferencePipelineRequest.

    :ivar module_node_id:
    :vartype module_node_id: str
    :ivar port_name:
    :vartype port_name: str
    :ivar training_pipeline_draft_name:
    :vartype training_pipeline_draft_name: str
    :ivar name:
    :vartype name: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
    :vartype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'module_node_id': {'key': 'moduleNodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
        'training_pipeline_draft_name': {'key': 'trainingPipelineDraftName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'flattened_sub_graphs': {'key': 'flattenedSubGraphs', 'type': '{PipelineSubDraft}'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        module_node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        training_pipeline_draft_name: Optional[str] = None,
        name: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        flattened_sub_graphs: Optional[Dict[str, "PipelineSubDraft"]] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword module_node_id:
        :paramtype module_node_id: str
        :keyword port_name:
        :paramtype port_name: str
        :keyword training_pipeline_draft_name:
        :paramtype training_pipeline_draft_name: str
        :keyword name:
        :paramtype name: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
        :paramtype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(CreateInferencePipelineRequest, self).__init__(**kwargs)
        self.module_node_id = module_node_id
        self.port_name = port_name
        self.training_pipeline_draft_name = training_pipeline_draft_name
        self.name = name
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.sub_pipelines_info = sub_pipelines_info
        self.flattened_sub_graphs = flattened_sub_graphs
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class CreatePipelineDraftRequest(msrest.serialization.Model):
    """CreatePipelineDraftRequest.

    :ivar name:
    :vartype name: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
    :vartype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'flattened_sub_graphs': {'key': 'flattenedSubGraphs', 'type': '{PipelineSubDraft}'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        flattened_sub_graphs: Optional[Dict[str, "PipelineSubDraft"]] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
        :paramtype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(CreatePipelineDraftRequest, self).__init__(**kwargs)
        self.name = name
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.sub_pipelines_info = sub_pipelines_info
        self.flattened_sub_graphs = flattened_sub_graphs
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class CreatePublishedPipelineRequest(msrest.serialization.Model):
    """CreatePublishedPipelineRequest.

    :ivar use_pipeline_endpoint:
    :vartype use_pipeline_endpoint: bool
    :ivar pipeline_name:
    :vartype pipeline_name: str
    :ivar pipeline_description:
    :vartype pipeline_description: str
    :ivar use_existing_pipeline_endpoint:
    :vartype use_existing_pipeline_endpoint: bool
    :ivar pipeline_endpoint_name:
    :vartype pipeline_endpoint_name: str
    :ivar pipeline_endpoint_description:
    :vartype pipeline_endpoint_description: str
    :ivar set_as_default_pipeline_for_endpoint:
    :vartype set_as_default_pipeline_for_endpoint: bool
    :ivar step_tags: This is a dictionary.
    :vartype step_tags: dict[str, str]
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar pipeline_parameters: This is a dictionary.
    :vartype pipeline_parameters: dict[str, str]
    :ivar data_path_assignments: This is a dictionary.
    :vartype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
    :ivar data_set_definition_value_assignments: This is a dictionary.
    :vartype data_set_definition_value_assignments: dict[str,
     ~designer.models.DataSetDefinitionValue]
    :ivar enable_notification:
    :vartype enable_notification: bool
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar display_name:
    :vartype display_name: str
    :ivar run_id:
    :vartype run_id: str
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'use_pipeline_endpoint': {'key': 'usePipelineEndpoint', 'type': 'bool'},
        'pipeline_name': {'key': 'pipelineName', 'type': 'str'},
        'pipeline_description': {'key': 'pipelineDescription', 'type': 'str'},
        'use_existing_pipeline_endpoint': {'key': 'useExistingPipelineEndpoint', 'type': 'bool'},
        'pipeline_endpoint_name': {'key': 'pipelineEndpointName', 'type': 'str'},
        'pipeline_endpoint_description': {'key': 'pipelineEndpointDescription', 'type': 'str'},
        'set_as_default_pipeline_for_endpoint': {'key': 'setAsDefaultPipelineForEndpoint', 'type': 'bool'},
        'step_tags': {'key': 'stepTags', 'type': '{str}'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'pipeline_parameters': {'key': 'pipelineParameters', 'type': '{str}'},
        'data_path_assignments': {'key': 'dataPathAssignments', 'type': '{LegacyDataPath}'},
        'data_set_definition_value_assignments': {'key': 'dataSetDefinitionValueAssignments', 'type': '{DataSetDefinitionValue}'},
        'enable_notification': {'key': 'enableNotification', 'type': 'bool'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        use_pipeline_endpoint: Optional[bool] = None,
        pipeline_name: Optional[str] = None,
        pipeline_description: Optional[str] = None,
        use_existing_pipeline_endpoint: Optional[bool] = None,
        pipeline_endpoint_name: Optional[str] = None,
        pipeline_endpoint_description: Optional[str] = None,
        set_as_default_pipeline_for_endpoint: Optional[bool] = None,
        step_tags: Optional[Dict[str, str]] = None,
        experiment_name: Optional[str] = None,
        pipeline_parameters: Optional[Dict[str, str]] = None,
        data_path_assignments: Optional[Dict[str, "LegacyDataPath"]] = None,
        data_set_definition_value_assignments: Optional[Dict[str, "DataSetDefinitionValue"]] = None,
        enable_notification: Optional[bool] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        display_name: Optional[str] = None,
        run_id: Optional[str] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword use_pipeline_endpoint:
        :paramtype use_pipeline_endpoint: bool
        :keyword pipeline_name:
        :paramtype pipeline_name: str
        :keyword pipeline_description:
        :paramtype pipeline_description: str
        :keyword use_existing_pipeline_endpoint:
        :paramtype use_existing_pipeline_endpoint: bool
        :keyword pipeline_endpoint_name:
        :paramtype pipeline_endpoint_name: str
        :keyword pipeline_endpoint_description:
        :paramtype pipeline_endpoint_description: str
        :keyword set_as_default_pipeline_for_endpoint:
        :paramtype set_as_default_pipeline_for_endpoint: bool
        :keyword step_tags: This is a dictionary.
        :paramtype step_tags: dict[str, str]
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword pipeline_parameters: This is a dictionary.
        :paramtype pipeline_parameters: dict[str, str]
        :keyword data_path_assignments: This is a dictionary.
        :paramtype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
        :keyword data_set_definition_value_assignments: This is a dictionary.
        :paramtype data_set_definition_value_assignments: dict[str,
         ~designer.models.DataSetDefinitionValue]
        :keyword enable_notification:
        :paramtype enable_notification: bool
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword display_name:
        :paramtype display_name: str
        :keyword run_id:
        :paramtype run_id: str
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(CreatePublishedPipelineRequest, self).__init__(**kwargs)
        self.use_pipeline_endpoint = use_pipeline_endpoint
        self.pipeline_name = pipeline_name
        self.pipeline_description = pipeline_description
        self.use_existing_pipeline_endpoint = use_existing_pipeline_endpoint
        self.pipeline_endpoint_name = pipeline_endpoint_name
        self.pipeline_endpoint_description = pipeline_endpoint_description
        self.set_as_default_pipeline_for_endpoint = set_as_default_pipeline_for_endpoint
        self.step_tags = step_tags
        self.experiment_name = experiment_name
        self.pipeline_parameters = pipeline_parameters
        self.data_path_assignments = data_path_assignments
        self.data_set_definition_value_assignments = data_set_definition_value_assignments
        self.enable_notification = enable_notification
        self.sub_pipelines_info = sub_pipelines_info
        self.display_name = display_name
        self.run_id = run_id
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class CreateRealTimeEndpointRequest(msrest.serialization.Model):
    """CreateRealTimeEndpointRequest.

    :ivar name:
    :vartype name: str
    :ivar compute_info:
    :vartype compute_info: ~designer.models.ComputeInfo
    :ivar description:
    :vartype description: str
    :ivar linked_pipeline_draft_id:
    :vartype linked_pipeline_draft_id: str
    :ivar aks_advance_settings:
    :vartype aks_advance_settings: ~designer.models.AKSAdvanceSettings
    :ivar aci_advance_settings:
    :vartype aci_advance_settings: ~designer.models.ACIAdvanceSettings
    :ivar linked_pipeline_run_id:
    :vartype linked_pipeline_run_id: str
    :ivar linked_experiment_name:
    :vartype linked_experiment_name: str
    :ivar graph_nodes_run_id_mapping: This is a dictionary.
    :vartype graph_nodes_run_id_mapping: dict[str, str]
    :ivar workflow:
    :vartype workflow: ~designer.models.PipelineGraph
    :ivar inputs:
    :vartype inputs: list[~designer.models.InputOutputPortMetadata]
    :ivar outputs:
    :vartype outputs: list[~designer.models.InputOutputPortMetadata]
    :ivar example_request:
    :vartype example_request: ~designer.models.ExampleRequest
    :ivar user_storage_connection_string:
    :vartype user_storage_connection_string: str
    :ivar user_storage_endpoint_uri:
    :vartype user_storage_endpoint_uri: str
    :ivar user_storage_workspace_sai_token:
    :vartype user_storage_workspace_sai_token: str
    :ivar user_storage_container_name:
    :vartype user_storage_container_name: str
    :ivar pipeline_run_id:
    :vartype pipeline_run_id: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar experiment_id:
    :vartype experiment_id: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'compute_info': {'key': 'computeInfo', 'type': 'ComputeInfo'},
        'description': {'key': 'description', 'type': 'str'},
        'linked_pipeline_draft_id': {'key': 'linkedPipelineDraftId', 'type': 'str'},
        'aks_advance_settings': {'key': 'aksAdvanceSettings', 'type': 'AKSAdvanceSettings'},
        'aci_advance_settings': {'key': 'aciAdvanceSettings', 'type': 'ACIAdvanceSettings'},
        'linked_pipeline_run_id': {'key': 'linkedPipelineRunId', 'type': 'str'},
        'linked_experiment_name': {'key': 'linkedExperimentName', 'type': 'str'},
        'graph_nodes_run_id_mapping': {'key': 'graphNodesRunIdMapping', 'type': '{str}'},
        'workflow': {'key': 'workflow', 'type': 'PipelineGraph'},
        'inputs': {'key': 'inputs', 'type': '[InputOutputPortMetadata]'},
        'outputs': {'key': 'outputs', 'type': '[InputOutputPortMetadata]'},
        'example_request': {'key': 'exampleRequest', 'type': 'ExampleRequest'},
        'user_storage_connection_string': {'key': 'userStorageConnectionString', 'type': 'str'},
        'user_storage_endpoint_uri': {'key': 'userStorageEndpointUri', 'type': 'str'},
        'user_storage_workspace_sai_token': {'key': 'userStorageWorkspaceSaiToken', 'type': 'str'},
        'user_storage_container_name': {'key': 'userStorageContainerName', 'type': 'str'},
        'pipeline_run_id': {'key': 'pipelineRunId', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        compute_info: Optional["ComputeInfo"] = None,
        description: Optional[str] = None,
        linked_pipeline_draft_id: Optional[str] = None,
        aks_advance_settings: Optional["AKSAdvanceSettings"] = None,
        aci_advance_settings: Optional["ACIAdvanceSettings"] = None,
        linked_pipeline_run_id: Optional[str] = None,
        linked_experiment_name: Optional[str] = None,
        graph_nodes_run_id_mapping: Optional[Dict[str, str]] = None,
        workflow: Optional["PipelineGraph"] = None,
        inputs: Optional[List["InputOutputPortMetadata"]] = None,
        outputs: Optional[List["InputOutputPortMetadata"]] = None,
        example_request: Optional["ExampleRequest"] = None,
        user_storage_connection_string: Optional[str] = None,
        user_storage_endpoint_uri: Optional[str] = None,
        user_storage_workspace_sai_token: Optional[str] = None,
        user_storage_container_name: Optional[str] = None,
        pipeline_run_id: Optional[str] = None,
        experiment_name: Optional[str] = None,
        experiment_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword compute_info:
        :paramtype compute_info: ~designer.models.ComputeInfo
        :keyword description:
        :paramtype description: str
        :keyword linked_pipeline_draft_id:
        :paramtype linked_pipeline_draft_id: str
        :keyword aks_advance_settings:
        :paramtype aks_advance_settings: ~designer.models.AKSAdvanceSettings
        :keyword aci_advance_settings:
        :paramtype aci_advance_settings: ~designer.models.ACIAdvanceSettings
        :keyword linked_pipeline_run_id:
        :paramtype linked_pipeline_run_id: str
        :keyword linked_experiment_name:
        :paramtype linked_experiment_name: str
        :keyword graph_nodes_run_id_mapping: This is a dictionary.
        :paramtype graph_nodes_run_id_mapping: dict[str, str]
        :keyword workflow:
        :paramtype workflow: ~designer.models.PipelineGraph
        :keyword inputs:
        :paramtype inputs: list[~designer.models.InputOutputPortMetadata]
        :keyword outputs:
        :paramtype outputs: list[~designer.models.InputOutputPortMetadata]
        :keyword example_request:
        :paramtype example_request: ~designer.models.ExampleRequest
        :keyword user_storage_connection_string:
        :paramtype user_storage_connection_string: str
        :keyword user_storage_endpoint_uri:
        :paramtype user_storage_endpoint_uri: str
        :keyword user_storage_workspace_sai_token:
        :paramtype user_storage_workspace_sai_token: str
        :keyword user_storage_container_name:
        :paramtype user_storage_container_name: str
        :keyword pipeline_run_id:
        :paramtype pipeline_run_id: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        """
        super(CreateRealTimeEndpointRequest, self).__init__(**kwargs)
        self.name = name
        self.compute_info = compute_info
        self.description = description
        self.linked_pipeline_draft_id = linked_pipeline_draft_id
        self.aks_advance_settings = aks_advance_settings
        self.aci_advance_settings = aci_advance_settings
        self.linked_pipeline_run_id = linked_pipeline_run_id
        self.linked_experiment_name = linked_experiment_name
        self.graph_nodes_run_id_mapping = graph_nodes_run_id_mapping
        self.workflow = workflow
        self.inputs = inputs
        self.outputs = outputs
        self.example_request = example_request
        self.user_storage_connection_string = user_storage_connection_string
        self.user_storage_endpoint_uri = user_storage_endpoint_uri
        self.user_storage_workspace_sai_token = user_storage_workspace_sai_token
        self.user_storage_container_name = user_storage_container_name
        self.pipeline_run_id = pipeline_run_id
        self.experiment_name = experiment_name
        self.experiment_id = experiment_id


class CreateSnapshotDto(msrest.serialization.Model):
    """CreateSnapshotDto.

    :ivar file_revision_list:
    :vartype file_revision_list: ~designer.models.FileNodeListDto
    :ivar dir_tree:
    :vartype dir_tree: ~designer.models.FlatDirTreeNodeListDto
    :ivar dir_tree_node:
    :vartype dir_tree_node: ~designer.models.DirTreeNode
    :ivar parent_snapshot_id:
    :vartype parent_snapshot_id: str
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar properties: Dictionary of :code:`<string>`.
    :vartype properties: dict[str, str]
    :ivar description:
    :vartype description: str
    """

    _attribute_map = {
        'file_revision_list': {'key': 'fileRevisionList', 'type': 'FileNodeListDto'},
        'dir_tree': {'key': 'dirTree', 'type': 'FlatDirTreeNodeListDto'},
        'dir_tree_node': {'key': 'dirTreeNode', 'type': 'DirTreeNode'},
        'parent_snapshot_id': {'key': 'parentSnapshotId', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'description': {'key': 'description', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        file_revision_list: Optional["FileNodeListDto"] = None,
        dir_tree: Optional["FlatDirTreeNodeListDto"] = None,
        dir_tree_node: Optional["DirTreeNode"] = None,
        parent_snapshot_id: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        description: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword file_revision_list:
        :paramtype file_revision_list: ~designer.models.FileNodeListDto
        :keyword dir_tree:
        :paramtype dir_tree: ~designer.models.FlatDirTreeNodeListDto
        :keyword dir_tree_node:
        :paramtype dir_tree_node: ~designer.models.DirTreeNode
        :keyword parent_snapshot_id:
        :paramtype parent_snapshot_id: str
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword properties: Dictionary of :code:`<string>`.
        :paramtype properties: dict[str, str]
        :keyword description:
        :paramtype description: str
        """
        super(CreateSnapshotDto, self).__init__(**kwargs)
        self.file_revision_list = file_revision_list
        self.dir_tree = dir_tree
        self.dir_tree_node = dir_tree_node
        self.parent_snapshot_id = parent_snapshot_id
        self.tags = tags
        self.properties = properties
        self.description = description


class CreationContext(msrest.serialization.Model):
    """CreationContext.

    :ivar created_time:
    :vartype created_time: ~datetime.datetime
    :ivar created_by:
    :vartype created_by: ~designer.models.SchemaContractsCreatedBy
    :ivar creation_source:
    :vartype creation_source: str
    """

    _attribute_map = {
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'created_by': {'key': 'createdBy', 'type': 'SchemaContractsCreatedBy'},
        'creation_source': {'key': 'creationSource', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        created_time: Optional[datetime.datetime] = None,
        created_by: Optional["SchemaContractsCreatedBy"] = None,
        creation_source: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword created_time:
        :paramtype created_time: ~datetime.datetime
        :keyword created_by:
        :paramtype created_by: ~designer.models.SchemaContractsCreatedBy
        :keyword creation_source:
        :paramtype creation_source: str
        """
        super(CreationContext, self).__init__(**kwargs)
        self.created_time = created_time
        self.created_by = created_by
        self.creation_source = creation_source


class CustomReference(msrest.serialization.Model):
    """CustomReference.

    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    :ivar relative_path:
    :vartype relative_path: str
    """

    _attribute_map = {
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        aml_data_store_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        """
        super(CustomReference, self).__init__(**kwargs)
        self.aml_data_store_name = aml_data_store_name
        self.relative_path = relative_path


class Data(msrest.serialization.Model):
    """Data.

    :ivar data_location:
    :vartype data_location: ~designer.models.ExecutionDataLocation
    :ivar mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
    :vartype mechanism: str or ~designer.models.DeliveryMechanism
    :ivar environment_variable_name:
    :vartype environment_variable_name: str
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    :ivar options: Dictionary of :code:`<string>`.
    :vartype options: dict[str, str]
    """

    _attribute_map = {
        'data_location': {'key': 'dataLocation', 'type': 'ExecutionDataLocation'},
        'mechanism': {'key': 'mechanism', 'type': 'str'},
        'environment_variable_name': {'key': 'environmentVariableName', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'options': {'key': 'options', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        data_location: Optional["ExecutionDataLocation"] = None,
        mechanism: Optional[Union[str, "DeliveryMechanism"]] = None,
        environment_variable_name: Optional[str] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        options: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword data_location:
        :paramtype data_location: ~designer.models.ExecutionDataLocation
        :keyword mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
        :paramtype mechanism: str or ~designer.models.DeliveryMechanism
        :keyword environment_variable_name:
        :paramtype environment_variable_name: str
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword options: Dictionary of :code:`<string>`.
        :paramtype options: dict[str, str]
        """
        super(Data, self).__init__(**kwargs)
        self.data_location = data_location
        self.mechanism = mechanism
        self.environment_variable_name = environment_variable_name
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite
        self.options = options


class DatabricksComputeInfo(msrest.serialization.Model):
    """DatabricksComputeInfo.

    :ivar existing_cluster_id:
    :vartype existing_cluster_id: str
    """

    _attribute_map = {
        'existing_cluster_id': {'key': 'existingClusterId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        existing_cluster_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword existing_cluster_id:
        :paramtype existing_cluster_id: str
        """
        super(DatabricksComputeInfo, self).__init__(**kwargs)
        self.existing_cluster_id = existing_cluster_id


class DatabricksConfiguration(msrest.serialization.Model):
    """DatabricksConfiguration.

    :ivar workers:
    :vartype workers: int
    :ivar minimum_worker_count:
    :vartype minimum_worker_count: int
    :ivar max_mum_worker_count:
    :vartype max_mum_worker_count: int
    :ivar spark_version:
    :vartype spark_version: str
    :ivar node_type_id:
    :vartype node_type_id: str
    :ivar spark_conf: Dictionary of :code:`<string>`.
    :vartype spark_conf: dict[str, str]
    :ivar spark_env_vars: Dictionary of :code:`<string>`.
    :vartype spark_env_vars: dict[str, str]
    :ivar cluster_log_conf_dbfs_path:
    :vartype cluster_log_conf_dbfs_path: str
    :ivar dbfs_init_scripts:
    :vartype dbfs_init_scripts: list[~designer.models.InitScriptInfoDto]
    :ivar instance_pool_id:
    :vartype instance_pool_id: str
    :ivar timeout_seconds:
    :vartype timeout_seconds: int
    :ivar notebook_task:
    :vartype notebook_task: ~designer.models.NoteBookTaskDto
    :ivar spark_python_task:
    :vartype spark_python_task: ~designer.models.SparkPythonTaskDto
    :ivar spark_jar_task:
    :vartype spark_jar_task: ~designer.models.SparkJarTaskDto
    :ivar spark_submit_task:
    :vartype spark_submit_task: ~designer.models.SparkSubmitTaskDto
    :ivar jar_libraries:
    :vartype jar_libraries: list[str]
    :ivar egg_libraries:
    :vartype egg_libraries: list[str]
    :ivar whl_libraries:
    :vartype whl_libraries: list[str]
    :ivar pypi_libraries:
    :vartype pypi_libraries: list[~designer.models.PythonPyPiOrRCranLibraryDto]
    :ivar r_cran_libraries:
    :vartype r_cran_libraries: list[~designer.models.PythonPyPiOrRCranLibraryDto]
    :ivar maven_libraries:
    :vartype maven_libraries: list[~designer.models.MavenLibraryDto]
    :ivar libraries:
    :vartype libraries: list[any]
    :ivar linked_adb_workspace_metadata:
    :vartype linked_adb_workspace_metadata: ~designer.models.LinkedADBWorkspaceMetadata
    :ivar databrick_resource_id:
    :vartype databrick_resource_id: str
    :ivar auto_scale:
    :vartype auto_scale: bool
    """

    _attribute_map = {
        'workers': {'key': 'workers', 'type': 'int'},
        'minimum_worker_count': {'key': 'minimumWorkerCount', 'type': 'int'},
        'max_mum_worker_count': {'key': 'maxMumWorkerCount', 'type': 'int'},
        'spark_version': {'key': 'sparkVersion', 'type': 'str'},
        'node_type_id': {'key': 'nodeTypeId', 'type': 'str'},
        'spark_conf': {'key': 'sparkConf', 'type': '{str}'},
        'spark_env_vars': {'key': 'sparkEnvVars', 'type': '{str}'},
        'cluster_log_conf_dbfs_path': {'key': 'clusterLogConfDbfsPath', 'type': 'str'},
        'dbfs_init_scripts': {'key': 'dbfsInitScripts', 'type': '[InitScriptInfoDto]'},
        'instance_pool_id': {'key': 'instancePoolId', 'type': 'str'},
        'timeout_seconds': {'key': 'timeoutSeconds', 'type': 'int'},
        'notebook_task': {'key': 'notebookTask', 'type': 'NoteBookTaskDto'},
        'spark_python_task': {'key': 'sparkPythonTask', 'type': 'SparkPythonTaskDto'},
        'spark_jar_task': {'key': 'sparkJarTask', 'type': 'SparkJarTaskDto'},
        'spark_submit_task': {'key': 'sparkSubmitTask', 'type': 'SparkSubmitTaskDto'},
        'jar_libraries': {'key': 'jarLibraries', 'type': '[str]'},
        'egg_libraries': {'key': 'eggLibraries', 'type': '[str]'},
        'whl_libraries': {'key': 'whlLibraries', 'type': '[str]'},
        'pypi_libraries': {'key': 'pypiLibraries', 'type': '[PythonPyPiOrRCranLibraryDto]'},
        'r_cran_libraries': {'key': 'rCranLibraries', 'type': '[PythonPyPiOrRCranLibraryDto]'},
        'maven_libraries': {'key': 'mavenLibraries', 'type': '[MavenLibraryDto]'},
        'libraries': {'key': 'libraries', 'type': '[object]'},
        'linked_adb_workspace_metadata': {'key': 'linkedADBWorkspaceMetadata', 'type': 'LinkedADBWorkspaceMetadata'},
        'databrick_resource_id': {'key': 'databrickResourceId', 'type': 'str'},
        'auto_scale': {'key': 'autoScale', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        workers: Optional[int] = None,
        minimum_worker_count: Optional[int] = None,
        max_mum_worker_count: Optional[int] = None,
        spark_version: Optional[str] = None,
        node_type_id: Optional[str] = None,
        spark_conf: Optional[Dict[str, str]] = None,
        spark_env_vars: Optional[Dict[str, str]] = None,
        cluster_log_conf_dbfs_path: Optional[str] = None,
        dbfs_init_scripts: Optional[List["InitScriptInfoDto"]] = None,
        instance_pool_id: Optional[str] = None,
        timeout_seconds: Optional[int] = None,
        notebook_task: Optional["NoteBookTaskDto"] = None,
        spark_python_task: Optional["SparkPythonTaskDto"] = None,
        spark_jar_task: Optional["SparkJarTaskDto"] = None,
        spark_submit_task: Optional["SparkSubmitTaskDto"] = None,
        jar_libraries: Optional[List[str]] = None,
        egg_libraries: Optional[List[str]] = None,
        whl_libraries: Optional[List[str]] = None,
        pypi_libraries: Optional[List["PythonPyPiOrRCranLibraryDto"]] = None,
        r_cran_libraries: Optional[List["PythonPyPiOrRCranLibraryDto"]] = None,
        maven_libraries: Optional[List["MavenLibraryDto"]] = None,
        libraries: Optional[List[Any]] = None,
        linked_adb_workspace_metadata: Optional["LinkedADBWorkspaceMetadata"] = None,
        databrick_resource_id: Optional[str] = None,
        auto_scale: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword workers:
        :paramtype workers: int
        :keyword minimum_worker_count:
        :paramtype minimum_worker_count: int
        :keyword max_mum_worker_count:
        :paramtype max_mum_worker_count: int
        :keyword spark_version:
        :paramtype spark_version: str
        :keyword node_type_id:
        :paramtype node_type_id: str
        :keyword spark_conf: Dictionary of :code:`<string>`.
        :paramtype spark_conf: dict[str, str]
        :keyword spark_env_vars: Dictionary of :code:`<string>`.
        :paramtype spark_env_vars: dict[str, str]
        :keyword cluster_log_conf_dbfs_path:
        :paramtype cluster_log_conf_dbfs_path: str
        :keyword dbfs_init_scripts:
        :paramtype dbfs_init_scripts: list[~designer.models.InitScriptInfoDto]
        :keyword instance_pool_id:
        :paramtype instance_pool_id: str
        :keyword timeout_seconds:
        :paramtype timeout_seconds: int
        :keyword notebook_task:
        :paramtype notebook_task: ~designer.models.NoteBookTaskDto
        :keyword spark_python_task:
        :paramtype spark_python_task: ~designer.models.SparkPythonTaskDto
        :keyword spark_jar_task:
        :paramtype spark_jar_task: ~designer.models.SparkJarTaskDto
        :keyword spark_submit_task:
        :paramtype spark_submit_task: ~designer.models.SparkSubmitTaskDto
        :keyword jar_libraries:
        :paramtype jar_libraries: list[str]
        :keyword egg_libraries:
        :paramtype egg_libraries: list[str]
        :keyword whl_libraries:
        :paramtype whl_libraries: list[str]
        :keyword pypi_libraries:
        :paramtype pypi_libraries: list[~designer.models.PythonPyPiOrRCranLibraryDto]
        :keyword r_cran_libraries:
        :paramtype r_cran_libraries: list[~designer.models.PythonPyPiOrRCranLibraryDto]
        :keyword maven_libraries:
        :paramtype maven_libraries: list[~designer.models.MavenLibraryDto]
        :keyword libraries:
        :paramtype libraries: list[any]
        :keyword linked_adb_workspace_metadata:
        :paramtype linked_adb_workspace_metadata: ~designer.models.LinkedADBWorkspaceMetadata
        :keyword databrick_resource_id:
        :paramtype databrick_resource_id: str
        :keyword auto_scale:
        :paramtype auto_scale: bool
        """
        super(DatabricksConfiguration, self).__init__(**kwargs)
        self.workers = workers
        self.minimum_worker_count = minimum_worker_count
        self.max_mum_worker_count = max_mum_worker_count
        self.spark_version = spark_version
        self.node_type_id = node_type_id
        self.spark_conf = spark_conf
        self.spark_env_vars = spark_env_vars
        self.cluster_log_conf_dbfs_path = cluster_log_conf_dbfs_path
        self.dbfs_init_scripts = dbfs_init_scripts
        self.instance_pool_id = instance_pool_id
        self.timeout_seconds = timeout_seconds
        self.notebook_task = notebook_task
        self.spark_python_task = spark_python_task
        self.spark_jar_task = spark_jar_task
        self.spark_submit_task = spark_submit_task
        self.jar_libraries = jar_libraries
        self.egg_libraries = egg_libraries
        self.whl_libraries = whl_libraries
        self.pypi_libraries = pypi_libraries
        self.r_cran_libraries = r_cran_libraries
        self.maven_libraries = maven_libraries
        self.libraries = libraries
        self.linked_adb_workspace_metadata = linked_adb_workspace_metadata
        self.databrick_resource_id = databrick_resource_id
        self.auto_scale = auto_scale


class DatacacheConfiguration(msrest.serialization.Model):
    """DatacacheConfiguration.

    :ivar datacache_id:
    :vartype datacache_id: str
    :ivar datacache_store:
    :vartype datacache_store: str
    :ivar dataset_id:
    :vartype dataset_id: str
    :ivar mode:  The only acceptable values to pass in are None and "Mount". The default value is
     None.
    :vartype mode: str
    :ivar replica:
    :vartype replica: int
    :ivar failure_fallback:
    :vartype failure_fallback: bool
    :ivar path_on_compute:
    :vartype path_on_compute: str
    """

    _attribute_map = {
        'datacache_id': {'key': 'datacacheId', 'type': 'str'},
        'datacache_store': {'key': 'datacacheStore', 'type': 'str'},
        'dataset_id': {'key': 'datasetId', 'type': 'str'},
        'mode': {'key': 'mode', 'type': 'str'},
        'replica': {'key': 'replica', 'type': 'int'},
        'failure_fallback': {'key': 'failureFallback', 'type': 'bool'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        datacache_id: Optional[str] = None,
        datacache_store: Optional[str] = None,
        dataset_id: Optional[str] = None,
        mode: Optional[str] = None,
        replica: Optional[int] = None,
        failure_fallback: Optional[bool] = None,
        path_on_compute: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword datacache_id:
        :paramtype datacache_id: str
        :keyword datacache_store:
        :paramtype datacache_store: str
        :keyword dataset_id:
        :paramtype dataset_id: str
        :keyword mode:  The only acceptable values to pass in are None and "Mount". The default value
         is None.
        :paramtype mode: str
        :keyword replica:
        :paramtype replica: int
        :keyword failure_fallback:
        :paramtype failure_fallback: bool
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        """
        super(DatacacheConfiguration, self).__init__(**kwargs)
        self.datacache_id = datacache_id
        self.datacache_store = datacache_store
        self.dataset_id = dataset_id
        self.mode = mode
        self.replica = replica
        self.failure_fallback = failure_fallback
        self.path_on_compute = path_on_compute


class DataInfo(msrest.serialization.Model):
    """DataInfo.

    :ivar feed_name:
    :vartype feed_name: str
    :ivar id:
    :vartype id: str
    :ivar data_source_type: Possible values include: "None", "PipelineDataSource", "AmlDataset",
     "GlobalDataset", "FeedModel", "FeedDataset".
    :vartype data_source_type: str or ~designer.models.DataSourceType
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar data_type_id:
    :vartype data_type_id: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar modified_date:
    :vartype modified_date: ~datetime.datetime
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar created_by_studio:
    :vartype created_by_studio: bool
    :ivar data_reference_type: Possible values include: "None", "AzureBlob", "AzureDataLake",
     "AzureFiles", "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS",
     "AzureMySqlDatabase", "Custom".
    :vartype data_reference_type: str or ~designer.models.DataReferenceType
    :ivar dataset_type:
    :vartype dataset_type: str
    :ivar saved_dataset_id:
    :vartype saved_dataset_id: str
    :ivar dataset_version_id:
    :vartype dataset_version_id: str
    :ivar is_visible:
    :vartype is_visible: bool
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, any]
    :ivar connection_string:
    :vartype connection_string: str
    :ivar container_name:
    :vartype container_name: str
    :ivar data_storage_endpoint_uri:
    :vartype data_storage_endpoint_uri: str
    :ivar workspace_sai_token:
    :vartype workspace_sai_token: str
    :ivar aml_dataset_data_flow:
    :vartype aml_dataset_data_flow: str
    :ivar system_data:
    :vartype system_data: ~designer.models.SystemData
    :ivar arm_id:
    :vartype arm_id: str
    :ivar asset_scope_type: Possible values include: "Workspace", "Global", "All", "Feed".
    :vartype asset_scope_type: str or ~designer.models.AssetScopeTypes
    :ivar pipeline_run_id:
    :vartype pipeline_run_id: str
    :ivar module_node_id:
    :vartype module_node_id: str
    :ivar output_port_name:
    :vartype output_port_name: str
    """

    _attribute_map = {
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'data_source_type': {'key': 'dataSourceType', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'data_type_id': {'key': 'dataTypeId', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'modified_date': {'key': 'modifiedDate', 'type': 'iso-8601'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'created_by_studio': {'key': 'createdByStudio', 'type': 'bool'},
        'data_reference_type': {'key': 'dataReferenceType', 'type': 'str'},
        'dataset_type': {'key': 'datasetType', 'type': 'str'},
        'saved_dataset_id': {'key': 'savedDatasetId', 'type': 'str'},
        'dataset_version_id': {'key': 'datasetVersionId', 'type': 'str'},
        'is_visible': {'key': 'isVisible', 'type': 'bool'},
        'properties': {'key': 'properties', 'type': '{object}'},
        'connection_string': {'key': 'connectionString', 'type': 'str'},
        'container_name': {'key': 'containerName', 'type': 'str'},
        'data_storage_endpoint_uri': {'key': 'dataStorageEndpointUri', 'type': 'str'},
        'workspace_sai_token': {'key': 'workspaceSaiToken', 'type': 'str'},
        'aml_dataset_data_flow': {'key': 'amlDatasetDataFlow', 'type': 'str'},
        'system_data': {'key': 'systemData', 'type': 'SystemData'},
        'arm_id': {'key': 'armId', 'type': 'str'},
        'asset_scope_type': {'key': 'assetScopeType', 'type': 'str'},
        'pipeline_run_id': {'key': 'pipelineRunId', 'type': 'str'},
        'module_node_id': {'key': 'moduleNodeId', 'type': 'str'},
        'output_port_name': {'key': 'outputPortName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        feed_name: Optional[str] = None,
        id: Optional[str] = None,
        data_source_type: Optional[Union[str, "DataSourceType"]] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        data_type_id: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        modified_date: Optional[datetime.datetime] = None,
        tags: Optional[Dict[str, str]] = None,
        created_by_studio: Optional[bool] = None,
        data_reference_type: Optional[Union[str, "DataReferenceType"]] = None,
        dataset_type: Optional[str] = None,
        saved_dataset_id: Optional[str] = None,
        dataset_version_id: Optional[str] = None,
        is_visible: Optional[bool] = None,
        properties: Optional[Dict[str, Any]] = None,
        connection_string: Optional[str] = None,
        container_name: Optional[str] = None,
        data_storage_endpoint_uri: Optional[str] = None,
        workspace_sai_token: Optional[str] = None,
        aml_dataset_data_flow: Optional[str] = None,
        system_data: Optional["SystemData"] = None,
        arm_id: Optional[str] = None,
        asset_scope_type: Optional[Union[str, "AssetScopeTypes"]] = None,
        pipeline_run_id: Optional[str] = None,
        module_node_id: Optional[str] = None,
        output_port_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword id:
        :paramtype id: str
        :keyword data_source_type: Possible values include: "None", "PipelineDataSource", "AmlDataset",
         "GlobalDataset", "FeedModel", "FeedDataset".
        :paramtype data_source_type: str or ~designer.models.DataSourceType
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword data_type_id:
        :paramtype data_type_id: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword modified_date:
        :paramtype modified_date: ~datetime.datetime
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword created_by_studio:
        :paramtype created_by_studio: bool
        :keyword data_reference_type: Possible values include: "None", "AzureBlob", "AzureDataLake",
         "AzureFiles", "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS",
         "AzureMySqlDatabase", "Custom".
        :paramtype data_reference_type: str or ~designer.models.DataReferenceType
        :keyword dataset_type:
        :paramtype dataset_type: str
        :keyword saved_dataset_id:
        :paramtype saved_dataset_id: str
        :keyword dataset_version_id:
        :paramtype dataset_version_id: str
        :keyword is_visible:
        :paramtype is_visible: bool
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, any]
        :keyword connection_string:
        :paramtype connection_string: str
        :keyword container_name:
        :paramtype container_name: str
        :keyword data_storage_endpoint_uri:
        :paramtype data_storage_endpoint_uri: str
        :keyword workspace_sai_token:
        :paramtype workspace_sai_token: str
        :keyword aml_dataset_data_flow:
        :paramtype aml_dataset_data_flow: str
        :keyword system_data:
        :paramtype system_data: ~designer.models.SystemData
        :keyword arm_id:
        :paramtype arm_id: str
        :keyword asset_scope_type: Possible values include: "Workspace", "Global", "All", "Feed".
        :paramtype asset_scope_type: str or ~designer.models.AssetScopeTypes
        :keyword pipeline_run_id:
        :paramtype pipeline_run_id: str
        :keyword module_node_id:
        :paramtype module_node_id: str
        :keyword output_port_name:
        :paramtype output_port_name: str
        """
        super(DataInfo, self).__init__(**kwargs)
        self.feed_name = feed_name
        self.id = id
        self.data_source_type = data_source_type
        self.name = name
        self.description = description
        self.data_type_id = data_type_id
        self.aml_data_store_name = aml_data_store_name
        self.relative_path = relative_path
        self.created_date = created_date
        self.modified_date = modified_date
        self.tags = tags
        self.created_by_studio = created_by_studio
        self.data_reference_type = data_reference_type
        self.dataset_type = dataset_type
        self.saved_dataset_id = saved_dataset_id
        self.dataset_version_id = dataset_version_id
        self.is_visible = is_visible
        self.properties = properties
        self.connection_string = connection_string
        self.container_name = container_name
        self.data_storage_endpoint_uri = data_storage_endpoint_uri
        self.workspace_sai_token = workspace_sai_token
        self.aml_dataset_data_flow = aml_dataset_data_flow
        self.system_data = system_data
        self.arm_id = arm_id
        self.asset_scope_type = asset_scope_type
        self.pipeline_run_id = pipeline_run_id
        self.module_node_id = module_node_id
        self.output_port_name = output_port_name


class DataLocation(msrest.serialization.Model):
    """DataLocation.

    :ivar storage_type: Possible values include: "None", "AzureBlob", "Artifact", "Snapshot",
     "SavedAmlDataset", "Asset".
    :vartype storage_type: str or ~designer.models.DataLocationStorageType
    :ivar storage_id:
    :vartype storage_id: str
    :ivar uri:
    :vartype uri: str
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar data_reference:
    :vartype data_reference: ~designer.models.DataReference
    :ivar aml_dataset:
    :vartype aml_dataset: ~designer.models.AmlDataset
    :ivar asset_reference:
    :vartype asset_reference: ~designer.models.AssetReference
    """

    _attribute_map = {
        'storage_type': {'key': 'storageType', 'type': 'str'},
        'storage_id': {'key': 'storageId', 'type': 'str'},
        'uri': {'key': 'uri', 'type': 'str'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'data_reference': {'key': 'dataReference', 'type': 'DataReference'},
        'aml_dataset': {'key': 'amlDataset', 'type': 'AmlDataset'},
        'asset_reference': {'key': 'assetReference', 'type': 'AssetReference'},
    }

    def __init__(
        self,
        *,
        storage_type: Optional[Union[str, "DataLocationStorageType"]] = None,
        storage_id: Optional[str] = None,
        uri: Optional[str] = None,
        data_store_name: Optional[str] = None,
        data_reference: Optional["DataReference"] = None,
        aml_dataset: Optional["AmlDataset"] = None,
        asset_reference: Optional["AssetReference"] = None,
        **kwargs
    ):
        """
        :keyword storage_type: Possible values include: "None", "AzureBlob", "Artifact", "Snapshot",
         "SavedAmlDataset", "Asset".
        :paramtype storage_type: str or ~designer.models.DataLocationStorageType
        :keyword storage_id:
        :paramtype storage_id: str
        :keyword uri:
        :paramtype uri: str
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword data_reference:
        :paramtype data_reference: ~designer.models.DataReference
        :keyword aml_dataset:
        :paramtype aml_dataset: ~designer.models.AmlDataset
        :keyword asset_reference:
        :paramtype asset_reference: ~designer.models.AssetReference
        """
        super(DataLocation, self).__init__(**kwargs)
        self.storage_type = storage_type
        self.storage_id = storage_id
        self.uri = uri
        self.data_store_name = data_store_name
        self.data_reference = data_reference
        self.aml_dataset = aml_dataset
        self.asset_reference = asset_reference


class DataPath(msrest.serialization.Model):
    """DataPath.

    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar sql_data_path:
    :vartype sql_data_path: ~designer.models.SqlDataPath
    """

    _attribute_map = {
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'sql_data_path': {'key': 'sqlDataPath', 'type': 'SqlDataPath'},
    }

    def __init__(
        self,
        *,
        data_store_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        sql_data_path: Optional["SqlDataPath"] = None,
        **kwargs
    ):
        """
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword sql_data_path:
        :paramtype sql_data_path: ~designer.models.SqlDataPath
        """
        super(DataPath, self).__init__(**kwargs)
        self.data_store_name = data_store_name
        self.relative_path = relative_path
        self.sql_data_path = sql_data_path


class DataPathParameter(msrest.serialization.Model):
    """DataPathParameter.

    :ivar name:
    :vartype name: str
    :ivar documentation:
    :vartype documentation: str
    :ivar default_value:
    :vartype default_value: ~designer.models.LegacyDataPath
    :ivar is_optional:
    :vartype is_optional: bool
    :ivar data_type_id:
    :vartype data_type_id: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'documentation': {'key': 'documentation', 'type': 'str'},
        'default_value': {'key': 'defaultValue', 'type': 'LegacyDataPath'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
        'data_type_id': {'key': 'dataTypeId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        documentation: Optional[str] = None,
        default_value: Optional["LegacyDataPath"] = None,
        is_optional: Optional[bool] = None,
        data_type_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword documentation:
        :paramtype documentation: str
        :keyword default_value:
        :paramtype default_value: ~designer.models.LegacyDataPath
        :keyword is_optional:
        :paramtype is_optional: bool
        :keyword data_type_id:
        :paramtype data_type_id: str
        """
        super(DataPathParameter, self).__init__(**kwargs)
        self.name = name
        self.documentation = documentation
        self.default_value = default_value
        self.is_optional = is_optional
        self.data_type_id = data_type_id


class DataReference(msrest.serialization.Model):
    """DataReference.

    :ivar type: Possible values include: "None", "AzureBlob", "AzureDataLake", "AzureFiles",
     "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS", "AzureMySqlDatabase",
     "Custom".
    :vartype type: str or ~designer.models.DataReferenceType
    :ivar azure_blob_reference:
    :vartype azure_blob_reference: ~designer.models.AzureBlobReference
    :ivar azure_data_lake_reference:
    :vartype azure_data_lake_reference: ~designer.models.AzureDataLakeReference
    :ivar azure_files_reference:
    :vartype azure_files_reference: ~designer.models.AzureFilesReference
    :ivar azure_sql_database_reference:
    :vartype azure_sql_database_reference: ~designer.models.AzureDatabaseReference
    :ivar azure_postgres_database_reference:
    :vartype azure_postgres_database_reference: ~designer.models.AzureDatabaseReference
    :ivar azure_data_lake_gen2_reference:
    :vartype azure_data_lake_gen2_reference: ~designer.models.AzureDataLakeGen2Reference
    :ivar dbfs_reference:
    :vartype dbfs_reference: ~designer.models.DBFSReference
    :ivar azure_my_sql_database_reference:
    :vartype azure_my_sql_database_reference: ~designer.models.AzureDatabaseReference
    :ivar custom_reference:
    :vartype custom_reference: ~designer.models.CustomReference
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'azure_blob_reference': {'key': 'azureBlobReference', 'type': 'AzureBlobReference'},
        'azure_data_lake_reference': {'key': 'azureDataLakeReference', 'type': 'AzureDataLakeReference'},
        'azure_files_reference': {'key': 'azureFilesReference', 'type': 'AzureFilesReference'},
        'azure_sql_database_reference': {'key': 'azureSqlDatabaseReference', 'type': 'AzureDatabaseReference'},
        'azure_postgres_database_reference': {'key': 'azurePostgresDatabaseReference', 'type': 'AzureDatabaseReference'},
        'azure_data_lake_gen2_reference': {'key': 'azureDataLakeGen2Reference', 'type': 'AzureDataLakeGen2Reference'},
        'dbfs_reference': {'key': 'dbfsReference', 'type': 'DBFSReference'},
        'azure_my_sql_database_reference': {'key': 'azureMySqlDatabaseReference', 'type': 'AzureDatabaseReference'},
        'custom_reference': {'key': 'customReference', 'type': 'CustomReference'},
    }

    def __init__(
        self,
        *,
        type: Optional[Union[str, "DataReferenceType"]] = None,
        azure_blob_reference: Optional["AzureBlobReference"] = None,
        azure_data_lake_reference: Optional["AzureDataLakeReference"] = None,
        azure_files_reference: Optional["AzureFilesReference"] = None,
        azure_sql_database_reference: Optional["AzureDatabaseReference"] = None,
        azure_postgres_database_reference: Optional["AzureDatabaseReference"] = None,
        azure_data_lake_gen2_reference: Optional["AzureDataLakeGen2Reference"] = None,
        dbfs_reference: Optional["DBFSReference"] = None,
        azure_my_sql_database_reference: Optional["AzureDatabaseReference"] = None,
        custom_reference: Optional["CustomReference"] = None,
        **kwargs
    ):
        """
        :keyword type: Possible values include: "None", "AzureBlob", "AzureDataLake", "AzureFiles",
         "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS", "AzureMySqlDatabase",
         "Custom".
        :paramtype type: str or ~designer.models.DataReferenceType
        :keyword azure_blob_reference:
        :paramtype azure_blob_reference: ~designer.models.AzureBlobReference
        :keyword azure_data_lake_reference:
        :paramtype azure_data_lake_reference: ~designer.models.AzureDataLakeReference
        :keyword azure_files_reference:
        :paramtype azure_files_reference: ~designer.models.AzureFilesReference
        :keyword azure_sql_database_reference:
        :paramtype azure_sql_database_reference: ~designer.models.AzureDatabaseReference
        :keyword azure_postgres_database_reference:
        :paramtype azure_postgres_database_reference: ~designer.models.AzureDatabaseReference
        :keyword azure_data_lake_gen2_reference:
        :paramtype azure_data_lake_gen2_reference: ~designer.models.AzureDataLakeGen2Reference
        :keyword dbfs_reference:
        :paramtype dbfs_reference: ~designer.models.DBFSReference
        :keyword azure_my_sql_database_reference:
        :paramtype azure_my_sql_database_reference: ~designer.models.AzureDatabaseReference
        :keyword custom_reference:
        :paramtype custom_reference: ~designer.models.CustomReference
        """
        super(DataReference, self).__init__(**kwargs)
        self.type = type
        self.azure_blob_reference = azure_blob_reference
        self.azure_data_lake_reference = azure_data_lake_reference
        self.azure_files_reference = azure_files_reference
        self.azure_sql_database_reference = azure_sql_database_reference
        self.azure_postgres_database_reference = azure_postgres_database_reference
        self.azure_data_lake_gen2_reference = azure_data_lake_gen2_reference
        self.dbfs_reference = dbfs_reference
        self.azure_my_sql_database_reference = azure_my_sql_database_reference
        self.custom_reference = custom_reference


class DataReferenceConfiguration(msrest.serialization.Model):
    """DataReferenceConfiguration.

    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar mode: Possible values include: "Mount", "Download", "Upload".
    :vartype mode: str or ~designer.models.DataStoreMode
    :ivar path_on_data_store:
    :vartype path_on_data_store: str
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    """

    _attribute_map = {
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'mode': {'key': 'mode', 'type': 'str'},
        'path_on_data_store': {'key': 'pathOnDataStore', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        data_store_name: Optional[str] = None,
        mode: Optional[Union[str, "DataStoreMode"]] = None,
        path_on_data_store: Optional[str] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword mode: Possible values include: "Mount", "Download", "Upload".
        :paramtype mode: str or ~designer.models.DataStoreMode
        :keyword path_on_data_store:
        :paramtype path_on_data_store: str
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        """
        super(DataReferenceConfiguration, self).__init__(**kwargs)
        self.data_store_name = data_store_name
        self.mode = mode
        self.path_on_data_store = path_on_data_store
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite


class DataSetDefinition(msrest.serialization.Model):
    """DataSetDefinition.

    :ivar data_type_short_name:
    :vartype data_type_short_name: str
    :ivar parameter_name:
    :vartype parameter_name: str
    :ivar value:
    :vartype value: ~designer.models.DataSetDefinitionValue
    """

    _attribute_map = {
        'data_type_short_name': {'key': 'dataTypeShortName', 'type': 'str'},
        'parameter_name': {'key': 'parameterName', 'type': 'str'},
        'value': {'key': 'value', 'type': 'DataSetDefinitionValue'},
    }

    def __init__(
        self,
        *,
        data_type_short_name: Optional[str] = None,
        parameter_name: Optional[str] = None,
        value: Optional["DataSetDefinitionValue"] = None,
        **kwargs
    ):
        """
        :keyword data_type_short_name:
        :paramtype data_type_short_name: str
        :keyword parameter_name:
        :paramtype parameter_name: str
        :keyword value:
        :paramtype value: ~designer.models.DataSetDefinitionValue
        """
        super(DataSetDefinition, self).__init__(**kwargs)
        self.data_type_short_name = data_type_short_name
        self.parameter_name = parameter_name
        self.value = value


class DataSetDefinitionValue(msrest.serialization.Model):
    """DataSetDefinitionValue.

    :ivar literal_value:
    :vartype literal_value: ~designer.models.DataPath
    :ivar data_set_reference:
    :vartype data_set_reference: ~designer.models.RegisteredDataSetReference
    :ivar saved_data_set_reference:
    :vartype saved_data_set_reference: ~designer.models.SavedDataSetReference
    :ivar asset_reference:
    :vartype asset_reference: ~designer.models.AssetReference
    """

    _attribute_map = {
        'literal_value': {'key': 'literalValue', 'type': 'DataPath'},
        'data_set_reference': {'key': 'dataSetReference', 'type': 'RegisteredDataSetReference'},
        'saved_data_set_reference': {'key': 'savedDataSetReference', 'type': 'SavedDataSetReference'},
        'asset_reference': {'key': 'assetReference', 'type': 'AssetReference'},
    }

    def __init__(
        self,
        *,
        literal_value: Optional["DataPath"] = None,
        data_set_reference: Optional["RegisteredDataSetReference"] = None,
        saved_data_set_reference: Optional["SavedDataSetReference"] = None,
        asset_reference: Optional["AssetReference"] = None,
        **kwargs
    ):
        """
        :keyword literal_value:
        :paramtype literal_value: ~designer.models.DataPath
        :keyword data_set_reference:
        :paramtype data_set_reference: ~designer.models.RegisteredDataSetReference
        :keyword saved_data_set_reference:
        :paramtype saved_data_set_reference: ~designer.models.SavedDataSetReference
        :keyword asset_reference:
        :paramtype asset_reference: ~designer.models.AssetReference
        """
        super(DataSetDefinitionValue, self).__init__(**kwargs)
        self.literal_value = literal_value
        self.data_set_reference = data_set_reference
        self.saved_data_set_reference = saved_data_set_reference
        self.asset_reference = asset_reference


class DatasetIdentifier(msrest.serialization.Model):
    """DatasetIdentifier.

    :ivar saved_id:
    :vartype saved_id: str
    :ivar registered_id:
    :vartype registered_id: str
    :ivar registered_version:
    :vartype registered_version: str
    """

    _attribute_map = {
        'saved_id': {'key': 'savedId', 'type': 'str'},
        'registered_id': {'key': 'registeredId', 'type': 'str'},
        'registered_version': {'key': 'registeredVersion', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        saved_id: Optional[str] = None,
        registered_id: Optional[str] = None,
        registered_version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword saved_id:
        :paramtype saved_id: str
        :keyword registered_id:
        :paramtype registered_id: str
        :keyword registered_version:
        :paramtype registered_version: str
        """
        super(DatasetIdentifier, self).__init__(**kwargs)
        self.saved_id = saved_id
        self.registered_id = registered_id
        self.registered_version = registered_version


class DatasetInputDetails(msrest.serialization.Model):
    """DatasetInputDetails.

    :ivar input_name:
    :vartype input_name: str
    :ivar mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
    :vartype mechanism: str or ~designer.models.DatasetDeliveryMechanism
    :ivar path_on_compute:
    :vartype path_on_compute: str
    """

    _attribute_map = {
        'input_name': {'key': 'inputName', 'type': 'str'},
        'mechanism': {'key': 'mechanism', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        input_name: Optional[str] = None,
        mechanism: Optional[Union[str, "DatasetDeliveryMechanism"]] = None,
        path_on_compute: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword input_name:
        :paramtype input_name: str
        :keyword mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
        :paramtype mechanism: str or ~designer.models.DatasetDeliveryMechanism
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        """
        super(DatasetInputDetails, self).__init__(**kwargs)
        self.input_name = input_name
        self.mechanism = mechanism
        self.path_on_compute = path_on_compute


class DatasetLineage(msrest.serialization.Model):
    """DatasetLineage.

    :ivar identifier:
    :vartype identifier: ~designer.models.DatasetIdentifier
    :ivar consumption_type: Possible values include: "RunInput", "Reference".
    :vartype consumption_type: str or ~designer.models.DatasetConsumptionType
    :ivar input_details:
    :vartype input_details: ~designer.models.DatasetInputDetails
    """

    _attribute_map = {
        'identifier': {'key': 'identifier', 'type': 'DatasetIdentifier'},
        'consumption_type': {'key': 'consumptionType', 'type': 'str'},
        'input_details': {'key': 'inputDetails', 'type': 'DatasetInputDetails'},
    }

    def __init__(
        self,
        *,
        identifier: Optional["DatasetIdentifier"] = None,
        consumption_type: Optional[Union[str, "DatasetConsumptionType"]] = None,
        input_details: Optional["DatasetInputDetails"] = None,
        **kwargs
    ):
        """
        :keyword identifier:
        :paramtype identifier: ~designer.models.DatasetIdentifier
        :keyword consumption_type: Possible values include: "RunInput", "Reference".
        :paramtype consumption_type: str or ~designer.models.DatasetConsumptionType
        :keyword input_details:
        :paramtype input_details: ~designer.models.DatasetInputDetails
        """
        super(DatasetLineage, self).__init__(**kwargs)
        self.identifier = identifier
        self.consumption_type = consumption_type
        self.input_details = input_details


class DatasetOutput(msrest.serialization.Model):
    """DatasetOutput.

    :ivar dataset_type: Possible values include: "File", "Tabular".
    :vartype dataset_type: str or ~designer.models.DatasetType
    :ivar dataset_registration:
    :vartype dataset_registration: ~designer.models.DatasetRegistration
    :ivar dataset_output_options:
    :vartype dataset_output_options: ~designer.models.DatasetOutputOptions
    """

    _attribute_map = {
        'dataset_type': {'key': 'datasetType', 'type': 'str'},
        'dataset_registration': {'key': 'datasetRegistration', 'type': 'DatasetRegistration'},
        'dataset_output_options': {'key': 'datasetOutputOptions', 'type': 'DatasetOutputOptions'},
    }

    def __init__(
        self,
        *,
        dataset_type: Optional[Union[str, "DatasetType"]] = None,
        dataset_registration: Optional["DatasetRegistration"] = None,
        dataset_output_options: Optional["DatasetOutputOptions"] = None,
        **kwargs
    ):
        """
        :keyword dataset_type: Possible values include: "File", "Tabular".
        :paramtype dataset_type: str or ~designer.models.DatasetType
        :keyword dataset_registration:
        :paramtype dataset_registration: ~designer.models.DatasetRegistration
        :keyword dataset_output_options:
        :paramtype dataset_output_options: ~designer.models.DatasetOutputOptions
        """
        super(DatasetOutput, self).__init__(**kwargs)
        self.dataset_type = dataset_type
        self.dataset_registration = dataset_registration
        self.dataset_output_options = dataset_output_options


class DatasetOutputDetails(msrest.serialization.Model):
    """DatasetOutputDetails.

    :ivar output_name:
    :vartype output_name: str
    """

    _attribute_map = {
        'output_name': {'key': 'outputName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        output_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword output_name:
        :paramtype output_name: str
        """
        super(DatasetOutputDetails, self).__init__(**kwargs)
        self.output_name = output_name


class DatasetOutputOptions(msrest.serialization.Model):
    """DatasetOutputOptions.

    :ivar source_globs:
    :vartype source_globs: ~designer.models.GlobsOptions
    :ivar path_on_datastore:
    :vartype path_on_datastore: str
    """

    _attribute_map = {
        'source_globs': {'key': 'sourceGlobs', 'type': 'GlobsOptions'},
        'path_on_datastore': {'key': 'pathOnDatastore', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        source_globs: Optional["GlobsOptions"] = None,
        path_on_datastore: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword source_globs:
        :paramtype source_globs: ~designer.models.GlobsOptions
        :keyword path_on_datastore:
        :paramtype path_on_datastore: str
        """
        super(DatasetOutputOptions, self).__init__(**kwargs)
        self.source_globs = source_globs
        self.path_on_datastore = path_on_datastore


class DataSetPathParameter(msrest.serialization.Model):
    """DataSetPathParameter.

    :ivar name:
    :vartype name: str
    :ivar documentation:
    :vartype documentation: str
    :ivar default_value:
    :vartype default_value: ~designer.models.DataSetDefinitionValue
    :ivar is_optional:
    :vartype is_optional: bool
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'documentation': {'key': 'documentation', 'type': 'str'},
        'default_value': {'key': 'defaultValue', 'type': 'DataSetDefinitionValue'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        documentation: Optional[str] = None,
        default_value: Optional["DataSetDefinitionValue"] = None,
        is_optional: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword documentation:
        :paramtype documentation: str
        :keyword default_value:
        :paramtype default_value: ~designer.models.DataSetDefinitionValue
        :keyword is_optional:
        :paramtype is_optional: bool
        """
        super(DataSetPathParameter, self).__init__(**kwargs)
        self.name = name
        self.documentation = documentation
        self.default_value = default_value
        self.is_optional = is_optional


class DatasetRegistration(msrest.serialization.Model):
    """DatasetRegistration.

    :ivar name:
    :vartype name: str
    :ivar create_new_version:
    :vartype create_new_version: bool
    :ivar description:
    :vartype description: str
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar additional_transformations:
    :vartype additional_transformations: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'create_new_version': {'key': 'createNewVersion', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'additional_transformations': {'key': 'additionalTransformations', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        create_new_version: Optional[bool] = None,
        description: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        additional_transformations: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword create_new_version:
        :paramtype create_new_version: bool
        :keyword description:
        :paramtype description: str
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword additional_transformations:
        :paramtype additional_transformations: str
        """
        super(DatasetRegistration, self).__init__(**kwargs)
        self.name = name
        self.create_new_version = create_new_version
        self.description = description
        self.tags = tags
        self.additional_transformations = additional_transformations


class DatasetRegistrationOptions(msrest.serialization.Model):
    """DatasetRegistrationOptions.

    :ivar additional_transformation:
    :vartype additional_transformation: str
    """

    _attribute_map = {
        'additional_transformation': {'key': 'additionalTransformation', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        additional_transformation: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword additional_transformation:
        :paramtype additional_transformation: str
        """
        super(DatasetRegistrationOptions, self).__init__(**kwargs)
        self.additional_transformation = additional_transformation


class DataSettings(msrest.serialization.Model):
    """DataSettings.

    :ivar target_column_name:
    :vartype target_column_name: str
    :ivar weight_column_name:
    :vartype weight_column_name: str
    :ivar validation_data:
    :vartype validation_data: ~designer.models.ValidationDataSettings
    :ivar test_data:
    :vartype test_data: ~designer.models.TestDataSettings
    """

    _attribute_map = {
        'target_column_name': {'key': 'targetColumnName', 'type': 'str'},
        'weight_column_name': {'key': 'weightColumnName', 'type': 'str'},
        'validation_data': {'key': 'validationData', 'type': 'ValidationDataSettings'},
        'test_data': {'key': 'testData', 'type': 'TestDataSettings'},
    }

    def __init__(
        self,
        *,
        target_column_name: Optional[str] = None,
        weight_column_name: Optional[str] = None,
        validation_data: Optional["ValidationDataSettings"] = None,
        test_data: Optional["TestDataSettings"] = None,
        **kwargs
    ):
        """
        :keyword target_column_name:
        :paramtype target_column_name: str
        :keyword weight_column_name:
        :paramtype weight_column_name: str
        :keyword validation_data:
        :paramtype validation_data: ~designer.models.ValidationDataSettings
        :keyword test_data:
        :paramtype test_data: ~designer.models.TestDataSettings
        """
        super(DataSettings, self).__init__(**kwargs)
        self.target_column_name = target_column_name
        self.weight_column_name = weight_column_name
        self.validation_data = validation_data
        self.test_data = test_data


class DatastoreSetting(msrest.serialization.Model):
    """DatastoreSetting.

    :ivar data_store_name:
    :vartype data_store_name: str
    """

    _attribute_map = {
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword data_store_name:
        :paramtype data_store_name: str
        """
        super(DatastoreSetting, self).__init__(**kwargs)
        self.data_store_name = data_store_name


class DataTransferCloudConfiguration(msrest.serialization.Model):
    """DataTransferCloudConfiguration.

    :ivar allow_overwrite:
    :vartype allow_overwrite: bool
    """

    _attribute_map = {
        'allow_overwrite': {'key': 'AllowOverwrite', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        allow_overwrite: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword allow_overwrite:
        :paramtype allow_overwrite: bool
        """
        super(DataTransferCloudConfiguration, self).__init__(**kwargs)
        self.allow_overwrite = allow_overwrite


class DBFSReference(msrest.serialization.Model):
    """DBFSReference.

    :ivar relative_path:
    :vartype relative_path: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    """

    _attribute_map = {
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        relative_path: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        """
        super(DBFSReference, self).__init__(**kwargs)
        self.relative_path = relative_path
        self.aml_data_store_name = aml_data_store_name


class DbfsStorageInfoDto(msrest.serialization.Model):
    """DbfsStorageInfoDto.

    :ivar destination:
    :vartype destination: str
    """

    _attribute_map = {
        'destination': {'key': 'destination', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        destination: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword destination:
        :paramtype destination: str
        """
        super(DbfsStorageInfoDto, self).__init__(**kwargs)
        self.destination = destination


class DebugInfoResponse(msrest.serialization.Model):
    """Internal debugging information not intended for external clients.

    :ivar type: The type.
    :vartype type: str
    :ivar message: The message.
    :vartype message: str
    :ivar stack_trace: The stack trace.
    :vartype stack_trace: str
    :ivar inner_exception: Internal debugging information not intended for external clients.
    :vartype inner_exception: ~designer.models.DebugInfoResponse
    :ivar data: This is a dictionary.
    :vartype data: dict[str, any]
    :ivar error_response: The error response.
    :vartype error_response: ~designer.models.ErrorResponse
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
        'stack_trace': {'key': 'stackTrace', 'type': 'str'},
        'inner_exception': {'key': 'innerException', 'type': 'DebugInfoResponse'},
        'data': {'key': 'data', 'type': '{object}'},
        'error_response': {'key': 'errorResponse', 'type': 'ErrorResponse'},
    }

    def __init__(
        self,
        *,
        type: Optional[str] = None,
        message: Optional[str] = None,
        stack_trace: Optional[str] = None,
        inner_exception: Optional["DebugInfoResponse"] = None,
        data: Optional[Dict[str, Any]] = None,
        error_response: Optional["ErrorResponse"] = None,
        **kwargs
    ):
        """
        :keyword type: The type.
        :paramtype type: str
        :keyword message: The message.
        :paramtype message: str
        :keyword stack_trace: The stack trace.
        :paramtype stack_trace: str
        :keyword inner_exception: Internal debugging information not intended for external clients.
        :paramtype inner_exception: ~designer.models.DebugInfoResponse
        :keyword data: This is a dictionary.
        :paramtype data: dict[str, any]
        :keyword error_response: The error response.
        :paramtype error_response: ~designer.models.ErrorResponse
        """
        super(DebugInfoResponse, self).__init__(**kwargs)
        self.type = type
        self.message = message
        self.stack_trace = stack_trace
        self.inner_exception = inner_exception
        self.data = data
        self.error_response = error_response


class DeploymentInfo(msrest.serialization.Model):
    """DeploymentInfo.

    :ivar operation_id:
    :vartype operation_id: str
    :ivar service_id:
    :vartype service_id: str
    :ivar service_name:
    :vartype service_name: str
    :ivar status_detail:
    :vartype status_detail: str
    """

    _attribute_map = {
        'operation_id': {'key': 'operationId', 'type': 'str'},
        'service_id': {'key': 'serviceId', 'type': 'str'},
        'service_name': {'key': 'serviceName', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        operation_id: Optional[str] = None,
        service_id: Optional[str] = None,
        service_name: Optional[str] = None,
        status_detail: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword operation_id:
        :paramtype operation_id: str
        :keyword service_id:
        :paramtype service_id: str
        :keyword service_name:
        :paramtype service_name: str
        :keyword status_detail:
        :paramtype status_detail: str
        """
        super(DeploymentInfo, self).__init__(**kwargs)
        self.operation_id = operation_id
        self.service_id = service_id
        self.service_name = service_name
        self.status_detail = status_detail


class DirTreeNode(msrest.serialization.Model):
    """DirTreeNode.

    :ivar name:
    :vartype name: str
    :ivar hash:
    :vartype hash: str
    :ivar type:
    :vartype type: str
    :ivar timestamp:
    :vartype timestamp: ~datetime.datetime
    :ivar sas_url:
    :vartype sas_url: str
    :ivar absolute_url:
    :vartype absolute_url: str
    :ivar size_bytes:
    :vartype size_bytes: long
    :ivar size_set:
    :vartype size_set: bool
    :ivar children: Dictionary of :code:`<DirTreeNode>`.
    :vartype children: dict[str, ~designer.models.DirTreeNode]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'hash': {'key': 'hash', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
        'timestamp': {'key': 'timestamp', 'type': 'iso-8601'},
        'sas_url': {'key': 'sasUrl', 'type': 'str'},
        'absolute_url': {'key': 'absoluteUrl', 'type': 'str'},
        'size_bytes': {'key': 'sizeBytes', 'type': 'long'},
        'size_set': {'key': 'sizeSet', 'type': 'bool'},
        'children': {'key': 'children', 'type': '{DirTreeNode}'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        hash: Optional[str] = None,
        type: Optional[str] = None,
        timestamp: Optional[datetime.datetime] = None,
        sas_url: Optional[str] = None,
        absolute_url: Optional[str] = None,
        size_bytes: Optional[int] = None,
        size_set: Optional[bool] = None,
        children: Optional[Dict[str, "DirTreeNode"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword hash:
        :paramtype hash: str
        :keyword type:
        :paramtype type: str
        :keyword timestamp:
        :paramtype timestamp: ~datetime.datetime
        :keyword sas_url:
        :paramtype sas_url: str
        :keyword absolute_url:
        :paramtype absolute_url: str
        :keyword size_bytes:
        :paramtype size_bytes: long
        :keyword size_set:
        :paramtype size_set: bool
        :keyword children: Dictionary of :code:`<DirTreeNode>`.
        :paramtype children: dict[str, ~designer.models.DirTreeNode]
        """
        super(DirTreeNode, self).__init__(**kwargs)
        self.name = name
        self.hash = hash
        self.type = type
        self.timestamp = timestamp
        self.sas_url = sas_url
        self.absolute_url = absolute_url
        self.size_bytes = size_bytes
        self.size_set = size_set
        self.children = children


class DockerBuildContext(msrest.serialization.Model):
    """DockerBuildContext.

    :ivar location_type: Possible values include: "Git", "StorageAccount".
    :vartype location_type: str or ~designer.models.BuildContextLocationType
    :ivar location:
    :vartype location: str
    :ivar dockerfile_path:
    :vartype dockerfile_path: str
    """

    _attribute_map = {
        'location_type': {'key': 'locationType', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'dockerfile_path': {'key': 'dockerfilePath', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        location_type: Optional[Union[str, "BuildContextLocationType"]] = None,
        location: Optional[str] = None,
        dockerfile_path: Optional[str] = "Dockerfile",
        **kwargs
    ):
        """
        :keyword location_type: Possible values include: "Git", "StorageAccount".
        :paramtype location_type: str or ~designer.models.BuildContextLocationType
        :keyword location:
        :paramtype location: str
        :keyword dockerfile_path:
        :paramtype dockerfile_path: str
        """
        super(DockerBuildContext, self).__init__(**kwargs)
        self.location_type = location_type
        self.location = location
        self.dockerfile_path = dockerfile_path


class DockerConfiguration(msrest.serialization.Model):
    """DockerConfiguration.

    :ivar use_docker:
    :vartype use_docker: bool
    :ivar shared_volumes:
    :vartype shared_volumes: bool
    :ivar arguments:
    :vartype arguments: list[str]
    """

    _attribute_map = {
        'use_docker': {'key': 'useDocker', 'type': 'bool'},
        'shared_volumes': {'key': 'sharedVolumes', 'type': 'bool'},
        'arguments': {'key': 'arguments', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        use_docker: Optional[bool] = None,
        shared_volumes: Optional[bool] = None,
        arguments: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword use_docker:
        :paramtype use_docker: bool
        :keyword shared_volumes:
        :paramtype shared_volumes: bool
        :keyword arguments:
        :paramtype arguments: list[str]
        """
        super(DockerConfiguration, self).__init__(**kwargs)
        self.use_docker = use_docker
        self.shared_volumes = shared_volumes
        self.arguments = arguments


class DockerImagePlatform(msrest.serialization.Model):
    """DockerImagePlatform.

    :ivar os:
    :vartype os: str
    :ivar architecture:
    :vartype architecture: str
    """

    _attribute_map = {
        'os': {'key': 'os', 'type': 'str'},
        'architecture': {'key': 'architecture', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        os: Optional[str] = None,
        architecture: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword os:
        :paramtype os: str
        :keyword architecture:
        :paramtype architecture: str
        """
        super(DockerImagePlatform, self).__init__(**kwargs)
        self.os = os
        self.architecture = architecture


class DockerSection(msrest.serialization.Model):
    """DockerSection.

    :ivar base_image:
    :vartype base_image: str
    :ivar platform:
    :vartype platform: ~designer.models.DockerImagePlatform
    :ivar base_dockerfile:
    :vartype base_dockerfile: str
    :ivar build_context:
    :vartype build_context: ~designer.models.DockerBuildContext
    :ivar base_image_registry:
    :vartype base_image_registry: ~designer.models.ContainerRegistry
    """

    _attribute_map = {
        'base_image': {'key': 'baseImage', 'type': 'str'},
        'platform': {'key': 'platform', 'type': 'DockerImagePlatform'},
        'base_dockerfile': {'key': 'baseDockerfile', 'type': 'str'},
        'build_context': {'key': 'buildContext', 'type': 'DockerBuildContext'},
        'base_image_registry': {'key': 'baseImageRegistry', 'type': 'ContainerRegistry'},
    }

    def __init__(
        self,
        *,
        base_image: Optional[str] = None,
        platform: Optional["DockerImagePlatform"] = None,
        base_dockerfile: Optional[str] = None,
        build_context: Optional["DockerBuildContext"] = None,
        base_image_registry: Optional["ContainerRegistry"] = None,
        **kwargs
    ):
        """
        :keyword base_image:
        :paramtype base_image: str
        :keyword platform:
        :paramtype platform: ~designer.models.DockerImagePlatform
        :keyword base_dockerfile:
        :paramtype base_dockerfile: str
        :keyword build_context:
        :paramtype build_context: ~designer.models.DockerBuildContext
        :keyword base_image_registry:
        :paramtype base_image_registry: ~designer.models.ContainerRegistry
        """
        super(DockerSection, self).__init__(**kwargs)
        self.base_image = base_image
        self.platform = platform
        self.base_dockerfile = base_dockerfile
        self.build_context = build_context
        self.base_image_registry = base_image_registry


class DownloadResourceInfo(msrest.serialization.Model):
    """DownloadResourceInfo.

    :ivar download_url:
    :vartype download_url: str
    :ivar size:
    :vartype size: long
    """

    _attribute_map = {
        'download_url': {'key': 'downloadUrl', 'type': 'str'},
        'size': {'key': 'size', 'type': 'long'},
    }

    def __init__(
        self,
        *,
        download_url: Optional[str] = None,
        size: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword download_url:
        :paramtype download_url: str
        :keyword size:
        :paramtype size: long
        """
        super(DownloadResourceInfo, self).__init__(**kwargs)
        self.download_url = download_url
        self.size = size


class EntityInterface(msrest.serialization.Model):
    """EntityInterface.

    :ivar parameters:
    :vartype parameters: list[~designer.models.Parameter]
    :ivar ports:
    :vartype ports: ~designer.models.NodePortInterface
    :ivar metadata_parameters:
    :vartype metadata_parameters: list[~designer.models.Parameter]
    :ivar data_path_parameters:
    :vartype data_path_parameters: list[~designer.models.DataPathParameter]
    :ivar data_path_parameter_list:
    :vartype data_path_parameter_list: list[~designer.models.DataSetPathParameter]
    """

    _attribute_map = {
        'parameters': {'key': 'parameters', 'type': '[Parameter]'},
        'ports': {'key': 'ports', 'type': 'NodePortInterface'},
        'metadata_parameters': {'key': 'metadataParameters', 'type': '[Parameter]'},
        'data_path_parameters': {'key': 'dataPathParameters', 'type': '[DataPathParameter]'},
        'data_path_parameter_list': {'key': 'dataPathParameterList', 'type': '[DataSetPathParameter]'},
    }

    def __init__(
        self,
        *,
        parameters: Optional[List["Parameter"]] = None,
        ports: Optional["NodePortInterface"] = None,
        metadata_parameters: Optional[List["Parameter"]] = None,
        data_path_parameters: Optional[List["DataPathParameter"]] = None,
        data_path_parameter_list: Optional[List["DataSetPathParameter"]] = None,
        **kwargs
    ):
        """
        :keyword parameters:
        :paramtype parameters: list[~designer.models.Parameter]
        :keyword ports:
        :paramtype ports: ~designer.models.NodePortInterface
        :keyword metadata_parameters:
        :paramtype metadata_parameters: list[~designer.models.Parameter]
        :keyword data_path_parameters:
        :paramtype data_path_parameters: list[~designer.models.DataPathParameter]
        :keyword data_path_parameter_list:
        :paramtype data_path_parameter_list: list[~designer.models.DataSetPathParameter]
        """
        super(EntityInterface, self).__init__(**kwargs)
        self.parameters = parameters
        self.ports = ports
        self.metadata_parameters = metadata_parameters
        self.data_path_parameters = data_path_parameters
        self.data_path_parameter_list = data_path_parameter_list


class EnumParameterRule(msrest.serialization.Model):
    """EnumParameterRule.

    :ivar valid_values:
    :vartype valid_values: list[str]
    """

    _attribute_map = {
        'valid_values': {'key': 'validValues', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        valid_values: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword valid_values:
        :paramtype valid_values: list[str]
        """
        super(EnumParameterRule, self).__init__(**kwargs)
        self.valid_values = valid_values


class EnvironmentConfiguration(msrest.serialization.Model):
    """EnvironmentConfiguration.

    :ivar name:
    :vartype name: str
    :ivar version:
    :vartype version: str
    :ivar use_environment_definition:
    :vartype use_environment_definition: bool
    :ivar environment_definition_string:
    :vartype environment_definition_string: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'use_environment_definition': {'key': 'useEnvironmentDefinition', 'type': 'bool'},
        'environment_definition_string': {'key': 'environmentDefinitionString', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        version: Optional[str] = None,
        use_environment_definition: Optional[bool] = None,
        environment_definition_string: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword version:
        :paramtype version: str
        :keyword use_environment_definition:
        :paramtype use_environment_definition: bool
        :keyword environment_definition_string:
        :paramtype environment_definition_string: str
        """
        super(EnvironmentConfiguration, self).__init__(**kwargs)
        self.name = name
        self.version = version
        self.use_environment_definition = use_environment_definition
        self.environment_definition_string = environment_definition_string


class EnvironmentDefinition(msrest.serialization.Model):
    """EnvironmentDefinition.

    :ivar name:
    :vartype name: str
    :ivar version:
    :vartype version: str
    :ivar asset_id:
    :vartype asset_id: str
    :ivar python:
    :vartype python: ~designer.models.PythonSection
    :ivar environment_variables: Dictionary of :code:`<string>`.
    :vartype environment_variables: dict[str, str]
    :ivar docker:
    :vartype docker: ~designer.models.DockerSection
    :ivar spark:
    :vartype spark: ~designer.models.SparkSection
    :ivar r:
    :vartype r: ~designer.models.RSection
    :ivar inferencing_stack_version:
    :vartype inferencing_stack_version: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'asset_id': {'key': 'assetId', 'type': 'str'},
        'python': {'key': 'python', 'type': 'PythonSection'},
        'environment_variables': {'key': 'environmentVariables', 'type': '{str}'},
        'docker': {'key': 'docker', 'type': 'DockerSection'},
        'spark': {'key': 'spark', 'type': 'SparkSection'},
        'r': {'key': 'r', 'type': 'RSection'},
        'inferencing_stack_version': {'key': 'inferencingStackVersion', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        version: Optional[str] = None,
        asset_id: Optional[str] = None,
        python: Optional["PythonSection"] = None,
        environment_variables: Optional[Dict[str, str]] = None,
        docker: Optional["DockerSection"] = None,
        spark: Optional["SparkSection"] = None,
        r: Optional["RSection"] = None,
        inferencing_stack_version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword version:
        :paramtype version: str
        :keyword asset_id:
        :paramtype asset_id: str
        :keyword python:
        :paramtype python: ~designer.models.PythonSection
        :keyword environment_variables: Dictionary of :code:`<string>`.
        :paramtype environment_variables: dict[str, str]
        :keyword docker:
        :paramtype docker: ~designer.models.DockerSection
        :keyword spark:
        :paramtype spark: ~designer.models.SparkSection
        :keyword r:
        :paramtype r: ~designer.models.RSection
        :keyword inferencing_stack_version:
        :paramtype inferencing_stack_version: str
        """
        super(EnvironmentDefinition, self).__init__(**kwargs)
        self.name = name
        self.version = version
        self.asset_id = asset_id
        self.python = python
        self.environment_variables = environment_variables
        self.docker = docker
        self.spark = spark
        self.r = r
        self.inferencing_stack_version = inferencing_stack_version


class ErrorAdditionalInfo(msrest.serialization.Model):
    """The resource management error additional info.

    :ivar type: The additional info type.
    :vartype type: str
    :ivar info: The additional info.
    :vartype info: any
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'info': {'key': 'info', 'type': 'object'},
    }

    def __init__(
        self,
        *,
        type: Optional[str] = None,
        info: Optional[Any] = None,
        **kwargs
    ):
        """
        :keyword type: The additional info type.
        :paramtype type: str
        :keyword info: The additional info.
        :paramtype info: any
        """
        super(ErrorAdditionalInfo, self).__init__(**kwargs)
        self.type = type
        self.info = info


class ErrorResponse(msrest.serialization.Model):
    """The error response.

    :ivar error: The root error.
    :vartype error: ~designer.models.RootError
    :ivar correlation: Dictionary containing correlation details for the error.
    :vartype correlation: dict[str, str]
    :ivar environment: The hosting environment.
    :vartype environment: str
    :ivar location: The Azure region.
    :vartype location: str
    :ivar time: The time in UTC.
    :vartype time: ~datetime.datetime
    :ivar component_name: Component name where error originated/encountered.
    :vartype component_name: str
    """

    _attribute_map = {
        'error': {'key': 'error', 'type': 'RootError'},
        'correlation': {'key': 'correlation', 'type': '{str}'},
        'environment': {'key': 'environment', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'time': {'key': 'time', 'type': 'iso-8601'},
        'component_name': {'key': 'componentName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        error: Optional["RootError"] = None,
        correlation: Optional[Dict[str, str]] = None,
        environment: Optional[str] = None,
        location: Optional[str] = None,
        time: Optional[datetime.datetime] = None,
        component_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword error: The root error.
        :paramtype error: ~designer.models.RootError
        :keyword correlation: Dictionary containing correlation details for the error.
        :paramtype correlation: dict[str, str]
        :keyword environment: The hosting environment.
        :paramtype environment: str
        :keyword location: The Azure region.
        :paramtype location: str
        :keyword time: The time in UTC.
        :paramtype time: ~datetime.datetime
        :keyword component_name: Component name where error originated/encountered.
        :paramtype component_name: str
        """
        super(ErrorResponse, self).__init__(**kwargs)
        self.error = error
        self.correlation = correlation
        self.environment = environment
        self.location = location
        self.time = time
        self.component_name = component_name


class EsCloudConfiguration(msrest.serialization.Model):
    """EsCloudConfiguration.

    :ivar enable_output_to_file_based_on_data_type_id:
    :vartype enable_output_to_file_based_on_data_type_id: bool
    :ivar environment:
    :vartype environment: ~designer.models.EnvironmentConfiguration
    :ivar hyper_drive_configuration:
    :vartype hyper_drive_configuration: ~designer.models.HyperDriveConfiguration
    """

    _attribute_map = {
        'enable_output_to_file_based_on_data_type_id': {'key': 'enableOutputToFileBasedOnDataTypeId', 'type': 'bool'},
        'environment': {'key': 'environment', 'type': 'EnvironmentConfiguration'},
        'hyper_drive_configuration': {'key': 'hyperDriveConfiguration', 'type': 'HyperDriveConfiguration'},
    }

    def __init__(
        self,
        *,
        enable_output_to_file_based_on_data_type_id: Optional[bool] = None,
        environment: Optional["EnvironmentConfiguration"] = None,
        hyper_drive_configuration: Optional["HyperDriveConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword enable_output_to_file_based_on_data_type_id:
        :paramtype enable_output_to_file_based_on_data_type_id: bool
        :keyword environment:
        :paramtype environment: ~designer.models.EnvironmentConfiguration
        :keyword hyper_drive_configuration:
        :paramtype hyper_drive_configuration: ~designer.models.HyperDriveConfiguration
        """
        super(EsCloudConfiguration, self).__init__(**kwargs)
        self.enable_output_to_file_based_on_data_type_id = enable_output_to_file_based_on_data_type_id
        self.environment = environment
        self.hyper_drive_configuration = hyper_drive_configuration


class ExampleRequest(msrest.serialization.Model):
    """ExampleRequest.

    :ivar inputs: This is a dictionary.
    :vartype inputs: dict[str, list[list[any]]]
    :ivar global_parameters: This is a dictionary.
    :vartype global_parameters: dict[str, any]
    """

    _attribute_map = {
        'inputs': {'key': 'inputs', 'type': '{[[object]]}'},
        'global_parameters': {'key': 'globalParameters', 'type': '{object}'},
    }

    def __init__(
        self,
        *,
        inputs: Optional[Dict[str, List[List[Any]]]] = None,
        global_parameters: Optional[Dict[str, Any]] = None,
        **kwargs
    ):
        """
        :keyword inputs: This is a dictionary.
        :paramtype inputs: dict[str, list[list[any]]]
        :keyword global_parameters: This is a dictionary.
        :paramtype global_parameters: dict[str, any]
        """
        super(ExampleRequest, self).__init__(**kwargs)
        self.inputs = inputs
        self.global_parameters = global_parameters


class ExecutionDataLocation(msrest.serialization.Model):
    """ExecutionDataLocation.

    :ivar dataset:
    :vartype dataset: ~designer.models.RunDatasetReference
    :ivar data_path:
    :vartype data_path: ~designer.models.ExecutionDataPath
    :ivar uri:
    :vartype uri: ~designer.models.UriReference
    :ivar type:
    :vartype type: str
    """

    _attribute_map = {
        'dataset': {'key': 'dataset', 'type': 'RunDatasetReference'},
        'data_path': {'key': 'dataPath', 'type': 'ExecutionDataPath'},
        'uri': {'key': 'uri', 'type': 'UriReference'},
        'type': {'key': 'type', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        dataset: Optional["RunDatasetReference"] = None,
        data_path: Optional["ExecutionDataPath"] = None,
        uri: Optional["UriReference"] = None,
        type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword dataset:
        :paramtype dataset: ~designer.models.RunDatasetReference
        :keyword data_path:
        :paramtype data_path: ~designer.models.ExecutionDataPath
        :keyword uri:
        :paramtype uri: ~designer.models.UriReference
        :keyword type:
        :paramtype type: str
        """
        super(ExecutionDataLocation, self).__init__(**kwargs)
        self.dataset = dataset
        self.data_path = data_path
        self.uri = uri
        self.type = type


class ExecutionDataPath(msrest.serialization.Model):
    """ExecutionDataPath.

    :ivar datastore_name:
    :vartype datastore_name: str
    :ivar relative_path:
    :vartype relative_path: str
    """

    _attribute_map = {
        'datastore_name': {'key': 'datastoreName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        datastore_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword datastore_name:
        :paramtype datastore_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        """
        super(ExecutionDataPath, self).__init__(**kwargs)
        self.datastore_name = datastore_name
        self.relative_path = relative_path


class ExecutionGlobsOptions(msrest.serialization.Model):
    """ExecutionGlobsOptions.

    :ivar glob_patterns:
    :vartype glob_patterns: list[str]
    """

    _attribute_map = {
        'glob_patterns': {'key': 'globPatterns', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        glob_patterns: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword glob_patterns:
        :paramtype glob_patterns: list[str]
        """
        super(ExecutionGlobsOptions, self).__init__(**kwargs)
        self.glob_patterns = glob_patterns


class ExperimentComputeMetaInfo(msrest.serialization.Model):
    """ExperimentComputeMetaInfo.

    :ivar current_node_count:
    :vartype current_node_count: int
    :ivar target_node_count:
    :vartype target_node_count: int
    :ivar max_node_count:
    :vartype max_node_count: int
    :ivar min_node_count:
    :vartype min_node_count: int
    :ivar idle_node_count:
    :vartype idle_node_count: int
    :ivar running_node_count:
    :vartype running_node_count: int
    :ivar preparing_node_count:
    :vartype preparing_node_count: int
    :ivar unusable_node_count:
    :vartype unusable_node_count: int
    :ivar leaving_node_count:
    :vartype leaving_node_count: int
    :ivar preempted_node_count:
    :vartype preempted_node_count: int
    :ivar vm_size:
    :vartype vm_size: str
    :ivar location:
    :vartype location: str
    :ivar provisioning_state:
    :vartype provisioning_state: str
    :ivar state:
    :vartype state: str
    :ivar os_type:
    :vartype os_type: str
    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar created_by_studio:
    :vartype created_by_studio: bool
    :ivar is_gpu_type:
    :vartype is_gpu_type: bool
    :ivar resource_id:
    :vartype resource_id: str
    :ivar compute_type:
    :vartype compute_type: str
    """

    _attribute_map = {
        'current_node_count': {'key': 'currentNodeCount', 'type': 'int'},
        'target_node_count': {'key': 'targetNodeCount', 'type': 'int'},
        'max_node_count': {'key': 'maxNodeCount', 'type': 'int'},
        'min_node_count': {'key': 'minNodeCount', 'type': 'int'},
        'idle_node_count': {'key': 'idleNodeCount', 'type': 'int'},
        'running_node_count': {'key': 'runningNodeCount', 'type': 'int'},
        'preparing_node_count': {'key': 'preparingNodeCount', 'type': 'int'},
        'unusable_node_count': {'key': 'unusableNodeCount', 'type': 'int'},
        'leaving_node_count': {'key': 'leavingNodeCount', 'type': 'int'},
        'preempted_node_count': {'key': 'preemptedNodeCount', 'type': 'int'},
        'vm_size': {'key': 'vmSize', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'provisioning_state': {'key': 'provisioningState', 'type': 'str'},
        'state': {'key': 'state', 'type': 'str'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'created_by_studio': {'key': 'createdByStudio', 'type': 'bool'},
        'is_gpu_type': {'key': 'isGpuType', 'type': 'bool'},
        'resource_id': {'key': 'resourceId', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        current_node_count: Optional[int] = None,
        target_node_count: Optional[int] = None,
        max_node_count: Optional[int] = None,
        min_node_count: Optional[int] = None,
        idle_node_count: Optional[int] = None,
        running_node_count: Optional[int] = None,
        preparing_node_count: Optional[int] = None,
        unusable_node_count: Optional[int] = None,
        leaving_node_count: Optional[int] = None,
        preempted_node_count: Optional[int] = None,
        vm_size: Optional[str] = None,
        location: Optional[str] = None,
        provisioning_state: Optional[str] = None,
        state: Optional[str] = None,
        os_type: Optional[str] = None,
        id: Optional[str] = None,
        name: Optional[str] = None,
        created_by_studio: Optional[bool] = None,
        is_gpu_type: Optional[bool] = None,
        resource_id: Optional[str] = None,
        compute_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword current_node_count:
        :paramtype current_node_count: int
        :keyword target_node_count:
        :paramtype target_node_count: int
        :keyword max_node_count:
        :paramtype max_node_count: int
        :keyword min_node_count:
        :paramtype min_node_count: int
        :keyword idle_node_count:
        :paramtype idle_node_count: int
        :keyword running_node_count:
        :paramtype running_node_count: int
        :keyword preparing_node_count:
        :paramtype preparing_node_count: int
        :keyword unusable_node_count:
        :paramtype unusable_node_count: int
        :keyword leaving_node_count:
        :paramtype leaving_node_count: int
        :keyword preempted_node_count:
        :paramtype preempted_node_count: int
        :keyword vm_size:
        :paramtype vm_size: str
        :keyword location:
        :paramtype location: str
        :keyword provisioning_state:
        :paramtype provisioning_state: str
        :keyword state:
        :paramtype state: str
        :keyword os_type:
        :paramtype os_type: str
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword created_by_studio:
        :paramtype created_by_studio: bool
        :keyword is_gpu_type:
        :paramtype is_gpu_type: bool
        :keyword resource_id:
        :paramtype resource_id: str
        :keyword compute_type:
        :paramtype compute_type: str
        """
        super(ExperimentComputeMetaInfo, self).__init__(**kwargs)
        self.current_node_count = current_node_count
        self.target_node_count = target_node_count
        self.max_node_count = max_node_count
        self.min_node_count = min_node_count
        self.idle_node_count = idle_node_count
        self.running_node_count = running_node_count
        self.preparing_node_count = preparing_node_count
        self.unusable_node_count = unusable_node_count
        self.leaving_node_count = leaving_node_count
        self.preempted_node_count = preempted_node_count
        self.vm_size = vm_size
        self.location = location
        self.provisioning_state = provisioning_state
        self.state = state
        self.os_type = os_type
        self.id = id
        self.name = name
        self.created_by_studio = created_by_studio
        self.is_gpu_type = is_gpu_type
        self.resource_id = resource_id
        self.compute_type = compute_type


class ExperimentInfo(msrest.serialization.Model):
    """ExperimentInfo.

    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar experiment_id:
    :vartype experiment_id: str
    """

    _attribute_map = {
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        experiment_name: Optional[str] = None,
        experiment_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        """
        super(ExperimentInfo, self).__init__(**kwargs)
        self.experiment_name = experiment_name
        self.experiment_id = experiment_id


class FeaturizationConfig(msrest.serialization.Model):
    """FeaturizationConfig.

    :ivar mode: Possible values include: "Auto", "Custom", "Off".
    :vartype mode: str or ~designer.models.FeaturizationMode
    :ivar blocked_transformers:
    :vartype blocked_transformers: list[str]
    :ivar column_purposes: Dictionary of :code:`<string>`.
    :vartype column_purposes: dict[str, str]
    :ivar drop_columns:
    :vartype drop_columns: list[str]
    :ivar transformer_params: Dictionary of
     <components·cq6llz·schemas·featurizationconfig·properties·transformerparams·additionalproperties>.
    :vartype transformer_params: dict[str, list[~designer.models.ColumnTransformer]]
    :ivar dataset_language:
    :vartype dataset_language: str
    """

    _attribute_map = {
        'mode': {'key': 'mode', 'type': 'str'},
        'blocked_transformers': {'key': 'blockedTransformers', 'type': '[str]'},
        'column_purposes': {'key': 'columnPurposes', 'type': '{str}'},
        'drop_columns': {'key': 'dropColumns', 'type': '[str]'},
        'transformer_params': {'key': 'transformerParams', 'type': '{[ColumnTransformer]}'},
        'dataset_language': {'key': 'datasetLanguage', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        mode: Optional[Union[str, "FeaturizationMode"]] = None,
        blocked_transformers: Optional[List[str]] = None,
        column_purposes: Optional[Dict[str, str]] = None,
        drop_columns: Optional[List[str]] = None,
        transformer_params: Optional[Dict[str, List["ColumnTransformer"]]] = None,
        dataset_language: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword mode: Possible values include: "Auto", "Custom", "Off".
        :paramtype mode: str or ~designer.models.FeaturizationMode
        :keyword blocked_transformers:
        :paramtype blocked_transformers: list[str]
        :keyword column_purposes: Dictionary of :code:`<string>`.
        :paramtype column_purposes: dict[str, str]
        :keyword drop_columns:
        :paramtype drop_columns: list[str]
        :keyword transformer_params: Dictionary of
         <components·cq6llz·schemas·featurizationconfig·properties·transformerparams·additionalproperties>.
        :paramtype transformer_params: dict[str, list[~designer.models.ColumnTransformer]]
        :keyword dataset_language:
        :paramtype dataset_language: str
        """
        super(FeaturizationConfig, self).__init__(**kwargs)
        self.mode = mode
        self.blocked_transformers = blocked_transformers
        self.column_purposes = column_purposes
        self.drop_columns = drop_columns
        self.transformer_params = transformer_params
        self.dataset_language = dataset_language


class FeedDto(msrest.serialization.Model):
    """FeedDto.

    :ivar name:
    :vartype name: str
    :ivar display_name:
    :vartype display_name: str
    :ivar description:
    :vartype description: str
    :ivar sharing_scopes:
    :vartype sharing_scopes: list[~designer.models.SharingScope]
    :ivar supported_asset_types:
    :vartype supported_asset_types: ~designer.models.FeedDtoSupportedAssetTypes
    :ivar regional_workspace_storage: This is a dictionary.
    :vartype regional_workspace_storage: dict[str, list[str]]
    :ivar intellectual_property_publisher:
    :vartype intellectual_property_publisher: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'sharing_scopes': {'key': 'sharingScopes', 'type': '[SharingScope]'},
        'supported_asset_types': {'key': 'supportedAssetTypes', 'type': 'FeedDtoSupportedAssetTypes'},
        'regional_workspace_storage': {'key': 'regionalWorkspaceStorage', 'type': '{[str]}'},
        'intellectual_property_publisher': {'key': 'intellectualPropertyPublisher', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        display_name: Optional[str] = None,
        description: Optional[str] = None,
        sharing_scopes: Optional[List["SharingScope"]] = None,
        supported_asset_types: Optional["FeedDtoSupportedAssetTypes"] = None,
        regional_workspace_storage: Optional[Dict[str, List[str]]] = None,
        intellectual_property_publisher: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword description:
        :paramtype description: str
        :keyword sharing_scopes:
        :paramtype sharing_scopes: list[~designer.models.SharingScope]
        :keyword supported_asset_types:
        :paramtype supported_asset_types: ~designer.models.FeedDtoSupportedAssetTypes
        :keyword regional_workspace_storage: This is a dictionary.
        :paramtype regional_workspace_storage: dict[str, list[str]]
        :keyword intellectual_property_publisher:
        :paramtype intellectual_property_publisher: str
        """
        super(FeedDto, self).__init__(**kwargs)
        self.name = name
        self.display_name = display_name
        self.description = description
        self.sharing_scopes = sharing_scopes
        self.supported_asset_types = supported_asset_types
        self.regional_workspace_storage = regional_workspace_storage
        self.intellectual_property_publisher = intellectual_property_publisher


class FeedDtoSupportedAssetTypes(msrest.serialization.Model):
    """FeedDtoSupportedAssetTypes.

    :ivar component:
    :vartype component: ~designer.models.AssetTypeMetaInfo
    :ivar model:
    :vartype model: ~designer.models.AssetTypeMetaInfo
    :ivar environment:
    :vartype environment: ~designer.models.AssetTypeMetaInfo
    :ivar dataset:
    :vartype dataset: ~designer.models.AssetTypeMetaInfo
    :ivar data_store:
    :vartype data_store: ~designer.models.AssetTypeMetaInfo
    :ivar sample_graph:
    :vartype sample_graph: ~designer.models.AssetTypeMetaInfo
    """

    _attribute_map = {
        'component': {'key': 'Component', 'type': 'AssetTypeMetaInfo'},
        'model': {'key': 'Model', 'type': 'AssetTypeMetaInfo'},
        'environment': {'key': 'Environment', 'type': 'AssetTypeMetaInfo'},
        'dataset': {'key': 'Dataset', 'type': 'AssetTypeMetaInfo'},
        'data_store': {'key': 'DataStore', 'type': 'AssetTypeMetaInfo'},
        'sample_graph': {'key': 'SampleGraph', 'type': 'AssetTypeMetaInfo'},
    }

    def __init__(
        self,
        *,
        component: Optional["AssetTypeMetaInfo"] = None,
        model: Optional["AssetTypeMetaInfo"] = None,
        environment: Optional["AssetTypeMetaInfo"] = None,
        dataset: Optional["AssetTypeMetaInfo"] = None,
        data_store: Optional["AssetTypeMetaInfo"] = None,
        sample_graph: Optional["AssetTypeMetaInfo"] = None,
        **kwargs
    ):
        """
        :keyword component:
        :paramtype component: ~designer.models.AssetTypeMetaInfo
        :keyword model:
        :paramtype model: ~designer.models.AssetTypeMetaInfo
        :keyword environment:
        :paramtype environment: ~designer.models.AssetTypeMetaInfo
        :keyword dataset:
        :paramtype dataset: ~designer.models.AssetTypeMetaInfo
        :keyword data_store:
        :paramtype data_store: ~designer.models.AssetTypeMetaInfo
        :keyword sample_graph:
        :paramtype sample_graph: ~designer.models.AssetTypeMetaInfo
        """
        super(FeedDtoSupportedAssetTypes, self).__init__(**kwargs)
        self.component = component
        self.model = model
        self.environment = environment
        self.dataset = dataset
        self.data_store = data_store
        self.sample_graph = sample_graph


class FileNodeDto(msrest.serialization.Model):
    """FileNodeDto.

    :ivar full_name:
    :vartype full_name: str
    :ivar absolute_blob_uri:
    :vartype absolute_blob_uri: str
    :ivar blob_uri:
    :vartype blob_uri: str
    :ivar file_size:
    :vartype file_size: long
    """

    _attribute_map = {
        'full_name': {'key': 'fullName', 'type': 'str'},
        'absolute_blob_uri': {'key': 'absoluteBlobUri', 'type': 'str'},
        'blob_uri': {'key': 'blobUri', 'type': 'str'},
        'file_size': {'key': 'fileSize', 'type': 'long'},
    }

    def __init__(
        self,
        *,
        full_name: Optional[str] = None,
        absolute_blob_uri: Optional[str] = None,
        blob_uri: Optional[str] = None,
        file_size: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword full_name:
        :paramtype full_name: str
        :keyword absolute_blob_uri:
        :paramtype absolute_blob_uri: str
        :keyword blob_uri:
        :paramtype blob_uri: str
        :keyword file_size:
        :paramtype file_size: long
        """
        super(FileNodeDto, self).__init__(**kwargs)
        self.full_name = full_name
        self.absolute_blob_uri = absolute_blob_uri
        self.blob_uri = blob_uri
        self.file_size = file_size


class FileNodeListDto(msrest.serialization.Model):
    """FileNodeListDto.

    :ivar file_nodes:
    :vartype file_nodes: list[~designer.models.FileNodeDto]
    """

    _attribute_map = {
        'file_nodes': {'key': 'fileNodes', 'type': '[FileNodeDto]'},
    }

    def __init__(
        self,
        *,
        file_nodes: Optional[List["FileNodeDto"]] = None,
        **kwargs
    ):
        """
        :keyword file_nodes:
        :paramtype file_nodes: list[~designer.models.FileNodeDto]
        """
        super(FileNodeListDto, self).__init__(**kwargs)
        self.file_nodes = file_nodes


class FlatDirTreeNodeDto(msrest.serialization.Model):
    """FlatDirTreeNodeDto.

    :ivar name:
    :vartype name: str
    :ivar hash:
    :vartype hash: str
    :ivar is_file:
    :vartype is_file: bool
    :ivar id:
    :vartype id: str
    :ivar parent_id:
    :vartype parent_id: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'hash': {'key': 'hash', 'type': 'str'},
        'is_file': {'key': 'isFile', 'type': 'bool'},
        'id': {'key': 'id', 'type': 'str'},
        'parent_id': {'key': 'parentId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        hash: Optional[str] = None,
        is_file: Optional[bool] = None,
        id: Optional[str] = None,
        parent_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword hash:
        :paramtype hash: str
        :keyword is_file:
        :paramtype is_file: bool
        :keyword id:
        :paramtype id: str
        :keyword parent_id:
        :paramtype parent_id: str
        """
        super(FlatDirTreeNodeDto, self).__init__(**kwargs)
        self.name = name
        self.hash = hash
        self.is_file = is_file
        self.id = id
        self.parent_id = parent_id


class FlatDirTreeNodeListDto(msrest.serialization.Model):
    """FlatDirTreeNodeListDto.

    :ivar files:
    :vartype files: list[~designer.models.FlatDirTreeNodeDto]
    """

    _attribute_map = {
        'files': {'key': 'files', 'type': '[FlatDirTreeNodeDto]'},
    }

    def __init__(
        self,
        *,
        files: Optional[List["FlatDirTreeNodeDto"]] = None,
        **kwargs
    ):
        """
        :keyword files:
        :paramtype files: list[~designer.models.FlatDirTreeNodeDto]
        """
        super(FlatDirTreeNodeListDto, self).__init__(**kwargs)
        self.files = files


class ForecastHorizon(msrest.serialization.Model):
    """ForecastHorizon.

    :ivar mode: Possible values include: "Auto", "Custom".
    :vartype mode: str or ~designer.models.ForecastHorizonMode
    :ivar value:
    :vartype value: int
    """

    _attribute_map = {
        'mode': {'key': 'mode', 'type': 'str'},
        'value': {'key': 'value', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        mode: Optional[Union[str, "ForecastHorizonMode"]] = None,
        value: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword mode: Possible values include: "Auto", "Custom".
        :paramtype mode: str or ~designer.models.ForecastHorizonMode
        :keyword value:
        :paramtype value: int
        """
        super(ForecastHorizon, self).__init__(**kwargs)
        self.mode = mode
        self.value = value


class ForecastingSettings(msrest.serialization.Model):
    """ForecastingSettings.

    :ivar country_or_region_for_holidays:
    :vartype country_or_region_for_holidays: str
    :ivar time_column_name:
    :vartype time_column_name: str
    :ivar target_lags:
    :vartype target_lags: ~designer.models.TargetLags
    :ivar target_rolling_window_size:
    :vartype target_rolling_window_size: ~designer.models.TargetRollingWindowSize
    :ivar forecast_horizon:
    :vartype forecast_horizon: ~designer.models.ForecastHorizon
    :ivar time_series_id_column_names:
    :vartype time_series_id_column_names: list[str]
    :ivar frequency:
    :vartype frequency: str
    :ivar feature_lags:
    :vartype feature_lags: str
    :ivar seasonality:
    :vartype seasonality: ~designer.models.Seasonality
    :ivar short_series_handling_config: Possible values include: "Auto", "Pad", "Drop".
    :vartype short_series_handling_config: str or ~designer.models.ShortSeriesHandlingConfiguration
    :ivar use_stl: Possible values include: "Season", "SeasonTrend".
    :vartype use_stl: str or ~designer.models.UseStl
    :ivar target_aggregate_function: Possible values include: "Sum", "Max", "Min", "Mean".
    :vartype target_aggregate_function: str or ~designer.models.TargetAggregationFunction
    """

    _attribute_map = {
        'country_or_region_for_holidays': {'key': 'countryOrRegionForHolidays', 'type': 'str'},
        'time_column_name': {'key': 'timeColumnName', 'type': 'str'},
        'target_lags': {'key': 'targetLags', 'type': 'TargetLags'},
        'target_rolling_window_size': {'key': 'targetRollingWindowSize', 'type': 'TargetRollingWindowSize'},
        'forecast_horizon': {'key': 'forecastHorizon', 'type': 'ForecastHorizon'},
        'time_series_id_column_names': {'key': 'timeSeriesIdColumnNames', 'type': '[str]'},
        'frequency': {'key': 'frequency', 'type': 'str'},
        'feature_lags': {'key': 'featureLags', 'type': 'str'},
        'seasonality': {'key': 'seasonality', 'type': 'Seasonality'},
        'short_series_handling_config': {'key': 'shortSeriesHandlingConfig', 'type': 'str'},
        'use_stl': {'key': 'useStl', 'type': 'str'},
        'target_aggregate_function': {'key': 'targetAggregateFunction', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        country_or_region_for_holidays: Optional[str] = None,
        time_column_name: Optional[str] = None,
        target_lags: Optional["TargetLags"] = None,
        target_rolling_window_size: Optional["TargetRollingWindowSize"] = None,
        forecast_horizon: Optional["ForecastHorizon"] = None,
        time_series_id_column_names: Optional[List[str]] = None,
        frequency: Optional[str] = None,
        feature_lags: Optional[str] = None,
        seasonality: Optional["Seasonality"] = None,
        short_series_handling_config: Optional[Union[str, "ShortSeriesHandlingConfiguration"]] = None,
        use_stl: Optional[Union[str, "UseStl"]] = None,
        target_aggregate_function: Optional[Union[str, "TargetAggregationFunction"]] = None,
        **kwargs
    ):
        """
        :keyword country_or_region_for_holidays:
        :paramtype country_or_region_for_holidays: str
        :keyword time_column_name:
        :paramtype time_column_name: str
        :keyword target_lags:
        :paramtype target_lags: ~designer.models.TargetLags
        :keyword target_rolling_window_size:
        :paramtype target_rolling_window_size: ~designer.models.TargetRollingWindowSize
        :keyword forecast_horizon:
        :paramtype forecast_horizon: ~designer.models.ForecastHorizon
        :keyword time_series_id_column_names:
        :paramtype time_series_id_column_names: list[str]
        :keyword frequency:
        :paramtype frequency: str
        :keyword feature_lags:
        :paramtype feature_lags: str
        :keyword seasonality:
        :paramtype seasonality: ~designer.models.Seasonality
        :keyword short_series_handling_config: Possible values include: "Auto", "Pad", "Drop".
        :paramtype short_series_handling_config: str or
         ~designer.models.ShortSeriesHandlingConfiguration
        :keyword use_stl: Possible values include: "Season", "SeasonTrend".
        :paramtype use_stl: str or ~designer.models.UseStl
        :keyword target_aggregate_function: Possible values include: "Sum", "Max", "Min", "Mean".
        :paramtype target_aggregate_function: str or ~designer.models.TargetAggregationFunction
        """
        super(ForecastingSettings, self).__init__(**kwargs)
        self.country_or_region_for_holidays = country_or_region_for_holidays
        self.time_column_name = time_column_name
        self.target_lags = target_lags
        self.target_rolling_window_size = target_rolling_window_size
        self.forecast_horizon = forecast_horizon
        self.time_series_id_column_names = time_series_id_column_names
        self.frequency = frequency
        self.feature_lags = feature_lags
        self.seasonality = seasonality
        self.short_series_handling_config = short_series_handling_config
        self.use_stl = use_stl
        self.target_aggregate_function = target_aggregate_function


class GeneralSettings(msrest.serialization.Model):
    """GeneralSettings.

    :ivar primary_metric: Possible values include: "AUCWeighted", "Accuracy", "NormMacroRecall",
     "AveragePrecisionScoreWeighted", "PrecisionScoreWeighted", "SpearmanCorrelation",
     "NormalizedRootMeanSquaredError", "R2Score", "NormalizedMeanAbsoluteError",
     "NormalizedRootMeanSquaredLogError".
    :vartype primary_metric: str or ~designer.models.PrimaryMetrics
    :ivar task_type: Possible values include: "Classification", "Regression", "Forecasting".
    :vartype task_type: str or ~designer.models.TaskType
    :ivar log_verbosity: Possible values include: "NotSet", "Debug", "Info", "Warning", "Error",
     "Critical".
    :vartype log_verbosity: str or ~designer.models.LogVerbosity
    """

    _attribute_map = {
        'primary_metric': {'key': 'primaryMetric', 'type': 'str'},
        'task_type': {'key': 'taskType', 'type': 'str'},
        'log_verbosity': {'key': 'logVerbosity', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        primary_metric: Optional[Union[str, "PrimaryMetrics"]] = None,
        task_type: Optional[Union[str, "TaskType"]] = None,
        log_verbosity: Optional[Union[str, "LogVerbosity"]] = None,
        **kwargs
    ):
        """
        :keyword primary_metric: Possible values include: "AUCWeighted", "Accuracy", "NormMacroRecall",
         "AveragePrecisionScoreWeighted", "PrecisionScoreWeighted", "SpearmanCorrelation",
         "NormalizedRootMeanSquaredError", "R2Score", "NormalizedMeanAbsoluteError",
         "NormalizedRootMeanSquaredLogError".
        :paramtype primary_metric: str or ~designer.models.PrimaryMetrics
        :keyword task_type: Possible values include: "Classification", "Regression", "Forecasting".
        :paramtype task_type: str or ~designer.models.TaskType
        :keyword log_verbosity: Possible values include: "NotSet", "Debug", "Info", "Warning", "Error",
         "Critical".
        :paramtype log_verbosity: str or ~designer.models.LogVerbosity
        """
        super(GeneralSettings, self).__init__(**kwargs)
        self.primary_metric = primary_metric
        self.task_type = task_type
        self.log_verbosity = log_verbosity


class GeneratePipelineComponentRequest(msrest.serialization.Model):
    """GeneratePipelineComponentRequest.

    :ivar name:
    :vartype name: str
    :ivar display_name:
    :vartype display_name: str
    :ivar module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous", "Step",
     "Draft", "Feed", "Registry".
    :vartype module_scope: str or ~designer.models.ModuleScope
    :ivar is_deterministic:
    :vartype is_deterministic: bool
    :ivar category:
    :vartype category: str
    :ivar version:
    :vartype version: str
    :ivar set_as_default_version:
    :vartype set_as_default_version: bool
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'module_scope': {'key': 'moduleScope', 'type': 'str'},
        'is_deterministic': {'key': 'isDeterministic', 'type': 'bool'},
        'category': {'key': 'category', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'set_as_default_version': {'key': 'setAsDefaultVersion', 'type': 'bool'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        display_name: Optional[str] = None,
        module_scope: Optional[Union[str, "ModuleScope"]] = None,
        is_deterministic: Optional[bool] = None,
        category: Optional[str] = None,
        version: Optional[str] = None,
        set_as_default_version: Optional[bool] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous",
         "Step", "Draft", "Feed", "Registry".
        :paramtype module_scope: str or ~designer.models.ModuleScope
        :keyword is_deterministic:
        :paramtype is_deterministic: bool
        :keyword category:
        :paramtype category: str
        :keyword version:
        :paramtype version: str
        :keyword set_as_default_version:
        :paramtype set_as_default_version: bool
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(GeneratePipelineComponentRequest, self).__init__(**kwargs)
        self.name = name
        self.display_name = display_name
        self.module_scope = module_scope
        self.is_deterministic = is_deterministic
        self.category = category
        self.version = version
        self.set_as_default_version = set_as_default_version
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class GlobalJobDispatcherConfiguration(msrest.serialization.Model):
    """GlobalJobDispatcherConfiguration.

    :ivar vm_size:
    :vartype vm_size: list[str]
    :ivar compute_type: Possible values include: "AmlCompute", "AmlK8s".
    :vartype compute_type: str or ~designer.models.GlobalJobDispatcherSupportedComputeType
    :ivar region:
    :vartype region: list[str]
    :ivar my_resource_only:
    :vartype my_resource_only: bool
    :ivar redispatch_allowed:
    :vartype redispatch_allowed: bool
    :ivar low_priority_vm_tolerant:
    :vartype low_priority_vm_tolerant: bool
    :ivar vc_list:
    :vartype vc_list: list[str]
    :ivar plan_id:
    :vartype plan_id: str
    :ivar plan_region_id:
    :vartype plan_region_id: str
    :ivar vc_block_list:
    :vartype vc_block_list: list[str]
    :ivar cluster_block_list:
    :vartype cluster_block_list: list[str]
    """

    _attribute_map = {
        'vm_size': {'key': 'vmSize', 'type': '[str]'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'region': {'key': 'region', 'type': '[str]'},
        'my_resource_only': {'key': 'myResourceOnly', 'type': 'bool'},
        'redispatch_allowed': {'key': 'redispatchAllowed', 'type': 'bool'},
        'low_priority_vm_tolerant': {'key': 'lowPriorityVMTolerant', 'type': 'bool'},
        'vc_list': {'key': 'vcList', 'type': '[str]'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'plan_region_id': {'key': 'planRegionId', 'type': 'str'},
        'vc_block_list': {'key': 'vcBlockList', 'type': '[str]'},
        'cluster_block_list': {'key': 'clusterBlockList', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        vm_size: Optional[List[str]] = None,
        compute_type: Optional[Union[str, "GlobalJobDispatcherSupportedComputeType"]] = None,
        region: Optional[List[str]] = None,
        my_resource_only: Optional[bool] = None,
        redispatch_allowed: Optional[bool] = None,
        low_priority_vm_tolerant: Optional[bool] = None,
        vc_list: Optional[List[str]] = None,
        plan_id: Optional[str] = None,
        plan_region_id: Optional[str] = None,
        vc_block_list: Optional[List[str]] = None,
        cluster_block_list: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword vm_size:
        :paramtype vm_size: list[str]
        :keyword compute_type: Possible values include: "AmlCompute", "AmlK8s".
        :paramtype compute_type: str or ~designer.models.GlobalJobDispatcherSupportedComputeType
        :keyword region:
        :paramtype region: list[str]
        :keyword my_resource_only:
        :paramtype my_resource_only: bool
        :keyword redispatch_allowed:
        :paramtype redispatch_allowed: bool
        :keyword low_priority_vm_tolerant:
        :paramtype low_priority_vm_tolerant: bool
        :keyword vc_list:
        :paramtype vc_list: list[str]
        :keyword plan_id:
        :paramtype plan_id: str
        :keyword plan_region_id:
        :paramtype plan_region_id: str
        :keyword vc_block_list:
        :paramtype vc_block_list: list[str]
        :keyword cluster_block_list:
        :paramtype cluster_block_list: list[str]
        """
        super(GlobalJobDispatcherConfiguration, self).__init__(**kwargs)
        self.vm_size = vm_size
        self.compute_type = compute_type
        self.region = region
        self.my_resource_only = my_resource_only
        self.redispatch_allowed = redispatch_allowed
        self.low_priority_vm_tolerant = low_priority_vm_tolerant
        self.vc_list = vc_list
        self.plan_id = plan_id
        self.plan_region_id = plan_region_id
        self.vc_block_list = vc_block_list
        self.cluster_block_list = cluster_block_list


class GlobsOptions(msrest.serialization.Model):
    """GlobsOptions.

    :ivar glob_patterns:
    :vartype glob_patterns: list[str]
    """

    _attribute_map = {
        'glob_patterns': {'key': 'globPatterns', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        glob_patterns: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword glob_patterns:
        :paramtype glob_patterns: list[str]
        """
        super(GlobsOptions, self).__init__(**kwargs)
        self.glob_patterns = glob_patterns


class GraphControlNode(msrest.serialization.Model):
    """GraphControlNode.

    :ivar id:
    :vartype id: str
    :ivar control_type:  The only acceptable values to pass in are None and "IfElse". The default
     value is None.
    :vartype control_type: str
    :ivar control_parameter:
    :vartype control_parameter: ~designer.models.ParameterAssignment
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'control_type': {'key': 'controlType', 'type': 'str'},
        'control_parameter': {'key': 'controlParameter', 'type': 'ParameterAssignment'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        control_type: Optional[str] = None,
        control_parameter: Optional["ParameterAssignment"] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword control_type:  The only acceptable values to pass in are None and "IfElse". The
         default value is None.
        :paramtype control_type: str
        :keyword control_parameter:
        :paramtype control_parameter: ~designer.models.ParameterAssignment
        """
        super(GraphControlNode, self).__init__(**kwargs)
        self.id = id
        self.control_type = control_type
        self.control_parameter = control_parameter


class GraphDatasetNode(msrest.serialization.Model):
    """GraphDatasetNode.

    :ivar id:
    :vartype id: str
    :ivar dataset_id:
    :vartype dataset_id: str
    :ivar data_path_parameter_name:
    :vartype data_path_parameter_name: str
    :ivar data_set_definition:
    :vartype data_set_definition: ~designer.models.DataSetDefinition
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'dataset_id': {'key': 'datasetId', 'type': 'str'},
        'data_path_parameter_name': {'key': 'dataPathParameterName', 'type': 'str'},
        'data_set_definition': {'key': 'dataSetDefinition', 'type': 'DataSetDefinition'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        dataset_id: Optional[str] = None,
        data_path_parameter_name: Optional[str] = None,
        data_set_definition: Optional["DataSetDefinition"] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword dataset_id:
        :paramtype dataset_id: str
        :keyword data_path_parameter_name:
        :paramtype data_path_parameter_name: str
        :keyword data_set_definition:
        :paramtype data_set_definition: ~designer.models.DataSetDefinition
        """
        super(GraphDatasetNode, self).__init__(**kwargs)
        self.id = id
        self.dataset_id = dataset_id
        self.data_path_parameter_name = data_path_parameter_name
        self.data_set_definition = data_set_definition


class GraphDraftEntity(msrest.serialization.Model):
    """GraphDraftEntity.

    :ivar module_nodes:
    :vartype module_nodes: list[~designer.models.GraphModuleNode]
    :ivar dataset_nodes:
    :vartype dataset_nodes: list[~designer.models.GraphDatasetNode]
    :ivar sub_graph_nodes:
    :vartype sub_graph_nodes: list[~designer.models.GraphReferenceNode]
    :ivar control_nodes:
    :vartype control_nodes: list[~designer.models.GraphControlNode]
    :ivar edges:
    :vartype edges: list[~designer.models.GraphEdge]
    :ivar entity_interface:
    :vartype entity_interface: ~designer.models.EntityInterface
    :ivar graph_layout:
    :vartype graph_layout: ~designer.models.GraphLayout
    :ivar created_by:
    :vartype created_by: ~designer.models.CreatedBy
    :ivar last_updated_by:
    :vartype last_updated_by: ~designer.models.CreatedBy
    :ivar default_compute:
    :vartype default_compute: ~designer.models.ComputeSetting
    :ivar default_datastore:
    :vartype default_datastore: ~designer.models.DatastoreSetting
    :ivar default_cloud_priority:
    :vartype default_cloud_priority: ~designer.models.CloudPrioritySetting
    :ivar extended_properties: This is a dictionary.
    :vartype extended_properties: dict[str, str]
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'module_nodes': {'key': 'moduleNodes', 'type': '[GraphModuleNode]'},
        'dataset_nodes': {'key': 'datasetNodes', 'type': '[GraphDatasetNode]'},
        'sub_graph_nodes': {'key': 'subGraphNodes', 'type': '[GraphReferenceNode]'},
        'control_nodes': {'key': 'controlNodes', 'type': '[GraphControlNode]'},
        'edges': {'key': 'edges', 'type': '[GraphEdge]'},
        'entity_interface': {'key': 'entityInterface', 'type': 'EntityInterface'},
        'graph_layout': {'key': 'graphLayout', 'type': 'GraphLayout'},
        'created_by': {'key': 'createdBy', 'type': 'CreatedBy'},
        'last_updated_by': {'key': 'lastUpdatedBy', 'type': 'CreatedBy'},
        'default_compute': {'key': 'defaultCompute', 'type': 'ComputeSetting'},
        'default_datastore': {'key': 'defaultDatastore', 'type': 'DatastoreSetting'},
        'default_cloud_priority': {'key': 'defaultCloudPriority', 'type': 'CloudPrioritySetting'},
        'extended_properties': {'key': 'extendedProperties', 'type': '{str}'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        module_nodes: Optional[List["GraphModuleNode"]] = None,
        dataset_nodes: Optional[List["GraphDatasetNode"]] = None,
        sub_graph_nodes: Optional[List["GraphReferenceNode"]] = None,
        control_nodes: Optional[List["GraphControlNode"]] = None,
        edges: Optional[List["GraphEdge"]] = None,
        entity_interface: Optional["EntityInterface"] = None,
        graph_layout: Optional["GraphLayout"] = None,
        created_by: Optional["CreatedBy"] = None,
        last_updated_by: Optional["CreatedBy"] = None,
        default_compute: Optional["ComputeSetting"] = None,
        default_datastore: Optional["DatastoreSetting"] = None,
        default_cloud_priority: Optional["CloudPrioritySetting"] = None,
        extended_properties: Optional[Dict[str, str]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword module_nodes:
        :paramtype module_nodes: list[~designer.models.GraphModuleNode]
        :keyword dataset_nodes:
        :paramtype dataset_nodes: list[~designer.models.GraphDatasetNode]
        :keyword sub_graph_nodes:
        :paramtype sub_graph_nodes: list[~designer.models.GraphReferenceNode]
        :keyword control_nodes:
        :paramtype control_nodes: list[~designer.models.GraphControlNode]
        :keyword edges:
        :paramtype edges: list[~designer.models.GraphEdge]
        :keyword entity_interface:
        :paramtype entity_interface: ~designer.models.EntityInterface
        :keyword graph_layout:
        :paramtype graph_layout: ~designer.models.GraphLayout
        :keyword created_by:
        :paramtype created_by: ~designer.models.CreatedBy
        :keyword last_updated_by:
        :paramtype last_updated_by: ~designer.models.CreatedBy
        :keyword default_compute:
        :paramtype default_compute: ~designer.models.ComputeSetting
        :keyword default_datastore:
        :paramtype default_datastore: ~designer.models.DatastoreSetting
        :keyword default_cloud_priority:
        :paramtype default_cloud_priority: ~designer.models.CloudPrioritySetting
        :keyword extended_properties: This is a dictionary.
        :paramtype extended_properties: dict[str, str]
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(GraphDraftEntity, self).__init__(**kwargs)
        self.module_nodes = module_nodes
        self.dataset_nodes = dataset_nodes
        self.sub_graph_nodes = sub_graph_nodes
        self.control_nodes = control_nodes
        self.edges = edges
        self.entity_interface = entity_interface
        self.graph_layout = graph_layout
        self.created_by = created_by
        self.last_updated_by = last_updated_by
        self.default_compute = default_compute
        self.default_datastore = default_datastore
        self.default_cloud_priority = default_cloud_priority
        self.extended_properties = extended_properties
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class GraphEdge(msrest.serialization.Model):
    """GraphEdge.

    :ivar source_output_port:
    :vartype source_output_port: ~designer.models.PortInfo
    :ivar destination_input_port:
    :vartype destination_input_port: ~designer.models.PortInfo
    """

    _attribute_map = {
        'source_output_port': {'key': 'sourceOutputPort', 'type': 'PortInfo'},
        'destination_input_port': {'key': 'destinationInputPort', 'type': 'PortInfo'},
    }

    def __init__(
        self,
        *,
        source_output_port: Optional["PortInfo"] = None,
        destination_input_port: Optional["PortInfo"] = None,
        **kwargs
    ):
        """
        :keyword source_output_port:
        :paramtype source_output_port: ~designer.models.PortInfo
        :keyword destination_input_port:
        :paramtype destination_input_port: ~designer.models.PortInfo
        """
        super(GraphEdge, self).__init__(**kwargs)
        self.source_output_port = source_output_port
        self.destination_input_port = destination_input_port


class GraphLayout(msrest.serialization.Model):
    """GraphLayout.

    :ivar node_layouts: This is a dictionary.
    :vartype node_layouts: dict[str, ~designer.models.NodeLayout]
    :ivar extended_data:
    :vartype extended_data: str
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'node_layouts': {'key': 'nodeLayouts', 'type': '{NodeLayout}'},
        'extended_data': {'key': 'extendedData', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        node_layouts: Optional[Dict[str, "NodeLayout"]] = None,
        extended_data: Optional[str] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword node_layouts: This is a dictionary.
        :paramtype node_layouts: dict[str, ~designer.models.NodeLayout]
        :keyword extended_data:
        :paramtype extended_data: str
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(GraphLayout, self).__init__(**kwargs)
        self.node_layouts = node_layouts
        self.extended_data = extended_data
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class GraphLayoutCreationInfo(msrest.serialization.Model):
    """GraphLayoutCreationInfo.

    :ivar node_layouts: This is a dictionary.
    :vartype node_layouts: dict[str, ~designer.models.NodeLayout]
    :ivar extended_data:
    :vartype extended_data: str
    """

    _attribute_map = {
        'node_layouts': {'key': 'nodeLayouts', 'type': '{NodeLayout}'},
        'extended_data': {'key': 'extendedData', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_layouts: Optional[Dict[str, "NodeLayout"]] = None,
        extended_data: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_layouts: This is a dictionary.
        :paramtype node_layouts: dict[str, ~designer.models.NodeLayout]
        :keyword extended_data:
        :paramtype extended_data: str
        """
        super(GraphLayoutCreationInfo, self).__init__(**kwargs)
        self.node_layouts = node_layouts
        self.extended_data = extended_data


class GraphModuleNode(msrest.serialization.Model):
    """GraphModuleNode.

    :ivar module_type: Possible values include: "None", "BatchInferencing".
    :vartype module_type: str or ~designer.models.ModuleType
    :ivar runconfig:
    :vartype runconfig: str
    :ivar cloud_settings:
    :vartype cloud_settings: ~designer.models.CloudSettings
    :ivar id:
    :vartype id: str
    :ivar module_id:
    :vartype module_id: str
    :ivar comment:
    :vartype comment: str
    :ivar name:
    :vartype name: str
    :ivar module_parameters:
    :vartype module_parameters: list[~designer.models.ParameterAssignment]
    :ivar module_metadata_parameters:
    :vartype module_metadata_parameters: list[~designer.models.ParameterAssignment]
    :ivar module_output_settings:
    :vartype module_output_settings: list[~designer.models.OutputSetting]
    :ivar module_input_settings:
    :vartype module_input_settings: list[~designer.models.InputSetting]
    :ivar use_graph_default_compute:
    :vartype use_graph_default_compute: bool
    :ivar use_graph_default_datastore:
    :vartype use_graph_default_datastore: bool
    :ivar regenerate_output:
    :vartype regenerate_output: bool
    :ivar control_inputs:
    :vartype control_inputs: list[~designer.models.ControlInput]
    """

    _attribute_map = {
        'module_type': {'key': 'moduleType', 'type': 'str'},
        'runconfig': {'key': 'runconfig', 'type': 'str'},
        'cloud_settings': {'key': 'cloudSettings', 'type': 'CloudSettings'},
        'id': {'key': 'id', 'type': 'str'},
        'module_id': {'key': 'moduleId', 'type': 'str'},
        'comment': {'key': 'comment', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'module_parameters': {'key': 'moduleParameters', 'type': '[ParameterAssignment]'},
        'module_metadata_parameters': {'key': 'moduleMetadataParameters', 'type': '[ParameterAssignment]'},
        'module_output_settings': {'key': 'moduleOutputSettings', 'type': '[OutputSetting]'},
        'module_input_settings': {'key': 'moduleInputSettings', 'type': '[InputSetting]'},
        'use_graph_default_compute': {'key': 'useGraphDefaultCompute', 'type': 'bool'},
        'use_graph_default_datastore': {'key': 'useGraphDefaultDatastore', 'type': 'bool'},
        'regenerate_output': {'key': 'regenerateOutput', 'type': 'bool'},
        'control_inputs': {'key': 'controlInputs', 'type': '[ControlInput]'},
    }

    def __init__(
        self,
        *,
        module_type: Optional[Union[str, "ModuleType"]] = None,
        runconfig: Optional[str] = None,
        cloud_settings: Optional["CloudSettings"] = None,
        id: Optional[str] = None,
        module_id: Optional[str] = None,
        comment: Optional[str] = None,
        name: Optional[str] = None,
        module_parameters: Optional[List["ParameterAssignment"]] = None,
        module_metadata_parameters: Optional[List["ParameterAssignment"]] = None,
        module_output_settings: Optional[List["OutputSetting"]] = None,
        module_input_settings: Optional[List["InputSetting"]] = None,
        use_graph_default_compute: Optional[bool] = None,
        use_graph_default_datastore: Optional[bool] = None,
        regenerate_output: Optional[bool] = None,
        control_inputs: Optional[List["ControlInput"]] = None,
        **kwargs
    ):
        """
        :keyword module_type: Possible values include: "None", "BatchInferencing".
        :paramtype module_type: str or ~designer.models.ModuleType
        :keyword runconfig:
        :paramtype runconfig: str
        :keyword cloud_settings:
        :paramtype cloud_settings: ~designer.models.CloudSettings
        :keyword id:
        :paramtype id: str
        :keyword module_id:
        :paramtype module_id: str
        :keyword comment:
        :paramtype comment: str
        :keyword name:
        :paramtype name: str
        :keyword module_parameters:
        :paramtype module_parameters: list[~designer.models.ParameterAssignment]
        :keyword module_metadata_parameters:
        :paramtype module_metadata_parameters: list[~designer.models.ParameterAssignment]
        :keyword module_output_settings:
        :paramtype module_output_settings: list[~designer.models.OutputSetting]
        :keyword module_input_settings:
        :paramtype module_input_settings: list[~designer.models.InputSetting]
        :keyword use_graph_default_compute:
        :paramtype use_graph_default_compute: bool
        :keyword use_graph_default_datastore:
        :paramtype use_graph_default_datastore: bool
        :keyword regenerate_output:
        :paramtype regenerate_output: bool
        :keyword control_inputs:
        :paramtype control_inputs: list[~designer.models.ControlInput]
        """
        super(GraphModuleNode, self).__init__(**kwargs)
        self.module_type = module_type
        self.runconfig = runconfig
        self.cloud_settings = cloud_settings
        self.id = id
        self.module_id = module_id
        self.comment = comment
        self.name = name
        self.module_parameters = module_parameters
        self.module_metadata_parameters = module_metadata_parameters
        self.module_output_settings = module_output_settings
        self.module_input_settings = module_input_settings
        self.use_graph_default_compute = use_graph_default_compute
        self.use_graph_default_datastore = use_graph_default_datastore
        self.regenerate_output = regenerate_output
        self.control_inputs = control_inputs


class GraphModuleNodeRunSetting(msrest.serialization.Model):
    """GraphModuleNodeRunSetting.

    :ivar node_id:
    :vartype node_id: str
    :ivar module_id:
    :vartype module_id: str
    :ivar step_type:
    :vartype step_type: str
    :ivar run_settings:
    :vartype run_settings: list[~designer.models.RunSettingParameterAssignment]
    """

    _attribute_map = {
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'module_id': {'key': 'moduleId', 'type': 'str'},
        'step_type': {'key': 'stepType', 'type': 'str'},
        'run_settings': {'key': 'runSettings', 'type': '[RunSettingParameterAssignment]'},
    }

    def __init__(
        self,
        *,
        node_id: Optional[str] = None,
        module_id: Optional[str] = None,
        step_type: Optional[str] = None,
        run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        **kwargs
    ):
        """
        :keyword node_id:
        :paramtype node_id: str
        :keyword module_id:
        :paramtype module_id: str
        :keyword step_type:
        :paramtype step_type: str
        :keyword run_settings:
        :paramtype run_settings: list[~designer.models.RunSettingParameterAssignment]
        """
        super(GraphModuleNodeRunSetting, self).__init__(**kwargs)
        self.node_id = node_id
        self.module_id = module_id
        self.step_type = step_type
        self.run_settings = run_settings


class GraphNodeStatusInfo(msrest.serialization.Model):
    """GraphNodeStatusInfo.

    :ivar status: Possible values include: "NotStarted", "Queued", "Running", "Failed", "Finished",
     "Canceled", "PartiallyExecuted", "Bypassed".
    :vartype status: str or ~designer.models.TaskStatusCode
    :ivar run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype run_status: str or ~designer.models.RunStatus
    :ivar aether_start_time:
    :vartype aether_start_time: ~datetime.datetime
    :ivar aether_end_time:
    :vartype aether_end_time: ~datetime.datetime
    :ivar aether_creation_time:
    :vartype aether_creation_time: ~datetime.datetime
    :ivar run_history_start_time:
    :vartype run_history_start_time: ~datetime.datetime
    :ivar run_history_end_time:
    :vartype run_history_end_time: ~datetime.datetime
    :ivar run_history_creation_time:
    :vartype run_history_creation_time: ~datetime.datetime
    :ivar reuse_info:
    :vartype reuse_info: ~designer.models.TaskReuseInfo
    :ivar status_code: Possible values include: "NotStarted", "Queued", "Running", "Failed",
     "Finished", "Canceled", "PartiallyExecuted", "Bypassed".
    :vartype status_code: str or ~designer.models.TaskStatusCode
    :ivar status_detail:
    :vartype status_detail: str
    :ivar creation_time:
    :vartype creation_time: ~datetime.datetime
    :ivar schedule_time:
    :vartype schedule_time: ~datetime.datetime
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar request_id:
    :vartype request_id: str
    :ivar run_id:
    :vartype run_id: str
    :ivar data_container_id:
    :vartype data_container_id: str
    :ivar real_time_log_path:
    :vartype real_time_log_path: str
    :ivar has_warnings:
    :vartype has_warnings: bool
    :ivar composite_node_id:
    :vartype composite_node_id: str
    """

    _attribute_map = {
        'status': {'key': 'status', 'type': 'str'},
        'run_status': {'key': 'runStatus', 'type': 'str'},
        'aether_start_time': {'key': 'aetherStartTime', 'type': 'iso-8601'},
        'aether_end_time': {'key': 'aetherEndTime', 'type': 'iso-8601'},
        'aether_creation_time': {'key': 'aetherCreationTime', 'type': 'iso-8601'},
        'run_history_start_time': {'key': 'runHistoryStartTime', 'type': 'iso-8601'},
        'run_history_end_time': {'key': 'runHistoryEndTime', 'type': 'iso-8601'},
        'run_history_creation_time': {'key': 'runHistoryCreationTime', 'type': 'iso-8601'},
        'reuse_info': {'key': 'reuseInfo', 'type': 'TaskReuseInfo'},
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'creation_time': {'key': 'creationTime', 'type': 'iso-8601'},
        'schedule_time': {'key': 'scheduleTime', 'type': 'iso-8601'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'request_id': {'key': 'requestId', 'type': 'str'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'data_container_id': {'key': 'dataContainerId', 'type': 'str'},
        'real_time_log_path': {'key': 'realTimeLogPath', 'type': 'str'},
        'has_warnings': {'key': 'hasWarnings', 'type': 'bool'},
        'composite_node_id': {'key': 'compositeNodeId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        status: Optional[Union[str, "TaskStatusCode"]] = None,
        run_status: Optional[Union[str, "RunStatus"]] = None,
        aether_start_time: Optional[datetime.datetime] = None,
        aether_end_time: Optional[datetime.datetime] = None,
        aether_creation_time: Optional[datetime.datetime] = None,
        run_history_start_time: Optional[datetime.datetime] = None,
        run_history_end_time: Optional[datetime.datetime] = None,
        run_history_creation_time: Optional[datetime.datetime] = None,
        reuse_info: Optional["TaskReuseInfo"] = None,
        status_code: Optional[Union[str, "TaskStatusCode"]] = None,
        status_detail: Optional[str] = None,
        creation_time: Optional[datetime.datetime] = None,
        schedule_time: Optional[datetime.datetime] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        request_id: Optional[str] = None,
        run_id: Optional[str] = None,
        data_container_id: Optional[str] = None,
        real_time_log_path: Optional[str] = None,
        has_warnings: Optional[bool] = None,
        composite_node_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword status: Possible values include: "NotStarted", "Queued", "Running", "Failed",
         "Finished", "Canceled", "PartiallyExecuted", "Bypassed".
        :paramtype status: str or ~designer.models.TaskStatusCode
        :keyword run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype run_status: str or ~designer.models.RunStatus
        :keyword aether_start_time:
        :paramtype aether_start_time: ~datetime.datetime
        :keyword aether_end_time:
        :paramtype aether_end_time: ~datetime.datetime
        :keyword aether_creation_time:
        :paramtype aether_creation_time: ~datetime.datetime
        :keyword run_history_start_time:
        :paramtype run_history_start_time: ~datetime.datetime
        :keyword run_history_end_time:
        :paramtype run_history_end_time: ~datetime.datetime
        :keyword run_history_creation_time:
        :paramtype run_history_creation_time: ~datetime.datetime
        :keyword reuse_info:
        :paramtype reuse_info: ~designer.models.TaskReuseInfo
        :keyword status_code: Possible values include: "NotStarted", "Queued", "Running", "Failed",
         "Finished", "Canceled", "PartiallyExecuted", "Bypassed".
        :paramtype status_code: str or ~designer.models.TaskStatusCode
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword creation_time:
        :paramtype creation_time: ~datetime.datetime
        :keyword schedule_time:
        :paramtype schedule_time: ~datetime.datetime
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword request_id:
        :paramtype request_id: str
        :keyword run_id:
        :paramtype run_id: str
        :keyword data_container_id:
        :paramtype data_container_id: str
        :keyword real_time_log_path:
        :paramtype real_time_log_path: str
        :keyword has_warnings:
        :paramtype has_warnings: bool
        :keyword composite_node_id:
        :paramtype composite_node_id: str
        """
        super(GraphNodeStatusInfo, self).__init__(**kwargs)
        self.status = status
        self.run_status = run_status
        self.aether_start_time = aether_start_time
        self.aether_end_time = aether_end_time
        self.aether_creation_time = aether_creation_time
        self.run_history_start_time = run_history_start_time
        self.run_history_end_time = run_history_end_time
        self.run_history_creation_time = run_history_creation_time
        self.reuse_info = reuse_info
        self.status_code = status_code
        self.status_detail = status_detail
        self.creation_time = creation_time
        self.schedule_time = schedule_time
        self.start_time = start_time
        self.end_time = end_time
        self.request_id = request_id
        self.run_id = run_id
        self.data_container_id = data_container_id
        self.real_time_log_path = real_time_log_path
        self.has_warnings = has_warnings
        self.composite_node_id = composite_node_id


class GraphReferenceNode(msrest.serialization.Model):
    """GraphReferenceNode.

    :ivar graph_id:
    :vartype graph_id: str
    :ivar default_compute:
    :vartype default_compute: ~designer.models.ComputeSetting
    :ivar default_datastore:
    :vartype default_datastore: ~designer.models.DatastoreSetting
    :ivar id:
    :vartype id: str
    :ivar module_id:
    :vartype module_id: str
    :ivar comment:
    :vartype comment: str
    :ivar name:
    :vartype name: str
    :ivar module_parameters:
    :vartype module_parameters: list[~designer.models.ParameterAssignment]
    :ivar module_metadata_parameters:
    :vartype module_metadata_parameters: list[~designer.models.ParameterAssignment]
    :ivar module_output_settings:
    :vartype module_output_settings: list[~designer.models.OutputSetting]
    :ivar module_input_settings:
    :vartype module_input_settings: list[~designer.models.InputSetting]
    :ivar use_graph_default_compute:
    :vartype use_graph_default_compute: bool
    :ivar use_graph_default_datastore:
    :vartype use_graph_default_datastore: bool
    :ivar regenerate_output:
    :vartype regenerate_output: bool
    :ivar control_inputs:
    :vartype control_inputs: list[~designer.models.ControlInput]
    """

    _attribute_map = {
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'default_compute': {'key': 'defaultCompute', 'type': 'ComputeSetting'},
        'default_datastore': {'key': 'defaultDatastore', 'type': 'DatastoreSetting'},
        'id': {'key': 'id', 'type': 'str'},
        'module_id': {'key': 'moduleId', 'type': 'str'},
        'comment': {'key': 'comment', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'module_parameters': {'key': 'moduleParameters', 'type': '[ParameterAssignment]'},
        'module_metadata_parameters': {'key': 'moduleMetadataParameters', 'type': '[ParameterAssignment]'},
        'module_output_settings': {'key': 'moduleOutputSettings', 'type': '[OutputSetting]'},
        'module_input_settings': {'key': 'moduleInputSettings', 'type': '[InputSetting]'},
        'use_graph_default_compute': {'key': 'useGraphDefaultCompute', 'type': 'bool'},
        'use_graph_default_datastore': {'key': 'useGraphDefaultDatastore', 'type': 'bool'},
        'regenerate_output': {'key': 'regenerateOutput', 'type': 'bool'},
        'control_inputs': {'key': 'controlInputs', 'type': '[ControlInput]'},
    }

    def __init__(
        self,
        *,
        graph_id: Optional[str] = None,
        default_compute: Optional["ComputeSetting"] = None,
        default_datastore: Optional["DatastoreSetting"] = None,
        id: Optional[str] = None,
        module_id: Optional[str] = None,
        comment: Optional[str] = None,
        name: Optional[str] = None,
        module_parameters: Optional[List["ParameterAssignment"]] = None,
        module_metadata_parameters: Optional[List["ParameterAssignment"]] = None,
        module_output_settings: Optional[List["OutputSetting"]] = None,
        module_input_settings: Optional[List["InputSetting"]] = None,
        use_graph_default_compute: Optional[bool] = None,
        use_graph_default_datastore: Optional[bool] = None,
        regenerate_output: Optional[bool] = None,
        control_inputs: Optional[List["ControlInput"]] = None,
        **kwargs
    ):
        """
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword default_compute:
        :paramtype default_compute: ~designer.models.ComputeSetting
        :keyword default_datastore:
        :paramtype default_datastore: ~designer.models.DatastoreSetting
        :keyword id:
        :paramtype id: str
        :keyword module_id:
        :paramtype module_id: str
        :keyword comment:
        :paramtype comment: str
        :keyword name:
        :paramtype name: str
        :keyword module_parameters:
        :paramtype module_parameters: list[~designer.models.ParameterAssignment]
        :keyword module_metadata_parameters:
        :paramtype module_metadata_parameters: list[~designer.models.ParameterAssignment]
        :keyword module_output_settings:
        :paramtype module_output_settings: list[~designer.models.OutputSetting]
        :keyword module_input_settings:
        :paramtype module_input_settings: list[~designer.models.InputSetting]
        :keyword use_graph_default_compute:
        :paramtype use_graph_default_compute: bool
        :keyword use_graph_default_datastore:
        :paramtype use_graph_default_datastore: bool
        :keyword regenerate_output:
        :paramtype regenerate_output: bool
        :keyword control_inputs:
        :paramtype control_inputs: list[~designer.models.ControlInput]
        """
        super(GraphReferenceNode, self).__init__(**kwargs)
        self.graph_id = graph_id
        self.default_compute = default_compute
        self.default_datastore = default_datastore
        self.id = id
        self.module_id = module_id
        self.comment = comment
        self.name = name
        self.module_parameters = module_parameters
        self.module_metadata_parameters = module_metadata_parameters
        self.module_output_settings = module_output_settings
        self.module_input_settings = module_input_settings
        self.use_graph_default_compute = use_graph_default_compute
        self.use_graph_default_datastore = use_graph_default_datastore
        self.regenerate_output = regenerate_output
        self.control_inputs = control_inputs


class HdiClusterComputeInfo(msrest.serialization.Model):
    """HdiClusterComputeInfo.

    :ivar address:
    :vartype address: str
    :ivar username:
    :vartype username: str
    :ivar password:
    :vartype password: str
    :ivar private_key:
    :vartype private_key: str
    """

    _attribute_map = {
        'address': {'key': 'address', 'type': 'str'},
        'username': {'key': 'username', 'type': 'str'},
        'password': {'key': 'password', 'type': 'str'},
        'private_key': {'key': 'privateKey', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        address: Optional[str] = None,
        username: Optional[str] = None,
        password: Optional[str] = None,
        private_key: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword address:
        :paramtype address: str
        :keyword username:
        :paramtype username: str
        :keyword password:
        :paramtype password: str
        :keyword private_key:
        :paramtype private_key: str
        """
        super(HdiClusterComputeInfo, self).__init__(**kwargs)
        self.address = address
        self.username = username
        self.password = password
        self.private_key = private_key


class HdiConfiguration(msrest.serialization.Model):
    """HdiConfiguration.

    :ivar yarn_deploy_mode: Possible values include: "None", "Client", "Cluster".
    :vartype yarn_deploy_mode: str or ~designer.models.YarnDeployMode
    """

    _attribute_map = {
        'yarn_deploy_mode': {'key': 'yarnDeployMode', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        yarn_deploy_mode: Optional[Union[str, "YarnDeployMode"]] = None,
        **kwargs
    ):
        """
        :keyword yarn_deploy_mode: Possible values include: "None", "Client", "Cluster".
        :paramtype yarn_deploy_mode: str or ~designer.models.YarnDeployMode
        """
        super(HdiConfiguration, self).__init__(**kwargs)
        self.yarn_deploy_mode = yarn_deploy_mode


class HdiRunConfiguration(msrest.serialization.Model):
    """HdiRunConfiguration.

    :ivar file:
    :vartype file: str
    :ivar class_name:
    :vartype class_name: str
    :ivar files:
    :vartype files: list[str]
    :ivar archives:
    :vartype archives: list[str]
    :ivar jars:
    :vartype jars: list[str]
    :ivar py_files:
    :vartype py_files: list[str]
    :ivar compute_name:
    :vartype compute_name: str
    :ivar queue:
    :vartype queue: str
    :ivar driver_memory:
    :vartype driver_memory: str
    :ivar driver_cores:
    :vartype driver_cores: int
    :ivar executor_memory:
    :vartype executor_memory: str
    :ivar executor_cores:
    :vartype executor_cores: int
    :ivar number_executors:
    :vartype number_executors: int
    :ivar conf: Dictionary of :code:`<string>`.
    :vartype conf: dict[str, str]
    :ivar name:
    :vartype name: str
    """

    _attribute_map = {
        'file': {'key': 'file', 'type': 'str'},
        'class_name': {'key': 'className', 'type': 'str'},
        'files': {'key': 'files', 'type': '[str]'},
        'archives': {'key': 'archives', 'type': '[str]'},
        'jars': {'key': 'jars', 'type': '[str]'},
        'py_files': {'key': 'pyFiles', 'type': '[str]'},
        'compute_name': {'key': 'computeName', 'type': 'str'},
        'queue': {'key': 'queue', 'type': 'str'},
        'driver_memory': {'key': 'driverMemory', 'type': 'str'},
        'driver_cores': {'key': 'driverCores', 'type': 'int'},
        'executor_memory': {'key': 'executorMemory', 'type': 'str'},
        'executor_cores': {'key': 'executorCores', 'type': 'int'},
        'number_executors': {'key': 'numberExecutors', 'type': 'int'},
        'conf': {'key': 'conf', 'type': '{str}'},
        'name': {'key': 'name', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        file: Optional[str] = None,
        class_name: Optional[str] = None,
        files: Optional[List[str]] = None,
        archives: Optional[List[str]] = None,
        jars: Optional[List[str]] = None,
        py_files: Optional[List[str]] = None,
        compute_name: Optional[str] = None,
        queue: Optional[str] = None,
        driver_memory: Optional[str] = None,
        driver_cores: Optional[int] = None,
        executor_memory: Optional[str] = None,
        executor_cores: Optional[int] = None,
        number_executors: Optional[int] = None,
        conf: Optional[Dict[str, str]] = None,
        name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword file:
        :paramtype file: str
        :keyword class_name:
        :paramtype class_name: str
        :keyword files:
        :paramtype files: list[str]
        :keyword archives:
        :paramtype archives: list[str]
        :keyword jars:
        :paramtype jars: list[str]
        :keyword py_files:
        :paramtype py_files: list[str]
        :keyword compute_name:
        :paramtype compute_name: str
        :keyword queue:
        :paramtype queue: str
        :keyword driver_memory:
        :paramtype driver_memory: str
        :keyword driver_cores:
        :paramtype driver_cores: int
        :keyword executor_memory:
        :paramtype executor_memory: str
        :keyword executor_cores:
        :paramtype executor_cores: int
        :keyword number_executors:
        :paramtype number_executors: int
        :keyword conf: Dictionary of :code:`<string>`.
        :paramtype conf: dict[str, str]
        :keyword name:
        :paramtype name: str
        """
        super(HdiRunConfiguration, self).__init__(**kwargs)
        self.file = file
        self.class_name = class_name
        self.files = files
        self.archives = archives
        self.jars = jars
        self.py_files = py_files
        self.compute_name = compute_name
        self.queue = queue
        self.driver_memory = driver_memory
        self.driver_cores = driver_cores
        self.executor_memory = executor_memory
        self.executor_cores = executor_cores
        self.number_executors = number_executors
        self.conf = conf
        self.name = name


class HistoryConfiguration(msrest.serialization.Model):
    """HistoryConfiguration.

    :ivar output_collection:
    :vartype output_collection: bool
    :ivar directories_to_watch:
    :vartype directories_to_watch: list[str]
    :ivar enable_m_lflow_tracking:
    :vartype enable_m_lflow_tracking: bool
    """

    _attribute_map = {
        'output_collection': {'key': 'outputCollection', 'type': 'bool'},
        'directories_to_watch': {'key': 'directoriesToWatch', 'type': '[str]'},
        'enable_m_lflow_tracking': {'key': 'enableMLflowTracking', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        output_collection: Optional[bool] = True,
        directories_to_watch: Optional[List[str]] = ['logs'],
        enable_m_lflow_tracking: Optional[bool] = True,
        **kwargs
    ):
        """
        :keyword output_collection:
        :paramtype output_collection: bool
        :keyword directories_to_watch:
        :paramtype directories_to_watch: list[str]
        :keyword enable_m_lflow_tracking:
        :paramtype enable_m_lflow_tracking: bool
        """
        super(HistoryConfiguration, self).__init__(**kwargs)
        self.output_collection = output_collection
        self.directories_to_watch = directories_to_watch
        self.enable_m_lflow_tracking = enable_m_lflow_tracking


class HttpContent(msrest.serialization.Model):
    """HttpContent.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar headers:
    :vartype headers: list[~designer.models.KeyValuePairStringIEnumerable]
    """

    _validation = {
        'headers': {'readonly': True},
    }

    _attribute_map = {
        'headers': {'key': 'headers', 'type': '[KeyValuePairStringIEnumerable]'},
    }

    def __init__(
        self,
        **kwargs
    ):
        """
        """
        super(HttpContent, self).__init__(**kwargs)
        self.headers = None


class HttpMethod(msrest.serialization.Model):
    """HttpMethod.

    :ivar method:
    :vartype method: str
    """

    _attribute_map = {
        'method': {'key': 'method', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        method: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword method:
        :paramtype method: str
        """
        super(HttpMethod, self).__init__(**kwargs)
        self.method = method


class HttpRequestMessage(msrest.serialization.Model):
    """HttpRequestMessage.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar request_uri:
    :vartype request_uri: str
    :ivar version:
    :vartype version: str
    :ivar version_policy: Possible values include: "RequestVersionOrLower",
     "RequestVersionOrHigher", "RequestVersionExact".
    :vartype version_policy: str or ~designer.models.HttpVersionPolicy
    :ivar content:
    :vartype content: ~designer.models.HttpContent
    :ivar method:
    :vartype method: ~designer.models.HttpMethod
    :ivar headers:
    :vartype headers: list[~designer.models.KeyValuePairStringIEnumerable]
    :ivar options: Dictionary of :code:`<any>`.
    :vartype options: dict[str, any]
    """

    _validation = {
        'headers': {'readonly': True},
        'options': {'readonly': True},
    }

    _attribute_map = {
        'request_uri': {'key': 'requestUri', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'version_policy': {'key': 'versionPolicy', 'type': 'str'},
        'content': {'key': 'content', 'type': 'HttpContent'},
        'method': {'key': 'method', 'type': 'HttpMethod'},
        'headers': {'key': 'headers', 'type': '[KeyValuePairStringIEnumerable]'},
        'options': {'key': 'options', 'type': '{object}'},
    }

    def __init__(
        self,
        *,
        request_uri: Optional[str] = None,
        version: Optional[str] = None,
        version_policy: Optional[Union[str, "HttpVersionPolicy"]] = None,
        content: Optional["HttpContent"] = None,
        method: Optional["HttpMethod"] = None,
        **kwargs
    ):
        """
        :keyword request_uri:
        :paramtype request_uri: str
        :keyword version:
        :paramtype version: str
        :keyword version_policy: Possible values include: "RequestVersionOrLower",
         "RequestVersionOrHigher", "RequestVersionExact".
        :paramtype version_policy: str or ~designer.models.HttpVersionPolicy
        :keyword content:
        :paramtype content: ~designer.models.HttpContent
        :keyword method:
        :paramtype method: ~designer.models.HttpMethod
        """
        super(HttpRequestMessage, self).__init__(**kwargs)
        self.request_uri = request_uri
        self.version = version
        self.version_policy = version_policy
        self.content = content
        self.method = method
        self.headers = None
        self.options = None


class HttpResponseMessage(msrest.serialization.Model):
    """HttpResponseMessage.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar content:
    :vartype content: ~designer.models.HttpContent
    :ivar status_code: Possible values include: "Continue", "SwitchingProtocols", "Processing",
     "EarlyHints", "OK", "Created", "Accepted", "NonAuthoritativeInformation", "NoContent",
     "ResetContent", "PartialContent", "MultiStatus", "AlreadyReported", "IMUsed",
     "MultipleChoices", "Ambiguous", "MovedPermanently", "Moved", "Found", "Redirect", "SeeOther",
     "RedirectMethod", "NotModified", "UseProxy", "Unused", "TemporaryRedirect", "RedirectKeepVerb",
     "PermanentRedirect", "BadRequest", "Unauthorized", "PaymentRequired", "Forbidden", "NotFound",
     "MethodNotAllowed", "NotAcceptable", "ProxyAuthenticationRequired", "RequestTimeout",
     "Conflict", "Gone", "LengthRequired", "PreconditionFailed", "RequestEntityTooLarge",
     "RequestUriTooLong", "UnsupportedMediaType", "RequestedRangeNotSatisfiable",
     "ExpectationFailed", "MisdirectedRequest", "UnprocessableEntity", "Locked", "FailedDependency",
     "UpgradeRequired", "PreconditionRequired", "TooManyRequests", "RequestHeaderFieldsTooLarge",
     "UnavailableForLegalReasons", "InternalServerError", "NotImplemented", "BadGateway",
     "ServiceUnavailable", "GatewayTimeout", "HttpVersionNotSupported", "VariantAlsoNegotiates",
     "InsufficientStorage", "LoopDetected", "NotExtended", "NetworkAuthenticationRequired".
    :vartype status_code: str or ~designer.models.HttpStatusCode
    :ivar headers:
    :vartype headers: list[~designer.models.KeyValuePairStringIEnumerable]
    :ivar version:
    :vartype version: str
    :ivar reason_phrase:
    :vartype reason_phrase: str
    :ivar trailing_headers:
    :vartype trailing_headers: list[~designer.models.KeyValuePairStringIEnumerable]
    :ivar request_message:
    :vartype request_message: ~designer.models.HttpRequestMessage
    :ivar is_success_status_code:
    :vartype is_success_status_code: bool
    """

    _validation = {
        'headers': {'readonly': True},
        'trailing_headers': {'readonly': True},
        'is_success_status_code': {'readonly': True},
    }

    _attribute_map = {
        'content': {'key': 'content', 'type': 'HttpContent'},
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'headers': {'key': 'headers', 'type': '[KeyValuePairStringIEnumerable]'},
        'version': {'key': 'version', 'type': 'str'},
        'reason_phrase': {'key': 'reasonPhrase', 'type': 'str'},
        'trailing_headers': {'key': 'trailingHeaders', 'type': '[KeyValuePairStringIEnumerable]'},
        'request_message': {'key': 'requestMessage', 'type': 'HttpRequestMessage'},
        'is_success_status_code': {'key': 'isSuccessStatusCode', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        content: Optional["HttpContent"] = None,
        status_code: Optional[Union[str, "HttpStatusCode"]] = None,
        version: Optional[str] = None,
        reason_phrase: Optional[str] = None,
        request_message: Optional["HttpRequestMessage"] = None,
        **kwargs
    ):
        """
        :keyword content:
        :paramtype content: ~designer.models.HttpContent
        :keyword status_code: Possible values include: "Continue", "SwitchingProtocols", "Processing",
         "EarlyHints", "OK", "Created", "Accepted", "NonAuthoritativeInformation", "NoContent",
         "ResetContent", "PartialContent", "MultiStatus", "AlreadyReported", "IMUsed",
         "MultipleChoices", "Ambiguous", "MovedPermanently", "Moved", "Found", "Redirect", "SeeOther",
         "RedirectMethod", "NotModified", "UseProxy", "Unused", "TemporaryRedirect", "RedirectKeepVerb",
         "PermanentRedirect", "BadRequest", "Unauthorized", "PaymentRequired", "Forbidden", "NotFound",
         "MethodNotAllowed", "NotAcceptable", "ProxyAuthenticationRequired", "RequestTimeout",
         "Conflict", "Gone", "LengthRequired", "PreconditionFailed", "RequestEntityTooLarge",
         "RequestUriTooLong", "UnsupportedMediaType", "RequestedRangeNotSatisfiable",
         "ExpectationFailed", "MisdirectedRequest", "UnprocessableEntity", "Locked", "FailedDependency",
         "UpgradeRequired", "PreconditionRequired", "TooManyRequests", "RequestHeaderFieldsTooLarge",
         "UnavailableForLegalReasons", "InternalServerError", "NotImplemented", "BadGateway",
         "ServiceUnavailable", "GatewayTimeout", "HttpVersionNotSupported", "VariantAlsoNegotiates",
         "InsufficientStorage", "LoopDetected", "NotExtended", "NetworkAuthenticationRequired".
        :paramtype status_code: str or ~designer.models.HttpStatusCode
        :keyword version:
        :paramtype version: str
        :keyword reason_phrase:
        :paramtype reason_phrase: str
        :keyword request_message:
        :paramtype request_message: ~designer.models.HttpRequestMessage
        """
        super(HttpResponseMessage, self).__init__(**kwargs)
        self.content = content
        self.status_code = status_code
        self.headers = None
        self.version = version
        self.reason_phrase = reason_phrase
        self.trailing_headers = None
        self.request_message = request_message
        self.is_success_status_code = None


class HyperDriveConfiguration(msrest.serialization.Model):
    """HyperDriveConfiguration.

    :ivar hyper_drive_run_config:
    :vartype hyper_drive_run_config: str
    :ivar primary_metric_goal:
    :vartype primary_metric_goal: str
    :ivar primary_metric_name:
    :vartype primary_metric_name: str
    :ivar arguments:
    :vartype arguments: list[~designer.models.ArgumentAssignment]
    """

    _attribute_map = {
        'hyper_drive_run_config': {'key': 'hyperDriveRunConfig', 'type': 'str'},
        'primary_metric_goal': {'key': 'primaryMetricGoal', 'type': 'str'},
        'primary_metric_name': {'key': 'primaryMetricName', 'type': 'str'},
        'arguments': {'key': 'arguments', 'type': '[ArgumentAssignment]'},
    }

    def __init__(
        self,
        *,
        hyper_drive_run_config: Optional[str] = None,
        primary_metric_goal: Optional[str] = None,
        primary_metric_name: Optional[str] = None,
        arguments: Optional[List["ArgumentAssignment"]] = None,
        **kwargs
    ):
        """
        :keyword hyper_drive_run_config:
        :paramtype hyper_drive_run_config: str
        :keyword primary_metric_goal:
        :paramtype primary_metric_goal: str
        :keyword primary_metric_name:
        :paramtype primary_metric_name: str
        :keyword arguments:
        :paramtype arguments: list[~designer.models.ArgumentAssignment]
        """
        super(HyperDriveConfiguration, self).__init__(**kwargs)
        self.hyper_drive_run_config = hyper_drive_run_config
        self.primary_metric_goal = primary_metric_goal
        self.primary_metric_name = primary_metric_name
        self.arguments = arguments


class ICheckableLongRunningOperationResponse(msrest.serialization.Model):
    """ICheckableLongRunningOperationResponse.

    :ivar completion_result: Any object.
    :vartype completion_result: any
    :ivar location:
    :vartype location: str
    :ivar operation_result:
    :vartype operation_result: str
    """

    _attribute_map = {
        'completion_result': {'key': 'completionResult', 'type': 'object'},
        'location': {'key': 'location', 'type': 'str'},
        'operation_result': {'key': 'operationResult', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        completion_result: Optional[Any] = None,
        location: Optional[str] = None,
        operation_result: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword completion_result: Any object.
        :paramtype completion_result: any
        :keyword location:
        :paramtype location: str
        :keyword operation_result:
        :paramtype operation_result: str
        """
        super(ICheckableLongRunningOperationResponse, self).__init__(**kwargs)
        self.completion_result = completion_result
        self.location = location
        self.operation_result = operation_result


class IdentityConfiguration(msrest.serialization.Model):
    """IdentityConfiguration.

    :ivar type: Possible values include: "Managed", "ServicePrincipal", "AMLToken".
    :vartype type: str or ~designer.models.IdentityType
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar secret:
    :vartype secret: str
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'secret': {'key': 'secret', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        type: Optional[Union[str, "IdentityType"]] = None,
        properties: Optional[Dict[str, str]] = None,
        secret: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword type: Possible values include: "Managed", "ServicePrincipal", "AMLToken".
        :paramtype type: str or ~designer.models.IdentityType
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword secret:
        :paramtype secret: str
        """
        super(IdentityConfiguration, self).__init__(**kwargs)
        self.type = type
        self.properties = properties
        self.secret = secret


class IndexedErrorResponse(msrest.serialization.Model):
    """IndexedErrorResponse.

    :ivar code:
    :vartype code: str
    :ivar error_code_hierarchy:
    :vartype error_code_hierarchy: str
    :ivar message:
    :vartype message: str
    :ivar time:
    :vartype time: ~datetime.datetime
    :ivar component_name:
    :vartype component_name: str
    :ivar severity:
    :vartype severity: int
    :ivar details_uri:
    :vartype details_uri: str
    :ivar reference_code:
    :vartype reference_code: str
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'error_code_hierarchy': {'key': 'errorCodeHierarchy', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
        'time': {'key': 'time', 'type': 'iso-8601'},
        'component_name': {'key': 'componentName', 'type': 'str'},
        'severity': {'key': 'severity', 'type': 'int'},
        'details_uri': {'key': 'detailsUri', 'type': 'str'},
        'reference_code': {'key': 'referenceCode', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        error_code_hierarchy: Optional[str] = None,
        message: Optional[str] = None,
        time: Optional[datetime.datetime] = None,
        component_name: Optional[str] = None,
        severity: Optional[int] = None,
        details_uri: Optional[str] = None,
        reference_code: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword code:
        :paramtype code: str
        :keyword error_code_hierarchy:
        :paramtype error_code_hierarchy: str
        :keyword message:
        :paramtype message: str
        :keyword time:
        :paramtype time: ~datetime.datetime
        :keyword component_name:
        :paramtype component_name: str
        :keyword severity:
        :paramtype severity: int
        :keyword details_uri:
        :paramtype details_uri: str
        :keyword reference_code:
        :paramtype reference_code: str
        """
        super(IndexedErrorResponse, self).__init__(**kwargs)
        self.code = code
        self.error_code_hierarchy = error_code_hierarchy
        self.message = message
        self.time = time
        self.component_name = component_name
        self.severity = severity
        self.details_uri = details_uri
        self.reference_code = reference_code


class InitScriptInfoDto(msrest.serialization.Model):
    """InitScriptInfoDto.

    :ivar dbfs:
    :vartype dbfs: ~designer.models.DbfsStorageInfoDto
    """

    _attribute_map = {
        'dbfs': {'key': 'dbfs', 'type': 'DbfsStorageInfoDto'},
    }

    def __init__(
        self,
        *,
        dbfs: Optional["DbfsStorageInfoDto"] = None,
        **kwargs
    ):
        """
        :keyword dbfs:
        :paramtype dbfs: ~designer.models.DbfsStorageInfoDto
        """
        super(InitScriptInfoDto, self).__init__(**kwargs)
        self.dbfs = dbfs


class InnerErrorDetails(msrest.serialization.Model):
    """InnerErrorDetails.

    :ivar code:
    :vartype code: str
    :ivar message:
    :vartype message: str
    :ivar target:
    :vartype target: str
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        message: Optional[str] = None,
        target: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword code:
        :paramtype code: str
        :keyword message:
        :paramtype message: str
        :keyword target:
        :paramtype target: str
        """
        super(InnerErrorDetails, self).__init__(**kwargs)
        self.code = code
        self.message = message
        self.target = target


class InnerErrorResponse(msrest.serialization.Model):
    """A nested structure of errors.

    :ivar code: The error code.
    :vartype code: str
    :ivar inner_error: A nested structure of errors.
    :vartype inner_error: ~designer.models.InnerErrorResponse
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'inner_error': {'key': 'innerError', 'type': 'InnerErrorResponse'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        inner_error: Optional["InnerErrorResponse"] = None,
        **kwargs
    ):
        """
        :keyword code: The error code.
        :paramtype code: str
        :keyword inner_error: A nested structure of errors.
        :paramtype inner_error: ~designer.models.InnerErrorResponse
        """
        super(InnerErrorResponse, self).__init__(**kwargs)
        self.code = code
        self.inner_error = inner_error


class InputAsset(msrest.serialization.Model):
    """InputAsset.

    :ivar asset:
    :vartype asset: ~designer.models.Asset
    :ivar mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
    :vartype mechanism: str or ~designer.models.DeliveryMechanism
    :ivar environment_variable_name:
    :vartype environment_variable_name: str
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    :ivar options: Dictionary of :code:`<string>`.
    :vartype options: dict[str, str]
    """

    _attribute_map = {
        'asset': {'key': 'asset', 'type': 'Asset'},
        'mechanism': {'key': 'mechanism', 'type': 'str'},
        'environment_variable_name': {'key': 'environmentVariableName', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'options': {'key': 'options', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        asset: Optional["Asset"] = None,
        mechanism: Optional[Union[str, "DeliveryMechanism"]] = None,
        environment_variable_name: Optional[str] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        options: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword asset:
        :paramtype asset: ~designer.models.Asset
        :keyword mechanism: Possible values include: "Direct", "Mount", "Download", "Hdfs".
        :paramtype mechanism: str or ~designer.models.DeliveryMechanism
        :keyword environment_variable_name:
        :paramtype environment_variable_name: str
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword options: Dictionary of :code:`<string>`.
        :paramtype options: dict[str, str]
        """
        super(InputAsset, self).__init__(**kwargs)
        self.asset = asset
        self.mechanism = mechanism
        self.environment_variable_name = environment_variable_name
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite
        self.options = options


class InputOutputPortMetadata(msrest.serialization.Model):
    """InputOutputPortMetadata.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar graph_module_node_id:
    :vartype graph_module_node_id: str
    :ivar port_name:
    :vartype port_name: str
    :ivar schema:
    :vartype schema: str
    :ivar name:
    :vartype name: str
    :ivar id:
    :vartype id: str
    """

    _validation = {
        'id': {'readonly': True},
    }

    _attribute_map = {
        'graph_module_node_id': {'key': 'graphModuleNodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
        'schema': {'key': 'schema', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        graph_module_node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        schema: Optional[str] = None,
        name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword graph_module_node_id:
        :paramtype graph_module_node_id: str
        :keyword port_name:
        :paramtype port_name: str
        :keyword schema:
        :paramtype schema: str
        :keyword name:
        :paramtype name: str
        """
        super(InputOutputPortMetadata, self).__init__(**kwargs)
        self.graph_module_node_id = graph_module_node_id
        self.port_name = port_name
        self.schema = schema
        self.name = name
        self.id = None


class InputPortDef(msrest.serialization.Model):
    """InputPortDef.

    :ivar name:
    :vartype name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        """
        super(InputPortDef, self).__init__(**kwargs)
        self.name = name
        self.data_store_mode = data_store_mode


class InputSetting(msrest.serialization.Model):
    """InputSetting.

    :ivar name:
    :vartype name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar options: This is a dictionary.
    :vartype options: dict[str, str]
    :ivar additional_transformations:
    :vartype additional_transformations: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'options': {'key': 'options', 'type': '{str}'},
        'additional_transformations': {'key': 'additionalTransformations', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        path_on_compute: Optional[str] = None,
        options: Optional[Dict[str, str]] = None,
        additional_transformations: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword options: This is a dictionary.
        :paramtype options: dict[str, str]
        :keyword additional_transformations:
        :paramtype additional_transformations: str
        """
        super(InputSetting, self).__init__(**kwargs)
        self.name = name
        self.data_store_mode = data_store_mode
        self.path_on_compute = path_on_compute
        self.options = options
        self.additional_transformations = additional_transformations


class InteractiveConfiguration(msrest.serialization.Model):
    """InteractiveConfiguration.

    :ivar is_ssh_enabled:
    :vartype is_ssh_enabled: bool
    :ivar ssh_public_key:
    :vartype ssh_public_key: str
    :ivar is_i_python_enabled:
    :vartype is_i_python_enabled: bool
    :ivar is_tensor_board_enabled:
    :vartype is_tensor_board_enabled: bool
    :ivar interactive_port:
    :vartype interactive_port: int
    """

    _attribute_map = {
        'is_ssh_enabled': {'key': 'isSSHEnabled', 'type': 'bool'},
        'ssh_public_key': {'key': 'sshPublicKey', 'type': 'str'},
        'is_i_python_enabled': {'key': 'isIPythonEnabled', 'type': 'bool'},
        'is_tensor_board_enabled': {'key': 'isTensorBoardEnabled', 'type': 'bool'},
        'interactive_port': {'key': 'interactivePort', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        is_ssh_enabled: Optional[bool] = None,
        ssh_public_key: Optional[str] = None,
        is_i_python_enabled: Optional[bool] = None,
        is_tensor_board_enabled: Optional[bool] = None,
        interactive_port: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword is_ssh_enabled:
        :paramtype is_ssh_enabled: bool
        :keyword ssh_public_key:
        :paramtype ssh_public_key: str
        :keyword is_i_python_enabled:
        :paramtype is_i_python_enabled: bool
        :keyword is_tensor_board_enabled:
        :paramtype is_tensor_board_enabled: bool
        :keyword interactive_port:
        :paramtype interactive_port: int
        """
        super(InteractiveConfiguration, self).__init__(**kwargs)
        self.is_ssh_enabled = is_ssh_enabled
        self.ssh_public_key = ssh_public_key
        self.is_i_python_enabled = is_i_python_enabled
        self.is_tensor_board_enabled = is_tensor_board_enabled
        self.interactive_port = interactive_port


class JobCost(msrest.serialization.Model):
    """JobCost.

    :ivar charged_cpu_core_seconds:
    :vartype charged_cpu_core_seconds: float
    :ivar charged_cpu_memory_megabyte_seconds:
    :vartype charged_cpu_memory_megabyte_seconds: float
    :ivar charged_gpu_seconds:
    :vartype charged_gpu_seconds: float
    :ivar charged_node_utilization_seconds:
    :vartype charged_node_utilization_seconds: float
    """

    _attribute_map = {
        'charged_cpu_core_seconds': {'key': 'chargedCpuCoreSeconds', 'type': 'float'},
        'charged_cpu_memory_megabyte_seconds': {'key': 'chargedCpuMemoryMegabyteSeconds', 'type': 'float'},
        'charged_gpu_seconds': {'key': 'chargedGpuSeconds', 'type': 'float'},
        'charged_node_utilization_seconds': {'key': 'chargedNodeUtilizationSeconds', 'type': 'float'},
    }

    def __init__(
        self,
        *,
        charged_cpu_core_seconds: Optional[float] = None,
        charged_cpu_memory_megabyte_seconds: Optional[float] = None,
        charged_gpu_seconds: Optional[float] = None,
        charged_node_utilization_seconds: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword charged_cpu_core_seconds:
        :paramtype charged_cpu_core_seconds: float
        :keyword charged_cpu_memory_megabyte_seconds:
        :paramtype charged_cpu_memory_megabyte_seconds: float
        :keyword charged_gpu_seconds:
        :paramtype charged_gpu_seconds: float
        :keyword charged_node_utilization_seconds:
        :paramtype charged_node_utilization_seconds: float
        """
        super(JobCost, self).__init__(**kwargs)
        self.charged_cpu_core_seconds = charged_cpu_core_seconds
        self.charged_cpu_memory_megabyte_seconds = charged_cpu_memory_megabyte_seconds
        self.charged_gpu_seconds = charged_gpu_seconds
        self.charged_node_utilization_seconds = charged_node_utilization_seconds


class KeyValuePairStringIEnumerable(msrest.serialization.Model):
    """KeyValuePairStringIEnumerable.

    :ivar key:
    :vartype key: str
    :ivar value:
    :vartype value: list[str]
    """

    _attribute_map = {
        'key': {'key': 'key', 'type': 'str'},
        'value': {'key': 'value', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        key: Optional[str] = None,
        value: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword key:
        :paramtype key: str
        :keyword value:
        :paramtype value: list[str]
        """
        super(KeyValuePairStringIEnumerable, self).__init__(**kwargs)
        self.key = key
        self.value = value


class KubernetesConfiguration(msrest.serialization.Model):
    """KubernetesConfiguration.

    :ivar instance_type:
    :vartype instance_type: str
    """

    _attribute_map = {
        'instance_type': {'key': 'instanceType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        instance_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword instance_type:
        :paramtype instance_type: str
        """
        super(KubernetesConfiguration, self).__init__(**kwargs)
        self.instance_type = instance_type


class Kwarg(msrest.serialization.Model):
    """Kwarg.

    :ivar key:
    :vartype key: str
    :ivar value:
    :vartype value: str
    """

    _attribute_map = {
        'key': {'key': 'key', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        key: Optional[str] = None,
        value: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword key:
        :paramtype key: str
        :keyword value:
        :paramtype value: str
        """
        super(Kwarg, self).__init__(**kwargs)
        self.key = key
        self.value = value


class LegacyDataPath(msrest.serialization.Model):
    """LegacyDataPath.

    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar relative_path:
    :vartype relative_path: str
    """

    _attribute_map = {
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        data_store_name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        relative_path: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword relative_path:
        :paramtype relative_path: str
        """
        super(LegacyDataPath, self).__init__(**kwargs)
        self.data_store_name = data_store_name
        self.data_store_mode = data_store_mode
        self.relative_path = relative_path


class LimitSettings(msrest.serialization.Model):
    """LimitSettings.

    :ivar max_trials:
    :vartype max_trials: int
    :ivar trial_timeout:
    :vartype trial_timeout: str
    :ivar max_concurrent_trials:
    :vartype max_concurrent_trials: int
    :ivar max_cores_per_trial:
    :vartype max_cores_per_trial: int
    :ivar exit_score:
    :vartype exit_score: float
    :ivar enable_early_termination:
    :vartype enable_early_termination: bool
    """

    _attribute_map = {
        'max_trials': {'key': 'maxTrials', 'type': 'int'},
        'trial_timeout': {'key': 'trialTimeout', 'type': 'str'},
        'max_concurrent_trials': {'key': 'maxConcurrentTrials', 'type': 'int'},
        'max_cores_per_trial': {'key': 'maxCoresPerTrial', 'type': 'int'},
        'exit_score': {'key': 'exitScore', 'type': 'float'},
        'enable_early_termination': {'key': 'enableEarlyTermination', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        max_trials: Optional[int] = None,
        trial_timeout: Optional[str] = None,
        max_concurrent_trials: Optional[int] = None,
        max_cores_per_trial: Optional[int] = None,
        exit_score: Optional[float] = None,
        enable_early_termination: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword max_trials:
        :paramtype max_trials: int
        :keyword trial_timeout:
        :paramtype trial_timeout: str
        :keyword max_concurrent_trials:
        :paramtype max_concurrent_trials: int
        :keyword max_cores_per_trial:
        :paramtype max_cores_per_trial: int
        :keyword exit_score:
        :paramtype exit_score: float
        :keyword enable_early_termination:
        :paramtype enable_early_termination: bool
        """
        super(LimitSettings, self).__init__(**kwargs)
        self.max_trials = max_trials
        self.trial_timeout = trial_timeout
        self.max_concurrent_trials = max_concurrent_trials
        self.max_cores_per_trial = max_cores_per_trial
        self.exit_score = exit_score
        self.enable_early_termination = enable_early_termination


class LinkedADBWorkspaceMetadata(msrest.serialization.Model):
    """LinkedADBWorkspaceMetadata.

    :ivar workspace_id:
    :vartype workspace_id: str
    :ivar region:
    :vartype region: str
    """

    _attribute_map = {
        'workspace_id': {'key': 'workspaceId', 'type': 'str'},
        'region': {'key': 'region', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        workspace_id: Optional[str] = None,
        region: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword workspace_id:
        :paramtype workspace_id: str
        :keyword region:
        :paramtype region: str
        """
        super(LinkedADBWorkspaceMetadata, self).__init__(**kwargs)
        self.workspace_id = workspace_id
        self.region = region


class LinkedPipelineInfo(msrest.serialization.Model):
    """LinkedPipelineInfo.

    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar module_node_id:
    :vartype module_node_id: str
    :ivar port_name:
    :vartype port_name: str
    :ivar linked_pipeline_draft_id:
    :vartype linked_pipeline_draft_id: str
    :ivar linked_pipeline_run_id:
    :vartype linked_pipeline_run_id: str
    :ivar is_direct_link:
    :vartype is_direct_link: bool
    """

    _attribute_map = {
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'module_node_id': {'key': 'moduleNodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
        'linked_pipeline_draft_id': {'key': 'linkedPipelineDraftId', 'type': 'str'},
        'linked_pipeline_run_id': {'key': 'linkedPipelineRunId', 'type': 'str'},
        'is_direct_link': {'key': 'isDirectLink', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        module_node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        linked_pipeline_draft_id: Optional[str] = None,
        linked_pipeline_run_id: Optional[str] = None,
        is_direct_link: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword module_node_id:
        :paramtype module_node_id: str
        :keyword port_name:
        :paramtype port_name: str
        :keyword linked_pipeline_draft_id:
        :paramtype linked_pipeline_draft_id: str
        :keyword linked_pipeline_run_id:
        :paramtype linked_pipeline_run_id: str
        :keyword is_direct_link:
        :paramtype is_direct_link: bool
        """
        super(LinkedPipelineInfo, self).__init__(**kwargs)
        self.pipeline_type = pipeline_type
        self.module_node_id = module_node_id
        self.port_name = port_name
        self.linked_pipeline_draft_id = linked_pipeline_draft_id
        self.linked_pipeline_run_id = linked_pipeline_run_id
        self.is_direct_link = is_direct_link


class MavenLibraryDto(msrest.serialization.Model):
    """MavenLibraryDto.

    :ivar coordinates:
    :vartype coordinates: str
    :ivar repo:
    :vartype repo: str
    :ivar exclusions:
    :vartype exclusions: list[str]
    """

    _attribute_map = {
        'coordinates': {'key': 'coordinates', 'type': 'str'},
        'repo': {'key': 'repo', 'type': 'str'},
        'exclusions': {'key': 'exclusions', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        coordinates: Optional[str] = None,
        repo: Optional[str] = None,
        exclusions: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword coordinates:
        :paramtype coordinates: str
        :keyword repo:
        :paramtype repo: str
        :keyword exclusions:
        :paramtype exclusions: list[str]
        """
        super(MavenLibraryDto, self).__init__(**kwargs)
        self.coordinates = coordinates
        self.repo = repo
        self.exclusions = exclusions


class MetricProperties(msrest.serialization.Model):
    """MetricProperties.

    :ivar ux_metric_type:
    :vartype ux_metric_type: str
    """

    _attribute_map = {
        'ux_metric_type': {'key': 'uxMetricType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        ux_metric_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword ux_metric_type:
        :paramtype ux_metric_type: str
        """
        super(MetricProperties, self).__init__(**kwargs)
        self.ux_metric_type = ux_metric_type


class MetricSchemaDto(msrest.serialization.Model):
    """MetricSchemaDto.

    :ivar num_properties:
    :vartype num_properties: int
    :ivar properties:
    :vartype properties: list[~designer.models.MetricSchemaPropertyDto]
    """

    _attribute_map = {
        'num_properties': {'key': 'numProperties', 'type': 'int'},
        'properties': {'key': 'properties', 'type': '[MetricSchemaPropertyDto]'},
    }

    def __init__(
        self,
        *,
        num_properties: Optional[int] = None,
        properties: Optional[List["MetricSchemaPropertyDto"]] = None,
        **kwargs
    ):
        """
        :keyword num_properties:
        :paramtype num_properties: int
        :keyword properties:
        :paramtype properties: list[~designer.models.MetricSchemaPropertyDto]
        """
        super(MetricSchemaDto, self).__init__(**kwargs)
        self.num_properties = num_properties
        self.properties = properties


class MetricSchemaPropertyDto(msrest.serialization.Model):
    """MetricSchemaPropertyDto.

    :ivar property_id:
    :vartype property_id: str
    :ivar name:
    :vartype name: str
    :ivar type:
    :vartype type: str
    """

    _attribute_map = {
        'property_id': {'key': 'propertyId', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        property_id: Optional[str] = None,
        name: Optional[str] = None,
        type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword property_id:
        :paramtype property_id: str
        :keyword name:
        :paramtype name: str
        :keyword type:
        :paramtype type: str
        """
        super(MetricSchemaPropertyDto, self).__init__(**kwargs)
        self.property_id = property_id
        self.name = name
        self.type = type


class MetricV2Dto(msrest.serialization.Model):
    """MetricV2Dto.

    :ivar data_container_id:
    :vartype data_container_id: str
    :ivar name:
    :vartype name: str
    :ivar columns: This is a dictionary.
    :vartype columns: dict[str, str or ~designer.models.MetricValueType]
    :ivar properties:
    :vartype properties: ~designer.models.MetricProperties
    :ivar namespace:
    :vartype namespace: str
    :ivar standard_schema_id:
    :vartype standard_schema_id: str
    :ivar value:
    :vartype value: list[~designer.models.MetricV2Value]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'data_container_id': {'key': 'dataContainerId', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'columns': {'key': 'columns', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': 'MetricProperties'},
        'namespace': {'key': 'namespace', 'type': 'str'},
        'standard_schema_id': {'key': 'standardSchemaId', 'type': 'str'},
        'value': {'key': 'value', 'type': '[MetricV2Value]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        data_container_id: Optional[str] = None,
        name: Optional[str] = None,
        columns: Optional[Dict[str, Union[str, "MetricValueType"]]] = None,
        properties: Optional["MetricProperties"] = None,
        namespace: Optional[str] = None,
        standard_schema_id: Optional[str] = None,
        value: Optional[List["MetricV2Value"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword data_container_id:
        :paramtype data_container_id: str
        :keyword name:
        :paramtype name: str
        :keyword columns: This is a dictionary.
        :paramtype columns: dict[str, str or ~designer.models.MetricValueType]
        :keyword properties:
        :paramtype properties: ~designer.models.MetricProperties
        :keyword namespace:
        :paramtype namespace: str
        :keyword standard_schema_id:
        :paramtype standard_schema_id: str
        :keyword value:
        :paramtype value: list[~designer.models.MetricV2Value]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(MetricV2Dto, self).__init__(**kwargs)
        self.data_container_id = data_container_id
        self.name = name
        self.columns = columns
        self.properties = properties
        self.namespace = namespace
        self.standard_schema_id = standard_schema_id
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class MetricV2Value(msrest.serialization.Model):
    """MetricV2Value.

    :ivar metric_id:
    :vartype metric_id: str
    :ivar created_utc:
    :vartype created_utc: ~datetime.datetime
    :ivar step:
    :vartype step: long
    :ivar data: Dictionary of :code:`<any>`.
    :vartype data: dict[str, any]
    """

    _attribute_map = {
        'metric_id': {'key': 'metricId', 'type': 'str'},
        'created_utc': {'key': 'createdUtc', 'type': 'iso-8601'},
        'step': {'key': 'step', 'type': 'long'},
        'data': {'key': 'data', 'type': '{object}'},
    }

    def __init__(
        self,
        *,
        metric_id: Optional[str] = None,
        created_utc: Optional[datetime.datetime] = None,
        step: Optional[int] = None,
        data: Optional[Dict[str, Any]] = None,
        **kwargs
    ):
        """
        :keyword metric_id:
        :paramtype metric_id: str
        :keyword created_utc:
        :paramtype created_utc: ~datetime.datetime
        :keyword step:
        :paramtype step: long
        :keyword data: Dictionary of :code:`<any>`.
        :paramtype data: dict[str, any]
        """
        super(MetricV2Value, self).__init__(**kwargs)
        self.metric_id = metric_id
        self.created_utc = created_utc
        self.step = step
        self.data = data


class MinMaxParameterRule(msrest.serialization.Model):
    """MinMaxParameterRule.

    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    """

    _attribute_map = {
        'min': {'key': 'min', 'type': 'float'},
        'max': {'key': 'max', 'type': 'float'},
    }

    def __init__(
        self,
        *,
        min: Optional[float] = None,
        max: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        """
        super(MinMaxParameterRule, self).__init__(**kwargs)
        self.min = min
        self.max = max


class MlcComputeInfo(msrest.serialization.Model):
    """MlcComputeInfo.

    :ivar mlc_compute_type:
    :vartype mlc_compute_type: str
    """

    _attribute_map = {
        'mlc_compute_type': {'key': 'mlcComputeType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        mlc_compute_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword mlc_compute_type:
        :paramtype mlc_compute_type: str
        """
        super(MlcComputeInfo, self).__init__(**kwargs)
        self.mlc_compute_type = mlc_compute_type


class ModelDto(msrest.serialization.Model):
    """ModelDto.

    :ivar feed_name:
    :vartype feed_name: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar aml_data_store_name:
    :vartype aml_data_store_name: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar id:
    :vartype id: str
    :ivar version:
    :vartype version: str
    :ivar system_data:
    :vartype system_data: ~designer.models.SystemData
    :ivar arm_id:
    :vartype arm_id: str
    :ivar online_endpoint_yaml_str:
    :vartype online_endpoint_yaml_str: str
    """

    _attribute_map = {
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'aml_data_store_name': {'key': 'amlDataStoreName', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'system_data': {'key': 'systemData', 'type': 'SystemData'},
        'arm_id': {'key': 'armId', 'type': 'str'},
        'online_endpoint_yaml_str': {'key': 'onlineEndpointYamlStr', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        feed_name: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        aml_data_store_name: Optional[str] = None,
        relative_path: Optional[str] = None,
        id: Optional[str] = None,
        version: Optional[str] = None,
        system_data: Optional["SystemData"] = None,
        arm_id: Optional[str] = None,
        online_endpoint_yaml_str: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword aml_data_store_name:
        :paramtype aml_data_store_name: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword id:
        :paramtype id: str
        :keyword version:
        :paramtype version: str
        :keyword system_data:
        :paramtype system_data: ~designer.models.SystemData
        :keyword arm_id:
        :paramtype arm_id: str
        :keyword online_endpoint_yaml_str:
        :paramtype online_endpoint_yaml_str: str
        """
        super(ModelDto, self).__init__(**kwargs)
        self.feed_name = feed_name
        self.name = name
        self.description = description
        self.aml_data_store_name = aml_data_store_name
        self.relative_path = relative_path
        self.id = id
        self.version = version
        self.system_data = system_data
        self.arm_id = arm_id
        self.online_endpoint_yaml_str = online_endpoint_yaml_str


class ModelManagementErrorResponse(msrest.serialization.Model):
    """ModelManagementErrorResponse.

    :ivar code:
    :vartype code: str
    :ivar status_code:
    :vartype status_code: int
    :ivar message:
    :vartype message: str
    :ivar target:
    :vartype target: str
    :ivar details:
    :vartype details: list[~designer.models.InnerErrorDetails]
    :ivar correlation: Dictionary of :code:`<string>`.
    :vartype correlation: dict[str, str]
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'status_code': {'key': 'statusCode', 'type': 'int'},
        'message': {'key': 'message', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'details': {'key': 'details', 'type': '[InnerErrorDetails]'},
        'correlation': {'key': 'correlation', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        status_code: Optional[int] = None,
        message: Optional[str] = None,
        target: Optional[str] = None,
        details: Optional[List["InnerErrorDetails"]] = None,
        correlation: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword code:
        :paramtype code: str
        :keyword status_code:
        :paramtype status_code: int
        :keyword message:
        :paramtype message: str
        :keyword target:
        :paramtype target: str
        :keyword details:
        :paramtype details: list[~designer.models.InnerErrorDetails]
        :keyword correlation: Dictionary of :code:`<string>`.
        :paramtype correlation: dict[str, str]
        """
        super(ModelManagementErrorResponse, self).__init__(**kwargs)
        self.code = code
        self.status_code = status_code
        self.message = message
        self.target = target
        self.details = details
        self.correlation = correlation


class ModuleDto(msrest.serialization.Model):
    """ModuleDto.

    :ivar namespace:
    :vartype namespace: str
    :ivar tags: A set of tags.
    :vartype tags: list[str]
    :ivar display_name:
    :vartype display_name: str
    :ivar dict_tags: Dictionary of :code:`<string>`.
    :vartype dict_tags: dict[str, str]
    :ivar module_version_id:
    :vartype module_version_id: str
    :ivar feed_name:
    :vartype feed_name: str
    :ivar registry_name:
    :vartype registry_name: str
    :ivar module_name:
    :vartype module_name: str
    :ivar module_version:
    :vartype module_version: str
    :ivar description:
    :vartype description: str
    :ivar owner:
    :vartype owner: str
    :ivar job_type:
    :vartype job_type: str
    :ivar default_version:
    :vartype default_version: str
    :ivar family_id:
    :vartype family_id: str
    :ivar help_document:
    :vartype help_document: str
    :ivar codegen_by:
    :vartype codegen_by: str
    :ivar arm_id:
    :vartype arm_id: str
    :ivar module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous", "Step",
     "Draft", "Feed", "Registry".
    :vartype module_scope: str or ~designer.models.ModuleScope
    :ivar module_entity:
    :vartype module_entity: ~designer.models.ModuleEntity
    :ivar input_types:
    :vartype input_types: list[str]
    :ivar output_types:
    :vartype output_types: list[str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    :ivar yaml_link:
    :vartype yaml_link: str
    :ivar yaml_link_with_commit_sha:
    :vartype yaml_link_with_commit_sha: str
    :ivar module_source_type: Possible values include: "Unknown", "Local", "GithubFile",
     "GithubFolder", "DevopsArtifactsZip", "SerializedModuleInfo".
    :vartype module_source_type: str or ~designer.models.ModuleSourceType
    :ivar registered_by:
    :vartype registered_by: str
    :ivar versions:
    :vartype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
    :ivar is_default_module_version:
    :vartype is_default_module_version: bool
    :ivar system_data:
    :vartype system_data: ~designer.models.SystemData
    :ivar system_meta:
    :vartype system_meta: ~designer.models.SystemMeta
    :ivar snapshot_id:
    :vartype snapshot_id: str
    :ivar entry:
    :vartype entry: str
    :ivar os_type:
    :vartype os_type: str
    :ivar require_gpu:
    :vartype require_gpu: bool
    :ivar module_python_interface:
    :vartype module_python_interface: ~designer.models.ModulePythonInterface
    :ivar run_setting_parameters:
    :vartype run_setting_parameters: list[~designer.models.RunSettingParameter]
    :ivar yaml_str:
    :vartype yaml_str: str
    """

    _attribute_map = {
        'namespace': {'key': 'namespace', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '[str]'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'dict_tags': {'key': 'dictTags', 'type': '{str}'},
        'module_version_id': {'key': 'moduleVersionId', 'type': 'str'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'registry_name': {'key': 'registryName', 'type': 'str'},
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'owner': {'key': 'owner', 'type': 'str'},
        'job_type': {'key': 'jobType', 'type': 'str'},
        'default_version': {'key': 'defaultVersion', 'type': 'str'},
        'family_id': {'key': 'familyId', 'type': 'str'},
        'help_document': {'key': 'helpDocument', 'type': 'str'},
        'codegen_by': {'key': 'codegenBy', 'type': 'str'},
        'arm_id': {'key': 'armId', 'type': 'str'},
        'module_scope': {'key': 'moduleScope', 'type': 'str'},
        'module_entity': {'key': 'moduleEntity', 'type': 'ModuleEntity'},
        'input_types': {'key': 'inputTypes', 'type': '[str]'},
        'output_types': {'key': 'outputTypes', 'type': '[str]'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
        'yaml_link': {'key': 'yamlLink', 'type': 'str'},
        'yaml_link_with_commit_sha': {'key': 'yamlLinkWithCommitSha', 'type': 'str'},
        'module_source_type': {'key': 'moduleSourceType', 'type': 'str'},
        'registered_by': {'key': 'registeredBy', 'type': 'str'},
        'versions': {'key': 'versions', 'type': '[AzureMLModuleVersionDescriptor]'},
        'is_default_module_version': {'key': 'isDefaultModuleVersion', 'type': 'bool'},
        'system_data': {'key': 'systemData', 'type': 'SystemData'},
        'system_meta': {'key': 'systemMeta', 'type': 'SystemMeta'},
        'snapshot_id': {'key': 'snapshotId', 'type': 'str'},
        'entry': {'key': 'entry', 'type': 'str'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'require_gpu': {'key': 'requireGpu', 'type': 'bool'},
        'module_python_interface': {'key': 'modulePythonInterface', 'type': 'ModulePythonInterface'},
        'run_setting_parameters': {'key': 'runSettingParameters', 'type': '[RunSettingParameter]'},
        'yaml_str': {'key': 'yamlStr', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        namespace: Optional[str] = None,
        tags: Optional[List[str]] = None,
        display_name: Optional[str] = None,
        dict_tags: Optional[Dict[str, str]] = None,
        module_version_id: Optional[str] = None,
        feed_name: Optional[str] = None,
        registry_name: Optional[str] = None,
        module_name: Optional[str] = None,
        module_version: Optional[str] = None,
        description: Optional[str] = None,
        owner: Optional[str] = None,
        job_type: Optional[str] = None,
        default_version: Optional[str] = None,
        family_id: Optional[str] = None,
        help_document: Optional[str] = None,
        codegen_by: Optional[str] = None,
        arm_id: Optional[str] = None,
        module_scope: Optional[Union[str, "ModuleScope"]] = None,
        module_entity: Optional["ModuleEntity"] = None,
        input_types: Optional[List[str]] = None,
        output_types: Optional[List[str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        yaml_link: Optional[str] = None,
        yaml_link_with_commit_sha: Optional[str] = None,
        module_source_type: Optional[Union[str, "ModuleSourceType"]] = None,
        registered_by: Optional[str] = None,
        versions: Optional[List["AzureMLModuleVersionDescriptor"]] = None,
        is_default_module_version: Optional[bool] = None,
        system_data: Optional["SystemData"] = None,
        system_meta: Optional["SystemMeta"] = None,
        snapshot_id: Optional[str] = None,
        entry: Optional[str] = None,
        os_type: Optional[str] = None,
        require_gpu: Optional[bool] = None,
        module_python_interface: Optional["ModulePythonInterface"] = None,
        run_setting_parameters: Optional[List["RunSettingParameter"]] = None,
        yaml_str: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword namespace:
        :paramtype namespace: str
        :keyword tags: A set of tags.
        :paramtype tags: list[str]
        :keyword display_name:
        :paramtype display_name: str
        :keyword dict_tags: Dictionary of :code:`<string>`.
        :paramtype dict_tags: dict[str, str]
        :keyword module_version_id:
        :paramtype module_version_id: str
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword registry_name:
        :paramtype registry_name: str
        :keyword module_name:
        :paramtype module_name: str
        :keyword module_version:
        :paramtype module_version: str
        :keyword description:
        :paramtype description: str
        :keyword owner:
        :paramtype owner: str
        :keyword job_type:
        :paramtype job_type: str
        :keyword default_version:
        :paramtype default_version: str
        :keyword family_id:
        :paramtype family_id: str
        :keyword help_document:
        :paramtype help_document: str
        :keyword codegen_by:
        :paramtype codegen_by: str
        :keyword arm_id:
        :paramtype arm_id: str
        :keyword module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous",
         "Step", "Draft", "Feed", "Registry".
        :paramtype module_scope: str or ~designer.models.ModuleScope
        :keyword module_entity:
        :paramtype module_entity: ~designer.models.ModuleEntity
        :keyword input_types:
        :paramtype input_types: list[str]
        :keyword output_types:
        :paramtype output_types: list[str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        :keyword yaml_link:
        :paramtype yaml_link: str
        :keyword yaml_link_with_commit_sha:
        :paramtype yaml_link_with_commit_sha: str
        :keyword module_source_type: Possible values include: "Unknown", "Local", "GithubFile",
         "GithubFolder", "DevopsArtifactsZip", "SerializedModuleInfo".
        :paramtype module_source_type: str or ~designer.models.ModuleSourceType
        :keyword registered_by:
        :paramtype registered_by: str
        :keyword versions:
        :paramtype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
        :keyword is_default_module_version:
        :paramtype is_default_module_version: bool
        :keyword system_data:
        :paramtype system_data: ~designer.models.SystemData
        :keyword system_meta:
        :paramtype system_meta: ~designer.models.SystemMeta
        :keyword snapshot_id:
        :paramtype snapshot_id: str
        :keyword entry:
        :paramtype entry: str
        :keyword os_type:
        :paramtype os_type: str
        :keyword require_gpu:
        :paramtype require_gpu: bool
        :keyword module_python_interface:
        :paramtype module_python_interface: ~designer.models.ModulePythonInterface
        :keyword run_setting_parameters:
        :paramtype run_setting_parameters: list[~designer.models.RunSettingParameter]
        :keyword yaml_str:
        :paramtype yaml_str: str
        """
        super(ModuleDto, self).__init__(**kwargs)
        self.namespace = namespace
        self.tags = tags
        self.display_name = display_name
        self.dict_tags = dict_tags
        self.module_version_id = module_version_id
        self.feed_name = feed_name
        self.registry_name = registry_name
        self.module_name = module_name
        self.module_version = module_version
        self.description = description
        self.owner = owner
        self.job_type = job_type
        self.default_version = default_version
        self.family_id = family_id
        self.help_document = help_document
        self.codegen_by = codegen_by
        self.arm_id = arm_id
        self.module_scope = module_scope
        self.module_entity = module_entity
        self.input_types = input_types
        self.output_types = output_types
        self.entity_status = entity_status
        self.created_date = created_date
        self.last_modified_date = last_modified_date
        self.yaml_link = yaml_link
        self.yaml_link_with_commit_sha = yaml_link_with_commit_sha
        self.module_source_type = module_source_type
        self.registered_by = registered_by
        self.versions = versions
        self.is_default_module_version = is_default_module_version
        self.system_data = system_data
        self.system_meta = system_meta
        self.snapshot_id = snapshot_id
        self.entry = entry
        self.os_type = os_type
        self.require_gpu = require_gpu
        self.module_python_interface = module_python_interface
        self.run_setting_parameters = run_setting_parameters
        self.yaml_str = yaml_str


class ModuleDtoWithValidateStatus(msrest.serialization.Model):
    """ModuleDtoWithValidateStatus.

    :ivar existing_module_entity:
    :vartype existing_module_entity: ~designer.models.ModuleEntity
    :ivar status: Possible values include: "NewModule", "NewVersion", "Conflict", "ParseError",
     "ProcessRequestError".
    :vartype status: str or ~designer.models.ModuleInfoFromYamlStatusEnum
    :ivar status_details:
    :vartype status_details: str
    :ivar serialized_module_info:
    :vartype serialized_module_info: str
    :ivar namespace:
    :vartype namespace: str
    :ivar tags: A set of tags.
    :vartype tags: list[str]
    :ivar display_name:
    :vartype display_name: str
    :ivar dict_tags: Dictionary of :code:`<string>`.
    :vartype dict_tags: dict[str, str]
    :ivar module_version_id:
    :vartype module_version_id: str
    :ivar feed_name:
    :vartype feed_name: str
    :ivar registry_name:
    :vartype registry_name: str
    :ivar module_name:
    :vartype module_name: str
    :ivar module_version:
    :vartype module_version: str
    :ivar description:
    :vartype description: str
    :ivar owner:
    :vartype owner: str
    :ivar job_type:
    :vartype job_type: str
    :ivar default_version:
    :vartype default_version: str
    :ivar family_id:
    :vartype family_id: str
    :ivar help_document:
    :vartype help_document: str
    :ivar codegen_by:
    :vartype codegen_by: str
    :ivar arm_id:
    :vartype arm_id: str
    :ivar module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous", "Step",
     "Draft", "Feed", "Registry".
    :vartype module_scope: str or ~designer.models.ModuleScope
    :ivar module_entity:
    :vartype module_entity: ~designer.models.ModuleEntity
    :ivar input_types:
    :vartype input_types: list[str]
    :ivar output_types:
    :vartype output_types: list[str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    :ivar yaml_link:
    :vartype yaml_link: str
    :ivar yaml_link_with_commit_sha:
    :vartype yaml_link_with_commit_sha: str
    :ivar module_source_type: Possible values include: "Unknown", "Local", "GithubFile",
     "GithubFolder", "DevopsArtifactsZip", "SerializedModuleInfo".
    :vartype module_source_type: str or ~designer.models.ModuleSourceType
    :ivar registered_by:
    :vartype registered_by: str
    :ivar versions:
    :vartype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
    :ivar is_default_module_version:
    :vartype is_default_module_version: bool
    :ivar system_data:
    :vartype system_data: ~designer.models.SystemData
    :ivar system_meta:
    :vartype system_meta: ~designer.models.SystemMeta
    :ivar snapshot_id:
    :vartype snapshot_id: str
    :ivar entry:
    :vartype entry: str
    :ivar os_type:
    :vartype os_type: str
    :ivar require_gpu:
    :vartype require_gpu: bool
    :ivar module_python_interface:
    :vartype module_python_interface: ~designer.models.ModulePythonInterface
    :ivar run_setting_parameters:
    :vartype run_setting_parameters: list[~designer.models.RunSettingParameter]
    :ivar yaml_str:
    :vartype yaml_str: str
    """

    _attribute_map = {
        'existing_module_entity': {'key': 'existingModuleEntity', 'type': 'ModuleEntity'},
        'status': {'key': 'status', 'type': 'str'},
        'status_details': {'key': 'statusDetails', 'type': 'str'},
        'serialized_module_info': {'key': 'serializedModuleInfo', 'type': 'str'},
        'namespace': {'key': 'namespace', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '[str]'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'dict_tags': {'key': 'dictTags', 'type': '{str}'},
        'module_version_id': {'key': 'moduleVersionId', 'type': 'str'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'registry_name': {'key': 'registryName', 'type': 'str'},
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'owner': {'key': 'owner', 'type': 'str'},
        'job_type': {'key': 'jobType', 'type': 'str'},
        'default_version': {'key': 'defaultVersion', 'type': 'str'},
        'family_id': {'key': 'familyId', 'type': 'str'},
        'help_document': {'key': 'helpDocument', 'type': 'str'},
        'codegen_by': {'key': 'codegenBy', 'type': 'str'},
        'arm_id': {'key': 'armId', 'type': 'str'},
        'module_scope': {'key': 'moduleScope', 'type': 'str'},
        'module_entity': {'key': 'moduleEntity', 'type': 'ModuleEntity'},
        'input_types': {'key': 'inputTypes', 'type': '[str]'},
        'output_types': {'key': 'outputTypes', 'type': '[str]'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
        'yaml_link': {'key': 'yamlLink', 'type': 'str'},
        'yaml_link_with_commit_sha': {'key': 'yamlLinkWithCommitSha', 'type': 'str'},
        'module_source_type': {'key': 'moduleSourceType', 'type': 'str'},
        'registered_by': {'key': 'registeredBy', 'type': 'str'},
        'versions': {'key': 'versions', 'type': '[AzureMLModuleVersionDescriptor]'},
        'is_default_module_version': {'key': 'isDefaultModuleVersion', 'type': 'bool'},
        'system_data': {'key': 'systemData', 'type': 'SystemData'},
        'system_meta': {'key': 'systemMeta', 'type': 'SystemMeta'},
        'snapshot_id': {'key': 'snapshotId', 'type': 'str'},
        'entry': {'key': 'entry', 'type': 'str'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'require_gpu': {'key': 'requireGpu', 'type': 'bool'},
        'module_python_interface': {'key': 'modulePythonInterface', 'type': 'ModulePythonInterface'},
        'run_setting_parameters': {'key': 'runSettingParameters', 'type': '[RunSettingParameter]'},
        'yaml_str': {'key': 'yamlStr', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        existing_module_entity: Optional["ModuleEntity"] = None,
        status: Optional[Union[str, "ModuleInfoFromYamlStatusEnum"]] = None,
        status_details: Optional[str] = None,
        serialized_module_info: Optional[str] = None,
        namespace: Optional[str] = None,
        tags: Optional[List[str]] = None,
        display_name: Optional[str] = None,
        dict_tags: Optional[Dict[str, str]] = None,
        module_version_id: Optional[str] = None,
        feed_name: Optional[str] = None,
        registry_name: Optional[str] = None,
        module_name: Optional[str] = None,
        module_version: Optional[str] = None,
        description: Optional[str] = None,
        owner: Optional[str] = None,
        job_type: Optional[str] = None,
        default_version: Optional[str] = None,
        family_id: Optional[str] = None,
        help_document: Optional[str] = None,
        codegen_by: Optional[str] = None,
        arm_id: Optional[str] = None,
        module_scope: Optional[Union[str, "ModuleScope"]] = None,
        module_entity: Optional["ModuleEntity"] = None,
        input_types: Optional[List[str]] = None,
        output_types: Optional[List[str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        yaml_link: Optional[str] = None,
        yaml_link_with_commit_sha: Optional[str] = None,
        module_source_type: Optional[Union[str, "ModuleSourceType"]] = None,
        registered_by: Optional[str] = None,
        versions: Optional[List["AzureMLModuleVersionDescriptor"]] = None,
        is_default_module_version: Optional[bool] = None,
        system_data: Optional["SystemData"] = None,
        system_meta: Optional["SystemMeta"] = None,
        snapshot_id: Optional[str] = None,
        entry: Optional[str] = None,
        os_type: Optional[str] = None,
        require_gpu: Optional[bool] = None,
        module_python_interface: Optional["ModulePythonInterface"] = None,
        run_setting_parameters: Optional[List["RunSettingParameter"]] = None,
        yaml_str: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword existing_module_entity:
        :paramtype existing_module_entity: ~designer.models.ModuleEntity
        :keyword status: Possible values include: "NewModule", "NewVersion", "Conflict", "ParseError",
         "ProcessRequestError".
        :paramtype status: str or ~designer.models.ModuleInfoFromYamlStatusEnum
        :keyword status_details:
        :paramtype status_details: str
        :keyword serialized_module_info:
        :paramtype serialized_module_info: str
        :keyword namespace:
        :paramtype namespace: str
        :keyword tags: A set of tags.
        :paramtype tags: list[str]
        :keyword display_name:
        :paramtype display_name: str
        :keyword dict_tags: Dictionary of :code:`<string>`.
        :paramtype dict_tags: dict[str, str]
        :keyword module_version_id:
        :paramtype module_version_id: str
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword registry_name:
        :paramtype registry_name: str
        :keyword module_name:
        :paramtype module_name: str
        :keyword module_version:
        :paramtype module_version: str
        :keyword description:
        :paramtype description: str
        :keyword owner:
        :paramtype owner: str
        :keyword job_type:
        :paramtype job_type: str
        :keyword default_version:
        :paramtype default_version: str
        :keyword family_id:
        :paramtype family_id: str
        :keyword help_document:
        :paramtype help_document: str
        :keyword codegen_by:
        :paramtype codegen_by: str
        :keyword arm_id:
        :paramtype arm_id: str
        :keyword module_scope: Possible values include: "All", "Global", "Workspace", "Anonymous",
         "Step", "Draft", "Feed", "Registry".
        :paramtype module_scope: str or ~designer.models.ModuleScope
        :keyword module_entity:
        :paramtype module_entity: ~designer.models.ModuleEntity
        :keyword input_types:
        :paramtype input_types: list[str]
        :keyword output_types:
        :paramtype output_types: list[str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        :keyword yaml_link:
        :paramtype yaml_link: str
        :keyword yaml_link_with_commit_sha:
        :paramtype yaml_link_with_commit_sha: str
        :keyword module_source_type: Possible values include: "Unknown", "Local", "GithubFile",
         "GithubFolder", "DevopsArtifactsZip", "SerializedModuleInfo".
        :paramtype module_source_type: str or ~designer.models.ModuleSourceType
        :keyword registered_by:
        :paramtype registered_by: str
        :keyword versions:
        :paramtype versions: list[~designer.models.AzureMLModuleVersionDescriptor]
        :keyword is_default_module_version:
        :paramtype is_default_module_version: bool
        :keyword system_data:
        :paramtype system_data: ~designer.models.SystemData
        :keyword system_meta:
        :paramtype system_meta: ~designer.models.SystemMeta
        :keyword snapshot_id:
        :paramtype snapshot_id: str
        :keyword entry:
        :paramtype entry: str
        :keyword os_type:
        :paramtype os_type: str
        :keyword require_gpu:
        :paramtype require_gpu: bool
        :keyword module_python_interface:
        :paramtype module_python_interface: ~designer.models.ModulePythonInterface
        :keyword run_setting_parameters:
        :paramtype run_setting_parameters: list[~designer.models.RunSettingParameter]
        :keyword yaml_str:
        :paramtype yaml_str: str
        """
        super(ModuleDtoWithValidateStatus, self).__init__(**kwargs)
        self.existing_module_entity = existing_module_entity
        self.status = status
        self.status_details = status_details
        self.serialized_module_info = serialized_module_info
        self.namespace = namespace
        self.tags = tags
        self.display_name = display_name
        self.dict_tags = dict_tags
        self.module_version_id = module_version_id
        self.feed_name = feed_name
        self.registry_name = registry_name
        self.module_name = module_name
        self.module_version = module_version
        self.description = description
        self.owner = owner
        self.job_type = job_type
        self.default_version = default_version
        self.family_id = family_id
        self.help_document = help_document
        self.codegen_by = codegen_by
        self.arm_id = arm_id
        self.module_scope = module_scope
        self.module_entity = module_entity
        self.input_types = input_types
        self.output_types = output_types
        self.entity_status = entity_status
        self.created_date = created_date
        self.last_modified_date = last_modified_date
        self.yaml_link = yaml_link
        self.yaml_link_with_commit_sha = yaml_link_with_commit_sha
        self.module_source_type = module_source_type
        self.registered_by = registered_by
        self.versions = versions
        self.is_default_module_version = is_default_module_version
        self.system_data = system_data
        self.system_meta = system_meta
        self.snapshot_id = snapshot_id
        self.entry = entry
        self.os_type = os_type
        self.require_gpu = require_gpu
        self.module_python_interface = module_python_interface
        self.run_setting_parameters = run_setting_parameters
        self.yaml_str = yaml_str


class ModuleEntity(msrest.serialization.Model):
    """ModuleEntity.

    :ivar display_name:
    :vartype display_name: str
    :ivar module_execution_type:
    :vartype module_execution_type: str
    :ivar module_type: Possible values include: "None", "BatchInferencing".
    :vartype module_type: str or ~designer.models.ModuleType
    :ivar module_type_version:
    :vartype module_type_version: str
    :ivar upload_state: Possible values include: "Uploading", "Completed", "Canceled", "Failed".
    :vartype upload_state: str or ~designer.models.UploadState
    :ivar is_deterministic:
    :vartype is_deterministic: bool
    :ivar structured_interface:
    :vartype structured_interface: ~designer.models.StructuredInterface
    :ivar data_location:
    :vartype data_location: ~designer.models.DataLocation
    :ivar identifier_hash:
    :vartype identifier_hash: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar created_by:
    :vartype created_by: ~designer.models.CreatedBy
    :ivar last_updated_by:
    :vartype last_updated_by: ~designer.models.CreatedBy
    :ivar runconfig:
    :vartype runconfig: str
    :ivar cloud_settings:
    :vartype cloud_settings: ~designer.models.CloudSettings
    :ivar category:
    :vartype category: str
    :ivar step_type:
    :vartype step_type: str
    :ivar name:
    :vartype name: str
    :ivar hash:
    :vartype hash: str
    :ivar description:
    :vartype description: str
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'display_name': {'key': 'displayName', 'type': 'str'},
        'module_execution_type': {'key': 'moduleExecutionType', 'type': 'str'},
        'module_type': {'key': 'moduleType', 'type': 'str'},
        'module_type_version': {'key': 'moduleTypeVersion', 'type': 'str'},
        'upload_state': {'key': 'uploadState', 'type': 'str'},
        'is_deterministic': {'key': 'isDeterministic', 'type': 'bool'},
        'structured_interface': {'key': 'structuredInterface', 'type': 'StructuredInterface'},
        'data_location': {'key': 'dataLocation', 'type': 'DataLocation'},
        'identifier_hash': {'key': 'identifierHash', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'created_by': {'key': 'createdBy', 'type': 'CreatedBy'},
        'last_updated_by': {'key': 'lastUpdatedBy', 'type': 'CreatedBy'},
        'runconfig': {'key': 'runconfig', 'type': 'str'},
        'cloud_settings': {'key': 'cloudSettings', 'type': 'CloudSettings'},
        'category': {'key': 'category', 'type': 'str'},
        'step_type': {'key': 'stepType', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'hash': {'key': 'hash', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        display_name: Optional[str] = None,
        module_execution_type: Optional[str] = None,
        module_type: Optional[Union[str, "ModuleType"]] = None,
        module_type_version: Optional[str] = None,
        upload_state: Optional[Union[str, "UploadState"]] = None,
        is_deterministic: Optional[bool] = None,
        structured_interface: Optional["StructuredInterface"] = None,
        data_location: Optional["DataLocation"] = None,
        identifier_hash: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        created_by: Optional["CreatedBy"] = None,
        last_updated_by: Optional["CreatedBy"] = None,
        runconfig: Optional[str] = None,
        cloud_settings: Optional["CloudSettings"] = None,
        category: Optional[str] = None,
        step_type: Optional[str] = None,
        name: Optional[str] = None,
        hash: Optional[str] = None,
        description: Optional[str] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword display_name:
        :paramtype display_name: str
        :keyword module_execution_type:
        :paramtype module_execution_type: str
        :keyword module_type: Possible values include: "None", "BatchInferencing".
        :paramtype module_type: str or ~designer.models.ModuleType
        :keyword module_type_version:
        :paramtype module_type_version: str
        :keyword upload_state: Possible values include: "Uploading", "Completed", "Canceled", "Failed".
        :paramtype upload_state: str or ~designer.models.UploadState
        :keyword is_deterministic:
        :paramtype is_deterministic: bool
        :keyword structured_interface:
        :paramtype structured_interface: ~designer.models.StructuredInterface
        :keyword data_location:
        :paramtype data_location: ~designer.models.DataLocation
        :keyword identifier_hash:
        :paramtype identifier_hash: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword created_by:
        :paramtype created_by: ~designer.models.CreatedBy
        :keyword last_updated_by:
        :paramtype last_updated_by: ~designer.models.CreatedBy
        :keyword runconfig:
        :paramtype runconfig: str
        :keyword cloud_settings:
        :paramtype cloud_settings: ~designer.models.CloudSettings
        :keyword category:
        :paramtype category: str
        :keyword step_type:
        :paramtype step_type: str
        :keyword name:
        :paramtype name: str
        :keyword hash:
        :paramtype hash: str
        :keyword description:
        :paramtype description: str
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(ModuleEntity, self).__init__(**kwargs)
        self.display_name = display_name
        self.module_execution_type = module_execution_type
        self.module_type = module_type
        self.module_type_version = module_type_version
        self.upload_state = upload_state
        self.is_deterministic = is_deterministic
        self.structured_interface = structured_interface
        self.data_location = data_location
        self.identifier_hash = identifier_hash
        self.tags = tags
        self.properties = properties
        self.created_by = created_by
        self.last_updated_by = last_updated_by
        self.runconfig = runconfig
        self.cloud_settings = cloud_settings
        self.category = category
        self.step_type = step_type
        self.name = name
        self.hash = hash
        self.description = description
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class ModulePythonInterface(msrest.serialization.Model):
    """ModulePythonInterface.

    :ivar inputs:
    :vartype inputs: list[~designer.models.PythonInterfaceMapping]
    :ivar outputs:
    :vartype outputs: list[~designer.models.PythonInterfaceMapping]
    :ivar parameters:
    :vartype parameters: list[~designer.models.PythonInterfaceMapping]
    """

    _attribute_map = {
        'inputs': {'key': 'inputs', 'type': '[PythonInterfaceMapping]'},
        'outputs': {'key': 'outputs', 'type': '[PythonInterfaceMapping]'},
        'parameters': {'key': 'parameters', 'type': '[PythonInterfaceMapping]'},
    }

    def __init__(
        self,
        *,
        inputs: Optional[List["PythonInterfaceMapping"]] = None,
        outputs: Optional[List["PythonInterfaceMapping"]] = None,
        parameters: Optional[List["PythonInterfaceMapping"]] = None,
        **kwargs
    ):
        """
        :keyword inputs:
        :paramtype inputs: list[~designer.models.PythonInterfaceMapping]
        :keyword outputs:
        :paramtype outputs: list[~designer.models.PythonInterfaceMapping]
        :keyword parameters:
        :paramtype parameters: list[~designer.models.PythonInterfaceMapping]
        """
        super(ModulePythonInterface, self).__init__(**kwargs)
        self.inputs = inputs
        self.outputs = outputs
        self.parameters = parameters


class ModuleRegistrationStatus(msrest.serialization.Model):
    """ModuleRegistrationStatus.

    :ivar module_name:
    :vartype module_name: str
    :ivar status: Possible values include: "Succeeded", "Failed".
    :vartype status: str or ~designer.models.ModuleRegistrationStatusEnum
    :ivar status_details:
    :vartype status_details: str
    """

    _attribute_map = {
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'status_details': {'key': 'statusDetails', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_name: Optional[str] = None,
        status: Optional[Union[str, "ModuleRegistrationStatusEnum"]] = None,
        status_details: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword module_name:
        :paramtype module_name: str
        :keyword status: Possible values include: "Succeeded", "Failed".
        :paramtype status: str or ~designer.models.ModuleRegistrationStatusEnum
        :keyword status_details:
        :paramtype status_details: str
        """
        super(ModuleRegistrationStatus, self).__init__(**kwargs)
        self.module_name = module_name
        self.status = status
        self.status_details = status_details


class MpiConfiguration(msrest.serialization.Model):
    """MpiConfiguration.

    :ivar process_count_per_node:
    :vartype process_count_per_node: int
    """

    _attribute_map = {
        'process_count_per_node': {'key': 'processCountPerNode', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        process_count_per_node: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword process_count_per_node:
        :paramtype process_count_per_node: int
        """
        super(MpiConfiguration, self).__init__(**kwargs)
        self.process_count_per_node = process_count_per_node


class NodeInputPort(msrest.serialization.Model):
    """NodeInputPort.

    :ivar name:
    :vartype name: str
    :ivar documentation:
    :vartype documentation: str
    :ivar data_types_ids:
    :vartype data_types_ids: list[str]
    :ivar is_optional:
    :vartype is_optional: bool
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'documentation': {'key': 'documentation', 'type': 'str'},
        'data_types_ids': {'key': 'dataTypesIds', 'type': '[str]'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        documentation: Optional[str] = None,
        data_types_ids: Optional[List[str]] = None,
        is_optional: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword documentation:
        :paramtype documentation: str
        :keyword data_types_ids:
        :paramtype data_types_ids: list[str]
        :keyword is_optional:
        :paramtype is_optional: bool
        """
        super(NodeInputPort, self).__init__(**kwargs)
        self.name = name
        self.documentation = documentation
        self.data_types_ids = data_types_ids
        self.is_optional = is_optional


class NodeLayout(msrest.serialization.Model):
    """NodeLayout.

    :ivar x:
    :vartype x: float
    :ivar y:
    :vartype y: float
    :ivar width:
    :vartype width: float
    :ivar height:
    :vartype height: float
    :ivar extended_data:
    :vartype extended_data: str
    """

    _attribute_map = {
        'x': {'key': 'x', 'type': 'float'},
        'y': {'key': 'y', 'type': 'float'},
        'width': {'key': 'width', 'type': 'float'},
        'height': {'key': 'height', 'type': 'float'},
        'extended_data': {'key': 'extendedData', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        x: Optional[float] = None,
        y: Optional[float] = None,
        width: Optional[float] = None,
        height: Optional[float] = None,
        extended_data: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword x:
        :paramtype x: float
        :keyword y:
        :paramtype y: float
        :keyword width:
        :paramtype width: float
        :keyword height:
        :paramtype height: float
        :keyword extended_data:
        :paramtype extended_data: str
        """
        super(NodeLayout, self).__init__(**kwargs)
        self.x = x
        self.y = y
        self.width = width
        self.height = height
        self.extended_data = extended_data


class NodeOutputPort(msrest.serialization.Model):
    """NodeOutputPort.

    :ivar name:
    :vartype name: str
    :ivar documentation:
    :vartype documentation: str
    :ivar data_type_id:
    :vartype data_type_id: str
    :ivar pass_through_input_name:
    :vartype pass_through_input_name: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'documentation': {'key': 'documentation', 'type': 'str'},
        'data_type_id': {'key': 'dataTypeId', 'type': 'str'},
        'pass_through_input_name': {'key': 'passThroughInputName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        documentation: Optional[str] = None,
        data_type_id: Optional[str] = None,
        pass_through_input_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword documentation:
        :paramtype documentation: str
        :keyword data_type_id:
        :paramtype data_type_id: str
        :keyword pass_through_input_name:
        :paramtype pass_through_input_name: str
        """
        super(NodeOutputPort, self).__init__(**kwargs)
        self.name = name
        self.documentation = documentation
        self.data_type_id = data_type_id
        self.pass_through_input_name = pass_through_input_name


class NodePortInterface(msrest.serialization.Model):
    """NodePortInterface.

    :ivar inputs:
    :vartype inputs: list[~designer.models.NodeInputPort]
    :ivar outputs:
    :vartype outputs: list[~designer.models.NodeOutputPort]
    """

    _attribute_map = {
        'inputs': {'key': 'inputs', 'type': '[NodeInputPort]'},
        'outputs': {'key': 'outputs', 'type': '[NodeOutputPort]'},
    }

    def __init__(
        self,
        *,
        inputs: Optional[List["NodeInputPort"]] = None,
        outputs: Optional[List["NodeOutputPort"]] = None,
        **kwargs
    ):
        """
        :keyword inputs:
        :paramtype inputs: list[~designer.models.NodeInputPort]
        :keyword outputs:
        :paramtype outputs: list[~designer.models.NodeOutputPort]
        """
        super(NodePortInterface, self).__init__(**kwargs)
        self.inputs = inputs
        self.outputs = outputs


class NoteBookTaskDto(msrest.serialization.Model):
    """NoteBookTaskDto.

    :ivar notebook_path:
    :vartype notebook_path: str
    :ivar base_parameters: Dictionary of :code:`<string>`.
    :vartype base_parameters: dict[str, str]
    """

    _attribute_map = {
        'notebook_path': {'key': 'notebook_path', 'type': 'str'},
        'base_parameters': {'key': 'base_parameters', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        notebook_path: Optional[str] = None,
        base_parameters: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword notebook_path:
        :paramtype notebook_path: str
        :keyword base_parameters: Dictionary of :code:`<string>`.
        :paramtype base_parameters: dict[str, str]
        """
        super(NoteBookTaskDto, self).__init__(**kwargs)
        self.notebook_path = notebook_path
        self.base_parameters = base_parameters


class OutputData(msrest.serialization.Model):
    """OutputData.

    :ivar output_location:
    :vartype output_location: ~designer.models.ExecutionDataLocation
    :ivar mechanism: Possible values include: "Upload", "Mount", "Hdfs", "Link".
    :vartype mechanism: str or ~designer.models.OutputMechanism
    :ivar additional_options:
    :vartype additional_options: ~designer.models.OutputOptions
    :ivar environment_variable_name:
    :vartype environment_variable_name: str
    """

    _attribute_map = {
        'output_location': {'key': 'outputLocation', 'type': 'ExecutionDataLocation'},
        'mechanism': {'key': 'mechanism', 'type': 'str'},
        'additional_options': {'key': 'additionalOptions', 'type': 'OutputOptions'},
        'environment_variable_name': {'key': 'environmentVariableName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        output_location: Optional["ExecutionDataLocation"] = None,
        mechanism: Optional[Union[str, "OutputMechanism"]] = None,
        additional_options: Optional["OutputOptions"] = None,
        environment_variable_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword output_location:
        :paramtype output_location: ~designer.models.ExecutionDataLocation
        :keyword mechanism: Possible values include: "Upload", "Mount", "Hdfs", "Link".
        :paramtype mechanism: str or ~designer.models.OutputMechanism
        :keyword additional_options:
        :paramtype additional_options: ~designer.models.OutputOptions
        :keyword environment_variable_name:
        :paramtype environment_variable_name: str
        """
        super(OutputData, self).__init__(**kwargs)
        self.output_location = output_location
        self.mechanism = mechanism
        self.additional_options = additional_options
        self.environment_variable_name = environment_variable_name


class OutputDatasetLineage(msrest.serialization.Model):
    """OutputDatasetLineage.

    :ivar identifier:
    :vartype identifier: ~designer.models.DatasetIdentifier
    :ivar output_type: Possible values include: "RunOutput", "Reference".
    :vartype output_type: str or ~designer.models.DatasetOutputType
    :ivar output_details:
    :vartype output_details: ~designer.models.DatasetOutputDetails
    """

    _attribute_map = {
        'identifier': {'key': 'identifier', 'type': 'DatasetIdentifier'},
        'output_type': {'key': 'outputType', 'type': 'str'},
        'output_details': {'key': 'outputDetails', 'type': 'DatasetOutputDetails'},
    }

    def __init__(
        self,
        *,
        identifier: Optional["DatasetIdentifier"] = None,
        output_type: Optional[Union[str, "DatasetOutputType"]] = None,
        output_details: Optional["DatasetOutputDetails"] = None,
        **kwargs
    ):
        """
        :keyword identifier:
        :paramtype identifier: ~designer.models.DatasetIdentifier
        :keyword output_type: Possible values include: "RunOutput", "Reference".
        :paramtype output_type: str or ~designer.models.DatasetOutputType
        :keyword output_details:
        :paramtype output_details: ~designer.models.DatasetOutputDetails
        """
        super(OutputDatasetLineage, self).__init__(**kwargs)
        self.identifier = identifier
        self.output_type = output_type
        self.output_details = output_details


class OutputOptions(msrest.serialization.Model):
    """OutputOptions.

    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar registration_options:
    :vartype registration_options: ~designer.models.RegistrationOptions
    :ivar upload_options:
    :vartype upload_options: ~designer.models.UploadOptions
    :ivar mount_options: Dictionary of :code:`<string>`.
    :vartype mount_options: dict[str, str]
    """

    _attribute_map = {
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'registration_options': {'key': 'registrationOptions', 'type': 'RegistrationOptions'},
        'upload_options': {'key': 'uploadOptions', 'type': 'UploadOptions'},
        'mount_options': {'key': 'mountOptions', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        path_on_compute: Optional[str] = None,
        registration_options: Optional["RegistrationOptions"] = None,
        upload_options: Optional["UploadOptions"] = None,
        mount_options: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword registration_options:
        :paramtype registration_options: ~designer.models.RegistrationOptions
        :keyword upload_options:
        :paramtype upload_options: ~designer.models.UploadOptions
        :keyword mount_options: Dictionary of :code:`<string>`.
        :paramtype mount_options: dict[str, str]
        """
        super(OutputOptions, self).__init__(**kwargs)
        self.path_on_compute = path_on_compute
        self.registration_options = registration_options
        self.upload_options = upload_options
        self.mount_options = mount_options


class OutputPortDef(msrest.serialization.Model):
    """OutputPortDef.

    :ivar name:
    :vartype name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar is_directory:
    :vartype is_directory: bool
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'is_directory': {'key': 'isDirectory', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        data_store_name: Optional[str] = None,
        is_directory: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword is_directory:
        :paramtype is_directory: bool
        """
        super(OutputPortDef, self).__init__(**kwargs)
        self.name = name
        self.data_store_mode = data_store_mode
        self.data_store_name = data_store_name
        self.is_directory = is_directory


class OutputSetting(msrest.serialization.Model):
    """OutputSetting.

    :ivar name:
    :vartype name: str
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    :ivar data_reference_name:
    :vartype data_reference_name: str
    :ivar web_service_port:
    :vartype web_service_port: str
    :ivar dataset_registration:
    :vartype dataset_registration: ~designer.models.DatasetRegistration
    :ivar dataset_output_options:
    :vartype dataset_output_options: ~designer.models.DatasetOutputOptions
    :ivar asset_output_settings:
    :vartype asset_output_settings: ~designer.models.AssetOutputSettings
    :ivar parameter_name:
    :vartype parameter_name: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'data_reference_name': {'key': 'dataReferenceName', 'type': 'str'},
        'web_service_port': {'key': 'webServicePort', 'type': 'str'},
        'dataset_registration': {'key': 'datasetRegistration', 'type': 'DatasetRegistration'},
        'dataset_output_options': {'key': 'datasetOutputOptions', 'type': 'DatasetOutputOptions'},
        'asset_output_settings': {'key': 'AssetOutputSettings', 'type': 'AssetOutputSettings'},
        'parameter_name': {'key': 'parameterName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        data_store_name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        data_reference_name: Optional[str] = None,
        web_service_port: Optional[str] = None,
        dataset_registration: Optional["DatasetRegistration"] = None,
        dataset_output_options: Optional["DatasetOutputOptions"] = None,
        asset_output_settings: Optional["AssetOutputSettings"] = None,
        parameter_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword data_reference_name:
        :paramtype data_reference_name: str
        :keyword web_service_port:
        :paramtype web_service_port: str
        :keyword dataset_registration:
        :paramtype dataset_registration: ~designer.models.DatasetRegistration
        :keyword dataset_output_options:
        :paramtype dataset_output_options: ~designer.models.DatasetOutputOptions
        :keyword asset_output_settings:
        :paramtype asset_output_settings: ~designer.models.AssetOutputSettings
        :keyword parameter_name:
        :paramtype parameter_name: str
        """
        super(OutputSetting, self).__init__(**kwargs)
        self.name = name
        self.data_store_name = data_store_name
        self.data_store_mode = data_store_mode
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite
        self.data_reference_name = data_reference_name
        self.web_service_port = web_service_port
        self.dataset_registration = dataset_registration
        self.dataset_output_options = dataset_output_options
        self.asset_output_settings = asset_output_settings
        self.parameter_name = parameter_name


class PaginatedAmlModuleDetailsList(msrest.serialization.Model):
    """A paginated list of AmlModuleDetailss.

    :ivar value: An array of objects of type AmlModuleDetails.
    :vartype value: list[~designer.models.AmlModuleDetails]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[AmlModuleDetails]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["AmlModuleDetails"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type AmlModuleDetails.
        :paramtype value: list[~designer.models.AmlModuleDetails]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedAmlModuleDetailsList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedDataInfoList(msrest.serialization.Model):
    """A paginated list of DataInfos.

    :ivar value: An array of objects of type DataInfo.
    :vartype value: list[~designer.models.DataInfo]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[DataInfo]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["DataInfo"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type DataInfo.
        :paramtype value: list[~designer.models.DataInfo]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedDataInfoList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedModelDtoList(msrest.serialization.Model):
    """A paginated list of ModelDtos.

    :ivar value: An array of objects of type ModelDto.
    :vartype value: list[~designer.models.ModelDto]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[ModelDto]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["ModelDto"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type ModelDto.
        :paramtype value: list[~designer.models.ModelDto]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedModelDtoList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedModuleDtoList(msrest.serialization.Model):
    """A paginated list of ModuleDtos.

    :ivar value: An array of objects of type ModuleDto.
    :vartype value: list[~designer.models.ModuleDto]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[ModuleDto]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["ModuleDto"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type ModuleDto.
        :paramtype value: list[~designer.models.ModuleDto]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedModuleDtoList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedPipelineDraftSummaryList(msrest.serialization.Model):
    """A paginated list of PipelineDraftSummarys.

    :ivar value: An array of objects of type PipelineDraftSummary.
    :vartype value: list[~designer.models.PipelineDraftSummary]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[PipelineDraftSummary]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["PipelineDraftSummary"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type PipelineDraftSummary.
        :paramtype value: list[~designer.models.PipelineDraftSummary]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedPipelineDraftSummaryList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedPipelineEndpointSummaryList(msrest.serialization.Model):
    """A paginated list of PipelineEndpointSummarys.

    :ivar value: An array of objects of type PipelineEndpointSummary.
    :vartype value: list[~designer.models.PipelineEndpointSummary]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[PipelineEndpointSummary]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["PipelineEndpointSummary"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type PipelineEndpointSummary.
        :paramtype value: list[~designer.models.PipelineEndpointSummary]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedPipelineEndpointSummaryList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedPipelineRunSummaryList(msrest.serialization.Model):
    """A paginated list of PipelineRunSummarys.

    :ivar value: An array of objects of type PipelineRunSummary.
    :vartype value: list[~designer.models.PipelineRunSummary]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[PipelineRunSummary]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["PipelineRunSummary"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type PipelineRunSummary.
        :paramtype value: list[~designer.models.PipelineRunSummary]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedPipelineRunSummaryList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class PaginatedPublishedPipelineSummaryList(msrest.serialization.Model):
    """A paginated list of PublishedPipelineSummarys.

    :ivar value: An array of objects of type PublishedPipelineSummary.
    :vartype value: list[~designer.models.PublishedPipelineSummary]
    :ivar continuation_token: The token used in retrieving the next page. If null, there are no
     additional pages.
    :vartype continuation_token: str
    :ivar next_link: The link to the next page constructed using the continuationToken.  If null,
     there are no additional pages.
    :vartype next_link: str
    """

    _attribute_map = {
        'value': {'key': 'value', 'type': '[PublishedPipelineSummary]'},
        'continuation_token': {'key': 'continuationToken', 'type': 'str'},
        'next_link': {'key': 'nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value: Optional[List["PublishedPipelineSummary"]] = None,
        continuation_token: Optional[str] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value: An array of objects of type PublishedPipelineSummary.
        :paramtype value: list[~designer.models.PublishedPipelineSummary]
        :keyword continuation_token: The token used in retrieving the next page. If null, there are no
         additional pages.
        :paramtype continuation_token: str
        :keyword next_link: The link to the next page constructed using the continuationToken.  If
         null, there are no additional pages.
        :paramtype next_link: str
        """
        super(PaginatedPublishedPipelineSummaryList, self).__init__(**kwargs)
        self.value = value
        self.continuation_token = continuation_token
        self.next_link = next_link


class ParallelTaskConfiguration(msrest.serialization.Model):
    """ParallelTaskConfiguration.

    :ivar max_retries_per_worker:
    :vartype max_retries_per_worker: int
    :ivar worker_count_per_node:
    :vartype worker_count_per_node: int
    :ivar terminal_exit_codes:
    :vartype terminal_exit_codes: list[int]
    :ivar configuration: Dictionary of :code:`<string>`.
    :vartype configuration: dict[str, str]
    """

    _attribute_map = {
        'max_retries_per_worker': {'key': 'maxRetriesPerWorker', 'type': 'int'},
        'worker_count_per_node': {'key': 'workerCountPerNode', 'type': 'int'},
        'terminal_exit_codes': {'key': 'terminalExitCodes', 'type': '[int]'},
        'configuration': {'key': 'configuration', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        max_retries_per_worker: Optional[int] = None,
        worker_count_per_node: Optional[int] = None,
        terminal_exit_codes: Optional[List[int]] = None,
        configuration: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword max_retries_per_worker:
        :paramtype max_retries_per_worker: int
        :keyword worker_count_per_node:
        :paramtype worker_count_per_node: int
        :keyword terminal_exit_codes:
        :paramtype terminal_exit_codes: list[int]
        :keyword configuration: Dictionary of :code:`<string>`.
        :paramtype configuration: dict[str, str]
        """
        super(ParallelTaskConfiguration, self).__init__(**kwargs)
        self.max_retries_per_worker = max_retries_per_worker
        self.worker_count_per_node = worker_count_per_node
        self.terminal_exit_codes = terminal_exit_codes
        self.configuration = configuration


class Parameter(msrest.serialization.Model):
    """Parameter.

    :ivar name:
    :vartype name: str
    :ivar documentation:
    :vartype documentation: str
    :ivar default_value:
    :vartype default_value: str
    :ivar is_optional:
    :vartype is_optional: bool
    :ivar min_max_rules:
    :vartype min_max_rules: list[~designer.models.MinMaxParameterRule]
    :ivar enum_rules:
    :vartype enum_rules: list[~designer.models.EnumParameterRule]
    :ivar type: Possible values include: "Int", "Double", "Bool", "String", "Undefined".
    :vartype type: str or ~designer.models.ParameterType
    :ivar label:
    :vartype label: str
    :ivar group_names:
    :vartype group_names: list[str]
    :ivar argument_name:
    :vartype argument_name: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'documentation': {'key': 'documentation', 'type': 'str'},
        'default_value': {'key': 'defaultValue', 'type': 'str'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
        'min_max_rules': {'key': 'minMaxRules', 'type': '[MinMaxParameterRule]'},
        'enum_rules': {'key': 'enumRules', 'type': '[EnumParameterRule]'},
        'type': {'key': 'type', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'group_names': {'key': 'groupNames', 'type': '[str]'},
        'argument_name': {'key': 'argumentName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        documentation: Optional[str] = None,
        default_value: Optional[str] = None,
        is_optional: Optional[bool] = None,
        min_max_rules: Optional[List["MinMaxParameterRule"]] = None,
        enum_rules: Optional[List["EnumParameterRule"]] = None,
        type: Optional[Union[str, "ParameterType"]] = None,
        label: Optional[str] = None,
        group_names: Optional[List[str]] = None,
        argument_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword documentation:
        :paramtype documentation: str
        :keyword default_value:
        :paramtype default_value: str
        :keyword is_optional:
        :paramtype is_optional: bool
        :keyword min_max_rules:
        :paramtype min_max_rules: list[~designer.models.MinMaxParameterRule]
        :keyword enum_rules:
        :paramtype enum_rules: list[~designer.models.EnumParameterRule]
        :keyword type: Possible values include: "Int", "Double", "Bool", "String", "Undefined".
        :paramtype type: str or ~designer.models.ParameterType
        :keyword label:
        :paramtype label: str
        :keyword group_names:
        :paramtype group_names: list[str]
        :keyword argument_name:
        :paramtype argument_name: str
        """
        super(Parameter, self).__init__(**kwargs)
        self.name = name
        self.documentation = documentation
        self.default_value = default_value
        self.is_optional = is_optional
        self.min_max_rules = min_max_rules
        self.enum_rules = enum_rules
        self.type = type
        self.label = label
        self.group_names = group_names
        self.argument_name = argument_name


class ParameterAssignment(msrest.serialization.Model):
    """ParameterAssignment.

    :ivar value_type: Possible values include: "Literal", "GraphParameterName", "Concatenate",
     "Input", "DataPath", "DataSetDefinition".
    :vartype value_type: str or ~designer.models.ParameterValueType
    :ivar assignments_to_concatenate:
    :vartype assignments_to_concatenate: list[~designer.models.ParameterAssignment]
    :ivar data_path_assignment:
    :vartype data_path_assignment: ~designer.models.LegacyDataPath
    :ivar data_set_definition_value_assignment:
    :vartype data_set_definition_value_assignment: ~designer.models.DataSetDefinitionValue
    :ivar name:
    :vartype name: str
    :ivar value:
    :vartype value: str
    """

    _attribute_map = {
        'value_type': {'key': 'valueType', 'type': 'str'},
        'assignments_to_concatenate': {'key': 'assignmentsToConcatenate', 'type': '[ParameterAssignment]'},
        'data_path_assignment': {'key': 'dataPathAssignment', 'type': 'LegacyDataPath'},
        'data_set_definition_value_assignment': {'key': 'dataSetDefinitionValueAssignment', 'type': 'DataSetDefinitionValue'},
        'name': {'key': 'name', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        value_type: Optional[Union[str, "ParameterValueType"]] = None,
        assignments_to_concatenate: Optional[List["ParameterAssignment"]] = None,
        data_path_assignment: Optional["LegacyDataPath"] = None,
        data_set_definition_value_assignment: Optional["DataSetDefinitionValue"] = None,
        name: Optional[str] = None,
        value: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword value_type: Possible values include: "Literal", "GraphParameterName", "Concatenate",
         "Input", "DataPath", "DataSetDefinition".
        :paramtype value_type: str or ~designer.models.ParameterValueType
        :keyword assignments_to_concatenate:
        :paramtype assignments_to_concatenate: list[~designer.models.ParameterAssignment]
        :keyword data_path_assignment:
        :paramtype data_path_assignment: ~designer.models.LegacyDataPath
        :keyword data_set_definition_value_assignment:
        :paramtype data_set_definition_value_assignment: ~designer.models.DataSetDefinitionValue
        :keyword name:
        :paramtype name: str
        :keyword value:
        :paramtype value: str
        """
        super(ParameterAssignment, self).__init__(**kwargs)
        self.value_type = value_type
        self.assignments_to_concatenate = assignments_to_concatenate
        self.data_path_assignment = data_path_assignment
        self.data_set_definition_value_assignment = data_set_definition_value_assignment
        self.name = name
        self.value = value


class ParameterDefinition(msrest.serialization.Model):
    """ParameterDefinition.

    :ivar name:
    :vartype name: str
    :ivar type:
    :vartype type: str
    :ivar value:
    :vartype value: str
    :ivar is_optional:
    :vartype is_optional: bool
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        type: Optional[str] = None,
        value: Optional[str] = None,
        is_optional: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword type:
        :paramtype type: str
        :keyword value:
        :paramtype value: str
        :keyword is_optional:
        :paramtype is_optional: bool
        """
        super(ParameterDefinition, self).__init__(**kwargs)
        self.name = name
        self.type = type
        self.value = value
        self.is_optional = is_optional


class Paths12Z2UukModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths12Z2UukModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(Paths12Z2UukModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths143Xkp0ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths143Xkp0ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SetAsDefaultVersion: boolean, ModuleSourceType: , YamlFile: string,
     DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SetAsDefaultVersion: boolean, ModuleSourceType: , YamlFile: string,
         DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths143Xkp0ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths153FdkgComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths153FdkgComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
     DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
         DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths153FdkgComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths17Ggce0ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameComponentnamePutRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths17Ggce0ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameComponentnamePutRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SnapshotId: string, SetAsDefaultVersion: boolean, ModuleSourceType: ,
     YamlFile: string, DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo:
     boolean, DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri:
     string, SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SnapshotId: string, SetAsDefaultVersion: boolean, ModuleSourceType: ,
         YamlFile: string, DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo:
         boolean, DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri:
         string, SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths17Ggce0ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameComponentnamePutRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths18Qs6UvModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths18Qs6UvModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(Paths18Qs6UvModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths1FkggqiComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths1FkggqiComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
     DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
         DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths1FkggqiComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths1I2Kox6StudioserviceApiSubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths1I2Kox6StudioserviceApiSubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema.

    :ivar source_zip_file: add in client side.
    :vartype source_zip_file: IO
    :ivar properties: Name: string, ScriptName: string, Arguments: array, Inputs: array, Outputs:
     array, ComputeTarget: string, RunConfig: string, Params: object, AllowReuse: boolean, Version:
     string, SnapShotId: string, SourceZipFileName: string.
    :vartype properties: str
    """

    _attribute_map = {
        'source_zip_file': {'key': 'SourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword source_zip_file: add in client side.
        :paramtype source_zip_file: IO
        :keyword properties: Name: string, ScriptName: string, Arguments: array, Inputs: array,
         Outputs: array, ComputeTarget: string, RunConfig: string, Params: object, AllowReuse: boolean,
         Version: string, SnapShotId: string, SourceZipFileName: string.
        :paramtype properties: str
        """
        super(Paths1I2Kox6StudioserviceApiSubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.source_zip_file = source_zip_file
        self.properties = properties


class Paths1M5Y7AtModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths1M5Y7AtModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SetAsDefaultVersion: boolean, ModuleSourceType: , YamlFile: string,
     DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SetAsDefaultVersion: boolean, ModuleSourceType: , YamlFile: string,
         DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths1M5Y7AtModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameNamespacesModulenamespaceModulesModulenamePutRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths1R17P1FStudioserviceApiv2SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths1R17P1FStudioserviceApiv2SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema.

    :ivar source_zip_file: add in client side.
    :vartype source_zip_file: IO
    :ivar properties: Name: string, ScriptName: string, Arguments: array, Inputs: array, Outputs:
     array, ComputeTarget: string, RunConfig: string, Params: object, AllowReuse: boolean, Version:
     string, SnapShotId: string, SourceZipFileName: string.
    :vartype properties: str
    """

    _attribute_map = {
        'source_zip_file': {'key': 'SourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword source_zip_file: add in client side.
        :paramtype source_zip_file: IO
        :keyword properties: Name: string, ScriptName: string, Arguments: array, Inputs: array,
         Outputs: array, ComputeTarget: string, RunConfig: string, Params: object, AllowReuse: boolean,
         Version: string, SnapShotId: string, SourceZipFileName: string.
        :paramtype properties: str
        """
        super(Paths1R17P1FStudioserviceApiv2SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameModulesPythonscriptstepPostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.source_zip_file = source_zip_file
        self.properties = properties


class Paths1Z11O72ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths1Z11O72ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
     DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: SnapshotId: string, ModuleSourceType: , YamlFile: string,
         DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(Paths1Z11O72ComponentV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class Paths7Wrs6ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """Paths7Wrs6ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(Paths7Wrs6ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameValidatePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class PathsFvlxvyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """PathsFvlxvyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(PathsFvlxvyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class PathsLi0IzyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """PathsLi0IzyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(PathsLi0IzyModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameWorkspacesWorkspacenamePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class PathsMcoe09ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """PathsMcoe09ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
     ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
     BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
     string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: ModuleSourceType: , YamlFile: string, DevopsArtifactsZipUrl: string,
         ModuleWorkingMechanism: , IsPrivateRepo: boolean, DataTypeMechanism: ,
         BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string, SerializedModuleInfo:
         string.
        :paramtype properties: str
        """
        super(PathsMcoe09ModuleV10SubscriptionsSubscriptionidResourcegroupsResourcegroupnameProvidersMicrosoftMachinelearningservicesWorkspacesWorkspacenameParsePostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class PathsYupylbComponentV10AdminRegistryPostRequestbodyContentMultipartFormDataSchema(msrest.serialization.Model):
    """PathsYupylbComponentV10AdminRegistryPostRequestbodyContentMultipartFormDataSchema.

    :ivar snapshot_source_zip_file: add in client side.
    :vartype snapshot_source_zip_file: IO
    :ivar properties: RegistryName: string, SnapshotId: string, ModuleSourceType: , YamlFile:
     string, DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
     DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
     SerializedModuleInfo: string.
    :vartype properties: str
    """

    _attribute_map = {
        'snapshot_source_zip_file': {'key': 'SnapshotSourceZipFile', 'type': 'IO'},
        'properties': {'key': 'properties', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        snapshot_source_zip_file: Optional[IO] = None,
        properties: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword snapshot_source_zip_file: add in client side.
        :paramtype snapshot_source_zip_file: IO
        :keyword properties: RegistryName: string, SnapshotId: string, ModuleSourceType: , YamlFile:
         string, DevopsArtifactsZipUrl: string, ModuleWorkingMechanism: , IsPrivateRepo: boolean,
         DataTypeMechanism: , BlobFileInfo.DataStoreName: string, BlobFileInfo.RootBlobUri: string,
         SerializedModuleInfo: string.
        :paramtype properties: str
        """
        super(PathsYupylbComponentV10AdminRegistryPostRequestbodyContentMultipartFormDataSchema, self).__init__(**kwargs)
        self.snapshot_source_zip_file = snapshot_source_zip_file
        self.properties = properties


class PipelineDraft(msrest.serialization.Model):
    """PipelineDraft.

    :ivar graph_draft_id:
    :vartype graph_draft_id: str
    :ivar source_pipeline_run_id:
    :vartype source_pipeline_run_id: str
    :ivar latest_pipeline_run_id:
    :vartype latest_pipeline_run_id: str
    :ivar latest_run_experiment_name:
    :vartype latest_run_experiment_name: str
    :ivar latest_run_experiment_id:
    :vartype latest_run_experiment_id: str
    :ivar is_latest_run_experiment_archived:
    :vartype is_latest_run_experiment_archived: bool
    :ivar status:
    :vartype status: ~designer.models.PipelineStatus
    :ivar graph_detail:
    :vartype graph_detail: ~designer.models.PipelineRunGraphDetail
    :ivar real_time_endpoint_info:
    :vartype real_time_endpoint_info: ~designer.models.RealTimeEndpointInfo
    :ivar linked_pipelines_info:
    :vartype linked_pipelines_info: list[~designer.models.LinkedPipelineInfo]
    :ivar nodes_in_draft:
    :vartype nodes_in_draft: list[str]
    :ivar studio_migration_info:
    :vartype studio_migration_info: ~designer.models.StudioMigrationInfo
    :ivar flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
    :vartype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
    :ivar name:
    :vartype name: str
    :ivar last_edited_by:
    :vartype last_edited_by: str
    :ivar created_by:
    :vartype created_by: str
    :ivar description:
    :vartype description: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'graph_draft_id': {'key': 'graphDraftId', 'type': 'str'},
        'source_pipeline_run_id': {'key': 'sourcePipelineRunId', 'type': 'str'},
        'latest_pipeline_run_id': {'key': 'latestPipelineRunId', 'type': 'str'},
        'latest_run_experiment_name': {'key': 'latestRunExperimentName', 'type': 'str'},
        'latest_run_experiment_id': {'key': 'latestRunExperimentId', 'type': 'str'},
        'is_latest_run_experiment_archived': {'key': 'isLatestRunExperimentArchived', 'type': 'bool'},
        'status': {'key': 'status', 'type': 'PipelineStatus'},
        'graph_detail': {'key': 'graphDetail', 'type': 'PipelineRunGraphDetail'},
        'real_time_endpoint_info': {'key': 'realTimeEndpointInfo', 'type': 'RealTimeEndpointInfo'},
        'linked_pipelines_info': {'key': 'linkedPipelinesInfo', 'type': '[LinkedPipelineInfo]'},
        'nodes_in_draft': {'key': 'nodesInDraft', 'type': '[str]'},
        'studio_migration_info': {'key': 'studioMigrationInfo', 'type': 'StudioMigrationInfo'},
        'flattened_sub_graphs': {'key': 'flattenedSubGraphs', 'type': '{PipelineSubDraft}'},
        'name': {'key': 'name', 'type': 'str'},
        'last_edited_by': {'key': 'lastEditedBy', 'type': 'str'},
        'created_by': {'key': 'createdBy', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        graph_draft_id: Optional[str] = None,
        source_pipeline_run_id: Optional[str] = None,
        latest_pipeline_run_id: Optional[str] = None,
        latest_run_experiment_name: Optional[str] = None,
        latest_run_experiment_id: Optional[str] = None,
        is_latest_run_experiment_archived: Optional[bool] = None,
        status: Optional["PipelineStatus"] = None,
        graph_detail: Optional["PipelineRunGraphDetail"] = None,
        real_time_endpoint_info: Optional["RealTimeEndpointInfo"] = None,
        linked_pipelines_info: Optional[List["LinkedPipelineInfo"]] = None,
        nodes_in_draft: Optional[List[str]] = None,
        studio_migration_info: Optional["StudioMigrationInfo"] = None,
        flattened_sub_graphs: Optional[Dict[str, "PipelineSubDraft"]] = None,
        name: Optional[str] = None,
        last_edited_by: Optional[str] = None,
        created_by: Optional[str] = None,
        description: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword graph_draft_id:
        :paramtype graph_draft_id: str
        :keyword source_pipeline_run_id:
        :paramtype source_pipeline_run_id: str
        :keyword latest_pipeline_run_id:
        :paramtype latest_pipeline_run_id: str
        :keyword latest_run_experiment_name:
        :paramtype latest_run_experiment_name: str
        :keyword latest_run_experiment_id:
        :paramtype latest_run_experiment_id: str
        :keyword is_latest_run_experiment_archived:
        :paramtype is_latest_run_experiment_archived: bool
        :keyword status:
        :paramtype status: ~designer.models.PipelineStatus
        :keyword graph_detail:
        :paramtype graph_detail: ~designer.models.PipelineRunGraphDetail
        :keyword real_time_endpoint_info:
        :paramtype real_time_endpoint_info: ~designer.models.RealTimeEndpointInfo
        :keyword linked_pipelines_info:
        :paramtype linked_pipelines_info: list[~designer.models.LinkedPipelineInfo]
        :keyword nodes_in_draft:
        :paramtype nodes_in_draft: list[str]
        :keyword studio_migration_info:
        :paramtype studio_migration_info: ~designer.models.StudioMigrationInfo
        :keyword flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
        :paramtype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
        :keyword name:
        :paramtype name: str
        :keyword last_edited_by:
        :paramtype last_edited_by: str
        :keyword created_by:
        :paramtype created_by: str
        :keyword description:
        :paramtype description: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineDraft, self).__init__(**kwargs)
        self.graph_draft_id = graph_draft_id
        self.source_pipeline_run_id = source_pipeline_run_id
        self.latest_pipeline_run_id = latest_pipeline_run_id
        self.latest_run_experiment_name = latest_run_experiment_name
        self.latest_run_experiment_id = latest_run_experiment_id
        self.is_latest_run_experiment_archived = is_latest_run_experiment_archived
        self.status = status
        self.graph_detail = graph_detail
        self.real_time_endpoint_info = real_time_endpoint_info
        self.linked_pipelines_info = linked_pipelines_info
        self.nodes_in_draft = nodes_in_draft
        self.studio_migration_info = studio_migration_info
        self.flattened_sub_graphs = flattened_sub_graphs
        self.name = name
        self.last_edited_by = last_edited_by
        self.created_by = created_by
        self.description = description
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.tags = tags
        self.properties = properties
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineDraftStepDetails(msrest.serialization.Model):
    """PipelineDraftStepDetails.

    :ivar run_id:
    :vartype run_id: str
    :ivar target:
    :vartype target: str
    :ivar status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar parent_run_id:
    :vartype parent_run_id: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar is_reused:
    :vartype is_reused: bool
    :ivar reused_run_id:
    :vartype reused_run_id: str
    :ivar logs: This is a dictionary.
    :vartype logs: dict[str, str]
    :ivar output_log:
    :vartype output_log: str
    :ivar run_configuration:
    :vartype run_configuration: ~designer.models.RunConfiguration
    :ivar outputs: This is a dictionary.
    :vartype outputs: dict[str, str]
    :ivar port_outputs: This is a dictionary.
    :vartype port_outputs: dict[str, ~designer.models.PortOutputInfo]
    :ivar is_experiment_archived:
    :vartype is_experiment_archived: bool
    """

    _attribute_map = {
        'run_id': {'key': 'runId', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'parent_run_id': {'key': 'parentRunId', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'is_reused': {'key': 'isReused', 'type': 'bool'},
        'reused_run_id': {'key': 'reusedRunId', 'type': 'str'},
        'logs': {'key': 'logs', 'type': '{str}'},
        'output_log': {'key': 'outputLog', 'type': 'str'},
        'run_configuration': {'key': 'runConfiguration', 'type': 'RunConfiguration'},
        'outputs': {'key': 'outputs', 'type': '{str}'},
        'port_outputs': {'key': 'portOutputs', 'type': '{PortOutputInfo}'},
        'is_experiment_archived': {'key': 'isExperimentArchived', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        run_id: Optional[str] = None,
        target: Optional[str] = None,
        status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        parent_run_id: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        is_reused: Optional[bool] = None,
        reused_run_id: Optional[str] = None,
        logs: Optional[Dict[str, str]] = None,
        output_log: Optional[str] = None,
        run_configuration: Optional["RunConfiguration"] = None,
        outputs: Optional[Dict[str, str]] = None,
        port_outputs: Optional[Dict[str, "PortOutputInfo"]] = None,
        is_experiment_archived: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword run_id:
        :paramtype run_id: str
        :keyword target:
        :paramtype target: str
        :keyword status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword parent_run_id:
        :paramtype parent_run_id: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword is_reused:
        :paramtype is_reused: bool
        :keyword reused_run_id:
        :paramtype reused_run_id: str
        :keyword logs: This is a dictionary.
        :paramtype logs: dict[str, str]
        :keyword output_log:
        :paramtype output_log: str
        :keyword run_configuration:
        :paramtype run_configuration: ~designer.models.RunConfiguration
        :keyword outputs: This is a dictionary.
        :paramtype outputs: dict[str, str]
        :keyword port_outputs: This is a dictionary.
        :paramtype port_outputs: dict[str, ~designer.models.PortOutputInfo]
        :keyword is_experiment_archived:
        :paramtype is_experiment_archived: bool
        """
        super(PipelineDraftStepDetails, self).__init__(**kwargs)
        self.run_id = run_id
        self.target = target
        self.status = status
        self.status_detail = status_detail
        self.parent_run_id = parent_run_id
        self.start_time = start_time
        self.end_time = end_time
        self.is_reused = is_reused
        self.reused_run_id = reused_run_id
        self.logs = logs
        self.output_log = output_log
        self.run_configuration = run_configuration
        self.outputs = outputs
        self.port_outputs = port_outputs
        self.is_experiment_archived = is_experiment_archived


class PipelineDraftSummary(msrest.serialization.Model):
    """PipelineDraftSummary.

    :ivar name:
    :vartype name: str
    :ivar last_edited_by:
    :vartype last_edited_by: str
    :ivar created_by:
    :vartype created_by: str
    :ivar description:
    :vartype description: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'last_edited_by': {'key': 'lastEditedBy', 'type': 'str'},
        'created_by': {'key': 'createdBy', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        last_edited_by: Optional[str] = None,
        created_by: Optional[str] = None,
        description: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword last_edited_by:
        :paramtype last_edited_by: str
        :keyword created_by:
        :paramtype created_by: str
        :keyword description:
        :paramtype description: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineDraftSummary, self).__init__(**kwargs)
        self.name = name
        self.last_edited_by = last_edited_by
        self.created_by = created_by
        self.description = description
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.tags = tags
        self.properties = properties
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineEndpoint(msrest.serialization.Model):
    """PipelineEndpoint.

    :ivar default_version:
    :vartype default_version: str
    :ivar default_pipeline_id:
    :vartype default_pipeline_id: str
    :ivar default_graph_id:
    :vartype default_graph_id: str
    :ivar rest_endpoint:
    :vartype rest_endpoint: str
    :ivar published_date:
    :vartype published_date: ~datetime.datetime
    :ivar published_by:
    :vartype published_by: str
    :ivar parameters: This is a dictionary.
    :vartype parameters: dict[str, str]
    :ivar data_set_definition_value_assignment: This is a dictionary.
    :vartype data_set_definition_value_assignment: dict[str,
     ~designer.models.DataSetDefinitionValue]
    :ivar default_pipeline_name:
    :vartype default_pipeline_name: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar updated_by:
    :vartype updated_by: str
    :ivar swagger_url:
    :vartype swagger_url: str
    :ivar last_run_time:
    :vartype last_run_time: ~datetime.datetime
    :ivar last_run_status: Possible values include: "NotStarted", "Running", "Failed", "Finished",
     "Canceled".
    :vartype last_run_status: str or ~designer.models.PipelineRunStatusCode
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'default_version': {'key': 'defaultVersion', 'type': 'str'},
        'default_pipeline_id': {'key': 'defaultPipelineId', 'type': 'str'},
        'default_graph_id': {'key': 'defaultGraphId', 'type': 'str'},
        'rest_endpoint': {'key': 'restEndpoint', 'type': 'str'},
        'published_date': {'key': 'publishedDate', 'type': 'iso-8601'},
        'published_by': {'key': 'publishedBy', 'type': 'str'},
        'parameters': {'key': 'parameters', 'type': '{str}'},
        'data_set_definition_value_assignment': {'key': 'dataSetDefinitionValueAssignment', 'type': '{DataSetDefinitionValue}'},
        'default_pipeline_name': {'key': 'defaultPipelineName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'updated_by': {'key': 'updatedBy', 'type': 'str'},
        'swagger_url': {'key': 'swaggerUrl', 'type': 'str'},
        'last_run_time': {'key': 'lastRunTime', 'type': 'iso-8601'},
        'last_run_status': {'key': 'lastRunStatus', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        default_version: Optional[str] = None,
        default_pipeline_id: Optional[str] = None,
        default_graph_id: Optional[str] = None,
        rest_endpoint: Optional[str] = None,
        published_date: Optional[datetime.datetime] = None,
        published_by: Optional[str] = None,
        parameters: Optional[Dict[str, str]] = None,
        data_set_definition_value_assignment: Optional[Dict[str, "DataSetDefinitionValue"]] = None,
        default_pipeline_name: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        updated_by: Optional[str] = None,
        swagger_url: Optional[str] = None,
        last_run_time: Optional[datetime.datetime] = None,
        last_run_status: Optional[Union[str, "PipelineRunStatusCode"]] = None,
        tags: Optional[Dict[str, str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword default_version:
        :paramtype default_version: str
        :keyword default_pipeline_id:
        :paramtype default_pipeline_id: str
        :keyword default_graph_id:
        :paramtype default_graph_id: str
        :keyword rest_endpoint:
        :paramtype rest_endpoint: str
        :keyword published_date:
        :paramtype published_date: ~datetime.datetime
        :keyword published_by:
        :paramtype published_by: str
        :keyword parameters: This is a dictionary.
        :paramtype parameters: dict[str, str]
        :keyword data_set_definition_value_assignment: This is a dictionary.
        :paramtype data_set_definition_value_assignment: dict[str,
         ~designer.models.DataSetDefinitionValue]
        :keyword default_pipeline_name:
        :paramtype default_pipeline_name: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword updated_by:
        :paramtype updated_by: str
        :keyword swagger_url:
        :paramtype swagger_url: str
        :keyword last_run_time:
        :paramtype last_run_time: ~datetime.datetime
        :keyword last_run_status: Possible values include: "NotStarted", "Running", "Failed",
         "Finished", "Canceled".
        :paramtype last_run_status: str or ~designer.models.PipelineRunStatusCode
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineEndpoint, self).__init__(**kwargs)
        self.default_version = default_version
        self.default_pipeline_id = default_pipeline_id
        self.default_graph_id = default_graph_id
        self.rest_endpoint = rest_endpoint
        self.published_date = published_date
        self.published_by = published_by
        self.parameters = parameters
        self.data_set_definition_value_assignment = data_set_definition_value_assignment
        self.default_pipeline_name = default_pipeline_name
        self.name = name
        self.description = description
        self.updated_by = updated_by
        self.swagger_url = swagger_url
        self.last_run_time = last_run_time
        self.last_run_status = last_run_status
        self.tags = tags
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineEndpointSummary(msrest.serialization.Model):
    """PipelineEndpointSummary.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar updated_by:
    :vartype updated_by: str
    :ivar swagger_url:
    :vartype swagger_url: str
    :ivar last_run_time:
    :vartype last_run_time: ~datetime.datetime
    :ivar last_run_status: Possible values include: "NotStarted", "Running", "Failed", "Finished",
     "Canceled".
    :vartype last_run_status: str or ~designer.models.PipelineRunStatusCode
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'updated_by': {'key': 'updatedBy', 'type': 'str'},
        'swagger_url': {'key': 'swaggerUrl', 'type': 'str'},
        'last_run_time': {'key': 'lastRunTime', 'type': 'iso-8601'},
        'last_run_status': {'key': 'lastRunStatus', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        updated_by: Optional[str] = None,
        swagger_url: Optional[str] = None,
        last_run_time: Optional[datetime.datetime] = None,
        last_run_status: Optional[Union[str, "PipelineRunStatusCode"]] = None,
        tags: Optional[Dict[str, str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword updated_by:
        :paramtype updated_by: str
        :keyword swagger_url:
        :paramtype swagger_url: str
        :keyword last_run_time:
        :paramtype last_run_time: ~datetime.datetime
        :keyword last_run_status: Possible values include: "NotStarted", "Running", "Failed",
         "Finished", "Canceled".
        :paramtype last_run_status: str or ~designer.models.PipelineRunStatusCode
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineEndpointSummary, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.updated_by = updated_by
        self.swagger_url = swagger_url
        self.last_run_time = last_run_time
        self.last_run_status = last_run_status
        self.tags = tags
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineGraph(msrest.serialization.Model):
    """PipelineGraph.

    :ivar graph_module_dtos:
    :vartype graph_module_dtos: list[~designer.models.ModuleDto]
    :ivar graph_data_sources:
    :vartype graph_data_sources: list[~designer.models.DataInfo]
    :ivar graphs: This is a dictionary.
    :vartype graphs: dict[str, ~designer.models.PipelineGraph]
    :ivar graph_drafts: This is a dictionary.
    :vartype graph_drafts: dict[str, ~designer.models.PipelineGraph]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar referenced_node_id:
    :vartype referenced_node_id: str
    :ivar pipeline_run_setting_parameters:
    :vartype pipeline_run_setting_parameters: list[~designer.models.RunSettingParameter]
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_nodes:
    :vartype module_nodes: list[~designer.models.GraphModuleNode]
    :ivar dataset_nodes:
    :vartype dataset_nodes: list[~designer.models.GraphDatasetNode]
    :ivar sub_graph_nodes:
    :vartype sub_graph_nodes: list[~designer.models.GraphReferenceNode]
    :ivar control_nodes:
    :vartype control_nodes: list[~designer.models.GraphControlNode]
    :ivar edges:
    :vartype edges: list[~designer.models.GraphEdge]
    :ivar entity_interface:
    :vartype entity_interface: ~designer.models.EntityInterface
    :ivar graph_layout:
    :vartype graph_layout: ~designer.models.GraphLayout
    :ivar created_by:
    :vartype created_by: ~designer.models.CreatedBy
    :ivar last_updated_by:
    :vartype last_updated_by: ~designer.models.CreatedBy
    :ivar default_compute:
    :vartype default_compute: ~designer.models.ComputeSetting
    :ivar default_datastore:
    :vartype default_datastore: ~designer.models.DatastoreSetting
    :ivar default_cloud_priority:
    :vartype default_cloud_priority: ~designer.models.CloudPrioritySetting
    :ivar extended_properties: This is a dictionary.
    :vartype extended_properties: dict[str, str]
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'graph_module_dtos': {'key': 'graphModuleDtos', 'type': '[ModuleDto]'},
        'graph_data_sources': {'key': 'graphDataSources', 'type': '[DataInfo]'},
        'graphs': {'key': 'graphs', 'type': '{PipelineGraph}'},
        'graph_drafts': {'key': 'graphDrafts', 'type': '{PipelineGraph}'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'referenced_node_id': {'key': 'referencedNodeId', 'type': 'str'},
        'pipeline_run_setting_parameters': {'key': 'pipelineRunSettingParameters', 'type': '[RunSettingParameter]'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_nodes': {'key': 'moduleNodes', 'type': '[GraphModuleNode]'},
        'dataset_nodes': {'key': 'datasetNodes', 'type': '[GraphDatasetNode]'},
        'sub_graph_nodes': {'key': 'subGraphNodes', 'type': '[GraphReferenceNode]'},
        'control_nodes': {'key': 'controlNodes', 'type': '[GraphControlNode]'},
        'edges': {'key': 'edges', 'type': '[GraphEdge]'},
        'entity_interface': {'key': 'entityInterface', 'type': 'EntityInterface'},
        'graph_layout': {'key': 'graphLayout', 'type': 'GraphLayout'},
        'created_by': {'key': 'createdBy', 'type': 'CreatedBy'},
        'last_updated_by': {'key': 'lastUpdatedBy', 'type': 'CreatedBy'},
        'default_compute': {'key': 'defaultCompute', 'type': 'ComputeSetting'},
        'default_datastore': {'key': 'defaultDatastore', 'type': 'DatastoreSetting'},
        'default_cloud_priority': {'key': 'defaultCloudPriority', 'type': 'CloudPrioritySetting'},
        'extended_properties': {'key': 'extendedProperties', 'type': '{str}'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        graph_module_dtos: Optional[List["ModuleDto"]] = None,
        graph_data_sources: Optional[List["DataInfo"]] = None,
        graphs: Optional[Dict[str, "PipelineGraph"]] = None,
        graph_drafts: Optional[Dict[str, "PipelineGraph"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        referenced_node_id: Optional[str] = None,
        pipeline_run_setting_parameters: Optional[List["RunSettingParameter"]] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_nodes: Optional[List["GraphModuleNode"]] = None,
        dataset_nodes: Optional[List["GraphDatasetNode"]] = None,
        sub_graph_nodes: Optional[List["GraphReferenceNode"]] = None,
        control_nodes: Optional[List["GraphControlNode"]] = None,
        edges: Optional[List["GraphEdge"]] = None,
        entity_interface: Optional["EntityInterface"] = None,
        graph_layout: Optional["GraphLayout"] = None,
        created_by: Optional["CreatedBy"] = None,
        last_updated_by: Optional["CreatedBy"] = None,
        default_compute: Optional["ComputeSetting"] = None,
        default_datastore: Optional["DatastoreSetting"] = None,
        default_cloud_priority: Optional["CloudPrioritySetting"] = None,
        extended_properties: Optional[Dict[str, str]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword graph_module_dtos:
        :paramtype graph_module_dtos: list[~designer.models.ModuleDto]
        :keyword graph_data_sources:
        :paramtype graph_data_sources: list[~designer.models.DataInfo]
        :keyword graphs: This is a dictionary.
        :paramtype graphs: dict[str, ~designer.models.PipelineGraph]
        :keyword graph_drafts: This is a dictionary.
        :paramtype graph_drafts: dict[str, ~designer.models.PipelineGraph]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword referenced_node_id:
        :paramtype referenced_node_id: str
        :keyword pipeline_run_setting_parameters:
        :paramtype pipeline_run_setting_parameters: list[~designer.models.RunSettingParameter]
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_nodes:
        :paramtype module_nodes: list[~designer.models.GraphModuleNode]
        :keyword dataset_nodes:
        :paramtype dataset_nodes: list[~designer.models.GraphDatasetNode]
        :keyword sub_graph_nodes:
        :paramtype sub_graph_nodes: list[~designer.models.GraphReferenceNode]
        :keyword control_nodes:
        :paramtype control_nodes: list[~designer.models.GraphControlNode]
        :keyword edges:
        :paramtype edges: list[~designer.models.GraphEdge]
        :keyword entity_interface:
        :paramtype entity_interface: ~designer.models.EntityInterface
        :keyword graph_layout:
        :paramtype graph_layout: ~designer.models.GraphLayout
        :keyword created_by:
        :paramtype created_by: ~designer.models.CreatedBy
        :keyword last_updated_by:
        :paramtype last_updated_by: ~designer.models.CreatedBy
        :keyword default_compute:
        :paramtype default_compute: ~designer.models.ComputeSetting
        :keyword default_datastore:
        :paramtype default_datastore: ~designer.models.DatastoreSetting
        :keyword default_cloud_priority:
        :paramtype default_cloud_priority: ~designer.models.CloudPrioritySetting
        :keyword extended_properties: This is a dictionary.
        :paramtype extended_properties: dict[str, str]
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineGraph, self).__init__(**kwargs)
        self.graph_module_dtos = graph_module_dtos
        self.graph_data_sources = graph_data_sources
        self.graphs = graphs
        self.graph_drafts = graph_drafts
        self.module_node_run_settings = module_node_run_settings
        self.sub_pipelines_info = sub_pipelines_info
        self.referenced_node_id = referenced_node_id
        self.pipeline_run_setting_parameters = pipeline_run_setting_parameters
        self.pipeline_run_settings = pipeline_run_settings
        self.module_nodes = module_nodes
        self.dataset_nodes = dataset_nodes
        self.sub_graph_nodes = sub_graph_nodes
        self.control_nodes = control_nodes
        self.edges = edges
        self.entity_interface = entity_interface
        self.graph_layout = graph_layout
        self.created_by = created_by
        self.last_updated_by = last_updated_by
        self.default_compute = default_compute
        self.default_datastore = default_datastore
        self.default_cloud_priority = default_cloud_priority
        self.extended_properties = extended_properties
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineRun(msrest.serialization.Model):
    """PipelineRun.

    :ivar pipeline_id:
    :vartype pipeline_id: str
    :ivar run_source:
    :vartype run_source: str
    :ivar run_type: Possible values include: "HTTP", "SDK", "Schedule", "Portal".
    :vartype run_type: str or ~designer.models.RunType
    :ivar parameters: This is a dictionary.
    :vartype parameters: dict[str, str]
    :ivar data_path_assignments: This is a dictionary.
    :vartype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
    :ivar data_set_definition_value_assignment: This is a dictionary.
    :vartype data_set_definition_value_assignment: dict[str,
     ~designer.models.DataSetDefinitionValue]
    :ivar total_steps:
    :vartype total_steps: int
    :ivar logs: This is a dictionary.
    :vartype logs: dict[str, str]
    :ivar description:
    :vartype description: str
    :ivar display_name:
    :vartype display_name: str
    :ivar run_number:
    :vartype run_number: int
    :ivar status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
     "Failed", "Finished", "Canceled", "Throttled", "Unknown".
    :vartype status_code: str or ~designer.models.PipelineStatusCode
    :ivar run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype run_status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar graph_id:
    :vartype graph_id: str
    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar is_experiment_archived:
    :vartype is_experiment_archived: bool
    :ivar submitted_by:
    :vartype submitted_by: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar step_tags: This is a dictionary.
    :vartype step_tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar aether_start_time:
    :vartype aether_start_time: ~datetime.datetime
    :ivar aether_end_time:
    :vartype aether_end_time: ~datetime.datetime
    :ivar run_history_start_time:
    :vartype run_history_start_time: ~datetime.datetime
    :ivar run_history_end_time:
    :vartype run_history_end_time: ~datetime.datetime
    :ivar unique_child_run_compute_targets:
    :vartype unique_child_run_compute_targets: list[str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _validation = {
        'unique_child_run_compute_targets': {'unique': True},
    }

    _attribute_map = {
        'pipeline_id': {'key': 'pipelineId', 'type': 'str'},
        'run_source': {'key': 'runSource', 'type': 'str'},
        'run_type': {'key': 'runType', 'type': 'str'},
        'parameters': {'key': 'parameters', 'type': '{str}'},
        'data_path_assignments': {'key': 'dataPathAssignments', 'type': '{LegacyDataPath}'},
        'data_set_definition_value_assignment': {'key': 'dataSetDefinitionValueAssignment', 'type': '{DataSetDefinitionValue}'},
        'total_steps': {'key': 'totalSteps', 'type': 'int'},
        'logs': {'key': 'logs', 'type': '{str}'},
        'description': {'key': 'description', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'run_number': {'key': 'runNumber', 'type': 'int'},
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'run_status': {'key': 'runStatus', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'is_experiment_archived': {'key': 'isExperimentArchived', 'type': 'bool'},
        'submitted_by': {'key': 'submittedBy', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'step_tags': {'key': 'stepTags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'aether_start_time': {'key': 'aetherStartTime', 'type': 'iso-8601'},
        'aether_end_time': {'key': 'aetherEndTime', 'type': 'iso-8601'},
        'run_history_start_time': {'key': 'runHistoryStartTime', 'type': 'iso-8601'},
        'run_history_end_time': {'key': 'runHistoryEndTime', 'type': 'iso-8601'},
        'unique_child_run_compute_targets': {'key': 'uniqueChildRunComputeTargets', 'type': '[str]'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        pipeline_id: Optional[str] = None,
        run_source: Optional[str] = None,
        run_type: Optional[Union[str, "RunType"]] = None,
        parameters: Optional[Dict[str, str]] = None,
        data_path_assignments: Optional[Dict[str, "LegacyDataPath"]] = None,
        data_set_definition_value_assignment: Optional[Dict[str, "DataSetDefinitionValue"]] = None,
        total_steps: Optional[int] = None,
        logs: Optional[Dict[str, str]] = None,
        description: Optional[str] = None,
        display_name: Optional[str] = None,
        run_number: Optional[int] = None,
        status_code: Optional[Union[str, "PipelineStatusCode"]] = None,
        run_status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        graph_id: Optional[str] = None,
        experiment_id: Optional[str] = None,
        experiment_name: Optional[str] = None,
        is_experiment_archived: Optional[bool] = None,
        submitted_by: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        step_tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        aether_start_time: Optional[datetime.datetime] = None,
        aether_end_time: Optional[datetime.datetime] = None,
        run_history_start_time: Optional[datetime.datetime] = None,
        run_history_end_time: Optional[datetime.datetime] = None,
        unique_child_run_compute_targets: Optional[List[str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword pipeline_id:
        :paramtype pipeline_id: str
        :keyword run_source:
        :paramtype run_source: str
        :keyword run_type: Possible values include: "HTTP", "SDK", "Schedule", "Portal".
        :paramtype run_type: str or ~designer.models.RunType
        :keyword parameters: This is a dictionary.
        :paramtype parameters: dict[str, str]
        :keyword data_path_assignments: This is a dictionary.
        :paramtype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
        :keyword data_set_definition_value_assignment: This is a dictionary.
        :paramtype data_set_definition_value_assignment: dict[str,
         ~designer.models.DataSetDefinitionValue]
        :keyword total_steps:
        :paramtype total_steps: int
        :keyword logs: This is a dictionary.
        :paramtype logs: dict[str, str]
        :keyword description:
        :paramtype description: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword run_number:
        :paramtype run_number: int
        :keyword status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
         "Failed", "Finished", "Canceled", "Throttled", "Unknown".
        :paramtype status_code: str or ~designer.models.PipelineStatusCode
        :keyword run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype run_status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword is_experiment_archived:
        :paramtype is_experiment_archived: bool
        :keyword submitted_by:
        :paramtype submitted_by: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword step_tags: This is a dictionary.
        :paramtype step_tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword aether_start_time:
        :paramtype aether_start_time: ~datetime.datetime
        :keyword aether_end_time:
        :paramtype aether_end_time: ~datetime.datetime
        :keyword run_history_start_time:
        :paramtype run_history_start_time: ~datetime.datetime
        :keyword run_history_end_time:
        :paramtype run_history_end_time: ~datetime.datetime
        :keyword unique_child_run_compute_targets:
        :paramtype unique_child_run_compute_targets: list[str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineRun, self).__init__(**kwargs)
        self.pipeline_id = pipeline_id
        self.run_source = run_source
        self.run_type = run_type
        self.parameters = parameters
        self.data_path_assignments = data_path_assignments
        self.data_set_definition_value_assignment = data_set_definition_value_assignment
        self.total_steps = total_steps
        self.logs = logs
        self.description = description
        self.display_name = display_name
        self.run_number = run_number
        self.status_code = status_code
        self.run_status = run_status
        self.status_detail = status_detail
        self.start_time = start_time
        self.end_time = end_time
        self.graph_id = graph_id
        self.experiment_id = experiment_id
        self.experiment_name = experiment_name
        self.is_experiment_archived = is_experiment_archived
        self.submitted_by = submitted_by
        self.tags = tags
        self.step_tags = step_tags
        self.properties = properties
        self.aether_start_time = aether_start_time
        self.aether_end_time = aether_end_time
        self.run_history_start_time = run_history_start_time
        self.run_history_end_time = run_history_end_time
        self.unique_child_run_compute_targets = unique_child_run_compute_targets
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineRunGraphDetail(msrest.serialization.Model):
    """PipelineRunGraphDetail.

    :ivar graph:
    :vartype graph: ~designer.models.PipelineGraph
    :ivar graph_nodes_status: This is a dictionary.
    :vartype graph_nodes_status: dict[str, ~designer.models.GraphNodeStatusInfo]
    """

    _attribute_map = {
        'graph': {'key': 'graph', 'type': 'PipelineGraph'},
        'graph_nodes_status': {'key': 'graphNodesStatus', 'type': '{GraphNodeStatusInfo}'},
    }

    def __init__(
        self,
        *,
        graph: Optional["PipelineGraph"] = None,
        graph_nodes_status: Optional[Dict[str, "GraphNodeStatusInfo"]] = None,
        **kwargs
    ):
        """
        :keyword graph:
        :paramtype graph: ~designer.models.PipelineGraph
        :keyword graph_nodes_status: This is a dictionary.
        :paramtype graph_nodes_status: dict[str, ~designer.models.GraphNodeStatusInfo]
        """
        super(PipelineRunGraphDetail, self).__init__(**kwargs)
        self.graph = graph
        self.graph_nodes_status = graph_nodes_status


class PipelineRunGraphStatus(msrest.serialization.Model):
    """PipelineRunGraphStatus.

    :ivar status:
    :vartype status: ~designer.models.PipelineStatus
    :ivar graph_nodes_status: This is a dictionary.
    :vartype graph_nodes_status: dict[str, ~designer.models.GraphNodeStatusInfo]
    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar is_experiment_archived:
    :vartype is_experiment_archived: bool
    """

    _attribute_map = {
        'status': {'key': 'status', 'type': 'PipelineStatus'},
        'graph_nodes_status': {'key': 'graphNodesStatus', 'type': '{GraphNodeStatusInfo}'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'is_experiment_archived': {'key': 'isExperimentArchived', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        status: Optional["PipelineStatus"] = None,
        graph_nodes_status: Optional[Dict[str, "GraphNodeStatusInfo"]] = None,
        experiment_id: Optional[str] = None,
        is_experiment_archived: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword status:
        :paramtype status: ~designer.models.PipelineStatus
        :keyword graph_nodes_status: This is a dictionary.
        :paramtype graph_nodes_status: dict[str, ~designer.models.GraphNodeStatusInfo]
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword is_experiment_archived:
        :paramtype is_experiment_archived: bool
        """
        super(PipelineRunGraphStatus, self).__init__(**kwargs)
        self.status = status
        self.graph_nodes_status = graph_nodes_status
        self.experiment_id = experiment_id
        self.is_experiment_archived = is_experiment_archived


class PipelineRunProfile(msrest.serialization.Model):
    """PipelineRunProfile.

    :ivar run_id:
    :vartype run_id: str
    :ivar node_id:
    :vartype node_id: str
    :ivar run_url:
    :vartype run_url: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar description:
    :vartype description: str
    :ivar status:
    :vartype status: ~designer.models.PipelineRunStatus
    :ivar create_time:
    :vartype create_time: long
    :ivar start_time:
    :vartype start_time: long
    :ivar end_time:
    :vartype end_time: long
    :ivar profiling_time:
    :vartype profiling_time: long
    :ivar step_runs_profile:
    :vartype step_runs_profile: list[~designer.models.StepRunProfile]
    :ivar sub_pipeline_run_profile:
    :vartype sub_pipeline_run_profile: list[~designer.models.PipelineRunProfile]
    """

    _attribute_map = {
        'run_id': {'key': 'runId', 'type': 'str'},
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'run_url': {'key': 'runUrl', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'status': {'key': 'status', 'type': 'PipelineRunStatus'},
        'create_time': {'key': 'createTime', 'type': 'long'},
        'start_time': {'key': 'startTime', 'type': 'long'},
        'end_time': {'key': 'endTime', 'type': 'long'},
        'profiling_time': {'key': 'profilingTime', 'type': 'long'},
        'step_runs_profile': {'key': 'stepRunsProfile', 'type': '[StepRunProfile]'},
        'sub_pipeline_run_profile': {'key': 'subPipelineRunProfile', 'type': '[PipelineRunProfile]'},
    }

    def __init__(
        self,
        *,
        run_id: Optional[str] = None,
        node_id: Optional[str] = None,
        run_url: Optional[str] = None,
        experiment_name: Optional[str] = None,
        experiment_id: Optional[str] = None,
        description: Optional[str] = None,
        status: Optional["PipelineRunStatus"] = None,
        create_time: Optional[int] = None,
        start_time: Optional[int] = None,
        end_time: Optional[int] = None,
        profiling_time: Optional[int] = None,
        step_runs_profile: Optional[List["StepRunProfile"]] = None,
        sub_pipeline_run_profile: Optional[List["PipelineRunProfile"]] = None,
        **kwargs
    ):
        """
        :keyword run_id:
        :paramtype run_id: str
        :keyword node_id:
        :paramtype node_id: str
        :keyword run_url:
        :paramtype run_url: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword description:
        :paramtype description: str
        :keyword status:
        :paramtype status: ~designer.models.PipelineRunStatus
        :keyword create_time:
        :paramtype create_time: long
        :keyword start_time:
        :paramtype start_time: long
        :keyword end_time:
        :paramtype end_time: long
        :keyword profiling_time:
        :paramtype profiling_time: long
        :keyword step_runs_profile:
        :paramtype step_runs_profile: list[~designer.models.StepRunProfile]
        :keyword sub_pipeline_run_profile:
        :paramtype sub_pipeline_run_profile: list[~designer.models.PipelineRunProfile]
        """
        super(PipelineRunProfile, self).__init__(**kwargs)
        self.run_id = run_id
        self.node_id = node_id
        self.run_url = run_url
        self.experiment_name = experiment_name
        self.experiment_id = experiment_id
        self.description = description
        self.status = status
        self.create_time = create_time
        self.start_time = start_time
        self.end_time = end_time
        self.profiling_time = profiling_time
        self.step_runs_profile = step_runs_profile
        self.sub_pipeline_run_profile = sub_pipeline_run_profile


class PipelineRunStatus(msrest.serialization.Model):
    """PipelineRunStatus.

    :ivar status_code: Possible values include: "NotStarted", "Running", "Failed", "Finished",
     "Canceled".
    :vartype status_code: str or ~designer.models.PipelineRunStatusCode
    :ivar status_detail:
    :vartype status_detail: str
    :ivar creation_time:
    :vartype creation_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    """

    _attribute_map = {
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'creation_time': {'key': 'creationTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        status_code: Optional[Union[str, "PipelineRunStatusCode"]] = None,
        status_detail: Optional[str] = None,
        creation_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword status_code: Possible values include: "NotStarted", "Running", "Failed", "Finished",
         "Canceled".
        :paramtype status_code: str or ~designer.models.PipelineRunStatusCode
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword creation_time:
        :paramtype creation_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        """
        super(PipelineRunStatus, self).__init__(**kwargs)
        self.status_code = status_code
        self.status_detail = status_detail
        self.creation_time = creation_time
        self.end_time = end_time


class PipelineRunStepDetails(msrest.serialization.Model):
    """PipelineRunStepDetails.

    :ivar run_id:
    :vartype run_id: str
    :ivar target:
    :vartype target: str
    :ivar status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar parent_run_id:
    :vartype parent_run_id: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar is_reused:
    :vartype is_reused: bool
    :ivar logs: This is a dictionary.
    :vartype logs: dict[str, str]
    :ivar outputs: This is a dictionary.
    :vartype outputs: dict[str, str]
    :ivar snapshot_info:
    :vartype snapshot_info: ~designer.models.SnapshotInfo
    :ivar input_datasets:
    :vartype input_datasets: list[~designer.models.DatasetLineage]
    :ivar output_datasets:
    :vartype output_datasets: list[~designer.models.OutputDatasetLineage]
    """

    _validation = {
        'input_datasets': {'unique': True},
        'output_datasets': {'unique': True},
    }

    _attribute_map = {
        'run_id': {'key': 'runId', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'parent_run_id': {'key': 'parentRunId', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'is_reused': {'key': 'isReused', 'type': 'bool'},
        'logs': {'key': 'logs', 'type': '{str}'},
        'outputs': {'key': 'outputs', 'type': '{str}'},
        'snapshot_info': {'key': 'snapshotInfo', 'type': 'SnapshotInfo'},
        'input_datasets': {'key': 'inputDatasets', 'type': '[DatasetLineage]'},
        'output_datasets': {'key': 'outputDatasets', 'type': '[OutputDatasetLineage]'},
    }

    def __init__(
        self,
        *,
        run_id: Optional[str] = None,
        target: Optional[str] = None,
        status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        parent_run_id: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        is_reused: Optional[bool] = None,
        logs: Optional[Dict[str, str]] = None,
        outputs: Optional[Dict[str, str]] = None,
        snapshot_info: Optional["SnapshotInfo"] = None,
        input_datasets: Optional[List["DatasetLineage"]] = None,
        output_datasets: Optional[List["OutputDatasetLineage"]] = None,
        **kwargs
    ):
        """
        :keyword run_id:
        :paramtype run_id: str
        :keyword target:
        :paramtype target: str
        :keyword status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword parent_run_id:
        :paramtype parent_run_id: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword is_reused:
        :paramtype is_reused: bool
        :keyword logs: This is a dictionary.
        :paramtype logs: dict[str, str]
        :keyword outputs: This is a dictionary.
        :paramtype outputs: dict[str, str]
        :keyword snapshot_info:
        :paramtype snapshot_info: ~designer.models.SnapshotInfo
        :keyword input_datasets:
        :paramtype input_datasets: list[~designer.models.DatasetLineage]
        :keyword output_datasets:
        :paramtype output_datasets: list[~designer.models.OutputDatasetLineage]
        """
        super(PipelineRunStepDetails, self).__init__(**kwargs)
        self.run_id = run_id
        self.target = target
        self.status = status
        self.status_detail = status_detail
        self.parent_run_id = parent_run_id
        self.start_time = start_time
        self.end_time = end_time
        self.is_reused = is_reused
        self.logs = logs
        self.outputs = outputs
        self.snapshot_info = snapshot_info
        self.input_datasets = input_datasets
        self.output_datasets = output_datasets


class PipelineRunSummary(msrest.serialization.Model):
    """PipelineRunSummary.

    :ivar description:
    :vartype description: str
    :ivar display_name:
    :vartype display_name: str
    :ivar run_number:
    :vartype run_number: int
    :ivar status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
     "Failed", "Finished", "Canceled", "Throttled", "Unknown".
    :vartype status_code: str or ~designer.models.PipelineStatusCode
    :ivar run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype run_status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar graph_id:
    :vartype graph_id: str
    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar is_experiment_archived:
    :vartype is_experiment_archived: bool
    :ivar submitted_by:
    :vartype submitted_by: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar step_tags: This is a dictionary.
    :vartype step_tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar aether_start_time:
    :vartype aether_start_time: ~datetime.datetime
    :ivar aether_end_time:
    :vartype aether_end_time: ~datetime.datetime
    :ivar run_history_start_time:
    :vartype run_history_start_time: ~datetime.datetime
    :ivar run_history_end_time:
    :vartype run_history_end_time: ~datetime.datetime
    :ivar unique_child_run_compute_targets:
    :vartype unique_child_run_compute_targets: list[str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _validation = {
        'unique_child_run_compute_targets': {'unique': True},
    }

    _attribute_map = {
        'description': {'key': 'description', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'run_number': {'key': 'runNumber', 'type': 'int'},
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'run_status': {'key': 'runStatus', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'is_experiment_archived': {'key': 'isExperimentArchived', 'type': 'bool'},
        'submitted_by': {'key': 'submittedBy', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'step_tags': {'key': 'stepTags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'aether_start_time': {'key': 'aetherStartTime', 'type': 'iso-8601'},
        'aether_end_time': {'key': 'aetherEndTime', 'type': 'iso-8601'},
        'run_history_start_time': {'key': 'runHistoryStartTime', 'type': 'iso-8601'},
        'run_history_end_time': {'key': 'runHistoryEndTime', 'type': 'iso-8601'},
        'unique_child_run_compute_targets': {'key': 'uniqueChildRunComputeTargets', 'type': '[str]'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        description: Optional[str] = None,
        display_name: Optional[str] = None,
        run_number: Optional[int] = None,
        status_code: Optional[Union[str, "PipelineStatusCode"]] = None,
        run_status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        graph_id: Optional[str] = None,
        experiment_id: Optional[str] = None,
        experiment_name: Optional[str] = None,
        is_experiment_archived: Optional[bool] = None,
        submitted_by: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        step_tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        aether_start_time: Optional[datetime.datetime] = None,
        aether_end_time: Optional[datetime.datetime] = None,
        run_history_start_time: Optional[datetime.datetime] = None,
        run_history_end_time: Optional[datetime.datetime] = None,
        unique_child_run_compute_targets: Optional[List[str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword description:
        :paramtype description: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword run_number:
        :paramtype run_number: int
        :keyword status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
         "Failed", "Finished", "Canceled", "Throttled", "Unknown".
        :paramtype status_code: str or ~designer.models.PipelineStatusCode
        :keyword run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype run_status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword is_experiment_archived:
        :paramtype is_experiment_archived: bool
        :keyword submitted_by:
        :paramtype submitted_by: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword step_tags: This is a dictionary.
        :paramtype step_tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword aether_start_time:
        :paramtype aether_start_time: ~datetime.datetime
        :keyword aether_end_time:
        :paramtype aether_end_time: ~datetime.datetime
        :keyword run_history_start_time:
        :paramtype run_history_start_time: ~datetime.datetime
        :keyword run_history_end_time:
        :paramtype run_history_end_time: ~datetime.datetime
        :keyword unique_child_run_compute_targets:
        :paramtype unique_child_run_compute_targets: list[str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineRunSummary, self).__init__(**kwargs)
        self.description = description
        self.display_name = display_name
        self.run_number = run_number
        self.status_code = status_code
        self.run_status = run_status
        self.status_detail = status_detail
        self.start_time = start_time
        self.end_time = end_time
        self.graph_id = graph_id
        self.experiment_id = experiment_id
        self.experiment_name = experiment_name
        self.is_experiment_archived = is_experiment_archived
        self.submitted_by = submitted_by
        self.tags = tags
        self.step_tags = step_tags
        self.properties = properties
        self.aether_start_time = aether_start_time
        self.aether_end_time = aether_end_time
        self.run_history_start_time = run_history_start_time
        self.run_history_end_time = run_history_end_time
        self.unique_child_run_compute_targets = unique_child_run_compute_targets
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PipelineStatus(msrest.serialization.Model):
    """PipelineStatus.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
     "Failed", "Finished", "Canceled", "Throttled", "Unknown".
    :vartype status_code: str or ~designer.models.PipelineStatusCode
    :ivar run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype run_status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar is_terminal_state:
    :vartype is_terminal_state: bool
    """

    _validation = {
        'is_terminal_state': {'readonly': True},
    }

    _attribute_map = {
        'status_code': {'key': 'statusCode', 'type': 'str'},
        'run_status': {'key': 'runStatus', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'is_terminal_state': {'key': 'isTerminalState', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        status_code: Optional[Union[str, "PipelineStatusCode"]] = None,
        run_status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword status_code: Possible values include: "NotStarted", "InDraft", "Preparing", "Running",
         "Failed", "Finished", "Canceled", "Throttled", "Unknown".
        :paramtype status_code: str or ~designer.models.PipelineStatusCode
        :keyword run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype run_status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        """
        super(PipelineStatus, self).__init__(**kwargs)
        self.status_code = status_code
        self.run_status = run_status
        self.status_detail = status_detail
        self.start_time = start_time
        self.end_time = end_time
        self.is_terminal_state = None


class PipelineStepRun(msrest.serialization.Model):
    """PipelineStepRun.

    :ivar step_name:
    :vartype step_name: str
    :ivar run_number:
    :vartype run_number: int
    :ivar run_id:
    :vartype run_id: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype run_status: str or ~designer.models.RunStatus
    :ivar compute_target:
    :vartype compute_target: str
    :ivar compute_type:
    :vartype compute_type: str
    :ivar run_type:
    :vartype run_type: str
    :ivar step_type:
    :vartype step_type: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar is_reused:
    :vartype is_reused: bool
    """

    _attribute_map = {
        'step_name': {'key': 'stepName', 'type': 'str'},
        'run_number': {'key': 'runNumber', 'type': 'int'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'run_status': {'key': 'runStatus', 'type': 'str'},
        'compute_target': {'key': 'computeTarget', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'run_type': {'key': 'runType', 'type': 'str'},
        'step_type': {'key': 'stepType', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'is_reused': {'key': 'isReused', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        step_name: Optional[str] = None,
        run_number: Optional[int] = None,
        run_id: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        run_status: Optional[Union[str, "RunStatus"]] = None,
        compute_target: Optional[str] = None,
        compute_type: Optional[str] = None,
        run_type: Optional[str] = None,
        step_type: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        is_reused: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword step_name:
        :paramtype step_name: str
        :keyword run_number:
        :paramtype run_number: int
        :keyword run_id:
        :paramtype run_id: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword run_status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype run_status: str or ~designer.models.RunStatus
        :keyword compute_target:
        :paramtype compute_target: str
        :keyword compute_type:
        :paramtype compute_type: str
        :keyword run_type:
        :paramtype run_type: str
        :keyword step_type:
        :paramtype step_type: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword is_reused:
        :paramtype is_reused: bool
        """
        super(PipelineStepRun, self).__init__(**kwargs)
        self.step_name = step_name
        self.run_number = run_number
        self.run_id = run_id
        self.start_time = start_time
        self.end_time = end_time
        self.run_status = run_status
        self.compute_target = compute_target
        self.compute_type = compute_type
        self.run_type = run_type
        self.step_type = step_type
        self.tags = tags
        self.is_reused = is_reused


class PipelineStepRunOutputs(msrest.serialization.Model):
    """PipelineStepRunOutputs.

    :ivar outputs: This is a dictionary.
    :vartype outputs: dict[str, str]
    :ivar port_outputs: This is a dictionary.
    :vartype port_outputs: dict[str, ~designer.models.PortOutputInfo]
    """

    _attribute_map = {
        'outputs': {'key': 'outputs', 'type': '{str}'},
        'port_outputs': {'key': 'portOutputs', 'type': '{PortOutputInfo}'},
    }

    def __init__(
        self,
        *,
        outputs: Optional[Dict[str, str]] = None,
        port_outputs: Optional[Dict[str, "PortOutputInfo"]] = None,
        **kwargs
    ):
        """
        :keyword outputs: This is a dictionary.
        :paramtype outputs: dict[str, str]
        :keyword port_outputs: This is a dictionary.
        :paramtype port_outputs: dict[str, ~designer.models.PortOutputInfo]
        """
        super(PipelineStepRunOutputs, self).__init__(**kwargs)
        self.outputs = outputs
        self.port_outputs = port_outputs


class PipelineSubDraft(msrest.serialization.Model):
    """PipelineSubDraft.

    :ivar parent_graph_draft_id:
    :vartype parent_graph_draft_id: str
    :ivar parent_node_id:
    :vartype parent_node_id: str
    :ivar graph_detail:
    :vartype graph_detail: ~designer.models.PipelineRunGraphDetail
    :ivar module_dto:
    :vartype module_dto: ~designer.models.ModuleDto
    :ivar name:
    :vartype name: str
    :ivar last_edited_by:
    :vartype last_edited_by: str
    :ivar created_by:
    :vartype created_by: str
    :ivar description:
    :vartype description: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'parent_graph_draft_id': {'key': 'parentGraphDraftId', 'type': 'str'},
        'parent_node_id': {'key': 'parentNodeId', 'type': 'str'},
        'graph_detail': {'key': 'graphDetail', 'type': 'PipelineRunGraphDetail'},
        'module_dto': {'key': 'moduleDto', 'type': 'ModuleDto'},
        'name': {'key': 'name', 'type': 'str'},
        'last_edited_by': {'key': 'lastEditedBy', 'type': 'str'},
        'created_by': {'key': 'createdBy', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        parent_graph_draft_id: Optional[str] = None,
        parent_node_id: Optional[str] = None,
        graph_detail: Optional["PipelineRunGraphDetail"] = None,
        module_dto: Optional["ModuleDto"] = None,
        name: Optional[str] = None,
        last_edited_by: Optional[str] = None,
        created_by: Optional[str] = None,
        description: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword parent_graph_draft_id:
        :paramtype parent_graph_draft_id: str
        :keyword parent_node_id:
        :paramtype parent_node_id: str
        :keyword graph_detail:
        :paramtype graph_detail: ~designer.models.PipelineRunGraphDetail
        :keyword module_dto:
        :paramtype module_dto: ~designer.models.ModuleDto
        :keyword name:
        :paramtype name: str
        :keyword last_edited_by:
        :paramtype last_edited_by: str
        :keyword created_by:
        :paramtype created_by: str
        :keyword description:
        :paramtype description: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PipelineSubDraft, self).__init__(**kwargs)
        self.parent_graph_draft_id = parent_graph_draft_id
        self.parent_node_id = parent_node_id
        self.graph_detail = graph_detail
        self.module_dto = module_dto
        self.name = name
        self.last_edited_by = last_edited_by
        self.created_by = created_by
        self.description = description
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.tags = tags
        self.properties = properties
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PortInfo(msrest.serialization.Model):
    """PortInfo.

    :ivar node_id:
    :vartype node_id: str
    :ivar port_name:
    :vartype port_name: str
    :ivar graph_port_name:
    :vartype graph_port_name: str
    :ivar is_parameter:
    :vartype is_parameter: bool
    :ivar web_service_port:
    :vartype web_service_port: str
    """

    _attribute_map = {
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
        'graph_port_name': {'key': 'graphPortName', 'type': 'str'},
        'is_parameter': {'key': 'isParameter', 'type': 'bool'},
        'web_service_port': {'key': 'webServicePort', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        graph_port_name: Optional[str] = None,
        is_parameter: Optional[str] = None,
        web_service_port: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_id:
        :paramtype node_id: str
        :keyword port_name:
        :paramtype port_name: str
        :keyword graph_port_name:
        :paramtype graph_port_name: str
        :keyword is_parameter:
        :paramtype is_parameter: bool
        :keyword web_service_port:
        :paramtype web_service_port: str
        """
        super(PortInfo, self).__init__(**kwargs)
        self.node_id = node_id
        self.port_name = port_name
        self.graph_port_name = graph_port_name
        self.is_parameter = is_parameter
        self.web_service_port = web_service_port


class PortOutputInfo(msrest.serialization.Model):
    """PortOutputInfo.

    :ivar container_uri:
    :vartype container_uri: str
    :ivar relative_path:
    :vartype relative_path: str
    :ivar model_output_path:
    :vartype model_output_path: str
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar data_reference_type: Possible values include: "None", "AzureBlob", "AzureDataLake",
     "AzureFiles", "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS",
     "AzureMySqlDatabase", "Custom".
    :vartype data_reference_type: str or ~designer.models.DataReferenceType
    :ivar is_file:
    :vartype is_file: bool
    :ivar supported_actions:
    :vartype supported_actions: list[str or ~designer.models.PortAction]
    """

    _attribute_map = {
        'container_uri': {'key': 'containerUri', 'type': 'str'},
        'relative_path': {'key': 'relativePath', 'type': 'str'},
        'model_output_path': {'key': 'modelOutputPath', 'type': 'str'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'data_reference_type': {'key': 'dataReferenceType', 'type': 'str'},
        'is_file': {'key': 'isFile', 'type': 'bool'},
        'supported_actions': {'key': 'supportedActions', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        container_uri: Optional[str] = None,
        relative_path: Optional[str] = None,
        model_output_path: Optional[str] = None,
        data_store_name: Optional[str] = None,
        data_reference_type: Optional[Union[str, "DataReferenceType"]] = None,
        is_file: Optional[bool] = None,
        supported_actions: Optional[List[Union[str, "PortAction"]]] = None,
        **kwargs
    ):
        """
        :keyword container_uri:
        :paramtype container_uri: str
        :keyword relative_path:
        :paramtype relative_path: str
        :keyword model_output_path:
        :paramtype model_output_path: str
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword data_reference_type: Possible values include: "None", "AzureBlob", "AzureDataLake",
         "AzureFiles", "AzureSqlDatabase", "AzurePostgresDatabase", "AzureDataLakeGen2", "DBFS",
         "AzureMySqlDatabase", "Custom".
        :paramtype data_reference_type: str or ~designer.models.DataReferenceType
        :keyword is_file:
        :paramtype is_file: bool
        :keyword supported_actions:
        :paramtype supported_actions: list[str or ~designer.models.PortAction]
        """
        super(PortOutputInfo, self).__init__(**kwargs)
        self.container_uri = container_uri
        self.relative_path = relative_path
        self.model_output_path = model_output_path
        self.data_store_name = data_store_name
        self.data_reference_type = data_reference_type
        self.is_file = is_file
        self.supported_actions = supported_actions


class PriorityConfiguration(msrest.serialization.Model):
    """PriorityConfiguration.

    :ivar cloud_priority:
    :vartype cloud_priority: int
    """

    _attribute_map = {
        'cloud_priority': {'key': 'cloudPriority', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        cloud_priority: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword cloud_priority:
        :paramtype cloud_priority: int
        """
        super(PriorityConfiguration, self).__init__(**kwargs)
        self.cloud_priority = cloud_priority


class PromoteDataSetRequest(msrest.serialization.Model):
    """PromoteDataSetRequest.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar module_node_id:
    :vartype module_node_id: str
    :ivar step_run_id:
    :vartype step_run_id: str
    :ivar output_port_name:
    :vartype output_port_name: str
    :ivar model_output_path:
    :vartype model_output_path: str
    :ivar data_type_id:
    :vartype data_type_id: str
    :ivar dataset_type:
    :vartype dataset_type: str
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar output_relative_path:
    :vartype output_relative_path: str
    :ivar pipeline_run_id:
    :vartype pipeline_run_id: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar experiment_id:
    :vartype experiment_id: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'module_node_id': {'key': 'moduleNodeId', 'type': 'str'},
        'step_run_id': {'key': 'stepRunId', 'type': 'str'},
        'output_port_name': {'key': 'outputPortName', 'type': 'str'},
        'model_output_path': {'key': 'modelOutputPath', 'type': 'str'},
        'data_type_id': {'key': 'dataTypeId', 'type': 'str'},
        'dataset_type': {'key': 'datasetType', 'type': 'str'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'output_relative_path': {'key': 'outputRelativePath', 'type': 'str'},
        'pipeline_run_id': {'key': 'pipelineRunId', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        module_node_id: Optional[str] = None,
        step_run_id: Optional[str] = None,
        output_port_name: Optional[str] = None,
        model_output_path: Optional[str] = None,
        data_type_id: Optional[str] = None,
        dataset_type: Optional[str] = None,
        data_store_name: Optional[str] = None,
        output_relative_path: Optional[str] = None,
        pipeline_run_id: Optional[str] = None,
        experiment_name: Optional[str] = None,
        experiment_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword module_node_id:
        :paramtype module_node_id: str
        :keyword step_run_id:
        :paramtype step_run_id: str
        :keyword output_port_name:
        :paramtype output_port_name: str
        :keyword model_output_path:
        :paramtype model_output_path: str
        :keyword data_type_id:
        :paramtype data_type_id: str
        :keyword dataset_type:
        :paramtype dataset_type: str
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword output_relative_path:
        :paramtype output_relative_path: str
        :keyword pipeline_run_id:
        :paramtype pipeline_run_id: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        """
        super(PromoteDataSetRequest, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.module_node_id = module_node_id
        self.step_run_id = step_run_id
        self.output_port_name = output_port_name
        self.model_output_path = model_output_path
        self.data_type_id = data_type_id
        self.dataset_type = dataset_type
        self.data_store_name = data_store_name
        self.output_relative_path = output_relative_path
        self.pipeline_run_id = pipeline_run_id
        self.experiment_name = experiment_name
        self.experiment_id = experiment_id


class PublishedPipeline(msrest.serialization.Model):
    """PublishedPipeline.

    :ivar total_run_steps:
    :vartype total_run_steps: int
    :ivar total_runs:
    :vartype total_runs: int
    :ivar parameters: This is a dictionary.
    :vartype parameters: dict[str, str]
    :ivar data_set_definition_value_assignment: This is a dictionary.
    :vartype data_set_definition_value_assignment: dict[str,
     ~designer.models.DataSetDefinitionValue]
    :ivar rest_endpoint:
    :vartype rest_endpoint: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar graph_id:
    :vartype graph_id: str
    :ivar published_date:
    :vartype published_date: ~datetime.datetime
    :ivar last_run_time:
    :vartype last_run_time: ~datetime.datetime
    :ivar last_run_status: Possible values include: "NotStarted", "Running", "Failed", "Finished",
     "Canceled".
    :vartype last_run_status: str or ~designer.models.PipelineRunStatusCode
    :ivar published_by:
    :vartype published_by: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar version:
    :vartype version: str
    :ivar is_default:
    :vartype is_default: bool
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'total_run_steps': {'key': 'totalRunSteps', 'type': 'int'},
        'total_runs': {'key': 'totalRuns', 'type': 'int'},
        'parameters': {'key': 'parameters', 'type': '{str}'},
        'data_set_definition_value_assignment': {'key': 'dataSetDefinitionValueAssignment', 'type': '{DataSetDefinitionValue}'},
        'rest_endpoint': {'key': 'restEndpoint', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'published_date': {'key': 'publishedDate', 'type': 'iso-8601'},
        'last_run_time': {'key': 'lastRunTime', 'type': 'iso-8601'},
        'last_run_status': {'key': 'lastRunStatus', 'type': 'str'},
        'published_by': {'key': 'publishedBy', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'version': {'key': 'version', 'type': 'str'},
        'is_default': {'key': 'isDefault', 'type': 'bool'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        total_run_steps: Optional[int] = None,
        total_runs: Optional[int] = None,
        parameters: Optional[Dict[str, str]] = None,
        data_set_definition_value_assignment: Optional[Dict[str, "DataSetDefinitionValue"]] = None,
        rest_endpoint: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        graph_id: Optional[str] = None,
        published_date: Optional[datetime.datetime] = None,
        last_run_time: Optional[datetime.datetime] = None,
        last_run_status: Optional[Union[str, "PipelineRunStatusCode"]] = None,
        published_by: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        version: Optional[str] = None,
        is_default: Optional[bool] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword total_run_steps:
        :paramtype total_run_steps: int
        :keyword total_runs:
        :paramtype total_runs: int
        :keyword parameters: This is a dictionary.
        :paramtype parameters: dict[str, str]
        :keyword data_set_definition_value_assignment: This is a dictionary.
        :paramtype data_set_definition_value_assignment: dict[str,
         ~designer.models.DataSetDefinitionValue]
        :keyword rest_endpoint:
        :paramtype rest_endpoint: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword published_date:
        :paramtype published_date: ~datetime.datetime
        :keyword last_run_time:
        :paramtype last_run_time: ~datetime.datetime
        :keyword last_run_status: Possible values include: "NotStarted", "Running", "Failed",
         "Finished", "Canceled".
        :paramtype last_run_status: str or ~designer.models.PipelineRunStatusCode
        :keyword published_by:
        :paramtype published_by: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword version:
        :paramtype version: str
        :keyword is_default:
        :paramtype is_default: bool
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PublishedPipeline, self).__init__(**kwargs)
        self.total_run_steps = total_run_steps
        self.total_runs = total_runs
        self.parameters = parameters
        self.data_set_definition_value_assignment = data_set_definition_value_assignment
        self.rest_endpoint = rest_endpoint
        self.name = name
        self.description = description
        self.graph_id = graph_id
        self.published_date = published_date
        self.last_run_time = last_run_time
        self.last_run_status = last_run_status
        self.published_by = published_by
        self.tags = tags
        self.version = version
        self.is_default = is_default
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PublishedPipelineSummary(msrest.serialization.Model):
    """PublishedPipelineSummary.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar graph_id:
    :vartype graph_id: str
    :ivar published_date:
    :vartype published_date: ~datetime.datetime
    :ivar last_run_time:
    :vartype last_run_time: ~datetime.datetime
    :ivar last_run_status: Possible values include: "NotStarted", "Running", "Failed", "Finished",
     "Canceled".
    :vartype last_run_status: str or ~designer.models.PipelineRunStatusCode
    :ivar published_by:
    :vartype published_by: str
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar version:
    :vartype version: str
    :ivar is_default:
    :vartype is_default: bool
    :ivar entity_status: Possible values include: "Active", "Deprecated", "Disabled".
    :vartype entity_status: str or ~designer.models.EntityStatus
    :ivar id:
    :vartype id: str
    :ivar etag:
    :vartype etag: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar last_modified_date:
    :vartype last_modified_date: ~datetime.datetime
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'published_date': {'key': 'publishedDate', 'type': 'iso-8601'},
        'last_run_time': {'key': 'lastRunTime', 'type': 'iso-8601'},
        'last_run_status': {'key': 'lastRunStatus', 'type': 'str'},
        'published_by': {'key': 'publishedBy', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'version': {'key': 'version', 'type': 'str'},
        'is_default': {'key': 'isDefault', 'type': 'bool'},
        'entity_status': {'key': 'entityStatus', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        graph_id: Optional[str] = None,
        published_date: Optional[datetime.datetime] = None,
        last_run_time: Optional[datetime.datetime] = None,
        last_run_status: Optional[Union[str, "PipelineRunStatusCode"]] = None,
        published_by: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        version: Optional[str] = None,
        is_default: Optional[bool] = None,
        entity_status: Optional[Union[str, "EntityStatus"]] = None,
        id: Optional[str] = None,
        etag: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        last_modified_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword published_date:
        :paramtype published_date: ~datetime.datetime
        :keyword last_run_time:
        :paramtype last_run_time: ~datetime.datetime
        :keyword last_run_status: Possible values include: "NotStarted", "Running", "Failed",
         "Finished", "Canceled".
        :paramtype last_run_status: str or ~designer.models.PipelineRunStatusCode
        :keyword published_by:
        :paramtype published_by: str
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword version:
        :paramtype version: str
        :keyword is_default:
        :paramtype is_default: bool
        :keyword entity_status: Possible values include: "Active", "Deprecated", "Disabled".
        :paramtype entity_status: str or ~designer.models.EntityStatus
        :keyword id:
        :paramtype id: str
        :keyword etag:
        :paramtype etag: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword last_modified_date:
        :paramtype last_modified_date: ~datetime.datetime
        """
        super(PublishedPipelineSummary, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.graph_id = graph_id
        self.published_date = published_date
        self.last_run_time = last_run_time
        self.last_run_status = last_run_status
        self.published_by = published_by
        self.tags = tags
        self.version = version
        self.is_default = is_default
        self.entity_status = entity_status
        self.id = id
        self.etag = etag
        self.created_date = created_date
        self.last_modified_date = last_modified_date


class PythonInterfaceMapping(msrest.serialization.Model):
    """PythonInterfaceMapping.

    :ivar name:
    :vartype name: str
    :ivar name_in_yaml:
    :vartype name_in_yaml: str
    :ivar argument_name:
    :vartype argument_name: str
    :ivar command_line_option:
    :vartype command_line_option: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'name_in_yaml': {'key': 'nameInYaml', 'type': 'str'},
        'argument_name': {'key': 'argumentName', 'type': 'str'},
        'command_line_option': {'key': 'commandLineOption', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        name_in_yaml: Optional[str] = None,
        argument_name: Optional[str] = None,
        command_line_option: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword name_in_yaml:
        :paramtype name_in_yaml: str
        :keyword argument_name:
        :paramtype argument_name: str
        :keyword command_line_option:
        :paramtype command_line_option: str
        """
        super(PythonInterfaceMapping, self).__init__(**kwargs)
        self.name = name
        self.name_in_yaml = name_in_yaml
        self.argument_name = argument_name
        self.command_line_option = command_line_option


class PythonPyPiOrRCranLibraryDto(msrest.serialization.Model):
    """PythonPyPiOrRCranLibraryDto.

    :ivar package:
    :vartype package: str
    :ivar repo:
    :vartype repo: str
    """

    _attribute_map = {
        'package': {'key': 'package', 'type': 'str'},
        'repo': {'key': 'repo', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        package: Optional[str] = None,
        repo: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword package:
        :paramtype package: str
        :keyword repo:
        :paramtype repo: str
        """
        super(PythonPyPiOrRCranLibraryDto, self).__init__(**kwargs)
        self.package = package
        self.repo = repo


class PythonSection(msrest.serialization.Model):
    """PythonSection.

    :ivar interpreter_path:
    :vartype interpreter_path: str
    :ivar user_managed_dependencies:
    :vartype user_managed_dependencies: bool
    :ivar conda_dependencies: Anything.
    :vartype conda_dependencies: any
    :ivar base_conda_environment:
    :vartype base_conda_environment: str
    """

    _attribute_map = {
        'interpreter_path': {'key': 'interpreterPath', 'type': 'str'},
        'user_managed_dependencies': {'key': 'userManagedDependencies', 'type': 'bool'},
        'conda_dependencies': {'key': 'condaDependencies', 'type': 'object'},
        'base_conda_environment': {'key': 'baseCondaEnvironment', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        interpreter_path: Optional[str] = None,
        user_managed_dependencies: Optional[bool] = None,
        conda_dependencies: Optional[Any] = None,
        base_conda_environment: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword interpreter_path:
        :paramtype interpreter_path: str
        :keyword user_managed_dependencies:
        :paramtype user_managed_dependencies: bool
        :keyword conda_dependencies: Anything.
        :paramtype conda_dependencies: any
        :keyword base_conda_environment:
        :paramtype base_conda_environment: str
        """
        super(PythonSection, self).__init__(**kwargs)
        self.interpreter_path = interpreter_path
        self.user_managed_dependencies = user_managed_dependencies
        self.conda_dependencies = conda_dependencies
        self.base_conda_environment = base_conda_environment


class PyTorchConfiguration(msrest.serialization.Model):
    """PyTorchConfiguration.

    :ivar communication_backend:
    :vartype communication_backend: str
    :ivar process_count:
    :vartype process_count: int
    """

    _attribute_map = {
        'communication_backend': {'key': 'communicationBackend', 'type': 'str'},
        'process_count': {'key': 'processCount', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        communication_backend: Optional[str] = None,
        process_count: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword communication_backend:
        :paramtype communication_backend: str
        :keyword process_count:
        :paramtype process_count: int
        """
        super(PyTorchConfiguration, self).__init__(**kwargs)
        self.communication_backend = communication_backend
        self.process_count = process_count


class RCranPackage(msrest.serialization.Model):
    """RCranPackage.

    :ivar name:
    :vartype name: str
    :ivar version:
    :vartype version: str
    :ivar repository:
    :vartype repository: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'repository': {'key': 'repository', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        version: Optional[str] = None,
        repository: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword version:
        :paramtype version: str
        :keyword repository:
        :paramtype repository: str
        """
        super(RCranPackage, self).__init__(**kwargs)
        self.name = name
        self.version = version
        self.repository = repository


class RealTimeEndpoint(msrest.serialization.Model):
    """RealTimeEndpoint.

    :ivar created_by:
    :vartype created_by: str
    :ivar kv_tags: Dictionary of :code:`<string>`.
    :vartype kv_tags: dict[str, str]
    :ivar state: Possible values include: "Transitioning", "Healthy", "Unhealthy", "Failed",
     "Unschedulable".
    :vartype state: str or ~designer.models.WebServiceState
    :ivar error:
    :vartype error: ~designer.models.ModelManagementErrorResponse
    :ivar compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT", "AKSENDPOINT",
     "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE", "UNKNOWN".
    :vartype compute_type: str or ~designer.models.ComputeEnvironmentType
    :ivar image_id:
    :vartype image_id: str
    :ivar cpu:
    :vartype cpu: float
    :ivar memory_in_gb:
    :vartype memory_in_gb: float
    :ivar max_concurrent_requests_per_container:
    :vartype max_concurrent_requests_per_container: int
    :ivar num_replicas:
    :vartype num_replicas: int
    :ivar event_hub_enabled:
    :vartype event_hub_enabled: bool
    :ivar storage_enabled:
    :vartype storage_enabled: bool
    :ivar app_insights_enabled:
    :vartype app_insights_enabled: bool
    :ivar auto_scale_enabled:
    :vartype auto_scale_enabled: bool
    :ivar min_replicas:
    :vartype min_replicas: int
    :ivar max_replicas:
    :vartype max_replicas: int
    :ivar target_utilization:
    :vartype target_utilization: int
    :ivar refresh_period_in_seconds:
    :vartype refresh_period_in_seconds: int
    :ivar scoring_uri:
    :vartype scoring_uri: str
    :ivar deployment_status:
    :vartype deployment_status: ~designer.models.AKSReplicaStatus
    :ivar scoring_timeout_ms:
    :vartype scoring_timeout_ms: int
    :ivar auth_enabled:
    :vartype auth_enabled: bool
    :ivar aad_auth_enabled:
    :vartype aad_auth_enabled: bool
    :ivar region:
    :vartype region: str
    :ivar primary_key:
    :vartype primary_key: str
    :ivar secondary_key:
    :vartype secondary_key: str
    :ivar swagger_uri:
    :vartype swagger_uri: str
    :ivar linked_pipeline_draft_id:
    :vartype linked_pipeline_draft_id: str
    :ivar linked_pipeline_run_id:
    :vartype linked_pipeline_run_id: str
    :ivar warning:
    :vartype warning: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar id:
    :vartype id: str
    :ivar created_time:
    :vartype created_time: ~datetime.datetime
    :ivar updated_time:
    :vartype updated_time: ~datetime.datetime
    :ivar compute_name:
    :vartype compute_name: str
    :ivar updated_by:
    :vartype updated_by: str
    """

    _attribute_map = {
        'created_by': {'key': 'createdBy', 'type': 'str'},
        'kv_tags': {'key': 'kvTags', 'type': '{str}'},
        'state': {'key': 'state', 'type': 'str'},
        'error': {'key': 'error', 'type': 'ModelManagementErrorResponse'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'image_id': {'key': 'imageId', 'type': 'str'},
        'cpu': {'key': 'cpu', 'type': 'float'},
        'memory_in_gb': {'key': 'memoryInGB', 'type': 'float'},
        'max_concurrent_requests_per_container': {'key': 'maxConcurrentRequestsPerContainer', 'type': 'int'},
        'num_replicas': {'key': 'numReplicas', 'type': 'int'},
        'event_hub_enabled': {'key': 'eventHubEnabled', 'type': 'bool'},
        'storage_enabled': {'key': 'storageEnabled', 'type': 'bool'},
        'app_insights_enabled': {'key': 'appInsightsEnabled', 'type': 'bool'},
        'auto_scale_enabled': {'key': 'autoScaleEnabled', 'type': 'bool'},
        'min_replicas': {'key': 'minReplicas', 'type': 'int'},
        'max_replicas': {'key': 'maxReplicas', 'type': 'int'},
        'target_utilization': {'key': 'targetUtilization', 'type': 'int'},
        'refresh_period_in_seconds': {'key': 'refreshPeriodInSeconds', 'type': 'int'},
        'scoring_uri': {'key': 'scoringUri', 'type': 'str'},
        'deployment_status': {'key': 'deploymentStatus', 'type': 'AKSReplicaStatus'},
        'scoring_timeout_ms': {'key': 'scoringTimeoutMs', 'type': 'int'},
        'auth_enabled': {'key': 'authEnabled', 'type': 'bool'},
        'aad_auth_enabled': {'key': 'aadAuthEnabled', 'type': 'bool'},
        'region': {'key': 'region', 'type': 'str'},
        'primary_key': {'key': 'primaryKey', 'type': 'str'},
        'secondary_key': {'key': 'secondaryKey', 'type': 'str'},
        'swagger_uri': {'key': 'swaggerUri', 'type': 'str'},
        'linked_pipeline_draft_id': {'key': 'linkedPipelineDraftId', 'type': 'str'},
        'linked_pipeline_run_id': {'key': 'linkedPipelineRunId', 'type': 'str'},
        'warning': {'key': 'warning', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'updated_time': {'key': 'updatedTime', 'type': 'iso-8601'},
        'compute_name': {'key': 'computeName', 'type': 'str'},
        'updated_by': {'key': 'updatedBy', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        created_by: Optional[str] = None,
        kv_tags: Optional[Dict[str, str]] = None,
        state: Optional[Union[str, "WebServiceState"]] = None,
        error: Optional["ModelManagementErrorResponse"] = None,
        compute_type: Optional[Union[str, "ComputeEnvironmentType"]] = None,
        image_id: Optional[str] = None,
        cpu: Optional[float] = None,
        memory_in_gb: Optional[float] = None,
        max_concurrent_requests_per_container: Optional[int] = None,
        num_replicas: Optional[int] = None,
        event_hub_enabled: Optional[bool] = None,
        storage_enabled: Optional[bool] = None,
        app_insights_enabled: Optional[bool] = None,
        auto_scale_enabled: Optional[bool] = None,
        min_replicas: Optional[int] = None,
        max_replicas: Optional[int] = None,
        target_utilization: Optional[int] = None,
        refresh_period_in_seconds: Optional[int] = None,
        scoring_uri: Optional[str] = None,
        deployment_status: Optional["AKSReplicaStatus"] = None,
        scoring_timeout_ms: Optional[int] = None,
        auth_enabled: Optional[bool] = None,
        aad_auth_enabled: Optional[bool] = None,
        region: Optional[str] = None,
        primary_key: Optional[str] = None,
        secondary_key: Optional[str] = None,
        swagger_uri: Optional[str] = None,
        linked_pipeline_draft_id: Optional[str] = None,
        linked_pipeline_run_id: Optional[str] = None,
        warning: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        id: Optional[str] = None,
        created_time: Optional[datetime.datetime] = None,
        updated_time: Optional[datetime.datetime] = None,
        compute_name: Optional[str] = None,
        updated_by: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword created_by:
        :paramtype created_by: str
        :keyword kv_tags: Dictionary of :code:`<string>`.
        :paramtype kv_tags: dict[str, str]
        :keyword state: Possible values include: "Transitioning", "Healthy", "Unhealthy", "Failed",
         "Unschedulable".
        :paramtype state: str or ~designer.models.WebServiceState
        :keyword error:
        :paramtype error: ~designer.models.ModelManagementErrorResponse
        :keyword compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT",
         "AKSENDPOINT", "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE",
         "UNKNOWN".
        :paramtype compute_type: str or ~designer.models.ComputeEnvironmentType
        :keyword image_id:
        :paramtype image_id: str
        :keyword cpu:
        :paramtype cpu: float
        :keyword memory_in_gb:
        :paramtype memory_in_gb: float
        :keyword max_concurrent_requests_per_container:
        :paramtype max_concurrent_requests_per_container: int
        :keyword num_replicas:
        :paramtype num_replicas: int
        :keyword event_hub_enabled:
        :paramtype event_hub_enabled: bool
        :keyword storage_enabled:
        :paramtype storage_enabled: bool
        :keyword app_insights_enabled:
        :paramtype app_insights_enabled: bool
        :keyword auto_scale_enabled:
        :paramtype auto_scale_enabled: bool
        :keyword min_replicas:
        :paramtype min_replicas: int
        :keyword max_replicas:
        :paramtype max_replicas: int
        :keyword target_utilization:
        :paramtype target_utilization: int
        :keyword refresh_period_in_seconds:
        :paramtype refresh_period_in_seconds: int
        :keyword scoring_uri:
        :paramtype scoring_uri: str
        :keyword deployment_status:
        :paramtype deployment_status: ~designer.models.AKSReplicaStatus
        :keyword scoring_timeout_ms:
        :paramtype scoring_timeout_ms: int
        :keyword auth_enabled:
        :paramtype auth_enabled: bool
        :keyword aad_auth_enabled:
        :paramtype aad_auth_enabled: bool
        :keyword region:
        :paramtype region: str
        :keyword primary_key:
        :paramtype primary_key: str
        :keyword secondary_key:
        :paramtype secondary_key: str
        :keyword swagger_uri:
        :paramtype swagger_uri: str
        :keyword linked_pipeline_draft_id:
        :paramtype linked_pipeline_draft_id: str
        :keyword linked_pipeline_run_id:
        :paramtype linked_pipeline_run_id: str
        :keyword warning:
        :paramtype warning: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword id:
        :paramtype id: str
        :keyword created_time:
        :paramtype created_time: ~datetime.datetime
        :keyword updated_time:
        :paramtype updated_time: ~datetime.datetime
        :keyword compute_name:
        :paramtype compute_name: str
        :keyword updated_by:
        :paramtype updated_by: str
        """
        super(RealTimeEndpoint, self).__init__(**kwargs)
        self.created_by = created_by
        self.kv_tags = kv_tags
        self.state = state
        self.error = error
        self.compute_type = compute_type
        self.image_id = image_id
        self.cpu = cpu
        self.memory_in_gb = memory_in_gb
        self.max_concurrent_requests_per_container = max_concurrent_requests_per_container
        self.num_replicas = num_replicas
        self.event_hub_enabled = event_hub_enabled
        self.storage_enabled = storage_enabled
        self.app_insights_enabled = app_insights_enabled
        self.auto_scale_enabled = auto_scale_enabled
        self.min_replicas = min_replicas
        self.max_replicas = max_replicas
        self.target_utilization = target_utilization
        self.refresh_period_in_seconds = refresh_period_in_seconds
        self.scoring_uri = scoring_uri
        self.deployment_status = deployment_status
        self.scoring_timeout_ms = scoring_timeout_ms
        self.auth_enabled = auth_enabled
        self.aad_auth_enabled = aad_auth_enabled
        self.region = region
        self.primary_key = primary_key
        self.secondary_key = secondary_key
        self.swagger_uri = swagger_uri
        self.linked_pipeline_draft_id = linked_pipeline_draft_id
        self.linked_pipeline_run_id = linked_pipeline_run_id
        self.warning = warning
        self.name = name
        self.description = description
        self.id = id
        self.created_time = created_time
        self.updated_time = updated_time
        self.compute_name = compute_name
        self.updated_by = updated_by


class RealTimeEndpointInfo(msrest.serialization.Model):
    """RealTimeEndpointInfo.

    :ivar web_service_inputs:
    :vartype web_service_inputs: list[~designer.models.WebServicePort]
    :ivar web_service_outputs:
    :vartype web_service_outputs: list[~designer.models.WebServicePort]
    :ivar deployments_info:
    :vartype deployments_info: list[~designer.models.DeploymentInfo]
    """

    _attribute_map = {
        'web_service_inputs': {'key': 'webServiceInputs', 'type': '[WebServicePort]'},
        'web_service_outputs': {'key': 'webServiceOutputs', 'type': '[WebServicePort]'},
        'deployments_info': {'key': 'deploymentsInfo', 'type': '[DeploymentInfo]'},
    }

    def __init__(
        self,
        *,
        web_service_inputs: Optional[List["WebServicePort"]] = None,
        web_service_outputs: Optional[List["WebServicePort"]] = None,
        deployments_info: Optional[List["DeploymentInfo"]] = None,
        **kwargs
    ):
        """
        :keyword web_service_inputs:
        :paramtype web_service_inputs: list[~designer.models.WebServicePort]
        :keyword web_service_outputs:
        :paramtype web_service_outputs: list[~designer.models.WebServicePort]
        :keyword deployments_info:
        :paramtype deployments_info: list[~designer.models.DeploymentInfo]
        """
        super(RealTimeEndpointInfo, self).__init__(**kwargs)
        self.web_service_inputs = web_service_inputs
        self.web_service_outputs = web_service_outputs
        self.deployments_info = deployments_info


class RealTimeEndpointStatus(msrest.serialization.Model):
    """RealTimeEndpointStatus.

    :ivar last_operation: Possible values include: "Create", "Update", "Delete".
    :vartype last_operation: str or ~designer.models.RealTimeEndpointOpCode
    :ivar last_operation_status: Possible values include: "Ongoing", "Succeeded", "Failed",
     "SucceededWithWarning".
    :vartype last_operation_status: str or ~designer.models.RealTimeEndpointOpStatusCode
    :ivar internal_step: Possible values include: "AboutToDeploy", "WaitAksComputeReady",
     "RegisterModels", "CreateServiceFromModels", "UpdateServiceFromModels", "WaitServiceCreating",
     "FetchServiceRelatedInfo", "TestWithSampleData", "AboutToDelete", "DeleteDeployment",
     "DeleteAsset", "DeleteImage", "DeleteModel", "DeleteServiceRecord".
    :vartype internal_step: str or ~designer.models.RealTimeEndpointInternalStepCode
    :ivar status_detail:
    :vartype status_detail: str
    :ivar deployment_state:
    :vartype deployment_state: str
    :ivar service_id:
    :vartype service_id: str
    :ivar linked_pipeline_draft_id:
    :vartype linked_pipeline_draft_id: str
    """

    _attribute_map = {
        'last_operation': {'key': 'lastOperation', 'type': 'str'},
        'last_operation_status': {'key': 'lastOperationStatus', 'type': 'str'},
        'internal_step': {'key': 'internalStep', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'deployment_state': {'key': 'deploymentState', 'type': 'str'},
        'service_id': {'key': 'serviceId', 'type': 'str'},
        'linked_pipeline_draft_id': {'key': 'linkedPipelineDraftId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        last_operation: Optional[Union[str, "RealTimeEndpointOpCode"]] = None,
        last_operation_status: Optional[Union[str, "RealTimeEndpointOpStatusCode"]] = None,
        internal_step: Optional[Union[str, "RealTimeEndpointInternalStepCode"]] = None,
        status_detail: Optional[str] = None,
        deployment_state: Optional[str] = None,
        service_id: Optional[str] = None,
        linked_pipeline_draft_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword last_operation: Possible values include: "Create", "Update", "Delete".
        :paramtype last_operation: str or ~designer.models.RealTimeEndpointOpCode
        :keyword last_operation_status: Possible values include: "Ongoing", "Succeeded", "Failed",
         "SucceededWithWarning".
        :paramtype last_operation_status: str or ~designer.models.RealTimeEndpointOpStatusCode
        :keyword internal_step: Possible values include: "AboutToDeploy", "WaitAksComputeReady",
         "RegisterModels", "CreateServiceFromModels", "UpdateServiceFromModels", "WaitServiceCreating",
         "FetchServiceRelatedInfo", "TestWithSampleData", "AboutToDelete", "DeleteDeployment",
         "DeleteAsset", "DeleteImage", "DeleteModel", "DeleteServiceRecord".
        :paramtype internal_step: str or ~designer.models.RealTimeEndpointInternalStepCode
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword deployment_state:
        :paramtype deployment_state: str
        :keyword service_id:
        :paramtype service_id: str
        :keyword linked_pipeline_draft_id:
        :paramtype linked_pipeline_draft_id: str
        """
        super(RealTimeEndpointStatus, self).__init__(**kwargs)
        self.last_operation = last_operation
        self.last_operation_status = last_operation_status
        self.internal_step = internal_step
        self.status_detail = status_detail
        self.deployment_state = deployment_state
        self.service_id = service_id
        self.linked_pipeline_draft_id = linked_pipeline_draft_id


class RealTimeEndpointSummary(msrest.serialization.Model):
    """RealTimeEndpointSummary.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar id:
    :vartype id: str
    :ivar created_time:
    :vartype created_time: ~datetime.datetime
    :ivar updated_time:
    :vartype updated_time: ~datetime.datetime
    :ivar compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT", "AKSENDPOINT",
     "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE", "UNKNOWN".
    :vartype compute_type: str or ~designer.models.ComputeEnvironmentType
    :ivar compute_name:
    :vartype compute_name: str
    :ivar updated_by:
    :vartype updated_by: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'updated_time': {'key': 'updatedTime', 'type': 'iso-8601'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
        'compute_name': {'key': 'computeName', 'type': 'str'},
        'updated_by': {'key': 'updatedBy', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        id: Optional[str] = None,
        created_time: Optional[datetime.datetime] = None,
        updated_time: Optional[datetime.datetime] = None,
        compute_type: Optional[Union[str, "ComputeEnvironmentType"]] = None,
        compute_name: Optional[str] = None,
        updated_by: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword id:
        :paramtype id: str
        :keyword created_time:
        :paramtype created_time: ~datetime.datetime
        :keyword updated_time:
        :paramtype updated_time: ~datetime.datetime
        :keyword compute_type: Possible values include: "ACI", "AKS", "AMLCOMPUTE", "IOT",
         "AKSENDPOINT", "MIRSINGLEMODEL", "MIRAMLCOMPUTE", "MIRGA", "AMLARC", "BATCHAMLCOMPUTE",
         "UNKNOWN".
        :paramtype compute_type: str or ~designer.models.ComputeEnvironmentType
        :keyword compute_name:
        :paramtype compute_name: str
        :keyword updated_by:
        :paramtype updated_by: str
        """
        super(RealTimeEndpointSummary, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.id = id
        self.created_time = created_time
        self.updated_time = updated_time
        self.compute_type = compute_type
        self.compute_name = compute_name
        self.updated_by = updated_by


class RealTimeEndpointTestRequest(msrest.serialization.Model):
    """RealTimeEndpointTestRequest.

    :ivar end_point:
    :vartype end_point: str
    :ivar auth_key:
    :vartype auth_key: str
    :ivar payload:
    :vartype payload: str
    """

    _attribute_map = {
        'end_point': {'key': 'endPoint', 'type': 'str'},
        'auth_key': {'key': 'authKey', 'type': 'str'},
        'payload': {'key': 'payload', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        end_point: Optional[str] = None,
        auth_key: Optional[str] = None,
        payload: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword end_point:
        :paramtype end_point: str
        :keyword auth_key:
        :paramtype auth_key: str
        :keyword payload:
        :paramtype payload: str
        """
        super(RealTimeEndpointTestRequest, self).__init__(**kwargs)
        self.end_point = end_point
        self.auth_key = auth_key
        self.payload = payload


class RegenerateServiceKeysRequest(msrest.serialization.Model):
    """RegenerateServiceKeysRequest.

    :ivar key_type: Possible values include: "Primary", "Secondary".
    :vartype key_type: str or ~designer.models.KeyType
    :ivar key_value:
    :vartype key_value: str
    """

    _attribute_map = {
        'key_type': {'key': 'keyType', 'type': 'str'},
        'key_value': {'key': 'keyValue', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        key_type: Optional[Union[str, "KeyType"]] = None,
        key_value: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword key_type: Possible values include: "Primary", "Secondary".
        :paramtype key_type: str or ~designer.models.KeyType
        :keyword key_value:
        :paramtype key_value: str
        """
        super(RegenerateServiceKeysRequest, self).__init__(**kwargs)
        self.key_type = key_type
        self.key_value = key_value


class RegisteredDataSetReference(msrest.serialization.Model):
    """RegisteredDataSetReference.

    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        name: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword version:
        :paramtype version: str
        """
        super(RegisteredDataSetReference, self).__init__(**kwargs)
        self.id = id
        self.name = name
        self.version = version


class RegisterModuleMetaInfo(msrest.serialization.Model):
    """RegisterModuleMetaInfo.

    :ivar namespace:
    :vartype namespace: str
    :ivar module_name:
    :vartype module_name: str
    :ivar module_version:
    :vartype module_version: str
    :ivar module_entity_from_yaml:
    :vartype module_entity_from_yaml: ~designer.models.ModuleEntity
    :ivar set_as_default_version:
    :vartype set_as_default_version: bool
    :ivar family_id:
    :vartype family_id: str
    :ivar generate_graph_request:
    :vartype generate_graph_request: ~designer.models.GeneratePipelineComponentRequest
    :ivar graph_hash:
    :vartype graph_hash: str
    :ivar create_snapshot_dto:
    :vartype create_snapshot_dto: ~designer.models.CreateSnapshotDto
    :ivar root_blob_uri:
    :vartype root_blob_uri: str
    """

    _attribute_map = {
        'namespace': {'key': 'namespace', 'type': 'str'},
        'module_name': {'key': 'moduleName', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
        'module_entity_from_yaml': {'key': 'moduleEntityFromYaml', 'type': 'ModuleEntity'},
        'set_as_default_version': {'key': 'setAsDefaultVersion', 'type': 'bool'},
        'family_id': {'key': 'familyId', 'type': 'str'},
        'generate_graph_request': {'key': 'generateGraphRequest', 'type': 'GeneratePipelineComponentRequest'},
        'graph_hash': {'key': 'graphHash', 'type': 'str'},
        'create_snapshot_dto': {'key': 'createSnapshotDto', 'type': 'CreateSnapshotDto'},
        'root_blob_uri': {'key': 'rootBlobUri', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        namespace: Optional[str] = None,
        module_name: Optional[str] = None,
        module_version: Optional[str] = None,
        module_entity_from_yaml: Optional["ModuleEntity"] = None,
        set_as_default_version: Optional[bool] = None,
        family_id: Optional[str] = None,
        generate_graph_request: Optional["GeneratePipelineComponentRequest"] = None,
        graph_hash: Optional[str] = None,
        create_snapshot_dto: Optional["CreateSnapshotDto"] = None,
        root_blob_uri: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword namespace:
        :paramtype namespace: str
        :keyword module_name:
        :paramtype module_name: str
        :keyword module_version:
        :paramtype module_version: str
        :keyword module_entity_from_yaml:
        :paramtype module_entity_from_yaml: ~designer.models.ModuleEntity
        :keyword set_as_default_version:
        :paramtype set_as_default_version: bool
        :keyword family_id:
        :paramtype family_id: str
        :keyword generate_graph_request:
        :paramtype generate_graph_request: ~designer.models.GeneratePipelineComponentRequest
        :keyword graph_hash:
        :paramtype graph_hash: str
        :keyword create_snapshot_dto:
        :paramtype create_snapshot_dto: ~designer.models.CreateSnapshotDto
        :keyword root_blob_uri:
        :paramtype root_blob_uri: str
        """
        super(RegisterModuleMetaInfo, self).__init__(**kwargs)
        self.namespace = namespace
        self.module_name = module_name
        self.module_version = module_version
        self.module_entity_from_yaml = module_entity_from_yaml
        self.set_as_default_version = set_as_default_version
        self.family_id = family_id
        self.generate_graph_request = generate_graph_request
        self.graph_hash = graph_hash
        self.create_snapshot_dto = create_snapshot_dto
        self.root_blob_uri = root_blob_uri


class RegistrationOptions(msrest.serialization.Model):
    """RegistrationOptions.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar properties: Dictionary of :code:`<string>`.
    :vartype properties: dict[str, str]
    :ivar dataset_registration_options:
    :vartype dataset_registration_options: ~designer.models.DatasetRegistrationOptions
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'dataset_registration_options': {'key': 'datasetRegistrationOptions', 'type': 'DatasetRegistrationOptions'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        properties: Optional[Dict[str, str]] = None,
        dataset_registration_options: Optional["DatasetRegistrationOptions"] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword properties: Dictionary of :code:`<string>`.
        :paramtype properties: dict[str, str]
        :keyword dataset_registration_options:
        :paramtype dataset_registration_options: ~designer.models.DatasetRegistrationOptions
        """
        super(RegistrationOptions, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.tags = tags
        self.properties = properties
        self.dataset_registration_options = dataset_registration_options


class RegistryIdentity(msrest.serialization.Model):
    """RegistryIdentity.

    :ivar resource_id:
    :vartype resource_id: str
    :ivar client_id:
    :vartype client_id: str
    """

    _attribute_map = {
        'resource_id': {'key': 'resourceId', 'type': 'str'},
        'client_id': {'key': 'clientId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        resource_id: Optional[str] = None,
        client_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword resource_id:
        :paramtype resource_id: str
        :keyword client_id:
        :paramtype client_id: str
        """
        super(RegistryIdentity, self).__init__(**kwargs)
        self.resource_id = resource_id
        self.client_id = client_id


class Relationship(msrest.serialization.Model):
    """Relationship.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar relation_type:
    :vartype relation_type: str
    :ivar target_entity_id:
    :vartype target_entity_id: str
    :ivar asset_id:
    :vartype asset_id: str
    :ivar entity_type:
    :vartype entity_type: str
    :ivar direction:
    :vartype direction: str
    :ivar entity_container_id:
    :vartype entity_container_id: str
    """

    _validation = {
        'entity_type': {'readonly': True},
        'entity_container_id': {'readonly': True},
    }

    _attribute_map = {
        'relation_type': {'key': 'relationType', 'type': 'str'},
        'target_entity_id': {'key': 'targetEntityId', 'type': 'str'},
        'asset_id': {'key': 'assetId', 'type': 'str'},
        'entity_type': {'key': 'entityType', 'type': 'str'},
        'direction': {'key': 'direction', 'type': 'str'},
        'entity_container_id': {'key': 'entityContainerId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        relation_type: Optional[str] = None,
        target_entity_id: Optional[str] = None,
        asset_id: Optional[str] = None,
        direction: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword relation_type:
        :paramtype relation_type: str
        :keyword target_entity_id:
        :paramtype target_entity_id: str
        :keyword asset_id:
        :paramtype asset_id: str
        :keyword direction:
        :paramtype direction: str
        """
        super(Relationship, self).__init__(**kwargs)
        self.relation_type = relation_type
        self.target_entity_id = target_entity_id
        self.asset_id = asset_id
        self.entity_type = None
        self.direction = direction
        self.entity_container_id = None


class RemoteDockerComputeInfo(msrest.serialization.Model):
    """RemoteDockerComputeInfo.

    :ivar address:
    :vartype address: str
    :ivar username:
    :vartype username: str
    :ivar password:
    :vartype password: str
    :ivar private_key:
    :vartype private_key: str
    """

    _attribute_map = {
        'address': {'key': 'address', 'type': 'str'},
        'username': {'key': 'username', 'type': 'str'},
        'password': {'key': 'password', 'type': 'str'},
        'private_key': {'key': 'privateKey', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        address: Optional[str] = None,
        username: Optional[str] = None,
        password: Optional[str] = None,
        private_key: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword address:
        :paramtype address: str
        :keyword username:
        :paramtype username: str
        :keyword password:
        :paramtype password: str
        :keyword private_key:
        :paramtype private_key: str
        """
        super(RemoteDockerComputeInfo, self).__init__(**kwargs)
        self.address = address
        self.username = username
        self.password = password
        self.private_key = private_key


class ResourceConfiguration(msrest.serialization.Model):
    """ResourceConfiguration.

    :ivar gpu_count:
    :vartype gpu_count: int
    :ivar cpu_count:
    :vartype cpu_count: int
    :ivar memory_request_in_gb:
    :vartype memory_request_in_gb: int
    """

    _attribute_map = {
        'gpu_count': {'key': 'gpuCount', 'type': 'int'},
        'cpu_count': {'key': 'cpuCount', 'type': 'int'},
        'memory_request_in_gb': {'key': 'memoryRequestInGB', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        gpu_count: Optional[int] = None,
        cpu_count: Optional[int] = None,
        memory_request_in_gb: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword gpu_count:
        :paramtype gpu_count: int
        :keyword cpu_count:
        :paramtype cpu_count: int
        :keyword memory_request_in_gb:
        :paramtype memory_request_in_gb: int
        """
        super(ResourceConfiguration, self).__init__(**kwargs)
        self.gpu_count = gpu_count
        self.cpu_count = cpu_count
        self.memory_request_in_gb = memory_request_in_gb


class RetryConfiguration(msrest.serialization.Model):
    """RetryConfiguration.

    :ivar max_retry_count:
    :vartype max_retry_count: int
    """

    _attribute_map = {
        'max_retry_count': {'key': 'maxRetryCount', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        max_retry_count: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword max_retry_count:
        :paramtype max_retry_count: int
        """
        super(RetryConfiguration, self).__init__(**kwargs)
        self.max_retry_count = max_retry_count


class RGitHubPackage(msrest.serialization.Model):
    """RGitHubPackage.

    :ivar repository:
    :vartype repository: str
    :ivar auth_token:
    :vartype auth_token: str
    """

    _attribute_map = {
        'repository': {'key': 'repository', 'type': 'str'},
        'auth_token': {'key': 'authToken', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        repository: Optional[str] = None,
        auth_token: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword repository:
        :paramtype repository: str
        :keyword auth_token:
        :paramtype auth_token: str
        """
        super(RGitHubPackage, self).__init__(**kwargs)
        self.repository = repository
        self.auth_token = auth_token


class RootError(msrest.serialization.Model):
    """The root error.

    :ivar code: The service-defined error code. Supported error codes: ServiceError, UserError,
     ValidationError, AzureStorageError, TransientError, RequestThrottled.
    :vartype code: str
    :ivar severity: The Severity of error.
    :vartype severity: int
    :ivar message: A human-readable representation of the error.
    :vartype message: str
    :ivar message_format: An unformatted version of the message with no variable substitution.
    :vartype message_format: str
    :ivar message_parameters: Value substitutions corresponding to the contents of MessageFormat.
    :vartype message_parameters: dict[str, str]
    :ivar reference_code: This code can optionally be set by the system generating the error.
     It should be used to classify the problem and identify the module and code area where the
     failure occured.
    :vartype reference_code: str
    :ivar details_uri: A URI which points to more details about the context of the error.
    :vartype details_uri: str
    :ivar target: The target of the error (e.g., the name of the property in error).
    :vartype target: str
    :ivar details: The related errors that occurred during the request.
    :vartype details: list[~designer.models.RootError]
    :ivar inner_error: A nested structure of errors.
    :vartype inner_error: ~designer.models.InnerErrorResponse
    :ivar additional_info: The error additional info.
    :vartype additional_info: list[~designer.models.ErrorAdditionalInfo]
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'severity': {'key': 'severity', 'type': 'int'},
        'message': {'key': 'message', 'type': 'str'},
        'message_format': {'key': 'messageFormat', 'type': 'str'},
        'message_parameters': {'key': 'messageParameters', 'type': '{str}'},
        'reference_code': {'key': 'referenceCode', 'type': 'str'},
        'details_uri': {'key': 'detailsUri', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'details': {'key': 'details', 'type': '[RootError]'},
        'inner_error': {'key': 'innerError', 'type': 'InnerErrorResponse'},
        'additional_info': {'key': 'additionalInfo', 'type': '[ErrorAdditionalInfo]'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        severity: Optional[int] = None,
        message: Optional[str] = None,
        message_format: Optional[str] = None,
        message_parameters: Optional[Dict[str, str]] = None,
        reference_code: Optional[str] = None,
        details_uri: Optional[str] = None,
        target: Optional[str] = None,
        details: Optional[List["RootError"]] = None,
        inner_error: Optional["InnerErrorResponse"] = None,
        additional_info: Optional[List["ErrorAdditionalInfo"]] = None,
        **kwargs
    ):
        """
        :keyword code: The service-defined error code. Supported error codes: ServiceError, UserError,
         ValidationError, AzureStorageError, TransientError, RequestThrottled.
        :paramtype code: str
        :keyword severity: The Severity of error.
        :paramtype severity: int
        :keyword message: A human-readable representation of the error.
        :paramtype message: str
        :keyword message_format: An unformatted version of the message with no variable substitution.
        :paramtype message_format: str
        :keyword message_parameters: Value substitutions corresponding to the contents of
         MessageFormat.
        :paramtype message_parameters: dict[str, str]
        :keyword reference_code: This code can optionally be set by the system generating the error.
         It should be used to classify the problem and identify the module and code area where the
         failure occured.
        :paramtype reference_code: str
        :keyword details_uri: A URI which points to more details about the context of the error.
        :paramtype details_uri: str
        :keyword target: The target of the error (e.g., the name of the property in error).
        :paramtype target: str
        :keyword details: The related errors that occurred during the request.
        :paramtype details: list[~designer.models.RootError]
        :keyword inner_error: A nested structure of errors.
        :paramtype inner_error: ~designer.models.InnerErrorResponse
        :keyword additional_info: The error additional info.
        :paramtype additional_info: list[~designer.models.ErrorAdditionalInfo]
        """
        super(RootError, self).__init__(**kwargs)
        self.code = code
        self.severity = severity
        self.message = message
        self.message_format = message_format
        self.message_parameters = message_parameters
        self.reference_code = reference_code
        self.details_uri = details_uri
        self.target = target
        self.details = details
        self.inner_error = inner_error
        self.additional_info = additional_info


class RSection(msrest.serialization.Model):
    """RSection.

    :ivar r_version:
    :vartype r_version: str
    :ivar user_managed:
    :vartype user_managed: bool
    :ivar rscript_path:
    :vartype rscript_path: str
    :ivar snapshot_date:
    :vartype snapshot_date: str
    :ivar cran_packages:
    :vartype cran_packages: list[~designer.models.RCranPackage]
    :ivar git_hub_packages:
    :vartype git_hub_packages: list[~designer.models.RGitHubPackage]
    :ivar custom_url_packages:
    :vartype custom_url_packages: list[str]
    :ivar bio_conductor_packages:
    :vartype bio_conductor_packages: list[str]
    """

    _attribute_map = {
        'r_version': {'key': 'rVersion', 'type': 'str'},
        'user_managed': {'key': 'userManaged', 'type': 'bool'},
        'rscript_path': {'key': 'rscriptPath', 'type': 'str'},
        'snapshot_date': {'key': 'snapshotDate', 'type': 'str'},
        'cran_packages': {'key': 'cranPackages', 'type': '[RCranPackage]'},
        'git_hub_packages': {'key': 'gitHubPackages', 'type': '[RGitHubPackage]'},
        'custom_url_packages': {'key': 'customUrlPackages', 'type': '[str]'},
        'bio_conductor_packages': {'key': 'bioConductorPackages', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        r_version: Optional[str] = None,
        user_managed: Optional[bool] = None,
        rscript_path: Optional[str] = None,
        snapshot_date: Optional[str] = None,
        cran_packages: Optional[List["RCranPackage"]] = None,
        git_hub_packages: Optional[List["RGitHubPackage"]] = None,
        custom_url_packages: Optional[List[str]] = None,
        bio_conductor_packages: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword r_version:
        :paramtype r_version: str
        :keyword user_managed:
        :paramtype user_managed: bool
        :keyword rscript_path:
        :paramtype rscript_path: str
        :keyword snapshot_date:
        :paramtype snapshot_date: str
        :keyword cran_packages:
        :paramtype cran_packages: list[~designer.models.RCranPackage]
        :keyword git_hub_packages:
        :paramtype git_hub_packages: list[~designer.models.RGitHubPackage]
        :keyword custom_url_packages:
        :paramtype custom_url_packages: list[str]
        :keyword bio_conductor_packages:
        :paramtype bio_conductor_packages: list[str]
        """
        super(RSection, self).__init__(**kwargs)
        self.r_version = r_version
        self.user_managed = user_managed
        self.rscript_path = rscript_path
        self.snapshot_date = snapshot_date
        self.cran_packages = cran_packages
        self.git_hub_packages = git_hub_packages
        self.custom_url_packages = custom_url_packages
        self.bio_conductor_packages = bio_conductor_packages


class RunAnnotations(msrest.serialization.Model):
    """RunAnnotations.

    :ivar display_name:
    :vartype display_name: str
    :ivar status:
    :vartype status: str
    :ivar primary_metric_name:
    :vartype primary_metric_name: str
    :ivar estimated_cost:
    :vartype estimated_cost: float
    :ivar primary_metric_summary:
    :vartype primary_metric_summary: ~designer.models.RunIndexMetricSummary
    :ivar metrics: Dictionary of :code:`<RunIndexMetricSummarySystemObject>`.
    :vartype metrics: dict[str, ~designer.models.RunIndexMetricSummarySystemObject]
    :ivar parameters: Dictionary of :code:`<any>`.
    :vartype parameters: dict[str, any]
    :ivar settings: Dictionary of :code:`<string>`.
    :vartype settings: dict[str, str]
    :ivar modified_time:
    :vartype modified_time: ~datetime.datetime
    :ivar retain_for_lifetime_of_workspace:
    :vartype retain_for_lifetime_of_workspace: bool
    :ivar error:
    :vartype error: ~designer.models.IndexedErrorResponse
    :ivar resource_metric_summary:
    :vartype resource_metric_summary: ~designer.models.RunIndexResourceMetricSummary
    :ivar job_cost:
    :vartype job_cost: ~designer.models.JobCost
    :ivar compute_duration:
    :vartype compute_duration: str
    :ivar compute_duration_milliseconds:
    :vartype compute_duration_milliseconds: float
    :ivar effective_start_time_utc:
    :vartype effective_start_time_utc: ~datetime.datetime
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar archived:
    :vartype archived: bool
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    """

    _attribute_map = {
        'display_name': {'key': 'displayName', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'primary_metric_name': {'key': 'primaryMetricName', 'type': 'str'},
        'estimated_cost': {'key': 'estimatedCost', 'type': 'float'},
        'primary_metric_summary': {'key': 'primaryMetricSummary', 'type': 'RunIndexMetricSummary'},
        'metrics': {'key': 'metrics', 'type': '{RunIndexMetricSummarySystemObject}'},
        'parameters': {'key': 'parameters', 'type': '{object}'},
        'settings': {'key': 'settings', 'type': '{str}'},
        'modified_time': {'key': 'modifiedTime', 'type': 'iso-8601'},
        'retain_for_lifetime_of_workspace': {'key': 'retainForLifetimeOfWorkspace', 'type': 'bool'},
        'error': {'key': 'error', 'type': 'IndexedErrorResponse'},
        'resource_metric_summary': {'key': 'resourceMetricSummary', 'type': 'RunIndexResourceMetricSummary'},
        'job_cost': {'key': 'jobCost', 'type': 'JobCost'},
        'compute_duration': {'key': 'computeDuration', 'type': 'str'},
        'compute_duration_milliseconds': {'key': 'computeDurationMilliseconds', 'type': 'float'},
        'effective_start_time_utc': {'key': 'effectiveStartTimeUtc', 'type': 'iso-8601'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'archived': {'key': 'archived', 'type': 'bool'},
        'tags': {'key': 'tags', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        display_name: Optional[str] = None,
        status: Optional[str] = None,
        primary_metric_name: Optional[str] = None,
        estimated_cost: Optional[float] = None,
        primary_metric_summary: Optional["RunIndexMetricSummary"] = None,
        metrics: Optional[Dict[str, "RunIndexMetricSummarySystemObject"]] = None,
        parameters: Optional[Dict[str, Any]] = None,
        settings: Optional[Dict[str, str]] = None,
        modified_time: Optional[datetime.datetime] = None,
        retain_for_lifetime_of_workspace: Optional[bool] = None,
        error: Optional["IndexedErrorResponse"] = None,
        resource_metric_summary: Optional["RunIndexResourceMetricSummary"] = None,
        job_cost: Optional["JobCost"] = None,
        compute_duration: Optional[str] = None,
        compute_duration_milliseconds: Optional[float] = None,
        effective_start_time_utc: Optional[datetime.datetime] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        archived: Optional[bool] = None,
        tags: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword display_name:
        :paramtype display_name: str
        :keyword status:
        :paramtype status: str
        :keyword primary_metric_name:
        :paramtype primary_metric_name: str
        :keyword estimated_cost:
        :paramtype estimated_cost: float
        :keyword primary_metric_summary:
        :paramtype primary_metric_summary: ~designer.models.RunIndexMetricSummary
        :keyword metrics: Dictionary of :code:`<RunIndexMetricSummarySystemObject>`.
        :paramtype metrics: dict[str, ~designer.models.RunIndexMetricSummarySystemObject]
        :keyword parameters: Dictionary of :code:`<any>`.
        :paramtype parameters: dict[str, any]
        :keyword settings: Dictionary of :code:`<string>`.
        :paramtype settings: dict[str, str]
        :keyword modified_time:
        :paramtype modified_time: ~datetime.datetime
        :keyword retain_for_lifetime_of_workspace:
        :paramtype retain_for_lifetime_of_workspace: bool
        :keyword error:
        :paramtype error: ~designer.models.IndexedErrorResponse
        :keyword resource_metric_summary:
        :paramtype resource_metric_summary: ~designer.models.RunIndexResourceMetricSummary
        :keyword job_cost:
        :paramtype job_cost: ~designer.models.JobCost
        :keyword compute_duration:
        :paramtype compute_duration: str
        :keyword compute_duration_milliseconds:
        :paramtype compute_duration_milliseconds: float
        :keyword effective_start_time_utc:
        :paramtype effective_start_time_utc: ~datetime.datetime
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword archived:
        :paramtype archived: bool
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        """
        super(RunAnnotations, self).__init__(**kwargs)
        self.display_name = display_name
        self.status = status
        self.primary_metric_name = primary_metric_name
        self.estimated_cost = estimated_cost
        self.primary_metric_summary = primary_metric_summary
        self.metrics = metrics
        self.parameters = parameters
        self.settings = settings
        self.modified_time = modified_time
        self.retain_for_lifetime_of_workspace = retain_for_lifetime_of_workspace
        self.error = error
        self.resource_metric_summary = resource_metric_summary
        self.job_cost = job_cost
        self.compute_duration = compute_duration
        self.compute_duration_milliseconds = compute_duration_milliseconds
        self.effective_start_time_utc = effective_start_time_utc
        self.name = name
        self.description = description
        self.archived = archived
        self.tags = tags


class RunConfiguration(msrest.serialization.Model):
    """RunConfiguration.

    :ivar script:
    :vartype script: str
    :ivar command:
    :vartype command: str
    :ivar use_absolute_path:
    :vartype use_absolute_path: bool
    :ivar arguments:
    :vartype arguments: list[str]
    :ivar framework: Possible values include: "Python", "PySpark", "Cntk", "TensorFlow", "PyTorch",
     "PySparkInteractive", "R".
    :vartype framework: str or ~designer.models.Framework
    :ivar communicator: Possible values include: "None", "ParameterServer", "Gloo", "Mpi", "Nccl",
     "ParallelTask".
    :vartype communicator: str or ~designer.models.Communicator
    :ivar target:
    :vartype target: str
    :ivar auto_cluster_compute_specification:
    :vartype auto_cluster_compute_specification: ~designer.models.AutoClusterComputeSpecification
    :ivar data_references: Dictionary of :code:`<DataReferenceConfiguration>`.
    :vartype data_references: dict[str, ~designer.models.DataReferenceConfiguration]
    :ivar data: Dictionary of :code:`<Data>`.
    :vartype data: dict[str, ~designer.models.Data]
    :ivar input_assets: Dictionary of :code:`<InputAsset>`.
    :vartype input_assets: dict[str, ~designer.models.InputAsset]
    :ivar output_data: Dictionary of :code:`<OutputData>`.
    :vartype output_data: dict[str, ~designer.models.OutputData]
    :ivar datacaches:
    :vartype datacaches: list[~designer.models.DatacacheConfiguration]
    :ivar job_name:
    :vartype job_name: str
    :ivar max_run_duration_seconds:
    :vartype max_run_duration_seconds: long
    :ivar node_count:
    :vartype node_count: int
    :ivar instance_types:
    :vartype instance_types: list[str]
    :ivar priority:
    :vartype priority: int
    :ivar credential_passthrough:
    :vartype credential_passthrough: bool
    :ivar identity:
    :vartype identity: ~designer.models.IdentityConfiguration
    :ivar environment:
    :vartype environment: ~designer.models.EnvironmentDefinition
    :ivar history:
    :vartype history: ~designer.models.HistoryConfiguration
    :ivar spark:
    :vartype spark: ~designer.models.SparkConfiguration
    :ivar parallel_task:
    :vartype parallel_task: ~designer.models.ParallelTaskConfiguration
    :ivar ai_super_computer:
    :vartype ai_super_computer: ~designer.models.AISuperComputerConfiguration
    :ivar tensorflow:
    :vartype tensorflow: ~designer.models.TensorflowConfiguration
    :ivar mpi:
    :vartype mpi: ~designer.models.MpiConfiguration
    :ivar py_torch:
    :vartype py_torch: ~designer.models.PyTorchConfiguration
    :ivar hdi:
    :vartype hdi: ~designer.models.HdiConfiguration
    :ivar docker:
    :vartype docker: ~designer.models.DockerConfiguration
    :ivar command_return_code_config:
    :vartype command_return_code_config: ~designer.models.CommandReturnCodeConfig
    :ivar environment_variables: Dictionary of :code:`<string>`.
    :vartype environment_variables: dict[str, str]
    :ivar application_endpoints: Dictionary of :code:`<ApplicationEndpointConfiguration>`.
    :vartype application_endpoints: dict[str, ~designer.models.ApplicationEndpointConfiguration]
    :ivar parameters:
    :vartype parameters: list[~designer.models.ParameterDefinition]
    :ivar data_bricks:
    :vartype data_bricks: ~designer.models.DatabricksConfiguration
    """

    _attribute_map = {
        'script': {'key': 'script', 'type': 'str'},
        'command': {'key': 'command', 'type': 'str'},
        'use_absolute_path': {'key': 'useAbsolutePath', 'type': 'bool'},
        'arguments': {'key': 'arguments', 'type': '[str]'},
        'framework': {'key': 'framework', 'type': 'str'},
        'communicator': {'key': 'communicator', 'type': 'str'},
        'target': {'key': 'target', 'type': 'str'},
        'auto_cluster_compute_specification': {'key': 'autoClusterComputeSpecification', 'type': 'AutoClusterComputeSpecification'},
        'data_references': {'key': 'dataReferences', 'type': '{DataReferenceConfiguration}'},
        'data': {'key': 'data', 'type': '{Data}'},
        'input_assets': {'key': 'inputAssets', 'type': '{InputAsset}'},
        'output_data': {'key': 'outputData', 'type': '{OutputData}'},
        'datacaches': {'key': 'datacaches', 'type': '[DatacacheConfiguration]'},
        'job_name': {'key': 'jobName', 'type': 'str'},
        'max_run_duration_seconds': {'key': 'maxRunDurationSeconds', 'type': 'long'},
        'node_count': {'key': 'nodeCount', 'type': 'int'},
        'instance_types': {'key': 'instanceTypes', 'type': '[str]'},
        'priority': {'key': 'priority', 'type': 'int'},
        'credential_passthrough': {'key': 'credentialPassthrough', 'type': 'bool'},
        'identity': {'key': 'identity', 'type': 'IdentityConfiguration'},
        'environment': {'key': 'environment', 'type': 'EnvironmentDefinition'},
        'history': {'key': 'history', 'type': 'HistoryConfiguration'},
        'spark': {'key': 'spark', 'type': 'SparkConfiguration'},
        'parallel_task': {'key': 'parallelTask', 'type': 'ParallelTaskConfiguration'},
        'ai_super_computer': {'key': 'aiSuperComputer', 'type': 'AISuperComputerConfiguration'},
        'tensorflow': {'key': 'tensorflow', 'type': 'TensorflowConfiguration'},
        'mpi': {'key': 'mpi', 'type': 'MpiConfiguration'},
        'py_torch': {'key': 'pyTorch', 'type': 'PyTorchConfiguration'},
        'hdi': {'key': 'hdi', 'type': 'HdiConfiguration'},
        'docker': {'key': 'docker', 'type': 'DockerConfiguration'},
        'command_return_code_config': {'key': 'commandReturnCodeConfig', 'type': 'CommandReturnCodeConfig'},
        'environment_variables': {'key': 'environmentVariables', 'type': '{str}'},
        'application_endpoints': {'key': 'applicationEndpoints', 'type': '{ApplicationEndpointConfiguration}'},
        'parameters': {'key': 'parameters', 'type': '[ParameterDefinition]'},
        'data_bricks': {'key': 'dataBricks', 'type': 'DatabricksConfiguration'},
    }

    def __init__(
        self,
        *,
        script: Optional[str] = None,
        command: Optional[str] = None,
        use_absolute_path: Optional[bool] = None,
        arguments: Optional[List[str]] = None,
        framework: Optional[Union[str, "Framework"]] = None,
        communicator: Optional[Union[str, "Communicator"]] = None,
        target: Optional[str] = None,
        auto_cluster_compute_specification: Optional["AutoClusterComputeSpecification"] = None,
        data_references: Optional[Dict[str, "DataReferenceConfiguration"]] = None,
        data: Optional[Dict[str, "Data"]] = None,
        input_assets: Optional[Dict[str, "InputAsset"]] = None,
        output_data: Optional[Dict[str, "OutputData"]] = None,
        datacaches: Optional[List["DatacacheConfiguration"]] = None,
        job_name: Optional[str] = None,
        max_run_duration_seconds: Optional[int] = None,
        node_count: Optional[int] = None,
        instance_types: Optional[List[str]] = None,
        priority: Optional[int] = None,
        credential_passthrough: Optional[bool] = None,
        identity: Optional["IdentityConfiguration"] = None,
        environment: Optional["EnvironmentDefinition"] = None,
        history: Optional["HistoryConfiguration"] = None,
        spark: Optional["SparkConfiguration"] = None,
        parallel_task: Optional["ParallelTaskConfiguration"] = None,
        ai_super_computer: Optional["AISuperComputerConfiguration"] = None,
        tensorflow: Optional["TensorflowConfiguration"] = None,
        mpi: Optional["MpiConfiguration"] = None,
        py_torch: Optional["PyTorchConfiguration"] = None,
        hdi: Optional["HdiConfiguration"] = None,
        docker: Optional["DockerConfiguration"] = None,
        command_return_code_config: Optional["CommandReturnCodeConfig"] = None,
        environment_variables: Optional[Dict[str, str]] = None,
        application_endpoints: Optional[Dict[str, "ApplicationEndpointConfiguration"]] = None,
        parameters: Optional[List["ParameterDefinition"]] = None,
        data_bricks: Optional["DatabricksConfiguration"] = None,
        **kwargs
    ):
        """
        :keyword script:
        :paramtype script: str
        :keyword command:
        :paramtype command: str
        :keyword use_absolute_path:
        :paramtype use_absolute_path: bool
        :keyword arguments:
        :paramtype arguments: list[str]
        :keyword framework: Possible values include: "Python", "PySpark", "Cntk", "TensorFlow",
         "PyTorch", "PySparkInteractive", "R".
        :paramtype framework: str or ~designer.models.Framework
        :keyword communicator: Possible values include: "None", "ParameterServer", "Gloo", "Mpi",
         "Nccl", "ParallelTask".
        :paramtype communicator: str or ~designer.models.Communicator
        :keyword target:
        :paramtype target: str
        :keyword auto_cluster_compute_specification:
        :paramtype auto_cluster_compute_specification: ~designer.models.AutoClusterComputeSpecification
        :keyword data_references: Dictionary of :code:`<DataReferenceConfiguration>`.
        :paramtype data_references: dict[str, ~designer.models.DataReferenceConfiguration]
        :keyword data: Dictionary of :code:`<Data>`.
        :paramtype data: dict[str, ~designer.models.Data]
        :keyword input_assets: Dictionary of :code:`<InputAsset>`.
        :paramtype input_assets: dict[str, ~designer.models.InputAsset]
        :keyword output_data: Dictionary of :code:`<OutputData>`.
        :paramtype output_data: dict[str, ~designer.models.OutputData]
        :keyword datacaches:
        :paramtype datacaches: list[~designer.models.DatacacheConfiguration]
        :keyword job_name:
        :paramtype job_name: str
        :keyword max_run_duration_seconds:
        :paramtype max_run_duration_seconds: long
        :keyword node_count:
        :paramtype node_count: int
        :keyword instance_types:
        :paramtype instance_types: list[str]
        :keyword priority:
        :paramtype priority: int
        :keyword credential_passthrough:
        :paramtype credential_passthrough: bool
        :keyword identity:
        :paramtype identity: ~designer.models.IdentityConfiguration
        :keyword environment:
        :paramtype environment: ~designer.models.EnvironmentDefinition
        :keyword history:
        :paramtype history: ~designer.models.HistoryConfiguration
        :keyword spark:
        :paramtype spark: ~designer.models.SparkConfiguration
        :keyword parallel_task:
        :paramtype parallel_task: ~designer.models.ParallelTaskConfiguration
        :keyword ai_super_computer:
        :paramtype ai_super_computer: ~designer.models.AISuperComputerConfiguration
        :keyword tensorflow:
        :paramtype tensorflow: ~designer.models.TensorflowConfiguration
        :keyword mpi:
        :paramtype mpi: ~designer.models.MpiConfiguration
        :keyword py_torch:
        :paramtype py_torch: ~designer.models.PyTorchConfiguration
        :keyword hdi:
        :paramtype hdi: ~designer.models.HdiConfiguration
        :keyword docker:
        :paramtype docker: ~designer.models.DockerConfiguration
        :keyword command_return_code_config:
        :paramtype command_return_code_config: ~designer.models.CommandReturnCodeConfig
        :keyword environment_variables: Dictionary of :code:`<string>`.
        :paramtype environment_variables: dict[str, str]
        :keyword application_endpoints: Dictionary of :code:`<ApplicationEndpointConfiguration>`.
        :paramtype application_endpoints: dict[str, ~designer.models.ApplicationEndpointConfiguration]
        :keyword parameters:
        :paramtype parameters: list[~designer.models.ParameterDefinition]
        :keyword data_bricks:
        :paramtype data_bricks: ~designer.models.DatabricksConfiguration
        """
        super(RunConfiguration, self).__init__(**kwargs)
        self.script = script
        self.command = command
        self.use_absolute_path = use_absolute_path
        self.arguments = arguments
        self.framework = framework
        self.communicator = communicator
        self.target = target
        self.auto_cluster_compute_specification = auto_cluster_compute_specification
        self.data_references = data_references
        self.data = data
        self.input_assets = input_assets
        self.output_data = output_data
        self.datacaches = datacaches
        self.job_name = job_name
        self.max_run_duration_seconds = max_run_duration_seconds
        self.node_count = node_count
        self.instance_types = instance_types
        self.priority = priority
        self.credential_passthrough = credential_passthrough
        self.identity = identity
        self.environment = environment
        self.history = history
        self.spark = spark
        self.parallel_task = parallel_task
        self.ai_super_computer = ai_super_computer
        self.tensorflow = tensorflow
        self.mpi = mpi
        self.py_torch = py_torch
        self.hdi = hdi
        self.docker = docker
        self.command_return_code_config = command_return_code_config
        self.environment_variables = environment_variables
        self.application_endpoints = application_endpoints
        self.parameters = parameters
        self.data_bricks = data_bricks


class RunDatasetReference(msrest.serialization.Model):
    """RunDatasetReference.

    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        name: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword version:
        :paramtype version: str
        """
        super(RunDatasetReference, self).__init__(**kwargs)
        self.id = id
        self.name = name
        self.version = version


class RunDefinition(msrest.serialization.Model):
    """RunDefinition.

    :ivar configuration:
    :vartype configuration: ~designer.models.RunConfiguration
    :ivar snapshot_id:
    :vartype snapshot_id: str
    :ivar snapshots:
    :vartype snapshots: list[~designer.models.Snapshot]
    :ivar parent_run_id:
    :vartype parent_run_id: str
    :ivar run_type:
    :vartype run_type: str
    :ivar display_name:
    :vartype display_name: str
    :ivar primary_metric_name:
    :vartype primary_metric_name: str
    :ivar description:
    :vartype description: str
    :ivar cancel_reason:
    :vartype cancel_reason: str
    :ivar properties: Dictionary of :code:`<string>`.
    :vartype properties: dict[str, str]
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    """

    _attribute_map = {
        'configuration': {'key': 'configuration', 'type': 'RunConfiguration'},
        'snapshot_id': {'key': 'snapshotId', 'type': 'str'},
        'snapshots': {'key': 'snapshots', 'type': '[Snapshot]'},
        'parent_run_id': {'key': 'parentRunId', 'type': 'str'},
        'run_type': {'key': 'runType', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'primary_metric_name': {'key': 'primaryMetricName', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'cancel_reason': {'key': 'cancelReason', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
        'tags': {'key': 'tags', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        configuration: Optional["RunConfiguration"] = None,
        snapshot_id: Optional[str] = None,
        snapshots: Optional[List["Snapshot"]] = None,
        parent_run_id: Optional[str] = None,
        run_type: Optional[str] = None,
        display_name: Optional[str] = None,
        primary_metric_name: Optional[str] = None,
        description: Optional[str] = None,
        cancel_reason: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        tags: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword configuration:
        :paramtype configuration: ~designer.models.RunConfiguration
        :keyword snapshot_id:
        :paramtype snapshot_id: str
        :keyword snapshots:
        :paramtype snapshots: list[~designer.models.Snapshot]
        :keyword parent_run_id:
        :paramtype parent_run_id: str
        :keyword run_type:
        :paramtype run_type: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword primary_metric_name:
        :paramtype primary_metric_name: str
        :keyword description:
        :paramtype description: str
        :keyword cancel_reason:
        :paramtype cancel_reason: str
        :keyword properties: Dictionary of :code:`<string>`.
        :paramtype properties: dict[str, str]
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        """
        super(RunDefinition, self).__init__(**kwargs)
        self.configuration = configuration
        self.snapshot_id = snapshot_id
        self.snapshots = snapshots
        self.parent_run_id = parent_run_id
        self.run_type = run_type
        self.display_name = display_name
        self.primary_metric_name = primary_metric_name
        self.description = description
        self.cancel_reason = cancel_reason
        self.properties = properties
        self.tags = tags


class RunIndexEntity(msrest.serialization.Model):
    """RunIndexEntity.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar schema_id:
    :vartype schema_id: str
    :ivar entity_id:
    :vartype entity_id: str
    :ivar kind: Possible values include: "Invalid", "LineageRoot", "Versioned", "Unversioned".
    :vartype kind: str or ~designer.models.EntityKind
    :ivar annotations:
    :vartype annotations: ~designer.models.RunAnnotations
    :ivar properties:
    :vartype properties: ~designer.models.RunProperties
    :ivar internal: Any object.
    :vartype internal: any
    :ivar update_sequence:
    :vartype update_sequence: long
    :ivar type:
    :vartype type: str
    :ivar version:
    :vartype version: str
    :ivar entity_container_id:
    :vartype entity_container_id: str
    :ivar entity_object_id:
    :vartype entity_object_id: str
    :ivar resource_type:
    :vartype resource_type: str
    :ivar relationships:
    :vartype relationships: list[~designer.models.Relationship]
    :ivar asset_id:
    :vartype asset_id: str
    """

    _validation = {
        'version': {'readonly': True},
        'entity_container_id': {'readonly': True},
        'entity_object_id': {'readonly': True},
        'resource_type': {'readonly': True},
    }

    _attribute_map = {
        'schema_id': {'key': 'schemaId', 'type': 'str'},
        'entity_id': {'key': 'entityId', 'type': 'str'},
        'kind': {'key': 'kind', 'type': 'str'},
        'annotations': {'key': 'annotations', 'type': 'RunAnnotations'},
        'properties': {'key': 'properties', 'type': 'RunProperties'},
        'internal': {'key': 'internal', 'type': 'object'},
        'update_sequence': {'key': 'updateSequence', 'type': 'long'},
        'type': {'key': 'type', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
        'entity_container_id': {'key': 'entityContainerId', 'type': 'str'},
        'entity_object_id': {'key': 'entityObjectId', 'type': 'str'},
        'resource_type': {'key': 'resourceType', 'type': 'str'},
        'relationships': {'key': 'relationships', 'type': '[Relationship]'},
        'asset_id': {'key': 'assetId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        schema_id: Optional[str] = None,
        entity_id: Optional[str] = None,
        kind: Optional[Union[str, "EntityKind"]] = None,
        annotations: Optional["RunAnnotations"] = None,
        properties: Optional["RunProperties"] = None,
        internal: Optional[Any] = None,
        update_sequence: Optional[int] = None,
        type: Optional[str] = None,
        relationships: Optional[List["Relationship"]] = None,
        asset_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword schema_id:
        :paramtype schema_id: str
        :keyword entity_id:
        :paramtype entity_id: str
        :keyword kind: Possible values include: "Invalid", "LineageRoot", "Versioned", "Unversioned".
        :paramtype kind: str or ~designer.models.EntityKind
        :keyword annotations:
        :paramtype annotations: ~designer.models.RunAnnotations
        :keyword properties:
        :paramtype properties: ~designer.models.RunProperties
        :keyword internal: Any object.
        :paramtype internal: any
        :keyword update_sequence:
        :paramtype update_sequence: long
        :keyword type:
        :paramtype type: str
        :keyword relationships:
        :paramtype relationships: list[~designer.models.Relationship]
        :keyword asset_id:
        :paramtype asset_id: str
        """
        super(RunIndexEntity, self).__init__(**kwargs)
        self.schema_id = schema_id
        self.entity_id = entity_id
        self.kind = kind
        self.annotations = annotations
        self.properties = properties
        self.internal = internal
        self.update_sequence = update_sequence
        self.type = type
        self.version = None
        self.entity_container_id = None
        self.entity_object_id = None
        self.resource_type = None
        self.relationships = relationships
        self.asset_id = asset_id


class RunIndexMetricSummary(msrest.serialization.Model):
    """RunIndexMetricSummary.

    :ivar count:
    :vartype count: long
    :ivar last_value: Anything.
    :vartype last_value: any
    :ivar minimum_value: Anything.
    :vartype minimum_value: any
    :ivar maximum_value: Anything.
    :vartype maximum_value: any
    """

    _attribute_map = {
        'count': {'key': 'count', 'type': 'long'},
        'last_value': {'key': 'lastValue', 'type': 'object'},
        'minimum_value': {'key': 'minimumValue', 'type': 'object'},
        'maximum_value': {'key': 'maximumValue', 'type': 'object'},
    }

    def __init__(
        self,
        *,
        count: Optional[int] = None,
        last_value: Optional[Any] = None,
        minimum_value: Optional[Any] = None,
        maximum_value: Optional[Any] = None,
        **kwargs
    ):
        """
        :keyword count:
        :paramtype count: long
        :keyword last_value: Anything.
        :paramtype last_value: any
        :keyword minimum_value: Anything.
        :paramtype minimum_value: any
        :keyword maximum_value: Anything.
        :paramtype maximum_value: any
        """
        super(RunIndexMetricSummary, self).__init__(**kwargs)
        self.count = count
        self.last_value = last_value
        self.minimum_value = minimum_value
        self.maximum_value = maximum_value


class RunIndexMetricSummarySystemObject(msrest.serialization.Model):
    """RunIndexMetricSummarySystemObject.

    :ivar count:
    :vartype count: long
    :ivar last_value: Anything.
    :vartype last_value: any
    :ivar minimum_value: Anything.
    :vartype minimum_value: any
    :ivar maximum_value: Anything.
    :vartype maximum_value: any
    """

    _attribute_map = {
        'count': {'key': 'count', 'type': 'long'},
        'last_value': {'key': 'lastValue', 'type': 'object'},
        'minimum_value': {'key': 'minimumValue', 'type': 'object'},
        'maximum_value': {'key': 'maximumValue', 'type': 'object'},
    }

    def __init__(
        self,
        *,
        count: Optional[int] = None,
        last_value: Optional[Any] = None,
        minimum_value: Optional[Any] = None,
        maximum_value: Optional[Any] = None,
        **kwargs
    ):
        """
        :keyword count:
        :paramtype count: long
        :keyword last_value: Anything.
        :paramtype last_value: any
        :keyword minimum_value: Anything.
        :paramtype minimum_value: any
        :keyword maximum_value: Anything.
        :paramtype maximum_value: any
        """
        super(RunIndexMetricSummarySystemObject, self).__init__(**kwargs)
        self.count = count
        self.last_value = last_value
        self.minimum_value = minimum_value
        self.maximum_value = maximum_value


class RunIndexResourceMetricSummary(msrest.serialization.Model):
    """RunIndexResourceMetricSummary.

    :ivar gpu_utilization_percent_last_hour:
    :vartype gpu_utilization_percent_last_hour: float
    :ivar gpu_memory_utilization_percent_last_hour:
    :vartype gpu_memory_utilization_percent_last_hour: float
    :ivar gpu_energy_joules:
    :vartype gpu_energy_joules: float
    """

    _attribute_map = {
        'gpu_utilization_percent_last_hour': {'key': 'gpuUtilizationPercentLastHour', 'type': 'float'},
        'gpu_memory_utilization_percent_last_hour': {'key': 'gpuMemoryUtilizationPercentLastHour', 'type': 'float'},
        'gpu_energy_joules': {'key': 'gpuEnergyJoules', 'type': 'float'},
    }

    def __init__(
        self,
        *,
        gpu_utilization_percent_last_hour: Optional[float] = None,
        gpu_memory_utilization_percent_last_hour: Optional[float] = None,
        gpu_energy_joules: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword gpu_utilization_percent_last_hour:
        :paramtype gpu_utilization_percent_last_hour: float
        :keyword gpu_memory_utilization_percent_last_hour:
        :paramtype gpu_memory_utilization_percent_last_hour: float
        :keyword gpu_energy_joules:
        :paramtype gpu_energy_joules: float
        """
        super(RunIndexResourceMetricSummary, self).__init__(**kwargs)
        self.gpu_utilization_percent_last_hour = gpu_utilization_percent_last_hour
        self.gpu_memory_utilization_percent_last_hour = gpu_memory_utilization_percent_last_hour
        self.gpu_energy_joules = gpu_energy_joules


class RunMetricDto(msrest.serialization.Model):
    """RunMetricDto.

    :ivar run_id:
    :vartype run_id: str
    :ivar metric_id:
    :vartype metric_id: str
    :ivar data_container_id:
    :vartype data_container_id: str
    :ivar metric_type:
    :vartype metric_type: str
    :ivar created_utc:
    :vartype created_utc: ~datetime.datetime
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar label:
    :vartype label: str
    :ivar num_cells:
    :vartype num_cells: int
    :ivar data_location:
    :vartype data_location: str
    :ivar cells:
    :vartype cells: list[dict[str, any]]
    :ivar schema:
    :vartype schema: ~designer.models.MetricSchemaDto
    """

    _attribute_map = {
        'run_id': {'key': 'runId', 'type': 'str'},
        'metric_id': {'key': 'metricId', 'type': 'str'},
        'data_container_id': {'key': 'dataContainerId', 'type': 'str'},
        'metric_type': {'key': 'metricType', 'type': 'str'},
        'created_utc': {'key': 'createdUtc', 'type': 'iso-8601'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'num_cells': {'key': 'numCells', 'type': 'int'},
        'data_location': {'key': 'dataLocation', 'type': 'str'},
        'cells': {'key': 'cells', 'type': '[{object}]'},
        'schema': {'key': 'schema', 'type': 'MetricSchemaDto'},
    }

    def __init__(
        self,
        *,
        run_id: Optional[str] = None,
        metric_id: Optional[str] = None,
        data_container_id: Optional[str] = None,
        metric_type: Optional[str] = None,
        created_utc: Optional[datetime.datetime] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        label: Optional[str] = None,
        num_cells: Optional[int] = None,
        data_location: Optional[str] = None,
        cells: Optional[List[Dict[str, Any]]] = None,
        schema: Optional["MetricSchemaDto"] = None,
        **kwargs
    ):
        """
        :keyword run_id:
        :paramtype run_id: str
        :keyword metric_id:
        :paramtype metric_id: str
        :keyword data_container_id:
        :paramtype data_container_id: str
        :keyword metric_type:
        :paramtype metric_type: str
        :keyword created_utc:
        :paramtype created_utc: ~datetime.datetime
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword label:
        :paramtype label: str
        :keyword num_cells:
        :paramtype num_cells: int
        :keyword data_location:
        :paramtype data_location: str
        :keyword cells:
        :paramtype cells: list[dict[str, any]]
        :keyword schema:
        :paramtype schema: ~designer.models.MetricSchemaDto
        """
        super(RunMetricDto, self).__init__(**kwargs)
        self.run_id = run_id
        self.metric_id = metric_id
        self.data_container_id = data_container_id
        self.metric_type = metric_type
        self.created_utc = created_utc
        self.name = name
        self.description = description
        self.label = label
        self.num_cells = num_cells
        self.data_location = data_location
        self.cells = cells
        self.schema = schema


class RunMetricsTypesDto(msrest.serialization.Model):
    """RunMetricsTypesDto.

    :ivar name:
    :vartype name: str
    :ivar type:
    :vartype type: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword type:
        :paramtype type: str
        """
        super(RunMetricsTypesDto, self).__init__(**kwargs)
        self.name = name
        self.type = type


class RunProperties(msrest.serialization.Model):
    """RunProperties.

    :ivar data_container_id:
    :vartype data_container_id: str
    :ivar target_name:
    :vartype target_name: str
    :ivar run_name:
    :vartype run_name: str
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar run_id:
    :vartype run_id: str
    :ivar parent_run_id:
    :vartype parent_run_id: str
    :ivar root_run_id:
    :vartype root_run_id: str
    :ivar run_type:
    :vartype run_type: str
    :ivar run_type_v2:
    :vartype run_type_v2: ~designer.models.RunTypeV2Index
    :ivar script_name:
    :vartype script_name: str
    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar run_uuid:
    :vartype run_uuid: str
    :ivar parent_run_uuid:
    :vartype parent_run_uuid: str
    :ivar run_number:
    :vartype run_number: int
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar compute_request:
    :vartype compute_request: ~designer.models.ComputeRequest
    :ivar compute:
    :vartype compute: ~designer.models.Compute
    :ivar user_properties: This is a dictionary.
    :vartype user_properties: dict[str, str]
    :ivar action_uris: This is a dictionary.
    :vartype action_uris: dict[str, str]
    :ivar duration:
    :vartype duration: str
    :ivar duration_milliseconds:
    :vartype duration_milliseconds: float
    :ivar creation_context:
    :vartype creation_context: ~designer.models.CreationContext
    """

    _attribute_map = {
        'data_container_id': {'key': 'dataContainerId', 'type': 'str'},
        'target_name': {'key': 'targetName', 'type': 'str'},
        'run_name': {'key': 'runName', 'type': 'str'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'parent_run_id': {'key': 'parentRunId', 'type': 'str'},
        'root_run_id': {'key': 'rootRunId', 'type': 'str'},
        'run_type': {'key': 'runType', 'type': 'str'},
        'run_type_v2': {'key': 'runTypeV2', 'type': 'RunTypeV2Index'},
        'script_name': {'key': 'scriptName', 'type': 'str'},
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'run_uuid': {'key': 'runUuid', 'type': 'str'},
        'parent_run_uuid': {'key': 'parentRunUuid', 'type': 'str'},
        'run_number': {'key': 'runNumber', 'type': 'int'},
        'start_time': {'key': 'startTime', 'type': 'iso-8601'},
        'end_time': {'key': 'endTime', 'type': 'iso-8601'},
        'compute_request': {'key': 'computeRequest', 'type': 'ComputeRequest'},
        'compute': {'key': 'compute', 'type': 'Compute'},
        'user_properties': {'key': 'userProperties', 'type': '{str}'},
        'action_uris': {'key': 'actionUris', 'type': '{str}'},
        'duration': {'key': 'duration', 'type': 'str'},
        'duration_milliseconds': {'key': 'durationMilliseconds', 'type': 'float'},
        'creation_context': {'key': 'creationContext', 'type': 'CreationContext'},
    }

    def __init__(
        self,
        *,
        data_container_id: Optional[str] = None,
        target_name: Optional[str] = None,
        run_name: Optional[str] = None,
        experiment_name: Optional[str] = None,
        run_id: Optional[str] = None,
        parent_run_id: Optional[str] = None,
        root_run_id: Optional[str] = None,
        run_type: Optional[str] = None,
        run_type_v2: Optional["RunTypeV2Index"] = None,
        script_name: Optional[str] = None,
        experiment_id: Optional[str] = None,
        run_uuid: Optional[str] = None,
        parent_run_uuid: Optional[str] = None,
        run_number: Optional[int] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        compute_request: Optional["ComputeRequest"] = None,
        compute: Optional["Compute"] = None,
        user_properties: Optional[Dict[str, str]] = None,
        action_uris: Optional[Dict[str, str]] = None,
        duration: Optional[str] = None,
        duration_milliseconds: Optional[float] = None,
        creation_context: Optional["CreationContext"] = None,
        **kwargs
    ):
        """
        :keyword data_container_id:
        :paramtype data_container_id: str
        :keyword target_name:
        :paramtype target_name: str
        :keyword run_name:
        :paramtype run_name: str
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword run_id:
        :paramtype run_id: str
        :keyword parent_run_id:
        :paramtype parent_run_id: str
        :keyword root_run_id:
        :paramtype root_run_id: str
        :keyword run_type:
        :paramtype run_type: str
        :keyword run_type_v2:
        :paramtype run_type_v2: ~designer.models.RunTypeV2Index
        :keyword script_name:
        :paramtype script_name: str
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword run_uuid:
        :paramtype run_uuid: str
        :keyword parent_run_uuid:
        :paramtype parent_run_uuid: str
        :keyword run_number:
        :paramtype run_number: int
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword compute_request:
        :paramtype compute_request: ~designer.models.ComputeRequest
        :keyword compute:
        :paramtype compute: ~designer.models.Compute
        :keyword user_properties: This is a dictionary.
        :paramtype user_properties: dict[str, str]
        :keyword action_uris: This is a dictionary.
        :paramtype action_uris: dict[str, str]
        :keyword duration:
        :paramtype duration: str
        :keyword duration_milliseconds:
        :paramtype duration_milliseconds: float
        :keyword creation_context:
        :paramtype creation_context: ~designer.models.CreationContext
        """
        super(RunProperties, self).__init__(**kwargs)
        self.data_container_id = data_container_id
        self.target_name = target_name
        self.run_name = run_name
        self.experiment_name = experiment_name
        self.run_id = run_id
        self.parent_run_id = parent_run_id
        self.root_run_id = root_run_id
        self.run_type = run_type
        self.run_type_v2 = run_type_v2
        self.script_name = script_name
        self.experiment_id = experiment_id
        self.run_uuid = run_uuid
        self.parent_run_uuid = parent_run_uuid
        self.run_number = run_number
        self.start_time = start_time
        self.end_time = end_time
        self.compute_request = compute_request
        self.compute = compute
        self.user_properties = user_properties
        self.action_uris = action_uris
        self.duration = duration
        self.duration_milliseconds = duration_milliseconds
        self.creation_context = creation_context


class RunSettingParameter(msrest.serialization.Model):
    """RunSettingParameter.

    :ivar name:
    :vartype name: str
    :ivar label:
    :vartype label: str
    :ivar parameter_type: Possible values include: "Undefined", "Int", "Double", "Bool", "String",
     "JsonString", "YamlString".
    :vartype parameter_type: str or ~designer.models.RunSettingParameterType
    :ivar is_optional:
    :vartype is_optional: bool
    :ivar default_value:
    :vartype default_value: str
    :ivar lower_bound:
    :vartype lower_bound: str
    :ivar upper_bound:
    :vartype upper_bound: str
    :ivar description:
    :vartype description: str
    :ivar run_setting_ui_hint:
    :vartype run_setting_ui_hint: ~designer.models.RunSettingUIParameterHint
    :ivar argument_name:
    :vartype argument_name: str
    :ivar section_name:
    :vartype section_name: str
    :ivar section_description:
    :vartype section_description: str
    :ivar section_argument_name:
    :vartype section_argument_name: str
    :ivar examples:
    :vartype examples: list[str]
    :ivar enum_values:
    :vartype enum_values: list[str]
    :ivar enum_values_to_argument_strings: This is a dictionary.
    :vartype enum_values_to_argument_strings: dict[str, str]
    :ivar enabled_by_parameter_name:
    :vartype enabled_by_parameter_name: str
    :ivar enabled_by_parameter_values:
    :vartype enabled_by_parameter_values: list[str]
    :ivar disabled_by_parameters:
    :vartype disabled_by_parameters: list[str]
    :ivar module_run_setting_type: Possible values include: "Default", "All", "Released",
     "Testing", "Legacy", "Full".
    :vartype module_run_setting_type: str or ~designer.models.ModuleRunSettingTypes
    :ivar linked_parameter_default_value_mapping: Dictionary of :code:`<string>`.
    :vartype linked_parameter_default_value_mapping: dict[str, str]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'parameter_type': {'key': 'parameterType', 'type': 'str'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
        'default_value': {'key': 'defaultValue', 'type': 'str'},
        'lower_bound': {'key': 'lowerBound', 'type': 'str'},
        'upper_bound': {'key': 'upperBound', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'run_setting_ui_hint': {'key': 'runSettingUIHint', 'type': 'RunSettingUIParameterHint'},
        'argument_name': {'key': 'argumentName', 'type': 'str'},
        'section_name': {'key': 'sectionName', 'type': 'str'},
        'section_description': {'key': 'sectionDescription', 'type': 'str'},
        'section_argument_name': {'key': 'sectionArgumentName', 'type': 'str'},
        'examples': {'key': 'examples', 'type': '[str]'},
        'enum_values': {'key': 'enumValues', 'type': '[str]'},
        'enum_values_to_argument_strings': {'key': 'enumValuesToArgumentStrings', 'type': '{str}'},
        'enabled_by_parameter_name': {'key': 'enabledByParameterName', 'type': 'str'},
        'enabled_by_parameter_values': {'key': 'enabledByParameterValues', 'type': '[str]'},
        'disabled_by_parameters': {'key': 'disabledByParameters', 'type': '[str]'},
        'module_run_setting_type': {'key': 'moduleRunSettingType', 'type': 'str'},
        'linked_parameter_default_value_mapping': {'key': 'linkedParameterDefaultValueMapping', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        label: Optional[str] = None,
        parameter_type: Optional[Union[str, "RunSettingParameterType"]] = None,
        is_optional: Optional[bool] = None,
        default_value: Optional[str] = None,
        lower_bound: Optional[str] = None,
        upper_bound: Optional[str] = None,
        description: Optional[str] = None,
        run_setting_ui_hint: Optional["RunSettingUIParameterHint"] = None,
        argument_name: Optional[str] = None,
        section_name: Optional[str] = None,
        section_description: Optional[str] = None,
        section_argument_name: Optional[str] = None,
        examples: Optional[List[str]] = None,
        enum_values: Optional[List[str]] = None,
        enum_values_to_argument_strings: Optional[Dict[str, str]] = None,
        enabled_by_parameter_name: Optional[str] = None,
        enabled_by_parameter_values: Optional[List[str]] = None,
        disabled_by_parameters: Optional[List[str]] = None,
        module_run_setting_type: Optional[Union[str, "ModuleRunSettingTypes"]] = None,
        linked_parameter_default_value_mapping: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword label:
        :paramtype label: str
        :keyword parameter_type: Possible values include: "Undefined", "Int", "Double", "Bool",
         "String", "JsonString", "YamlString".
        :paramtype parameter_type: str or ~designer.models.RunSettingParameterType
        :keyword is_optional:
        :paramtype is_optional: bool
        :keyword default_value:
        :paramtype default_value: str
        :keyword lower_bound:
        :paramtype lower_bound: str
        :keyword upper_bound:
        :paramtype upper_bound: str
        :keyword description:
        :paramtype description: str
        :keyword run_setting_ui_hint:
        :paramtype run_setting_ui_hint: ~designer.models.RunSettingUIParameterHint
        :keyword argument_name:
        :paramtype argument_name: str
        :keyword section_name:
        :paramtype section_name: str
        :keyword section_description:
        :paramtype section_description: str
        :keyword section_argument_name:
        :paramtype section_argument_name: str
        :keyword examples:
        :paramtype examples: list[str]
        :keyword enum_values:
        :paramtype enum_values: list[str]
        :keyword enum_values_to_argument_strings: This is a dictionary.
        :paramtype enum_values_to_argument_strings: dict[str, str]
        :keyword enabled_by_parameter_name:
        :paramtype enabled_by_parameter_name: str
        :keyword enabled_by_parameter_values:
        :paramtype enabled_by_parameter_values: list[str]
        :keyword disabled_by_parameters:
        :paramtype disabled_by_parameters: list[str]
        :keyword module_run_setting_type: Possible values include: "Default", "All", "Released",
         "Testing", "Legacy", "Full".
        :paramtype module_run_setting_type: str or ~designer.models.ModuleRunSettingTypes
        :keyword linked_parameter_default_value_mapping: Dictionary of :code:`<string>`.
        :paramtype linked_parameter_default_value_mapping: dict[str, str]
        """
        super(RunSettingParameter, self).__init__(**kwargs)
        self.name = name
        self.label = label
        self.parameter_type = parameter_type
        self.is_optional = is_optional
        self.default_value = default_value
        self.lower_bound = lower_bound
        self.upper_bound = upper_bound
        self.description = description
        self.run_setting_ui_hint = run_setting_ui_hint
        self.argument_name = argument_name
        self.section_name = section_name
        self.section_description = section_description
        self.section_argument_name = section_argument_name
        self.examples = examples
        self.enum_values = enum_values
        self.enum_values_to_argument_strings = enum_values_to_argument_strings
        self.enabled_by_parameter_name = enabled_by_parameter_name
        self.enabled_by_parameter_values = enabled_by_parameter_values
        self.disabled_by_parameters = disabled_by_parameters
        self.module_run_setting_type = module_run_setting_type
        self.linked_parameter_default_value_mapping = linked_parameter_default_value_mapping


class RunSettingParameterAssignment(msrest.serialization.Model):
    """RunSettingParameterAssignment.

    :ivar use_graph_default_compute:
    :vartype use_graph_default_compute: bool
    :ivar mlc_compute_type:
    :vartype mlc_compute_type: str
    :ivar compute_run_settings:
    :vartype compute_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar linked_parameter_name:
    :vartype linked_parameter_name: str
    :ivar value_type: Possible values include: "Literal", "GraphParameterName", "Concatenate",
     "Input", "DataPath", "DataSetDefinition".
    :vartype value_type: str or ~designer.models.ParameterValueType
    :ivar assignments_to_concatenate:
    :vartype assignments_to_concatenate: list[~designer.models.ParameterAssignment]
    :ivar data_path_assignment:
    :vartype data_path_assignment: ~designer.models.LegacyDataPath
    :ivar data_set_definition_value_assignment:
    :vartype data_set_definition_value_assignment: ~designer.models.DataSetDefinitionValue
    :ivar name:
    :vartype name: str
    :ivar value:
    :vartype value: str
    """

    _attribute_map = {
        'use_graph_default_compute': {'key': 'useGraphDefaultCompute', 'type': 'bool'},
        'mlc_compute_type': {'key': 'mlcComputeType', 'type': 'str'},
        'compute_run_settings': {'key': 'computeRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'linked_parameter_name': {'key': 'linkedParameterName', 'type': 'str'},
        'value_type': {'key': 'valueType', 'type': 'str'},
        'assignments_to_concatenate': {'key': 'assignmentsToConcatenate', 'type': '[ParameterAssignment]'},
        'data_path_assignment': {'key': 'dataPathAssignment', 'type': 'LegacyDataPath'},
        'data_set_definition_value_assignment': {'key': 'dataSetDefinitionValueAssignment', 'type': 'DataSetDefinitionValue'},
        'name': {'key': 'name', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        use_graph_default_compute: Optional[bool] = None,
        mlc_compute_type: Optional[str] = None,
        compute_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        linked_parameter_name: Optional[str] = None,
        value_type: Optional[Union[str, "ParameterValueType"]] = None,
        assignments_to_concatenate: Optional[List["ParameterAssignment"]] = None,
        data_path_assignment: Optional["LegacyDataPath"] = None,
        data_set_definition_value_assignment: Optional["DataSetDefinitionValue"] = None,
        name: Optional[str] = None,
        value: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword use_graph_default_compute:
        :paramtype use_graph_default_compute: bool
        :keyword mlc_compute_type:
        :paramtype mlc_compute_type: str
        :keyword compute_run_settings:
        :paramtype compute_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword linked_parameter_name:
        :paramtype linked_parameter_name: str
        :keyword value_type: Possible values include: "Literal", "GraphParameterName", "Concatenate",
         "Input", "DataPath", "DataSetDefinition".
        :paramtype value_type: str or ~designer.models.ParameterValueType
        :keyword assignments_to_concatenate:
        :paramtype assignments_to_concatenate: list[~designer.models.ParameterAssignment]
        :keyword data_path_assignment:
        :paramtype data_path_assignment: ~designer.models.LegacyDataPath
        :keyword data_set_definition_value_assignment:
        :paramtype data_set_definition_value_assignment: ~designer.models.DataSetDefinitionValue
        :keyword name:
        :paramtype name: str
        :keyword value:
        :paramtype value: str
        """
        super(RunSettingParameterAssignment, self).__init__(**kwargs)
        self.use_graph_default_compute = use_graph_default_compute
        self.mlc_compute_type = mlc_compute_type
        self.compute_run_settings = compute_run_settings
        self.linked_parameter_name = linked_parameter_name
        self.value_type = value_type
        self.assignments_to_concatenate = assignments_to_concatenate
        self.data_path_assignment = data_path_assignment
        self.data_set_definition_value_assignment = data_set_definition_value_assignment
        self.name = name
        self.value = value


class RunSettingUIParameterHint(msrest.serialization.Model):
    """RunSettingUIParameterHint.

    :ivar ui_widget_type: Possible values include: "Default", "ComputeSelection", "JsonEditor",
     "Mode", "SearchSpaceParameter", "SectionToggle", "YamlEditor".
    :vartype ui_widget_type: str or ~designer.models.RunSettingUIWidgetTypeEnum
    :ivar json_editor:
    :vartype json_editor: ~designer.models.UIJsonEditor
    :ivar compute_selection:
    :vartype compute_selection: ~designer.models.UIComputeSelection
    :ivar ux_ignore:
    :vartype ux_ignore: bool
    :ivar anonymous:
    :vartype anonymous: bool
    """

    _attribute_map = {
        'ui_widget_type': {'key': 'uiWidgetType', 'type': 'str'},
        'json_editor': {'key': 'jsonEditor', 'type': 'UIJsonEditor'},
        'compute_selection': {'key': 'computeSelection', 'type': 'UIComputeSelection'},
        'ux_ignore': {'key': 'uxIgnore', 'type': 'bool'},
        'anonymous': {'key': 'anonymous', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        ui_widget_type: Optional[Union[str, "RunSettingUIWidgetTypeEnum"]] = None,
        json_editor: Optional["UIJsonEditor"] = None,
        compute_selection: Optional["UIComputeSelection"] = None,
        ux_ignore: Optional[bool] = None,
        anonymous: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword ui_widget_type: Possible values include: "Default", "ComputeSelection", "JsonEditor",
         "Mode", "SearchSpaceParameter", "SectionToggle", "YamlEditor".
        :paramtype ui_widget_type: str or ~designer.models.RunSettingUIWidgetTypeEnum
        :keyword json_editor:
        :paramtype json_editor: ~designer.models.UIJsonEditor
        :keyword compute_selection:
        :paramtype compute_selection: ~designer.models.UIComputeSelection
        :keyword ux_ignore:
        :paramtype ux_ignore: bool
        :keyword anonymous:
        :paramtype anonymous: bool
        """
        super(RunSettingUIParameterHint, self).__init__(**kwargs)
        self.ui_widget_type = ui_widget_type
        self.json_editor = json_editor
        self.compute_selection = compute_selection
        self.ux_ignore = ux_ignore
        self.anonymous = anonymous


class RunStatusPeriod(msrest.serialization.Model):
    """RunStatusPeriod.

    :ivar status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype status: str or ~designer.models.RunStatus
    :ivar sub_periods:
    :vartype sub_periods: list[~designer.models.SubStatusPeriod]
    :ivar start:
    :vartype start: long
    :ivar end:
    :vartype end: long
    """

    _attribute_map = {
        'status': {'key': 'status', 'type': 'str'},
        'sub_periods': {'key': 'subPeriods', 'type': '[SubStatusPeriod]'},
        'start': {'key': 'start', 'type': 'long'},
        'end': {'key': 'end', 'type': 'long'},
    }

    def __init__(
        self,
        *,
        status: Optional[Union[str, "RunStatus"]] = None,
        sub_periods: Optional[List["SubStatusPeriod"]] = None,
        start: Optional[int] = None,
        end: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype status: str or ~designer.models.RunStatus
        :keyword sub_periods:
        :paramtype sub_periods: list[~designer.models.SubStatusPeriod]
        :keyword start:
        :paramtype start: long
        :keyword end:
        :paramtype end: long
        """
        super(RunStatusPeriod, self).__init__(**kwargs)
        self.status = status
        self.sub_periods = sub_periods
        self.start = start
        self.end = end


class RunTypeV2Index(msrest.serialization.Model):
    """RunTypeV2Index.

    :ivar orchestrator:
    :vartype orchestrator: str
    :ivar traits: Dictionary of :code:`<string>`.
    :vartype traits: dict[str, str]
    :ivar attribution:
    :vartype attribution: str
    :ivar compute_type:
    :vartype compute_type: str
    """

    _attribute_map = {
        'orchestrator': {'key': 'orchestrator', 'type': 'str'},
        'traits': {'key': 'traits', 'type': '{str}'},
        'attribution': {'key': 'attribution', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        orchestrator: Optional[str] = None,
        traits: Optional[Dict[str, str]] = None,
        attribution: Optional[str] = None,
        compute_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword orchestrator:
        :paramtype orchestrator: str
        :keyword traits: Dictionary of :code:`<string>`.
        :paramtype traits: dict[str, str]
        :keyword attribution:
        :paramtype attribution: str
        :keyword compute_type:
        :paramtype compute_type: str
        """
        super(RunTypeV2Index, self).__init__(**kwargs)
        self.orchestrator = orchestrator
        self.traits = traits
        self.attribution = attribution
        self.compute_type = compute_type


class SampleMeta(msrest.serialization.Model):
    """SampleMeta.

    :ivar image:
    :vartype image: str
    :ivar id:
    :vartype id: str
    :ivar display_name:
    :vartype display_name: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar doc_link:
    :vartype doc_link: str
    :ivar tags: A set of tags.
    :vartype tags: list[str]
    :ivar created_at:
    :vartype created_at: ~datetime.datetime
    :ivar updated_at:
    :vartype updated_at: ~datetime.datetime
    :ivar feed_name:
    :vartype feed_name: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'image': {'key': 'image', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'doc_link': {'key': 'docLink', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '[str]'},
        'created_at': {'key': 'createdAt', 'type': 'iso-8601'},
        'updated_at': {'key': 'updatedAt', 'type': 'iso-8601'},
        'feed_name': {'key': 'feedName', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        image: Optional[str] = None,
        id: Optional[str] = None,
        display_name: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        doc_link: Optional[str] = None,
        tags: Optional[List[str]] = None,
        created_at: Optional[datetime.datetime] = None,
        updated_at: Optional[datetime.datetime] = None,
        feed_name: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword image:
        :paramtype image: str
        :keyword id:
        :paramtype id: str
        :keyword display_name:
        :paramtype display_name: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword doc_link:
        :paramtype doc_link: str
        :keyword tags: A set of tags.
        :paramtype tags: list[str]
        :keyword created_at:
        :paramtype created_at: ~datetime.datetime
        :keyword updated_at:
        :paramtype updated_at: ~datetime.datetime
        :keyword feed_name:
        :paramtype feed_name: str
        :keyword version:
        :paramtype version: str
        """
        super(SampleMeta, self).__init__(**kwargs)
        self.image = image
        self.id = id
        self.display_name = display_name
        self.name = name
        self.description = description
        self.doc_link = doc_link
        self.tags = tags
        self.created_at = created_at
        self.updated_at = updated_at
        self.feed_name = feed_name
        self.version = version


class SavedDataSetReference(msrest.serialization.Model):
    """SavedDataSetReference.

    :ivar id:
    :vartype id: str
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        """
        super(SavedDataSetReference, self).__init__(**kwargs)
        self.id = id


class SavePipelineDraftRequest(msrest.serialization.Model):
    """SavePipelineDraftRequest.

    :ivar ui_widget_meta_infos:
    :vartype ui_widget_meta_infos: list[~designer.models.UIWidgetMetaInfo]
    :ivar web_service_inputs:
    :vartype web_service_inputs: list[~designer.models.WebServicePort]
    :ivar web_service_outputs:
    :vartype web_service_outputs: list[~designer.models.WebServicePort]
    :ivar nodes_in_draft:
    :vartype nodes_in_draft: list[str]
    :ivar name:
    :vartype name: str
    :ivar pipeline_type: Possible values include: "TrainingPipeline", "RealTimeInferencePipeline",
     "BatchInferencePipeline", "Unknown".
    :vartype pipeline_type: str or ~designer.models.PipelineType
    :ivar pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
    :vartype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
    :vartype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'ui_widget_meta_infos': {'key': 'uiWidgetMetaInfos', 'type': '[UIWidgetMetaInfo]'},
        'web_service_inputs': {'key': 'webServiceInputs', 'type': '[WebServicePort]'},
        'web_service_outputs': {'key': 'webServiceOutputs', 'type': '[WebServicePort]'},
        'nodes_in_draft': {'key': 'nodesInDraft', 'type': '[str]'},
        'name': {'key': 'name', 'type': 'str'},
        'pipeline_type': {'key': 'pipelineType', 'type': 'str'},
        'pipeline_draft_mode': {'key': 'pipelineDraftMode', 'type': 'str'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'flattened_sub_graphs': {'key': 'flattenedSubGraphs', 'type': '{PipelineSubDraft}'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        ui_widget_meta_infos: Optional[List["UIWidgetMetaInfo"]] = None,
        web_service_inputs: Optional[List["WebServicePort"]] = None,
        web_service_outputs: Optional[List["WebServicePort"]] = None,
        nodes_in_draft: Optional[List[str]] = None,
        name: Optional[str] = None,
        pipeline_type: Optional[Union[str, "PipelineType"]] = None,
        pipeline_draft_mode: Optional[Union[str, "PipelineDraftMode"]] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        flattened_sub_graphs: Optional[Dict[str, "PipelineSubDraft"]] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword ui_widget_meta_infos:
        :paramtype ui_widget_meta_infos: list[~designer.models.UIWidgetMetaInfo]
        :keyword web_service_inputs:
        :paramtype web_service_inputs: list[~designer.models.WebServicePort]
        :keyword web_service_outputs:
        :paramtype web_service_outputs: list[~designer.models.WebServicePort]
        :keyword nodes_in_draft:
        :paramtype nodes_in_draft: list[str]
        :keyword name:
        :paramtype name: str
        :keyword pipeline_type: Possible values include: "TrainingPipeline",
         "RealTimeInferencePipeline", "BatchInferencePipeline", "Unknown".
        :paramtype pipeline_type: str or ~designer.models.PipelineType
        :keyword pipeline_draft_mode: Possible values include: "None", "Normal", "Custom".
        :paramtype pipeline_draft_mode: str or ~designer.models.PipelineDraftMode
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
        :paramtype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(SavePipelineDraftRequest, self).__init__(**kwargs)
        self.ui_widget_meta_infos = ui_widget_meta_infos
        self.web_service_inputs = web_service_inputs
        self.web_service_outputs = web_service_outputs
        self.nodes_in_draft = nodes_in_draft
        self.name = name
        self.pipeline_type = pipeline_type
        self.pipeline_draft_mode = pipeline_draft_mode
        self.sub_pipelines_info = sub_pipelines_info
        self.flattened_sub_graphs = flattened_sub_graphs
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class SchemaContractsCreatedBy(msrest.serialization.Model):
    """SchemaContractsCreatedBy.

    :ivar user_object_id:
    :vartype user_object_id: str
    :ivar user_tenant_id:
    :vartype user_tenant_id: str
    :ivar user_name:
    :vartype user_name: str
    """

    _attribute_map = {
        'user_object_id': {'key': 'userObjectId', 'type': 'str'},
        'user_tenant_id': {'key': 'userTenantId', 'type': 'str'},
        'user_name': {'key': 'userName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        user_object_id: Optional[str] = None,
        user_tenant_id: Optional[str] = None,
        user_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword user_object_id:
        :paramtype user_object_id: str
        :keyword user_tenant_id:
        :paramtype user_tenant_id: str
        :keyword user_name:
        :paramtype user_name: str
        """
        super(SchemaContractsCreatedBy, self).__init__(**kwargs)
        self.user_object_id = user_object_id
        self.user_tenant_id = user_tenant_id
        self.user_name = user_name


class ScopeCloudConfiguration(msrest.serialization.Model):
    """ScopeCloudConfiguration.

    :ivar input_path_suffixes: This is a dictionary.
    :vartype input_path_suffixes: dict[str, ~designer.models.ArgumentAssignment]
    :ivar output_path_suffixes: This is a dictionary.
    :vartype output_path_suffixes: dict[str, ~designer.models.ArgumentAssignment]
    :ivar user_alias:
    :vartype user_alias: str
    """

    _attribute_map = {
        'input_path_suffixes': {'key': 'inputPathSuffixes', 'type': '{ArgumentAssignment}'},
        'output_path_suffixes': {'key': 'outputPathSuffixes', 'type': '{ArgumentAssignment}'},
        'user_alias': {'key': 'userAlias', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        input_path_suffixes: Optional[Dict[str, "ArgumentAssignment"]] = None,
        output_path_suffixes: Optional[Dict[str, "ArgumentAssignment"]] = None,
        user_alias: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword input_path_suffixes: This is a dictionary.
        :paramtype input_path_suffixes: dict[str, ~designer.models.ArgumentAssignment]
        :keyword output_path_suffixes: This is a dictionary.
        :paramtype output_path_suffixes: dict[str, ~designer.models.ArgumentAssignment]
        :keyword user_alias:
        :paramtype user_alias: str
        """
        super(ScopeCloudConfiguration, self).__init__(**kwargs)
        self.input_path_suffixes = input_path_suffixes
        self.output_path_suffixes = output_path_suffixes
        self.user_alias = user_alias


class Seasonality(msrest.serialization.Model):
    """Seasonality.

    :ivar mode: Possible values include: "Auto", "Custom".
    :vartype mode: str or ~designer.models.SeasonalityMode
    :ivar value:
    :vartype value: int
    """

    _attribute_map = {
        'mode': {'key': 'mode', 'type': 'str'},
        'value': {'key': 'value', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        mode: Optional[Union[str, "SeasonalityMode"]] = None,
        value: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword mode: Possible values include: "Auto", "Custom".
        :paramtype mode: str or ~designer.models.SeasonalityMode
        :keyword value:
        :paramtype value: int
        """
        super(Seasonality, self).__init__(**kwargs)
        self.mode = mode
        self.value = value


class SharingScope(msrest.serialization.Model):
    """SharingScope.

    :ivar type: Possible values include: "Global", "Tenant", "Subscription", "ResourceGroup",
     "Workspace".
    :vartype type: str or ~designer.models.ScopeType
    :ivar identifier:
    :vartype identifier: str
    """

    _attribute_map = {
        'type': {'key': 'type', 'type': 'str'},
        'identifier': {'key': 'identifier', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        type: Optional[Union[str, "ScopeType"]] = None,
        identifier: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword type: Possible values include: "Global", "Tenant", "Subscription", "ResourceGroup",
         "Workspace".
        :paramtype type: str or ~designer.models.ScopeType
        :keyword identifier:
        :paramtype identifier: str
        """
        super(SharingScope, self).__init__(**kwargs)
        self.type = type
        self.identifier = identifier


class Snapshot(msrest.serialization.Model):
    """Snapshot.

    :ivar id:
    :vartype id: str
    :ivar directory_name:
    :vartype directory_name: str
    :ivar snapshot_asset_id:
    :vartype snapshot_asset_id: str
    :ivar snapshot_entity_id:
    :vartype snapshot_entity_id: str
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'directory_name': {'key': 'directoryName', 'type': 'str'},
        'snapshot_asset_id': {'key': 'snapshotAssetId', 'type': 'str'},
        'snapshot_entity_id': {'key': 'snapshotEntityId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        directory_name: Optional[str] = None,
        snapshot_asset_id: Optional[str] = None,
        snapshot_entity_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword directory_name:
        :paramtype directory_name: str
        :keyword snapshot_asset_id:
        :paramtype snapshot_asset_id: str
        :keyword snapshot_entity_id:
        :paramtype snapshot_entity_id: str
        """
        super(Snapshot, self).__init__(**kwargs)
        self.id = id
        self.directory_name = directory_name
        self.snapshot_asset_id = snapshot_asset_id
        self.snapshot_entity_id = snapshot_entity_id


class SnapshotInfo(msrest.serialization.Model):
    """SnapshotInfo.

    :ivar root_download_url:
    :vartype root_download_url: str
    :ivar snapshots: This is a dictionary.
    :vartype snapshots: dict[str, ~designer.models.DownloadResourceInfo]
    """

    _attribute_map = {
        'root_download_url': {'key': 'rootDownloadUrl', 'type': 'str'},
        'snapshots': {'key': 'snapshots', 'type': '{DownloadResourceInfo}'},
    }

    def __init__(
        self,
        *,
        root_download_url: Optional[str] = None,
        snapshots: Optional[Dict[str, "DownloadResourceInfo"]] = None,
        **kwargs
    ):
        """
        :keyword root_download_url:
        :paramtype root_download_url: str
        :keyword snapshots: This is a dictionary.
        :paramtype snapshots: dict[str, ~designer.models.DownloadResourceInfo]
        """
        super(SnapshotInfo, self).__init__(**kwargs)
        self.root_download_url = root_download_url
        self.snapshots = snapshots


class SourceCodeDataReference(msrest.serialization.Model):
    """SourceCodeDataReference.

    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar path:
    :vartype path: str
    """

    _attribute_map = {
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'path': {'key': 'path', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        data_store_name: Optional[str] = None,
        path: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword path:
        :paramtype path: str
        """
        super(SourceCodeDataReference, self).__init__(**kwargs)
        self.data_store_name = data_store_name
        self.path = path


class SparkConfiguration(msrest.serialization.Model):
    """SparkConfiguration.

    :ivar configuration: Dictionary of :code:`<string>`.
    :vartype configuration: dict[str, str]
    """

    _attribute_map = {
        'configuration': {'key': 'configuration', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        configuration: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword configuration: Dictionary of :code:`<string>`.
        :paramtype configuration: dict[str, str]
        """
        super(SparkConfiguration, self).__init__(**kwargs)
        self.configuration = configuration


class SparkJarTaskDto(msrest.serialization.Model):
    """SparkJarTaskDto.

    :ivar main_class_name:
    :vartype main_class_name: str
    :ivar parameters:
    :vartype parameters: list[str]
    """

    _attribute_map = {
        'main_class_name': {'key': 'main_class_name', 'type': 'str'},
        'parameters': {'key': 'parameters', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        main_class_name: Optional[str] = None,
        parameters: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword main_class_name:
        :paramtype main_class_name: str
        :keyword parameters:
        :paramtype parameters: list[str]
        """
        super(SparkJarTaskDto, self).__init__(**kwargs)
        self.main_class_name = main_class_name
        self.parameters = parameters


class SparkMavenPackage(msrest.serialization.Model):
    """SparkMavenPackage.

    :ivar group:
    :vartype group: str
    :ivar artifact:
    :vartype artifact: str
    :ivar version:
    :vartype version: str
    """

    _attribute_map = {
        'group': {'key': 'group', 'type': 'str'},
        'artifact': {'key': 'artifact', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        group: Optional[str] = None,
        artifact: Optional[str] = None,
        version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword group:
        :paramtype group: str
        :keyword artifact:
        :paramtype artifact: str
        :keyword version:
        :paramtype version: str
        """
        super(SparkMavenPackage, self).__init__(**kwargs)
        self.group = group
        self.artifact = artifact
        self.version = version


class SparkPythonTaskDto(msrest.serialization.Model):
    """SparkPythonTaskDto.

    :ivar python_file:
    :vartype python_file: str
    :ivar parameters:
    :vartype parameters: list[str]
    """

    _attribute_map = {
        'python_file': {'key': 'python_file', 'type': 'str'},
        'parameters': {'key': 'parameters', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        python_file: Optional[str] = None,
        parameters: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword python_file:
        :paramtype python_file: str
        :keyword parameters:
        :paramtype parameters: list[str]
        """
        super(SparkPythonTaskDto, self).__init__(**kwargs)
        self.python_file = python_file
        self.parameters = parameters


class SparkSection(msrest.serialization.Model):
    """SparkSection.

    :ivar repositories:
    :vartype repositories: list[str]
    :ivar packages:
    :vartype packages: list[~designer.models.SparkMavenPackage]
    :ivar precache_packages:
    :vartype precache_packages: bool
    """

    _attribute_map = {
        'repositories': {'key': 'repositories', 'type': '[str]'},
        'packages': {'key': 'packages', 'type': '[SparkMavenPackage]'},
        'precache_packages': {'key': 'precachePackages', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        repositories: Optional[List[str]] = None,
        packages: Optional[List["SparkMavenPackage"]] = None,
        precache_packages: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword repositories:
        :paramtype repositories: list[str]
        :keyword packages:
        :paramtype packages: list[~designer.models.SparkMavenPackage]
        :keyword precache_packages:
        :paramtype precache_packages: bool
        """
        super(SparkSection, self).__init__(**kwargs)
        self.repositories = repositories
        self.packages = packages
        self.precache_packages = precache_packages


class SparkSubmitTaskDto(msrest.serialization.Model):
    """SparkSubmitTaskDto.

    :ivar parameters:
    :vartype parameters: list[str]
    """

    _attribute_map = {
        'parameters': {'key': 'parameters', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        parameters: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword parameters:
        :paramtype parameters: list[str]
        """
        super(SparkSubmitTaskDto, self).__init__(**kwargs)
        self.parameters = parameters


class SqlDataPath(msrest.serialization.Model):
    """SqlDataPath.

    :ivar sql_table_name:
    :vartype sql_table_name: str
    :ivar sql_query:
    :vartype sql_query: str
    :ivar sql_stored_procedure_name:
    :vartype sql_stored_procedure_name: str
    :ivar sql_stored_procedure_params:
    :vartype sql_stored_procedure_params: list[~designer.models.StoredProcedureParameter]
    """

    _attribute_map = {
        'sql_table_name': {'key': 'sqlTableName', 'type': 'str'},
        'sql_query': {'key': 'sqlQuery', 'type': 'str'},
        'sql_stored_procedure_name': {'key': 'sqlStoredProcedureName', 'type': 'str'},
        'sql_stored_procedure_params': {'key': 'sqlStoredProcedureParams', 'type': '[StoredProcedureParameter]'},
    }

    def __init__(
        self,
        *,
        sql_table_name: Optional[str] = None,
        sql_query: Optional[str] = None,
        sql_stored_procedure_name: Optional[str] = None,
        sql_stored_procedure_params: Optional[List["StoredProcedureParameter"]] = None,
        **kwargs
    ):
        """
        :keyword sql_table_name:
        :paramtype sql_table_name: str
        :keyword sql_query:
        :paramtype sql_query: str
        :keyword sql_stored_procedure_name:
        :paramtype sql_stored_procedure_name: str
        :keyword sql_stored_procedure_params:
        :paramtype sql_stored_procedure_params: list[~designer.models.StoredProcedureParameter]
        """
        super(SqlDataPath, self).__init__(**kwargs)
        self.sql_table_name = sql_table_name
        self.sql_query = sql_query
        self.sql_stored_procedure_name = sql_stored_procedure_name
        self.sql_stored_procedure_params = sql_stored_procedure_params


class StackEnsembleSettings(msrest.serialization.Model):
    """StackEnsembleSettings.

    :ivar stack_meta_learner_type: Possible values include: "None", "LogisticRegression",
     "LogisticRegressionCV", "LightGBMClassifier", "ElasticNet", "ElasticNetCV",
     "LightGBMRegressor", "LinearRegression".
    :vartype stack_meta_learner_type: str or ~designer.models.StackMetaLearnerType
    :ivar stack_meta_learner_train_percentage:
    :vartype stack_meta_learner_train_percentage: float
    :ivar stack_meta_learner_k_wargs: Dictionary of :code:`<any>`.
    :vartype stack_meta_learner_k_wargs: dict[str, any]
    """

    _attribute_map = {
        'stack_meta_learner_type': {'key': 'stackMetaLearnerType', 'type': 'str'},
        'stack_meta_learner_train_percentage': {'key': 'stackMetaLearnerTrainPercentage', 'type': 'float'},
        'stack_meta_learner_k_wargs': {'key': 'stackMetaLearnerKWargs', 'type': '{object}'},
    }

    def __init__(
        self,
        *,
        stack_meta_learner_type: Optional[Union[str, "StackMetaLearnerType"]] = None,
        stack_meta_learner_train_percentage: Optional[float] = None,
        stack_meta_learner_k_wargs: Optional[Dict[str, Any]] = None,
        **kwargs
    ):
        """
        :keyword stack_meta_learner_type: Possible values include: "None", "LogisticRegression",
         "LogisticRegressionCV", "LightGBMClassifier", "ElasticNet", "ElasticNetCV",
         "LightGBMRegressor", "LinearRegression".
        :paramtype stack_meta_learner_type: str or ~designer.models.StackMetaLearnerType
        :keyword stack_meta_learner_train_percentage:
        :paramtype stack_meta_learner_train_percentage: float
        :keyword stack_meta_learner_k_wargs: Dictionary of :code:`<any>`.
        :paramtype stack_meta_learner_k_wargs: dict[str, any]
        """
        super(StackEnsembleSettings, self).__init__(**kwargs)
        self.stack_meta_learner_type = stack_meta_learner_type
        self.stack_meta_learner_train_percentage = stack_meta_learner_train_percentage
        self.stack_meta_learner_k_wargs = stack_meta_learner_k_wargs


class StartRunResult(msrest.serialization.Model):
    """StartRunResult.

    All required parameters must be populated in order to send to Azure.

    :ivar run_id: Required.
    :vartype run_id: str
    """

    _validation = {
        'run_id': {'required': True},
    }

    _attribute_map = {
        'run_id': {'key': 'runId', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        run_id: str,
        **kwargs
    ):
        """
        :keyword run_id: Required.
        :paramtype run_id: str
        """
        super(StartRunResult, self).__init__(**kwargs)
        self.run_id = run_id


class StepRunProfile(msrest.serialization.Model):
    """StepRunProfile.

    :ivar step_run_id:
    :vartype step_run_id: str
    :ivar step_run_number:
    :vartype step_run_number: int
    :ivar run_url:
    :vartype run_url: str
    :ivar compute_target:
    :vartype compute_target: str
    :ivar compute_target_url:
    :vartype compute_target_url: str
    :ivar node_id:
    :vartype node_id: str
    :ivar node_name:
    :vartype node_name: str
    :ivar step_name:
    :vartype step_name: str
    :ivar create_time:
    :vartype create_time: long
    :ivar start_time:
    :vartype start_time: long
    :ivar end_time:
    :vartype end_time: long
    :ivar status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
     "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
     "Failed", "Canceled".
    :vartype status: str or ~designer.models.RunStatus
    :ivar status_detail:
    :vartype status_detail: str
    :ivar is_reused:
    :vartype is_reused: bool
    :ivar reused_pipeline_run_id:
    :vartype reused_pipeline_run_id: str
    :ivar reused_step_run_id:
    :vartype reused_step_run_id: str
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar status_timeline:
    :vartype status_timeline: list[~designer.models.RunStatusPeriod]
    """

    _attribute_map = {
        'step_run_id': {'key': 'stepRunId', 'type': 'str'},
        'step_run_number': {'key': 'stepRunNumber', 'type': 'int'},
        'run_url': {'key': 'runUrl', 'type': 'str'},
        'compute_target': {'key': 'computeTarget', 'type': 'str'},
        'compute_target_url': {'key': 'computeTargetUrl', 'type': 'str'},
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'node_name': {'key': 'nodeName', 'type': 'str'},
        'step_name': {'key': 'stepName', 'type': 'str'},
        'create_time': {'key': 'createTime', 'type': 'long'},
        'start_time': {'key': 'startTime', 'type': 'long'},
        'end_time': {'key': 'endTime', 'type': 'long'},
        'status': {'key': 'status', 'type': 'str'},
        'status_detail': {'key': 'statusDetail', 'type': 'str'},
        'is_reused': {'key': 'isReused', 'type': 'bool'},
        'reused_pipeline_run_id': {'key': 'reusedPipelineRunId', 'type': 'str'},
        'reused_step_run_id': {'key': 'reusedStepRunId', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'status_timeline': {'key': 'statusTimeline', 'type': '[RunStatusPeriod]'},
    }

    def __init__(
        self,
        *,
        step_run_id: Optional[str] = None,
        step_run_number: Optional[int] = None,
        run_url: Optional[str] = None,
        compute_target: Optional[str] = None,
        compute_target_url: Optional[str] = None,
        node_id: Optional[str] = None,
        node_name: Optional[str] = None,
        step_name: Optional[str] = None,
        create_time: Optional[int] = None,
        start_time: Optional[int] = None,
        end_time: Optional[int] = None,
        status: Optional[Union[str, "RunStatus"]] = None,
        status_detail: Optional[str] = None,
        is_reused: Optional[bool] = None,
        reused_pipeline_run_id: Optional[str] = None,
        reused_step_run_id: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        status_timeline: Optional[List["RunStatusPeriod"]] = None,
        **kwargs
    ):
        """
        :keyword step_run_id:
        :paramtype step_run_id: str
        :keyword step_run_number:
        :paramtype step_run_number: int
        :keyword run_url:
        :paramtype run_url: str
        :keyword compute_target:
        :paramtype compute_target: str
        :keyword compute_target_url:
        :paramtype compute_target_url: str
        :keyword node_id:
        :paramtype node_id: str
        :keyword node_name:
        :paramtype node_name: str
        :keyword step_name:
        :paramtype step_name: str
        :keyword create_time:
        :paramtype create_time: long
        :keyword start_time:
        :paramtype start_time: long
        :keyword end_time:
        :paramtype end_time: long
        :keyword status: Possible values include: "NotStarted", "Unapproved", "Pausing", "Paused",
         "Starting", "Preparing", "Queued", "Running", "Finalizing", "CancelRequested", "Completed",
         "Failed", "Canceled".
        :paramtype status: str or ~designer.models.RunStatus
        :keyword status_detail:
        :paramtype status_detail: str
        :keyword is_reused:
        :paramtype is_reused: bool
        :keyword reused_pipeline_run_id:
        :paramtype reused_pipeline_run_id: str
        :keyword reused_step_run_id:
        :paramtype reused_step_run_id: str
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword status_timeline:
        :paramtype status_timeline: list[~designer.models.RunStatusPeriod]
        """
        super(StepRunProfile, self).__init__(**kwargs)
        self.step_run_id = step_run_id
        self.step_run_number = step_run_number
        self.run_url = run_url
        self.compute_target = compute_target
        self.compute_target_url = compute_target_url
        self.node_id = node_id
        self.node_name = node_name
        self.step_name = step_name
        self.create_time = create_time
        self.start_time = start_time
        self.end_time = end_time
        self.status = status
        self.status_detail = status_detail
        self.is_reused = is_reused
        self.reused_pipeline_run_id = reused_pipeline_run_id
        self.reused_step_run_id = reused_step_run_id
        self.tags = tags
        self.status_timeline = status_timeline


class StoredProcedureParameter(msrest.serialization.Model):
    """StoredProcedureParameter.

    :ivar name:
    :vartype name: str
    :ivar value:
    :vartype value: str
    :ivar type: Possible values include: "String", "Int", "Decimal", "Guid", "Boolean", "Date".
    :vartype type: str or ~designer.models.StoredProcedureParameterType
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'value': {'key': 'value', 'type': 'str'},
        'type': {'key': 'type', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        value: Optional[str] = None,
        type: Optional[Union[str, "StoredProcedureParameterType"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword value:
        :paramtype value: str
        :keyword type: Possible values include: "String", "Int", "Decimal", "Guid", "Boolean", "Date".
        :paramtype type: str or ~designer.models.StoredProcedureParameterType
        """
        super(StoredProcedureParameter, self).__init__(**kwargs)
        self.name = name
        self.value = value
        self.type = type


class Stream(msrest.serialization.Model):
    """Stream.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar can_read:
    :vartype can_read: bool
    :ivar can_write:
    :vartype can_write: bool
    :ivar can_seek:
    :vartype can_seek: bool
    :ivar can_timeout:
    :vartype can_timeout: bool
    :ivar length:
    :vartype length: long
    :ivar position:
    :vartype position: long
    :ivar read_timeout:
    :vartype read_timeout: int
    :ivar write_timeout:
    :vartype write_timeout: int
    """

    _validation = {
        'can_read': {'readonly': True},
        'can_write': {'readonly': True},
        'can_seek': {'readonly': True},
        'can_timeout': {'readonly': True},
        'length': {'readonly': True},
    }

    _attribute_map = {
        'can_read': {'key': 'canRead', 'type': 'bool'},
        'can_write': {'key': 'canWrite', 'type': 'bool'},
        'can_seek': {'key': 'canSeek', 'type': 'bool'},
        'can_timeout': {'key': 'canTimeout', 'type': 'bool'},
        'length': {'key': 'length', 'type': 'long'},
        'position': {'key': 'position', 'type': 'long'},
        'read_timeout': {'key': 'readTimeout', 'type': 'int'},
        'write_timeout': {'key': 'writeTimeout', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        position: Optional[int] = None,
        read_timeout: Optional[int] = None,
        write_timeout: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword position:
        :paramtype position: long
        :keyword read_timeout:
        :paramtype read_timeout: int
        :keyword write_timeout:
        :paramtype write_timeout: int
        """
        super(Stream, self).__init__(**kwargs)
        self.can_read = None
        self.can_write = None
        self.can_seek = None
        self.can_timeout = None
        self.length = None
        self.position = position
        self.read_timeout = read_timeout
        self.write_timeout = write_timeout


class StructuredInterface(msrest.serialization.Model):
    """StructuredInterface.

    :ivar command_line_pattern:
    :vartype command_line_pattern: str
    :ivar inputs:
    :vartype inputs: list[~designer.models.StructuredInterfaceInput]
    :ivar outputs:
    :vartype outputs: list[~designer.models.StructuredInterfaceOutput]
    :ivar control_outputs:
    :vartype control_outputs: list[~designer.models.ControlOutput]
    :ivar parameters:
    :vartype parameters: list[~designer.models.StructuredInterfaceParameter]
    :ivar metadata_parameters:
    :vartype metadata_parameters: list[~designer.models.StructuredInterfaceParameter]
    :ivar arguments:
    :vartype arguments: list[~designer.models.ArgumentAssignment]
    """

    _attribute_map = {
        'command_line_pattern': {'key': 'commandLinePattern', 'type': 'str'},
        'inputs': {'key': 'inputs', 'type': '[StructuredInterfaceInput]'},
        'outputs': {'key': 'outputs', 'type': '[StructuredInterfaceOutput]'},
        'control_outputs': {'key': 'controlOutputs', 'type': '[ControlOutput]'},
        'parameters': {'key': 'parameters', 'type': '[StructuredInterfaceParameter]'},
        'metadata_parameters': {'key': 'metadataParameters', 'type': '[StructuredInterfaceParameter]'},
        'arguments': {'key': 'arguments', 'type': '[ArgumentAssignment]'},
    }

    def __init__(
        self,
        *,
        command_line_pattern: Optional[str] = None,
        inputs: Optional[List["StructuredInterfaceInput"]] = None,
        outputs: Optional[List["StructuredInterfaceOutput"]] = None,
        control_outputs: Optional[List["ControlOutput"]] = None,
        parameters: Optional[List["StructuredInterfaceParameter"]] = None,
        metadata_parameters: Optional[List["StructuredInterfaceParameter"]] = None,
        arguments: Optional[List["ArgumentAssignment"]] = None,
        **kwargs
    ):
        """
        :keyword command_line_pattern:
        :paramtype command_line_pattern: str
        :keyword inputs:
        :paramtype inputs: list[~designer.models.StructuredInterfaceInput]
        :keyword outputs:
        :paramtype outputs: list[~designer.models.StructuredInterfaceOutput]
        :keyword control_outputs:
        :paramtype control_outputs: list[~designer.models.ControlOutput]
        :keyword parameters:
        :paramtype parameters: list[~designer.models.StructuredInterfaceParameter]
        :keyword metadata_parameters:
        :paramtype metadata_parameters: list[~designer.models.StructuredInterfaceParameter]
        :keyword arguments:
        :paramtype arguments: list[~designer.models.ArgumentAssignment]
        """
        super(StructuredInterface, self).__init__(**kwargs)
        self.command_line_pattern = command_line_pattern
        self.inputs = inputs
        self.outputs = outputs
        self.control_outputs = control_outputs
        self.parameters = parameters
        self.metadata_parameters = metadata_parameters
        self.arguments = arguments


class StructuredInterfaceInput(msrest.serialization.Model):
    """StructuredInterfaceInput.

    :ivar name:
    :vartype name: str
    :ivar label:
    :vartype label: str
    :ivar data_type_ids_list:
    :vartype data_type_ids_list: list[str]
    :ivar is_optional:
    :vartype is_optional: bool
    :ivar description:
    :vartype description: str
    :ivar skip_processing:
    :vartype skip_processing: bool
    :ivar is_resource:
    :vartype is_resource: bool
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    :ivar data_reference_name:
    :vartype data_reference_name: str
    :ivar dataset_types:
    :vartype dataset_types: list[str or ~designer.models.DatasetType]
    """

    _validation = {
        'dataset_types': {'unique': True},
    }

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'data_type_ids_list': {'key': 'dataTypeIdsList', 'type': '[str]'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'skip_processing': {'key': 'skipProcessing', 'type': 'bool'},
        'is_resource': {'key': 'isResource', 'type': 'bool'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'data_reference_name': {'key': 'dataReferenceName', 'type': 'str'},
        'dataset_types': {'key': 'datasetTypes', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        label: Optional[str] = None,
        data_type_ids_list: Optional[List[str]] = None,
        is_optional: Optional[bool] = None,
        description: Optional[str] = None,
        skip_processing: Optional[bool] = None,
        is_resource: Optional[bool] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        data_reference_name: Optional[str] = None,
        dataset_types: Optional[List[Union[str, "DatasetType"]]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword label:
        :paramtype label: str
        :keyword data_type_ids_list:
        :paramtype data_type_ids_list: list[str]
        :keyword is_optional:
        :paramtype is_optional: bool
        :keyword description:
        :paramtype description: str
        :keyword skip_processing:
        :paramtype skip_processing: bool
        :keyword is_resource:
        :paramtype is_resource: bool
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword data_reference_name:
        :paramtype data_reference_name: str
        :keyword dataset_types:
        :paramtype dataset_types: list[str or ~designer.models.DatasetType]
        """
        super(StructuredInterfaceInput, self).__init__(**kwargs)
        self.name = name
        self.label = label
        self.data_type_ids_list = data_type_ids_list
        self.is_optional = is_optional
        self.description = description
        self.skip_processing = skip_processing
        self.is_resource = is_resource
        self.data_store_mode = data_store_mode
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite
        self.data_reference_name = data_reference_name
        self.dataset_types = dataset_types


class StructuredInterfaceOutput(msrest.serialization.Model):
    """StructuredInterfaceOutput.

    :ivar name:
    :vartype name: str
    :ivar label:
    :vartype label: str
    :ivar data_type_id:
    :vartype data_type_id: str
    :ivar pass_through_data_type_input_name:
    :vartype pass_through_data_type_input_name: str
    :ivar description:
    :vartype description: str
    :ivar skip_processing:
    :vartype skip_processing: bool
    :ivar is_artifact:
    :vartype is_artifact: bool
    :ivar data_store_name:
    :vartype data_store_name: str
    :ivar data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
     "Direct", "Hdfs", "Link".
    :vartype data_store_mode: str or ~designer.models.AEVADataStoreMode
    :ivar path_on_compute:
    :vartype path_on_compute: str
    :ivar overwrite:
    :vartype overwrite: bool
    :ivar data_reference_name:
    :vartype data_reference_name: str
    :ivar training_output:
    :vartype training_output: ~designer.models.TrainingOutput
    :ivar dataset_output:
    :vartype dataset_output: ~designer.models.DatasetOutput
    :ivar asset_output_settings:
    :vartype asset_output_settings: ~designer.models.AssetOutputSettings
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'data_type_id': {'key': 'dataTypeId', 'type': 'str'},
        'pass_through_data_type_input_name': {'key': 'passThroughDataTypeInputName', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'skip_processing': {'key': 'skipProcessing', 'type': 'bool'},
        'is_artifact': {'key': 'IsArtifact', 'type': 'bool'},
        'data_store_name': {'key': 'dataStoreName', 'type': 'str'},
        'data_store_mode': {'key': 'dataStoreMode', 'type': 'str'},
        'path_on_compute': {'key': 'pathOnCompute', 'type': 'str'},
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'data_reference_name': {'key': 'dataReferenceName', 'type': 'str'},
        'training_output': {'key': 'trainingOutput', 'type': 'TrainingOutput'},
        'dataset_output': {'key': 'datasetOutput', 'type': 'DatasetOutput'},
        'asset_output_settings': {'key': 'AssetOutputSettings', 'type': 'AssetOutputSettings'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        label: Optional[str] = None,
        data_type_id: Optional[str] = None,
        pass_through_data_type_input_name: Optional[str] = None,
        description: Optional[str] = None,
        skip_processing: Optional[bool] = None,
        is_artifact: Optional[bool] = None,
        data_store_name: Optional[str] = None,
        data_store_mode: Optional[Union[str, "AEVADataStoreMode"]] = None,
        path_on_compute: Optional[str] = None,
        overwrite: Optional[bool] = None,
        data_reference_name: Optional[str] = None,
        training_output: Optional["TrainingOutput"] = None,
        dataset_output: Optional["DatasetOutput"] = None,
        asset_output_settings: Optional["AssetOutputSettings"] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword label:
        :paramtype label: str
        :keyword data_type_id:
        :paramtype data_type_id: str
        :keyword pass_through_data_type_input_name:
        :paramtype pass_through_data_type_input_name: str
        :keyword description:
        :paramtype description: str
        :keyword skip_processing:
        :paramtype skip_processing: bool
        :keyword is_artifact:
        :paramtype is_artifact: bool
        :keyword data_store_name:
        :paramtype data_store_name: str
        :keyword data_store_mode: Possible values include: "None", "Mount", "Download", "Upload",
         "Direct", "Hdfs", "Link".
        :paramtype data_store_mode: str or ~designer.models.AEVADataStoreMode
        :keyword path_on_compute:
        :paramtype path_on_compute: str
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword data_reference_name:
        :paramtype data_reference_name: str
        :keyword training_output:
        :paramtype training_output: ~designer.models.TrainingOutput
        :keyword dataset_output:
        :paramtype dataset_output: ~designer.models.DatasetOutput
        :keyword asset_output_settings:
        :paramtype asset_output_settings: ~designer.models.AssetOutputSettings
        """
        super(StructuredInterfaceOutput, self).__init__(**kwargs)
        self.name = name
        self.label = label
        self.data_type_id = data_type_id
        self.pass_through_data_type_input_name = pass_through_data_type_input_name
        self.description = description
        self.skip_processing = skip_processing
        self.is_artifact = is_artifact
        self.data_store_name = data_store_name
        self.data_store_mode = data_store_mode
        self.path_on_compute = path_on_compute
        self.overwrite = overwrite
        self.data_reference_name = data_reference_name
        self.training_output = training_output
        self.dataset_output = dataset_output
        self.asset_output_settings = asset_output_settings


class StructuredInterfaceParameter(msrest.serialization.Model):
    """StructuredInterfaceParameter.

    :ivar name:
    :vartype name: str
    :ivar label:
    :vartype label: str
    :ivar parameter_type: Possible values include: "Int", "Double", "Bool", "String", "Undefined".
    :vartype parameter_type: str or ~designer.models.ParameterType
    :ivar is_optional:
    :vartype is_optional: bool
    :ivar default_value:
    :vartype default_value: str
    :ivar lower_bound:
    :vartype lower_bound: str
    :ivar upper_bound:
    :vartype upper_bound: str
    :ivar enum_values:
    :vartype enum_values: list[str]
    :ivar enum_values_to_argument_strings: This is a dictionary.
    :vartype enum_values_to_argument_strings: dict[str, str]
    :ivar description:
    :vartype description: str
    :ivar set_environment_variable:
    :vartype set_environment_variable: bool
    :ivar environment_variable_override:
    :vartype environment_variable_override: str
    :ivar enabled_by_parameter_name:
    :vartype enabled_by_parameter_name: str
    :ivar enabled_by_parameter_values:
    :vartype enabled_by_parameter_values: list[str]
    :ivar ui_hint:
    :vartype ui_hint: ~designer.models.UIParameterHint
    :ivar group_names:
    :vartype group_names: list[str]
    :ivar argument_name:
    :vartype argument_name: str
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'label': {'key': 'label', 'type': 'str'},
        'parameter_type': {'key': 'parameterType', 'type': 'str'},
        'is_optional': {'key': 'isOptional', 'type': 'bool'},
        'default_value': {'key': 'defaultValue', 'type': 'str'},
        'lower_bound': {'key': 'lowerBound', 'type': 'str'},
        'upper_bound': {'key': 'upperBound', 'type': 'str'},
        'enum_values': {'key': 'enumValues', 'type': '[str]'},
        'enum_values_to_argument_strings': {'key': 'enumValuesToArgumentStrings', 'type': '{str}'},
        'description': {'key': 'description', 'type': 'str'},
        'set_environment_variable': {'key': 'setEnvironmentVariable', 'type': 'bool'},
        'environment_variable_override': {'key': 'environmentVariableOverride', 'type': 'str'},
        'enabled_by_parameter_name': {'key': 'enabledByParameterName', 'type': 'str'},
        'enabled_by_parameter_values': {'key': 'enabledByParameterValues', 'type': '[str]'},
        'ui_hint': {'key': 'uiHint', 'type': 'UIParameterHint'},
        'group_names': {'key': 'groupNames', 'type': '[str]'},
        'argument_name': {'key': 'argumentName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        label: Optional[str] = None,
        parameter_type: Optional[Union[str, "ParameterType"]] = None,
        is_optional: Optional[bool] = None,
        default_value: Optional[str] = None,
        lower_bound: Optional[str] = None,
        upper_bound: Optional[str] = None,
        enum_values: Optional[List[str]] = None,
        enum_values_to_argument_strings: Optional[Dict[str, str]] = None,
        description: Optional[str] = None,
        set_environment_variable: Optional[bool] = None,
        environment_variable_override: Optional[str] = None,
        enabled_by_parameter_name: Optional[str] = None,
        enabled_by_parameter_values: Optional[List[str]] = None,
        ui_hint: Optional["UIParameterHint"] = None,
        group_names: Optional[List[str]] = None,
        argument_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword label:
        :paramtype label: str
        :keyword parameter_type: Possible values include: "Int", "Double", "Bool", "String",
         "Undefined".
        :paramtype parameter_type: str or ~designer.models.ParameterType
        :keyword is_optional:
        :paramtype is_optional: bool
        :keyword default_value:
        :paramtype default_value: str
        :keyword lower_bound:
        :paramtype lower_bound: str
        :keyword upper_bound:
        :paramtype upper_bound: str
        :keyword enum_values:
        :paramtype enum_values: list[str]
        :keyword enum_values_to_argument_strings: This is a dictionary.
        :paramtype enum_values_to_argument_strings: dict[str, str]
        :keyword description:
        :paramtype description: str
        :keyword set_environment_variable:
        :paramtype set_environment_variable: bool
        :keyword environment_variable_override:
        :paramtype environment_variable_override: str
        :keyword enabled_by_parameter_name:
        :paramtype enabled_by_parameter_name: str
        :keyword enabled_by_parameter_values:
        :paramtype enabled_by_parameter_values: list[str]
        :keyword ui_hint:
        :paramtype ui_hint: ~designer.models.UIParameterHint
        :keyword group_names:
        :paramtype group_names: list[str]
        :keyword argument_name:
        :paramtype argument_name: str
        """
        super(StructuredInterfaceParameter, self).__init__(**kwargs)
        self.name = name
        self.label = label
        self.parameter_type = parameter_type
        self.is_optional = is_optional
        self.default_value = default_value
        self.lower_bound = lower_bound
        self.upper_bound = upper_bound
        self.enum_values = enum_values
        self.enum_values_to_argument_strings = enum_values_to_argument_strings
        self.description = description
        self.set_environment_variable = set_environment_variable
        self.environment_variable_override = environment_variable_override
        self.enabled_by_parameter_name = enabled_by_parameter_name
        self.enabled_by_parameter_values = enabled_by_parameter_values
        self.ui_hint = ui_hint
        self.group_names = group_names
        self.argument_name = argument_name


class StudioMigrationInfo(msrest.serialization.Model):
    """StudioMigrationInfo.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar source_workspace_id:
    :vartype source_workspace_id: str
    :ivar source_experiment_id:
    :vartype source_experiment_id: str
    :ivar source_experiment_link:
    :vartype source_experiment_link: str
    :ivar failed_node_id_list:
    :vartype failed_node_id_list: list[str]
    :ivar error_message:
    :vartype error_message: str
    """

    _validation = {
        'error_message': {'readonly': True},
    }

    _attribute_map = {
        'source_workspace_id': {'key': 'sourceWorkspaceId', 'type': 'str'},
        'source_experiment_id': {'key': 'sourceExperimentId', 'type': 'str'},
        'source_experiment_link': {'key': 'sourceExperimentLink', 'type': 'str'},
        'failed_node_id_list': {'key': 'failedNodeIdList', 'type': '[str]'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        source_workspace_id: Optional[str] = None,
        source_experiment_id: Optional[str] = None,
        source_experiment_link: Optional[str] = None,
        failed_node_id_list: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword source_workspace_id:
        :paramtype source_workspace_id: str
        :keyword source_experiment_id:
        :paramtype source_experiment_id: str
        :keyword source_experiment_link:
        :paramtype source_experiment_link: str
        :keyword failed_node_id_list:
        :paramtype failed_node_id_list: list[str]
        """
        super(StudioMigrationInfo, self).__init__(**kwargs)
        self.source_workspace_id = source_workspace_id
        self.source_experiment_id = source_experiment_id
        self.source_experiment_link = source_experiment_link
        self.failed_node_id_list = failed_node_id_list
        self.error_message = None


class SubGraphConcatenateAssignment(msrest.serialization.Model):
    """SubGraphConcatenateAssignment.

    :ivar concatenate_parameter:
    :vartype concatenate_parameter: list[~designer.models.ParameterAssignment]
    :ivar parameter_assignments:
    :vartype parameter_assignments: ~designer.models.SubPipelineParameterAssignment
    """

    _attribute_map = {
        'concatenate_parameter': {'key': 'concatenateParameter', 'type': '[ParameterAssignment]'},
        'parameter_assignments': {'key': 'parameterAssignments', 'type': 'SubPipelineParameterAssignment'},
    }

    def __init__(
        self,
        *,
        concatenate_parameter: Optional[List["ParameterAssignment"]] = None,
        parameter_assignments: Optional["SubPipelineParameterAssignment"] = None,
        **kwargs
    ):
        """
        :keyword concatenate_parameter:
        :paramtype concatenate_parameter: list[~designer.models.ParameterAssignment]
        :keyword parameter_assignments:
        :paramtype parameter_assignments: ~designer.models.SubPipelineParameterAssignment
        """
        super(SubGraphConcatenateAssignment, self).__init__(**kwargs)
        self.concatenate_parameter = concatenate_parameter
        self.parameter_assignments = parameter_assignments


class SubGraphConfiguration(msrest.serialization.Model):
    """SubGraphConfiguration.

    :ivar graph_id:
    :vartype graph_id: str
    :ivar graph_draft_id:
    :vartype graph_draft_id: str
    :ivar default_cloud_priority:
    :vartype default_cloud_priority: ~designer.models.CloudPrioritySetting
    """

    _attribute_map = {
        'graph_id': {'key': 'graphId', 'type': 'str'},
        'graph_draft_id': {'key': 'graphDraftId', 'type': 'str'},
        'default_cloud_priority': {'key': 'DefaultCloudPriority', 'type': 'CloudPrioritySetting'},
    }

    def __init__(
        self,
        *,
        graph_id: Optional[str] = None,
        graph_draft_id: Optional[str] = None,
        default_cloud_priority: Optional["CloudPrioritySetting"] = None,
        **kwargs
    ):
        """
        :keyword graph_id:
        :paramtype graph_id: str
        :keyword graph_draft_id:
        :paramtype graph_draft_id: str
        :keyword default_cloud_priority:
        :paramtype default_cloud_priority: ~designer.models.CloudPrioritySetting
        """
        super(SubGraphConfiguration, self).__init__(**kwargs)
        self.graph_id = graph_id
        self.graph_draft_id = graph_draft_id
        self.default_cloud_priority = default_cloud_priority


class SubGraphConnectionInfo(msrest.serialization.Model):
    """SubGraphConnectionInfo.

    :ivar node_id:
    :vartype node_id: str
    :ivar port_name:
    :vartype port_name: str
    """

    _attribute_map = {
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_id:
        :paramtype node_id: str
        :keyword port_name:
        :paramtype port_name: str
        """
        super(SubGraphConnectionInfo, self).__init__(**kwargs)
        self.node_id = node_id
        self.port_name = port_name


class SubGraphDataPathParameterAssignment(msrest.serialization.Model):
    """SubGraphDataPathParameterAssignment.

    :ivar data_set_path_parameter:
    :vartype data_set_path_parameter: ~designer.models.DataSetPathParameter
    :ivar data_set_path_parameter_assignments:
    :vartype data_set_path_parameter_assignments: list[str]
    """

    _attribute_map = {
        'data_set_path_parameter': {'key': 'dataSetPathParameter', 'type': 'DataSetPathParameter'},
        'data_set_path_parameter_assignments': {'key': 'dataSetPathParameterAssignments', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        data_set_path_parameter: Optional["DataSetPathParameter"] = None,
        data_set_path_parameter_assignments: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword data_set_path_parameter:
        :paramtype data_set_path_parameter: ~designer.models.DataSetPathParameter
        :keyword data_set_path_parameter_assignments:
        :paramtype data_set_path_parameter_assignments: list[str]
        """
        super(SubGraphDataPathParameterAssignment, self).__init__(**kwargs)
        self.data_set_path_parameter = data_set_path_parameter
        self.data_set_path_parameter_assignments = data_set_path_parameter_assignments


class SubGraphInfo(msrest.serialization.Model):
    """SubGraphInfo.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar default_compute_target:
    :vartype default_compute_target: ~designer.models.ComputeSetting
    :ivar default_data_store:
    :vartype default_data_store: ~designer.models.DatastoreSetting
    :ivar id:
    :vartype id: str
    :ivar parent_graph_id:
    :vartype parent_graph_id: str
    :ivar pipeline_definition_id:
    :vartype pipeline_definition_id: str
    :ivar sub_graph_parameter_assignment:
    :vartype sub_graph_parameter_assignment: list[~designer.models.SubGraphParameterAssignment]
    :ivar sub_graph_concatenate_assignment:
    :vartype sub_graph_concatenate_assignment: list[~designer.models.SubGraphConcatenateAssignment]
    :ivar sub_graph_data_path_parameter_assignment:
    :vartype sub_graph_data_path_parameter_assignment:
     list[~designer.models.SubGraphDataPathParameterAssignment]
    :ivar sub_graph_default_compute_target_nodes:
    :vartype sub_graph_default_compute_target_nodes: list[str]
    :ivar sub_graph_default_data_store_nodes:
    :vartype sub_graph_default_data_store_nodes: list[str]
    :ivar inputs:
    :vartype inputs: list[~designer.models.SubGraphPortInfo]
    :ivar outputs:
    :vartype outputs: list[~designer.models.SubGraphPortInfo]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'default_compute_target': {'key': 'defaultComputeTarget', 'type': 'ComputeSetting'},
        'default_data_store': {'key': 'defaultDataStore', 'type': 'DatastoreSetting'},
        'id': {'key': 'id', 'type': 'str'},
        'parent_graph_id': {'key': 'parentGraphId', 'type': 'str'},
        'pipeline_definition_id': {'key': 'pipelineDefinitionId', 'type': 'str'},
        'sub_graph_parameter_assignment': {'key': 'subGraphParameterAssignment', 'type': '[SubGraphParameterAssignment]'},
        'sub_graph_concatenate_assignment': {'key': 'subGraphConcatenateAssignment', 'type': '[SubGraphConcatenateAssignment]'},
        'sub_graph_data_path_parameter_assignment': {'key': 'subGraphDataPathParameterAssignment', 'type': '[SubGraphDataPathParameterAssignment]'},
        'sub_graph_default_compute_target_nodes': {'key': 'subGraphDefaultComputeTargetNodes', 'type': '[str]'},
        'sub_graph_default_data_store_nodes': {'key': 'subGraphDefaultDataStoreNodes', 'type': '[str]'},
        'inputs': {'key': 'inputs', 'type': '[SubGraphPortInfo]'},
        'outputs': {'key': 'outputs', 'type': '[SubGraphPortInfo]'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        default_compute_target: Optional["ComputeSetting"] = None,
        default_data_store: Optional["DatastoreSetting"] = None,
        id: Optional[str] = None,
        parent_graph_id: Optional[str] = None,
        pipeline_definition_id: Optional[str] = None,
        sub_graph_parameter_assignment: Optional[List["SubGraphParameterAssignment"]] = None,
        sub_graph_concatenate_assignment: Optional[List["SubGraphConcatenateAssignment"]] = None,
        sub_graph_data_path_parameter_assignment: Optional[List["SubGraphDataPathParameterAssignment"]] = None,
        sub_graph_default_compute_target_nodes: Optional[List[str]] = None,
        sub_graph_default_data_store_nodes: Optional[List[str]] = None,
        inputs: Optional[List["SubGraphPortInfo"]] = None,
        outputs: Optional[List["SubGraphPortInfo"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword default_compute_target:
        :paramtype default_compute_target: ~designer.models.ComputeSetting
        :keyword default_data_store:
        :paramtype default_data_store: ~designer.models.DatastoreSetting
        :keyword id:
        :paramtype id: str
        :keyword parent_graph_id:
        :paramtype parent_graph_id: str
        :keyword pipeline_definition_id:
        :paramtype pipeline_definition_id: str
        :keyword sub_graph_parameter_assignment:
        :paramtype sub_graph_parameter_assignment: list[~designer.models.SubGraphParameterAssignment]
        :keyword sub_graph_concatenate_assignment:
        :paramtype sub_graph_concatenate_assignment:
         list[~designer.models.SubGraphConcatenateAssignment]
        :keyword sub_graph_data_path_parameter_assignment:
        :paramtype sub_graph_data_path_parameter_assignment:
         list[~designer.models.SubGraphDataPathParameterAssignment]
        :keyword sub_graph_default_compute_target_nodes:
        :paramtype sub_graph_default_compute_target_nodes: list[str]
        :keyword sub_graph_default_data_store_nodes:
        :paramtype sub_graph_default_data_store_nodes: list[str]
        :keyword inputs:
        :paramtype inputs: list[~designer.models.SubGraphPortInfo]
        :keyword outputs:
        :paramtype outputs: list[~designer.models.SubGraphPortInfo]
        """
        super(SubGraphInfo, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.default_compute_target = default_compute_target
        self.default_data_store = default_data_store
        self.id = id
        self.parent_graph_id = parent_graph_id
        self.pipeline_definition_id = pipeline_definition_id
        self.sub_graph_parameter_assignment = sub_graph_parameter_assignment
        self.sub_graph_concatenate_assignment = sub_graph_concatenate_assignment
        self.sub_graph_data_path_parameter_assignment = sub_graph_data_path_parameter_assignment
        self.sub_graph_default_compute_target_nodes = sub_graph_default_compute_target_nodes
        self.sub_graph_default_data_store_nodes = sub_graph_default_data_store_nodes
        self.inputs = inputs
        self.outputs = outputs


class SubGraphParameterAssignment(msrest.serialization.Model):
    """SubGraphParameterAssignment.

    :ivar parameter:
    :vartype parameter: ~designer.models.Parameter
    :ivar parameter_assignments:
    :vartype parameter_assignments: list[~designer.models.SubPipelineParameterAssignment]
    """

    _attribute_map = {
        'parameter': {'key': 'parameter', 'type': 'Parameter'},
        'parameter_assignments': {'key': 'parameterAssignments', 'type': '[SubPipelineParameterAssignment]'},
    }

    def __init__(
        self,
        *,
        parameter: Optional["Parameter"] = None,
        parameter_assignments: Optional[List["SubPipelineParameterAssignment"]] = None,
        **kwargs
    ):
        """
        :keyword parameter:
        :paramtype parameter: ~designer.models.Parameter
        :keyword parameter_assignments:
        :paramtype parameter_assignments: list[~designer.models.SubPipelineParameterAssignment]
        """
        super(SubGraphParameterAssignment, self).__init__(**kwargs)
        self.parameter = parameter
        self.parameter_assignments = parameter_assignments


class SubGraphPortInfo(msrest.serialization.Model):
    """SubGraphPortInfo.

    :ivar name:
    :vartype name: str
    :ivar internal:
    :vartype internal: list[~designer.models.SubGraphConnectionInfo]
    :ivar external:
    :vartype external: list[~designer.models.SubGraphConnectionInfo]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'internal': {'key': 'internal', 'type': '[SubGraphConnectionInfo]'},
        'external': {'key': 'external', 'type': '[SubGraphConnectionInfo]'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        internal: Optional[List["SubGraphConnectionInfo"]] = None,
        external: Optional[List["SubGraphConnectionInfo"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword internal:
        :paramtype internal: list[~designer.models.SubGraphConnectionInfo]
        :keyword external:
        :paramtype external: list[~designer.models.SubGraphConnectionInfo]
        """
        super(SubGraphPortInfo, self).__init__(**kwargs)
        self.name = name
        self.internal = internal
        self.external = external


class SubmitPipelineRunRequest(msrest.serialization.Model):
    """SubmitPipelineRunRequest.

    :ivar compute_target:
    :vartype compute_target: str
    :ivar flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
    :vartype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
    :ivar step_tags: This is a dictionary.
    :vartype step_tags: dict[str, str]
    :ivar experiment_name:
    :vartype experiment_name: str
    :ivar pipeline_parameters: This is a dictionary.
    :vartype pipeline_parameters: dict[str, str]
    :ivar data_path_assignments: This is a dictionary.
    :vartype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
    :ivar data_set_definition_value_assignments: This is a dictionary.
    :vartype data_set_definition_value_assignments: dict[str,
     ~designer.models.DataSetDefinitionValue]
    :ivar enable_notification:
    :vartype enable_notification: bool
    :ivar sub_pipelines_info:
    :vartype sub_pipelines_info: ~designer.models.SubPipelinesInfo
    :ivar display_name:
    :vartype display_name: str
    :ivar run_id:
    :vartype run_id: str
    :ivar graph:
    :vartype graph: ~designer.models.GraphDraftEntity
    :ivar pipeline_run_settings:
    :vartype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
    :ivar module_node_run_settings:
    :vartype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
    :ivar tags: A set of tags. This is a dictionary.
    :vartype tags: dict[str, str]
    :ivar continue_run_on_step_failure:
    :vartype continue_run_on_step_failure: bool
    :ivar description:
    :vartype description: str
    :ivar properties: This is a dictionary.
    :vartype properties: dict[str, str]
    """

    _attribute_map = {
        'compute_target': {'key': 'computeTarget', 'type': 'str'},
        'flattened_sub_graphs': {'key': 'flattenedSubGraphs', 'type': '{PipelineSubDraft}'},
        'step_tags': {'key': 'stepTags', 'type': '{str}'},
        'experiment_name': {'key': 'experimentName', 'type': 'str'},
        'pipeline_parameters': {'key': 'pipelineParameters', 'type': '{str}'},
        'data_path_assignments': {'key': 'dataPathAssignments', 'type': '{LegacyDataPath}'},
        'data_set_definition_value_assignments': {'key': 'dataSetDefinitionValueAssignments', 'type': '{DataSetDefinitionValue}'},
        'enable_notification': {'key': 'enableNotification', 'type': 'bool'},
        'sub_pipelines_info': {'key': 'subPipelinesInfo', 'type': 'SubPipelinesInfo'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'graph': {'key': 'graph', 'type': 'GraphDraftEntity'},
        'pipeline_run_settings': {'key': 'pipelineRunSettings', 'type': '[RunSettingParameterAssignment]'},
        'module_node_run_settings': {'key': 'moduleNodeRunSettings', 'type': '[GraphModuleNodeRunSetting]'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'continue_run_on_step_failure': {'key': 'continueRunOnStepFailure', 'type': 'bool'},
        'description': {'key': 'description', 'type': 'str'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(
        self,
        *,
        compute_target: Optional[str] = None,
        flattened_sub_graphs: Optional[Dict[str, "PipelineSubDraft"]] = None,
        step_tags: Optional[Dict[str, str]] = None,
        experiment_name: Optional[str] = None,
        pipeline_parameters: Optional[Dict[str, str]] = None,
        data_path_assignments: Optional[Dict[str, "LegacyDataPath"]] = None,
        data_set_definition_value_assignments: Optional[Dict[str, "DataSetDefinitionValue"]] = None,
        enable_notification: Optional[bool] = None,
        sub_pipelines_info: Optional["SubPipelinesInfo"] = None,
        display_name: Optional[str] = None,
        run_id: Optional[str] = None,
        graph: Optional["GraphDraftEntity"] = None,
        pipeline_run_settings: Optional[List["RunSettingParameterAssignment"]] = None,
        module_node_run_settings: Optional[List["GraphModuleNodeRunSetting"]] = None,
        tags: Optional[Dict[str, str]] = None,
        continue_run_on_step_failure: Optional[bool] = None,
        description: Optional[str] = None,
        properties: Optional[Dict[str, str]] = None,
        **kwargs
    ):
        """
        :keyword compute_target:
        :paramtype compute_target: str
        :keyword flattened_sub_graphs: Dictionary of :code:`<PipelineSubDraft>`.
        :paramtype flattened_sub_graphs: dict[str, ~designer.models.PipelineSubDraft]
        :keyword step_tags: This is a dictionary.
        :paramtype step_tags: dict[str, str]
        :keyword experiment_name:
        :paramtype experiment_name: str
        :keyword pipeline_parameters: This is a dictionary.
        :paramtype pipeline_parameters: dict[str, str]
        :keyword data_path_assignments: This is a dictionary.
        :paramtype data_path_assignments: dict[str, ~designer.models.LegacyDataPath]
        :keyword data_set_definition_value_assignments: This is a dictionary.
        :paramtype data_set_definition_value_assignments: dict[str,
         ~designer.models.DataSetDefinitionValue]
        :keyword enable_notification:
        :paramtype enable_notification: bool
        :keyword sub_pipelines_info:
        :paramtype sub_pipelines_info: ~designer.models.SubPipelinesInfo
        :keyword display_name:
        :paramtype display_name: str
        :keyword run_id:
        :paramtype run_id: str
        :keyword graph:
        :paramtype graph: ~designer.models.GraphDraftEntity
        :keyword pipeline_run_settings:
        :paramtype pipeline_run_settings: list[~designer.models.RunSettingParameterAssignment]
        :keyword module_node_run_settings:
        :paramtype module_node_run_settings: list[~designer.models.GraphModuleNodeRunSetting]
        :keyword tags: A set of tags. This is a dictionary.
        :paramtype tags: dict[str, str]
        :keyword continue_run_on_step_failure:
        :paramtype continue_run_on_step_failure: bool
        :keyword description:
        :paramtype description: str
        :keyword properties: This is a dictionary.
        :paramtype properties: dict[str, str]
        """
        super(SubmitPipelineRunRequest, self).__init__(**kwargs)
        self.compute_target = compute_target
        self.flattened_sub_graphs = flattened_sub_graphs
        self.step_tags = step_tags
        self.experiment_name = experiment_name
        self.pipeline_parameters = pipeline_parameters
        self.data_path_assignments = data_path_assignments
        self.data_set_definition_value_assignments = data_set_definition_value_assignments
        self.enable_notification = enable_notification
        self.sub_pipelines_info = sub_pipelines_info
        self.display_name = display_name
        self.run_id = run_id
        self.graph = graph
        self.pipeline_run_settings = pipeline_run_settings
        self.module_node_run_settings = module_node_run_settings
        self.tags = tags
        self.continue_run_on_step_failure = continue_run_on_step_failure
        self.description = description
        self.properties = properties


class SubPipelineDefinition(msrest.serialization.Model):
    """SubPipelineDefinition.

    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar default_compute_target:
    :vartype default_compute_target: ~designer.models.ComputeSetting
    :ivar default_data_store:
    :vartype default_data_store: ~designer.models.DatastoreSetting
    :ivar pipeline_function_name:
    :vartype pipeline_function_name: str
    :ivar id:
    :vartype id: str
    :ivar parent_definition_id:
    :vartype parent_definition_id: str
    :ivar from_module_name:
    :vartype from_module_name: str
    :ivar parameter_list:
    :vartype parameter_list: list[~designer.models.Kwarg]
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'default_compute_target': {'key': 'defaultComputeTarget', 'type': 'ComputeSetting'},
        'default_data_store': {'key': 'defaultDataStore', 'type': 'DatastoreSetting'},
        'pipeline_function_name': {'key': 'pipelineFunctionName', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'parent_definition_id': {'key': 'parentDefinitionId', 'type': 'str'},
        'from_module_name': {'key': 'fromModuleName', 'type': 'str'},
        'parameter_list': {'key': 'parameterList', 'type': '[Kwarg]'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        description: Optional[str] = None,
        default_compute_target: Optional["ComputeSetting"] = None,
        default_data_store: Optional["DatastoreSetting"] = None,
        pipeline_function_name: Optional[str] = None,
        id: Optional[str] = None,
        parent_definition_id: Optional[str] = None,
        from_module_name: Optional[str] = None,
        parameter_list: Optional[List["Kwarg"]] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword default_compute_target:
        :paramtype default_compute_target: ~designer.models.ComputeSetting
        :keyword default_data_store:
        :paramtype default_data_store: ~designer.models.DatastoreSetting
        :keyword pipeline_function_name:
        :paramtype pipeline_function_name: str
        :keyword id:
        :paramtype id: str
        :keyword parent_definition_id:
        :paramtype parent_definition_id: str
        :keyword from_module_name:
        :paramtype from_module_name: str
        :keyword parameter_list:
        :paramtype parameter_list: list[~designer.models.Kwarg]
        """
        super(SubPipelineDefinition, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.default_compute_target = default_compute_target
        self.default_data_store = default_data_store
        self.pipeline_function_name = pipeline_function_name
        self.id = id
        self.parent_definition_id = parent_definition_id
        self.from_module_name = from_module_name
        self.parameter_list = parameter_list


class SubPipelineParameterAssignment(msrest.serialization.Model):
    """SubPipelineParameterAssignment.

    :ivar node_id:
    :vartype node_id: str
    :ivar parameter_name:
    :vartype parameter_name: str
    """

    _attribute_map = {
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'parameter_name': {'key': 'parameterName', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_id: Optional[str] = None,
        parameter_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_id:
        :paramtype node_id: str
        :keyword parameter_name:
        :paramtype parameter_name: str
        """
        super(SubPipelineParameterAssignment, self).__init__(**kwargs)
        self.node_id = node_id
        self.parameter_name = parameter_name


class SubPipelinesInfo(msrest.serialization.Model):
    """SubPipelinesInfo.

    :ivar sub_graph_info:
    :vartype sub_graph_info: list[~designer.models.SubGraphInfo]
    :ivar node_id_to_sub_graph_id_mapping: Dictionary of :code:`<string>`.
    :vartype node_id_to_sub_graph_id_mapping: dict[str, str]
    :ivar sub_pipeline_definition:
    :vartype sub_pipeline_definition: list[~designer.models.SubPipelineDefinition]
    """

    _attribute_map = {
        'sub_graph_info': {'key': 'subGraphInfo', 'type': '[SubGraphInfo]'},
        'node_id_to_sub_graph_id_mapping': {'key': 'nodeIdToSubGraphIdMapping', 'type': '{str}'},
        'sub_pipeline_definition': {'key': 'subPipelineDefinition', 'type': '[SubPipelineDefinition]'},
    }

    def __init__(
        self,
        *,
        sub_graph_info: Optional[List["SubGraphInfo"]] = None,
        node_id_to_sub_graph_id_mapping: Optional[Dict[str, str]] = None,
        sub_pipeline_definition: Optional[List["SubPipelineDefinition"]] = None,
        **kwargs
    ):
        """
        :keyword sub_graph_info:
        :paramtype sub_graph_info: list[~designer.models.SubGraphInfo]
        :keyword node_id_to_sub_graph_id_mapping: Dictionary of :code:`<string>`.
        :paramtype node_id_to_sub_graph_id_mapping: dict[str, str]
        :keyword sub_pipeline_definition:
        :paramtype sub_pipeline_definition: list[~designer.models.SubPipelineDefinition]
        """
        super(SubPipelinesInfo, self).__init__(**kwargs)
        self.sub_graph_info = sub_graph_info
        self.node_id_to_sub_graph_id_mapping = node_id_to_sub_graph_id_mapping
        self.sub_pipeline_definition = sub_pipeline_definition


class SubStatusPeriod(msrest.serialization.Model):
    """SubStatusPeriod.

    :ivar name:
    :vartype name: str
    :ivar sub_periods:
    :vartype sub_periods: list[~designer.models.SubStatusPeriod]
    :ivar start:
    :vartype start: long
    :ivar end:
    :vartype end: long
    """

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'sub_periods': {'key': 'subPeriods', 'type': '[SubStatusPeriod]'},
        'start': {'key': 'start', 'type': 'long'},
        'end': {'key': 'end', 'type': 'long'},
    }

    def __init__(
        self,
        *,
        name: Optional[str] = None,
        sub_periods: Optional[List["SubStatusPeriod"]] = None,
        start: Optional[int] = None,
        end: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword name:
        :paramtype name: str
        :keyword sub_periods:
        :paramtype sub_periods: list[~designer.models.SubStatusPeriod]
        :keyword start:
        :paramtype start: long
        :keyword end:
        :paramtype end: long
        """
        super(SubStatusPeriod, self).__init__(**kwargs)
        self.name = name
        self.sub_periods = sub_periods
        self.start = start
        self.end = end


class SystemData(msrest.serialization.Model):
    """SystemData.

    :ivar created_at:
    :vartype created_at: ~datetime.datetime
    :ivar created_by:
    :vartype created_by: str
    :ivar created_by_type: Possible values include: "User", "Application", "ManagedIdentity",
     "Key".
    :vartype created_by_type: str or ~designer.models.UserType
    :ivar last_modified_at:
    :vartype last_modified_at: ~datetime.datetime
    :ivar last_modified_by:
    :vartype last_modified_by: str
    :ivar last_modified_by_type: Possible values include: "User", "Application", "ManagedIdentity",
     "Key".
    :vartype last_modified_by_type: str or ~designer.models.UserType
    """

    _attribute_map = {
        'created_at': {'key': 'createdAt', 'type': 'iso-8601'},
        'created_by': {'key': 'createdBy', 'type': 'str'},
        'created_by_type': {'key': 'createdByType', 'type': 'str'},
        'last_modified_at': {'key': 'lastModifiedAt', 'type': 'iso-8601'},
        'last_modified_by': {'key': 'lastModifiedBy', 'type': 'str'},
        'last_modified_by_type': {'key': 'lastModifiedByType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        created_at: Optional[datetime.datetime] = None,
        created_by: Optional[str] = None,
        created_by_type: Optional[Union[str, "UserType"]] = None,
        last_modified_at: Optional[datetime.datetime] = None,
        last_modified_by: Optional[str] = None,
        last_modified_by_type: Optional[Union[str, "UserType"]] = None,
        **kwargs
    ):
        """
        :keyword created_at:
        :paramtype created_at: ~datetime.datetime
        :keyword created_by:
        :paramtype created_by: str
        :keyword created_by_type: Possible values include: "User", "Application", "ManagedIdentity",
         "Key".
        :paramtype created_by_type: str or ~designer.models.UserType
        :keyword last_modified_at:
        :paramtype last_modified_at: ~datetime.datetime
        :keyword last_modified_by:
        :paramtype last_modified_by: str
        :keyword last_modified_by_type: Possible values include: "User", "Application",
         "ManagedIdentity", "Key".
        :paramtype last_modified_by_type: str or ~designer.models.UserType
        """
        super(SystemData, self).__init__(**kwargs)
        self.created_at = created_at
        self.created_by = created_by
        self.created_by_type = created_by_type
        self.last_modified_at = last_modified_at
        self.last_modified_by = last_modified_by
        self.last_modified_by_type = last_modified_by_type


class SystemMeta(msrest.serialization.Model):
    """SystemMeta.

    :ivar identifier_hash:
    :vartype identifier_hash: str
    :ivar extra_hash:
    :vartype extra_hash: str
    :ivar content_hash:
    :vartype content_hash: str
    """

    _attribute_map = {
        'identifier_hash': {'key': 'identifierHash', 'type': 'str'},
        'extra_hash': {'key': 'extraHash', 'type': 'str'},
        'content_hash': {'key': 'contentHash', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        identifier_hash: Optional[str] = None,
        extra_hash: Optional[str] = None,
        content_hash: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword identifier_hash:
        :paramtype identifier_hash: str
        :keyword extra_hash:
        :paramtype extra_hash: str
        :keyword content_hash:
        :paramtype content_hash: str
        """
        super(SystemMeta, self).__init__(**kwargs)
        self.identifier_hash = identifier_hash
        self.extra_hash = extra_hash
        self.content_hash = content_hash


class TargetLags(msrest.serialization.Model):
    """TargetLags.

    :ivar mode: Possible values include: "Auto", "Custom".
    :vartype mode: str or ~designer.models.TargetLagsMode
    :ivar values:
    :vartype values: list[int]
    """

    _attribute_map = {
        'mode': {'key': 'mode', 'type': 'str'},
        'values': {'key': 'values', 'type': '[int]'},
    }

    def __init__(
        self,
        *,
        mode: Optional[Union[str, "TargetLagsMode"]] = None,
        values: Optional[List[int]] = None,
        **kwargs
    ):
        """
        :keyword mode: Possible values include: "Auto", "Custom".
        :paramtype mode: str or ~designer.models.TargetLagsMode
        :keyword values:
        :paramtype values: list[int]
        """
        super(TargetLags, self).__init__(**kwargs)
        self.mode = mode
        self.values = values


class TargetRollingWindowSize(msrest.serialization.Model):
    """TargetRollingWindowSize.

    :ivar mode: Possible values include: "Auto", "Custom".
    :vartype mode: str or ~designer.models.TargetRollingWindowSizeMode
    :ivar value:
    :vartype value: int
    """

    _attribute_map = {
        'mode': {'key': 'mode', 'type': 'str'},
        'value': {'key': 'value', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        mode: Optional[Union[str, "TargetRollingWindowSizeMode"]] = None,
        value: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword mode: Possible values include: "Auto", "Custom".
        :paramtype mode: str or ~designer.models.TargetRollingWindowSizeMode
        :keyword value:
        :paramtype value: int
        """
        super(TargetRollingWindowSize, self).__init__(**kwargs)
        self.mode = mode
        self.value = value


class TaskReuseInfo(msrest.serialization.Model):
    """TaskReuseInfo.

    :ivar experiment_id:
    :vartype experiment_id: str
    :ivar pipeline_run_id:
    :vartype pipeline_run_id: str
    :ivar node_id:
    :vartype node_id: str
    :ivar request_id:
    :vartype request_id: str
    :ivar run_id:
    :vartype run_id: str
    :ivar node_start_time:
    :vartype node_start_time: ~datetime.datetime
    :ivar node_end_time:
    :vartype node_end_time: ~datetime.datetime
    """

    _attribute_map = {
        'experiment_id': {'key': 'experimentId', 'type': 'str'},
        'pipeline_run_id': {'key': 'pipelineRunId', 'type': 'str'},
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'request_id': {'key': 'requestId', 'type': 'str'},
        'run_id': {'key': 'runId', 'type': 'str'},
        'node_start_time': {'key': 'nodeStartTime', 'type': 'iso-8601'},
        'node_end_time': {'key': 'nodeEndTime', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        experiment_id: Optional[str] = None,
        pipeline_run_id: Optional[str] = None,
        node_id: Optional[str] = None,
        request_id: Optional[str] = None,
        run_id: Optional[str] = None,
        node_start_time: Optional[datetime.datetime] = None,
        node_end_time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword experiment_id:
        :paramtype experiment_id: str
        :keyword pipeline_run_id:
        :paramtype pipeline_run_id: str
        :keyword node_id:
        :paramtype node_id: str
        :keyword request_id:
        :paramtype request_id: str
        :keyword run_id:
        :paramtype run_id: str
        :keyword node_start_time:
        :paramtype node_start_time: ~datetime.datetime
        :keyword node_end_time:
        :paramtype node_end_time: ~datetime.datetime
        """
        super(TaskReuseInfo, self).__init__(**kwargs)
        self.experiment_id = experiment_id
        self.pipeline_run_id = pipeline_run_id
        self.node_id = node_id
        self.request_id = request_id
        self.run_id = run_id
        self.node_start_time = node_start_time
        self.node_end_time = node_end_time


class TensorflowConfiguration(msrest.serialization.Model):
    """TensorflowConfiguration.

    :ivar worker_count:
    :vartype worker_count: int
    :ivar parameter_server_count:
    :vartype parameter_server_count: int
    """

    _attribute_map = {
        'worker_count': {'key': 'workerCount', 'type': 'int'},
        'parameter_server_count': {'key': 'parameterServerCount', 'type': 'int'},
    }

    def __init__(
        self,
        *,
        worker_count: Optional[int] = None,
        parameter_server_count: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword worker_count:
        :paramtype worker_count: int
        :keyword parameter_server_count:
        :paramtype parameter_server_count: int
        """
        super(TensorflowConfiguration, self).__init__(**kwargs)
        self.worker_count = worker_count
        self.parameter_server_count = parameter_server_count


class TestDataSettings(msrest.serialization.Model):
    """TestDataSettings.

    :ivar test_data_size:
    :vartype test_data_size: float
    """

    _attribute_map = {
        'test_data_size': {'key': 'testDataSize', 'type': 'float'},
    }

    def __init__(
        self,
        *,
        test_data_size: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword test_data_size:
        :paramtype test_data_size: float
        """
        super(TestDataSettings, self).__init__(**kwargs)
        self.test_data_size = test_data_size


class TrainingOutput(msrest.serialization.Model):
    """TrainingOutput.

    :ivar training_output_type: Possible values include: "Metrics", "Model".
    :vartype training_output_type: str or ~designer.models.TrainingOutputType
    :ivar iteration:
    :vartype iteration: int
    :ivar metric:
    :vartype metric: str
    :ivar model_file:
    :vartype model_file: str
    """

    _attribute_map = {
        'training_output_type': {'key': 'trainingOutputType', 'type': 'str'},
        'iteration': {'key': 'iteration', 'type': 'int'},
        'metric': {'key': 'metric', 'type': 'str'},
        'model_file': {'key': 'modelFile', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        training_output_type: Optional[Union[str, "TrainingOutputType"]] = None,
        iteration: Optional[int] = None,
        metric: Optional[str] = None,
        model_file: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword training_output_type: Possible values include: "Metrics", "Model".
        :paramtype training_output_type: str or ~designer.models.TrainingOutputType
        :keyword iteration:
        :paramtype iteration: int
        :keyword metric:
        :paramtype metric: str
        :keyword model_file:
        :paramtype model_file: str
        """
        super(TrainingOutput, self).__init__(**kwargs)
        self.training_output_type = training_output_type
        self.iteration = iteration
        self.metric = metric
        self.model_file = model_file


class TrainingSettings(msrest.serialization.Model):
    """TrainingSettings.

    :ivar block_list_models:
    :vartype block_list_models: list[str]
    :ivar allow_list_models:
    :vartype allow_list_models: list[str]
    :ivar enable_dnn_training:
    :vartype enable_dnn_training: bool
    :ivar enable_onnx_compatible_models:
    :vartype enable_onnx_compatible_models: bool
    :ivar stack_ensemble_settings:
    :vartype stack_ensemble_settings: ~designer.models.StackEnsembleSettings
    :ivar enable_stack_ensemble:
    :vartype enable_stack_ensemble: bool
    :ivar enable_vote_ensemble:
    :vartype enable_vote_ensemble: bool
    :ivar ensemble_model_download_timeout:
    :vartype ensemble_model_download_timeout: str
    """

    _attribute_map = {
        'block_list_models': {'key': 'blockListModels', 'type': '[str]'},
        'allow_list_models': {'key': 'allowListModels', 'type': '[str]'},
        'enable_dnn_training': {'key': 'enableDnnTraining', 'type': 'bool'},
        'enable_onnx_compatible_models': {'key': 'enableOnnxCompatibleModels', 'type': 'bool'},
        'stack_ensemble_settings': {'key': 'stackEnsembleSettings', 'type': 'StackEnsembleSettings'},
        'enable_stack_ensemble': {'key': 'enableStackEnsemble', 'type': 'bool'},
        'enable_vote_ensemble': {'key': 'enableVoteEnsemble', 'type': 'bool'},
        'ensemble_model_download_timeout': {'key': 'ensembleModelDownloadTimeout', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        block_list_models: Optional[List[str]] = None,
        allow_list_models: Optional[List[str]] = None,
        enable_dnn_training: Optional[bool] = None,
        enable_onnx_compatible_models: Optional[bool] = None,
        stack_ensemble_settings: Optional["StackEnsembleSettings"] = None,
        enable_stack_ensemble: Optional[bool] = None,
        enable_vote_ensemble: Optional[bool] = None,
        ensemble_model_download_timeout: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword block_list_models:
        :paramtype block_list_models: list[str]
        :keyword allow_list_models:
        :paramtype allow_list_models: list[str]
        :keyword enable_dnn_training:
        :paramtype enable_dnn_training: bool
        :keyword enable_onnx_compatible_models:
        :paramtype enable_onnx_compatible_models: bool
        :keyword stack_ensemble_settings:
        :paramtype stack_ensemble_settings: ~designer.models.StackEnsembleSettings
        :keyword enable_stack_ensemble:
        :paramtype enable_stack_ensemble: bool
        :keyword enable_vote_ensemble:
        :paramtype enable_vote_ensemble: bool
        :keyword ensemble_model_download_timeout:
        :paramtype ensemble_model_download_timeout: str
        """
        super(TrainingSettings, self).__init__(**kwargs)
        self.block_list_models = block_list_models
        self.allow_list_models = allow_list_models
        self.enable_dnn_training = enable_dnn_training
        self.enable_onnx_compatible_models = enable_onnx_compatible_models
        self.stack_ensemble_settings = stack_ensemble_settings
        self.enable_stack_ensemble = enable_stack_ensemble
        self.enable_vote_ensemble = enable_vote_ensemble
        self.ensemble_model_download_timeout = ensemble_model_download_timeout


class UIColumnPicker(msrest.serialization.Model):
    """UIColumnPicker.

    :ivar column_picker_for:
    :vartype column_picker_for: str
    :ivar column_selection_categories:
    :vartype column_selection_categories: list[str]
    :ivar single_column_selection:
    :vartype single_column_selection: bool
    """

    _attribute_map = {
        'column_picker_for': {'key': 'columnPickerFor', 'type': 'str'},
        'column_selection_categories': {'key': 'columnSelectionCategories', 'type': '[str]'},
        'single_column_selection': {'key': 'singleColumnSelection', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        column_picker_for: Optional[str] = None,
        column_selection_categories: Optional[List[str]] = None,
        single_column_selection: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword column_picker_for:
        :paramtype column_picker_for: str
        :keyword column_selection_categories:
        :paramtype column_selection_categories: list[str]
        :keyword single_column_selection:
        :paramtype single_column_selection: bool
        """
        super(UIColumnPicker, self).__init__(**kwargs)
        self.column_picker_for = column_picker_for
        self.column_selection_categories = column_selection_categories
        self.single_column_selection = single_column_selection


class UIComputeSelection(msrest.serialization.Model):
    """UIComputeSelection.

    :ivar compute_types:
    :vartype compute_types: list[str]
    :ivar require_gpu:
    :vartype require_gpu: bool
    :ivar os_types:
    :vartype os_types: list[str]
    :ivar compute_run_settings_mapping: Dictionary of
     <components·10my8oj·schemas·uicomputeselection·properties·computerunsettingsmapping·additionalproperties>.
    :vartype compute_run_settings_mapping: dict[str, list[~designer.models.RunSettingParameter]]
    """

    _attribute_map = {
        'compute_types': {'key': 'computeTypes', 'type': '[str]'},
        'require_gpu': {'key': 'requireGpu', 'type': 'bool'},
        'os_types': {'key': 'osTypes', 'type': '[str]'},
        'compute_run_settings_mapping': {'key': 'computeRunSettingsMapping', 'type': '{[RunSettingParameter]}'},
    }

    def __init__(
        self,
        *,
        compute_types: Optional[List[str]] = None,
        require_gpu: Optional[bool] = None,
        os_types: Optional[List[str]] = None,
        compute_run_settings_mapping: Optional[Dict[str, List["RunSettingParameter"]]] = None,
        **kwargs
    ):
        """
        :keyword compute_types:
        :paramtype compute_types: list[str]
        :keyword require_gpu:
        :paramtype require_gpu: bool
        :keyword os_types:
        :paramtype os_types: list[str]
        :keyword compute_run_settings_mapping: Dictionary of
         <components·10my8oj·schemas·uicomputeselection·properties·computerunsettingsmapping·additionalproperties>.
        :paramtype compute_run_settings_mapping: dict[str, list[~designer.models.RunSettingParameter]]
        """
        super(UIComputeSelection, self).__init__(**kwargs)
        self.compute_types = compute_types
        self.require_gpu = require_gpu
        self.os_types = os_types
        self.compute_run_settings_mapping = compute_run_settings_mapping


class UIJsonEditor(msrest.serialization.Model):
    """UIJsonEditor.

    :ivar json_schema:
    :vartype json_schema: str
    """

    _attribute_map = {
        'json_schema': {'key': 'jsonSchema', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        json_schema: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword json_schema:
        :paramtype json_schema: str
        """
        super(UIJsonEditor, self).__init__(**kwargs)
        self.json_schema = json_schema


class UIParameterHint(msrest.serialization.Model):
    """UIParameterHint.

    :ivar ui_widget_type: Possible values include: "Default", "Mode", "ColumnPicker", "Credential",
     "Script".
    :vartype ui_widget_type: str or ~designer.models.UIWidgetTypeEnum
    :ivar column_picker:
    :vartype column_picker: ~designer.models.UIColumnPicker
    :ivar ui_script_language: Possible values include: "None", "Python", "R", "Json", "Sql".
    :vartype ui_script_language: str or ~designer.models.UIScriptLanguageEnum
    """

    _attribute_map = {
        'ui_widget_type': {'key': 'uiWidgetType', 'type': 'str'},
        'column_picker': {'key': 'columnPicker', 'type': 'UIColumnPicker'},
        'ui_script_language': {'key': 'uiScriptLanguage', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        ui_widget_type: Optional[Union[str, "UIWidgetTypeEnum"]] = None,
        column_picker: Optional["UIColumnPicker"] = None,
        ui_script_language: Optional[Union[str, "UIScriptLanguageEnum"]] = None,
        **kwargs
    ):
        """
        :keyword ui_widget_type: Possible values include: "Default", "Mode", "ColumnPicker",
         "Credential", "Script".
        :paramtype ui_widget_type: str or ~designer.models.UIWidgetTypeEnum
        :keyword column_picker:
        :paramtype column_picker: ~designer.models.UIColumnPicker
        :keyword ui_script_language: Possible values include: "None", "Python", "R", "Json", "Sql".
        :paramtype ui_script_language: str or ~designer.models.UIScriptLanguageEnum
        """
        super(UIParameterHint, self).__init__(**kwargs)
        self.ui_widget_type = ui_widget_type
        self.column_picker = column_picker
        self.ui_script_language = ui_script_language


class UIWidgetMetaInfo(msrest.serialization.Model):
    """UIWidgetMetaInfo.

    :ivar module_node_id:
    :vartype module_node_id: str
    :ivar meta_module_id:
    :vartype meta_module_id: str
    :ivar parameter_name:
    :vartype parameter_name: str
    :ivar ui_widget_type: Possible values include: "Default", "Mode", "ColumnPicker", "Credential",
     "Script".
    :vartype ui_widget_type: str or ~designer.models.UIWidgetTypeEnum
    """

    _attribute_map = {
        'module_node_id': {'key': 'moduleNodeId', 'type': 'str'},
        'meta_module_id': {'key': 'metaModuleId', 'type': 'str'},
        'parameter_name': {'key': 'parameterName', 'type': 'str'},
        'ui_widget_type': {'key': 'uiWidgetType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_node_id: Optional[str] = None,
        meta_module_id: Optional[str] = None,
        parameter_name: Optional[str] = None,
        ui_widget_type: Optional[Union[str, "UIWidgetTypeEnum"]] = None,
        **kwargs
    ):
        """
        :keyword module_node_id:
        :paramtype module_node_id: str
        :keyword meta_module_id:
        :paramtype meta_module_id: str
        :keyword parameter_name:
        :paramtype parameter_name: str
        :keyword ui_widget_type: Possible values include: "Default", "Mode", "ColumnPicker",
         "Credential", "Script".
        :paramtype ui_widget_type: str or ~designer.models.UIWidgetTypeEnum
        """
        super(UIWidgetMetaInfo, self).__init__(**kwargs)
        self.module_node_id = module_node_id
        self.meta_module_id = meta_module_id
        self.parameter_name = parameter_name
        self.ui_widget_type = ui_widget_type


class UpdateComponentRequest(msrest.serialization.Model):
    """UpdateComponentRequest.

    :ivar display_name:
    :vartype display_name: str
    :ivar description:
    :vartype description: str
    :ivar tags: A set of tags. Dictionary of :code:`<string>`.
    :vartype tags: dict[str, str]
    :ivar module_update_operation_type: Possible values include: "SetDefaultVersion",
     "EnableModule", "DisableModule", "UpdateDisplayName", "UpdateDescription", "UpdateTags".
    :vartype module_update_operation_type: str or ~designer.models.ModuleUpdateOperationType
    :ivar module_version:
    :vartype module_version: str
    """

    _attribute_map = {
        'display_name': {'key': 'displayName', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'tags': {'key': 'tags', 'type': '{str}'},
        'module_update_operation_type': {'key': 'moduleUpdateOperationType', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        display_name: Optional[str] = None,
        description: Optional[str] = None,
        tags: Optional[Dict[str, str]] = None,
        module_update_operation_type: Optional[Union[str, "ModuleUpdateOperationType"]] = None,
        module_version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword display_name:
        :paramtype display_name: str
        :keyword description:
        :paramtype description: str
        :keyword tags: A set of tags. Dictionary of :code:`<string>`.
        :paramtype tags: dict[str, str]
        :keyword module_update_operation_type: Possible values include: "SetDefaultVersion",
         "EnableModule", "DisableModule", "UpdateDisplayName", "UpdateDescription", "UpdateTags".
        :paramtype module_update_operation_type: str or ~designer.models.ModuleUpdateOperationType
        :keyword module_version:
        :paramtype module_version: str
        """
        super(UpdateComponentRequest, self).__init__(**kwargs)
        self.display_name = display_name
        self.description = description
        self.tags = tags
        self.module_update_operation_type = module_update_operation_type
        self.module_version = module_version


class UpdateModuleRequest(msrest.serialization.Model):
    """UpdateModuleRequest.

    :ivar module_update_operation_type: Possible values include: "SetDefaultVersion",
     "EnableModule", "DisableModule", "UpdateDisplayName", "UpdateDescription", "UpdateTags".
    :vartype module_update_operation_type: str or ~designer.models.ModuleUpdateOperationType
    :ivar module_version:
    :vartype module_version: str
    """

    _attribute_map = {
        'module_update_operation_type': {'key': 'moduleUpdateOperationType', 'type': 'str'},
        'module_version': {'key': 'moduleVersion', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        module_update_operation_type: Optional[Union[str, "ModuleUpdateOperationType"]] = None,
        module_version: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword module_update_operation_type: Possible values include: "SetDefaultVersion",
         "EnableModule", "DisableModule", "UpdateDisplayName", "UpdateDescription", "UpdateTags".
        :paramtype module_update_operation_type: str or ~designer.models.ModuleUpdateOperationType
        :keyword module_version:
        :paramtype module_version: str
        """
        super(UpdateModuleRequest, self).__init__(**kwargs)
        self.module_update_operation_type = module_update_operation_type
        self.module_version = module_version


class UpdateRegistryComponentRequest(msrest.serialization.Model):
    """UpdateRegistryComponentRequest.

    :ivar registry_name:
    :vartype registry_name: str
    :ivar component_name:
    :vartype component_name: str
    :ivar component_version:
    :vartype component_version: str
    :ivar update_type:  The only acceptable values to pass in are None and "SetDefaultVersion". The
     default value is None.
    :vartype update_type: str
    """

    _attribute_map = {
        'registry_name': {'key': 'registryName', 'type': 'str'},
        'component_name': {'key': 'componentName', 'type': 'str'},
        'component_version': {'key': 'componentVersion', 'type': 'str'},
        'update_type': {'key': 'updateType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        registry_name: Optional[str] = None,
        component_name: Optional[str] = None,
        component_version: Optional[str] = None,
        update_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword registry_name:
        :paramtype registry_name: str
        :keyword component_name:
        :paramtype component_name: str
        :keyword component_version:
        :paramtype component_version: str
        :keyword update_type:  The only acceptable values to pass in are None and "SetDefaultVersion".
         The default value is None.
        :paramtype update_type: str
        """
        super(UpdateRegistryComponentRequest, self).__init__(**kwargs)
        self.registry_name = registry_name
        self.component_name = component_name
        self.component_version = component_version
        self.update_type = update_type


class UploadOptions(msrest.serialization.Model):
    """UploadOptions.

    :ivar overwrite:
    :vartype overwrite: bool
    :ivar source_globs:
    :vartype source_globs: ~designer.models.ExecutionGlobsOptions
    """

    _attribute_map = {
        'overwrite': {'key': 'overwrite', 'type': 'bool'},
        'source_globs': {'key': 'sourceGlobs', 'type': 'ExecutionGlobsOptions'},
    }

    def __init__(
        self,
        *,
        overwrite: Optional[bool] = None,
        source_globs: Optional["ExecutionGlobsOptions"] = None,
        **kwargs
    ):
        """
        :keyword overwrite:
        :paramtype overwrite: bool
        :keyword source_globs:
        :paramtype source_globs: ~designer.models.ExecutionGlobsOptions
        """
        super(UploadOptions, self).__init__(**kwargs)
        self.overwrite = overwrite
        self.source_globs = source_globs


class UriReference(msrest.serialization.Model):
    """UriReference.

    :ivar path:
    :vartype path: str
    :ivar is_file:
    :vartype is_file: bool
    """

    _attribute_map = {
        'path': {'key': 'path', 'type': 'str'},
        'is_file': {'key': 'isFile', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        path: Optional[str] = None,
        is_file: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword path:
        :paramtype path: str
        :keyword is_file:
        :paramtype is_file: bool
        """
        super(UriReference, self).__init__(**kwargs)
        self.path = path
        self.is_file = is_file


class ValidationDataSettings(msrest.serialization.Model):
    """ValidationDataSettings.

    :ivar n_cross_validations:
    :vartype n_cross_validations: int
    :ivar validation_data_size:
    :vartype validation_data_size: float
    :ivar cv_split_column_names:
    :vartype cv_split_column_names: list[str]
    """

    _attribute_map = {
        'n_cross_validations': {'key': 'nCrossValidations', 'type': 'int'},
        'validation_data_size': {'key': 'validationDataSize', 'type': 'float'},
        'cv_split_column_names': {'key': 'cvSplitColumnNames', 'type': '[str]'},
    }

    def __init__(
        self,
        *,
        n_cross_validations: Optional[int] = None,
        validation_data_size: Optional[float] = None,
        cv_split_column_names: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword n_cross_validations:
        :paramtype n_cross_validations: int
        :keyword validation_data_size:
        :paramtype validation_data_size: float
        :keyword cv_split_column_names:
        :paramtype cv_split_column_names: list[str]
        """
        super(ValidationDataSettings, self).__init__(**kwargs)
        self.n_cross_validations = n_cross_validations
        self.validation_data_size = validation_data_size
        self.cv_split_column_names = cv_split_column_names


class WebServiceComputeMetaInfo(msrest.serialization.Model):
    """WebServiceComputeMetaInfo.

    :ivar node_count:
    :vartype node_count: int
    :ivar is_ssl_enabled:
    :vartype is_ssl_enabled: bool
    :ivar aks_not_found:
    :vartype aks_not_found: bool
    :ivar cluster_purpose:
    :vartype cluster_purpose: str
    :ivar public_ip_address:
    :vartype public_ip_address: str
    :ivar vm_size:
    :vartype vm_size: str
    :ivar location:
    :vartype location: str
    :ivar provisioning_state:
    :vartype provisioning_state: str
    :ivar state:
    :vartype state: str
    :ivar os_type:
    :vartype os_type: str
    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar created_by_studio:
    :vartype created_by_studio: bool
    :ivar is_gpu_type:
    :vartype is_gpu_type: bool
    :ivar resource_id:
    :vartype resource_id: str
    :ivar compute_type:
    :vartype compute_type: str
    """

    _attribute_map = {
        'node_count': {'key': 'nodeCount', 'type': 'int'},
        'is_ssl_enabled': {'key': 'isSslEnabled', 'type': 'bool'},
        'aks_not_found': {'key': 'aksNotFound', 'type': 'bool'},
        'cluster_purpose': {'key': 'clusterPurpose', 'type': 'str'},
        'public_ip_address': {'key': 'publicIpAddress', 'type': 'str'},
        'vm_size': {'key': 'vmSize', 'type': 'str'},
        'location': {'key': 'location', 'type': 'str'},
        'provisioning_state': {'key': 'provisioningState', 'type': 'str'},
        'state': {'key': 'state', 'type': 'str'},
        'os_type': {'key': 'osType', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'created_by_studio': {'key': 'createdByStudio', 'type': 'bool'},
        'is_gpu_type': {'key': 'isGpuType', 'type': 'bool'},
        'resource_id': {'key': 'resourceId', 'type': 'str'},
        'compute_type': {'key': 'computeType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_count: Optional[int] = None,
        is_ssl_enabled: Optional[bool] = None,
        aks_not_found: Optional[bool] = None,
        cluster_purpose: Optional[str] = None,
        public_ip_address: Optional[str] = None,
        vm_size: Optional[str] = None,
        location: Optional[str] = None,
        provisioning_state: Optional[str] = None,
        state: Optional[str] = None,
        os_type: Optional[str] = None,
        id: Optional[str] = None,
        name: Optional[str] = None,
        created_by_studio: Optional[bool] = None,
        is_gpu_type: Optional[bool] = None,
        resource_id: Optional[str] = None,
        compute_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_count:
        :paramtype node_count: int
        :keyword is_ssl_enabled:
        :paramtype is_ssl_enabled: bool
        :keyword aks_not_found:
        :paramtype aks_not_found: bool
        :keyword cluster_purpose:
        :paramtype cluster_purpose: str
        :keyword public_ip_address:
        :paramtype public_ip_address: str
        :keyword vm_size:
        :paramtype vm_size: str
        :keyword location:
        :paramtype location: str
        :keyword provisioning_state:
        :paramtype provisioning_state: str
        :keyword state:
        :paramtype state: str
        :keyword os_type:
        :paramtype os_type: str
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword created_by_studio:
        :paramtype created_by_studio: bool
        :keyword is_gpu_type:
        :paramtype is_gpu_type: bool
        :keyword resource_id:
        :paramtype resource_id: str
        :keyword compute_type:
        :paramtype compute_type: str
        """
        super(WebServiceComputeMetaInfo, self).__init__(**kwargs)
        self.node_count = node_count
        self.is_ssl_enabled = is_ssl_enabled
        self.aks_not_found = aks_not_found
        self.cluster_purpose = cluster_purpose
        self.public_ip_address = public_ip_address
        self.vm_size = vm_size
        self.location = location
        self.provisioning_state = provisioning_state
        self.state = state
        self.os_type = os_type
        self.id = id
        self.name = name
        self.created_by_studio = created_by_studio
        self.is_gpu_type = is_gpu_type
        self.resource_id = resource_id
        self.compute_type = compute_type


class WebServicePort(msrest.serialization.Model):
    """WebServicePort.

    :ivar node_id:
    :vartype node_id: str
    :ivar port_name:
    :vartype port_name: str
    :ivar name:
    :vartype name: str
    """

    _attribute_map = {
        'node_id': {'key': 'nodeId', 'type': 'str'},
        'port_name': {'key': 'portName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        node_id: Optional[str] = None,
        port_name: Optional[str] = None,
        name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword node_id:
        :paramtype node_id: str
        :keyword port_name:
        :paramtype port_name: str
        :keyword name:
        :paramtype name: str
        """
        super(WebServicePort, self).__init__(**kwargs)
        self.node_id = node_id
        self.port_name = port_name
        self.name = name
